

** panel_hh_id_back_w2 	drops the art split value from wave 2 households' "rid" and replaces it with "00", which allows for wave 2 households
** 				to be connected back with their original wave 1 households, even if the wave 2 household is a split off

** panel_hh_id_w2		this is equivalent to "rid" for wave 2 households; this is "rid" + "00" for wave 1 households
**				allows for merges of wave 1 households to wave 2 panel households which remained the same
**				(versus those that split off)

** panel_id_w2 		for non_panel individuals is the same as the wave 2 "id"; for panel individuals who did not change households
** 				it will be the same as the wave 2 "id" and the same as the wave 1 "id" with an extra "00" in the ART split position;
** 				for panel individuals who changed households it will be the same as the wave 1 "id" with an extra "00" in the ART split
** 				position but NOT the same as the wave 2 "id" [switch made using rar00_07, as below]


** panel_hh_id_back_w3 	drops the two art split values from wave 3 households' "rid" and replaces it with "00" + "00", which allows for wave 3 households
** 				to be connected back with their original wave 1 households, even if the wave 3 household is a split off

** panel_hh_id_w3		this is equivalent to "rid" for wave 3 households; this is "rid" + "00" + "00" for wave 1 households
**				allows for merges of wave 1 households to wave 3 panel households which remained the same
**				(versus those that split off)

** panel_id_w3 		for non_panel individuals is the same as the wave 3 "id"; for panel individuals who did not change households
** 				it will be the same as the wave 3 "id" and the same as the wave 1 "id" with an extra "00" + "00" in the ART split positions;
** 				for panel individuals who changed households in wave 2 or wave 3 it will be the same as the wave 1 "id" with an extra "00" + "00" in the ART split
** 				positions but NOT the same as the wave 2 or wave 3 "id" [switch made using rar00_07, as below]


**Wave I survey		Jun-Aug 2007
**Wave II survey		Oct-Dec 2008
**Wave III survey		Oct-Dec 2009
***************************************************************************************************
***************************************************************************************************
set more off

**We don't have wave 1 values for 1_1_old_2_3 so nothing here
local do_1_2_old_1_1 = 1
local do_1_3_old_1_2 = 1
local do_1_4_old_1_3 = 1  

local do_3_1 = 1
local do_3_2 = 1
local do_3_3 = 1
local do_3_4 = 1
local do_3_5 = 1




cd "Wave I"

use children0to36months_w1, clear
order rid id panel* *_w1 *_w2 *_w3
keep rid id panel* *_w1 *_w2 *_w3

tempfile tempchild
save `tempchild'

drop *_w3
sort panel_id_w2
tempfile child0to36_w1_w2
save `child0to36_w1_w2'

use `tempchild', clear
drop *_w2
sort panel_id_w3
tempfile child0to36_w1_w3
save `child0to36_w1_w3'

****

use children6to15years_w1, clear
order rid id panel* *_w1 *_w2 *_w3
keep rid id panel* *_w1 *_w2 *_w3

tempfile tempchild2
save `tempchild2'

drop *_w3
sort panel_id_w2
tempfile child6to15_w1_w2
save `child6to15_w1_w2'

use `tempchild2', clear
drop *_w2
sort panel_id_w3
tempfile child6to15_w1_w3
save `child6to15_w1_w3'

****

use marriedwoman16to49years_w1, clear

** If there is a missing for one of the indicators for one birth but not for the other (ex: miscarriage which means no info on delivery type for one birth)
** it will ascribe the value of the nonmissing value b/c it just ignores missing obs. in calculating the mean, this is what we want
foreach x of var pre_natal_visits_w1 pre_natal_dummy_w1 iron_pills_dummy_w1 iron_pills_categ_w1 good_assisted_delivery_w1 post_natal_visits_w1 post_natal_dummy_w1{
	disp "***`x'***"
	bys id: egen `x'_avg = mean(`x')
	**count if `x'_avg == . & `x' != .  **All 0, so fine
	replace `x' = `x'_avg
	drop `x'_avg
	}

keep id panel_id* rid panel_hh_id* *_w1
duplicates drop

order rid id panel* *_w1
keep rid id panel* *_w1

tempfile tempwoman
save `tempwoman'

drop *_w3
sort panel_id_w2
tempfile woman16to49_w1_w2
save `woman16to49_w1_w2'

use `tempwoman', clear
drop *_w2
sort panel_id_w3
tempfile woman16to49_w1_w3
save `woman16to49_w1_w3'

**********
**********

**We create kecamatan level mortality averages to sub in for the individual level controls, since it not make sense to control for death at the individual level
use infant_mortality_w1, clear
gen obs_type = 1
foreach x of var dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21{
	disp "***`x'***"
	bys Location_ID: egen kec_`x' = mean(`x')
}

keep Location_ID kec*_w1 obs_type
duplicates drop
sort Location_ID obs_type

tempfile tempmort
save `tempmort'


tempfile infant_mort_w1_w2
save `infant_mort_w1_w2'

use `tempmort', clear
tempfile infant_mort_w1_w3
save `infant_mort_w1_w3'

****

use infant_morbidity_w1, clear
gen obs_type = 2
order rid id panel* *_w1
keep rid id panel* *_w1 obs_type

tempfile tempmorb
save `tempmorb'

drop *_w3
sort panel_id_w2 obs_type
tempfile infant_morb_w1_w2
save `infant_morb_w1_w2'

use `tempmorb', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile infant_morb_w1_w3
save `infant_morb_w1_w3'

use test_results_generasi_w1, clear
keep rid id panel* *_w1 obs_type
sort panel_id_w3 obs_type
tempfile home_test_w1_w3
save `home_test_w1_w3'
**No analogous code for wave 2 b/c not have home based testing there


use children0to36months_w1, clear
drop obs_type
gen obs_type = 3

keep id panel_id* rid panel_hh_id* severe*_w1 mal*_w1 z*_w1 _f* obs_type

tempfile tempnourish
save `tempnourish'

drop *_w3
sort panel_id_w2 obs_type
tempfile nourish_w1_w2
save `nourish_w1_w2'

use `tempnourish', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile nourish_w1_w3
save `nourish_w1_w3'
***************************************
***************************************

use Data\R, clear

duplicates drop
duplicates drop rid, force

//Generate household survey dates using first survey attempt with at least partial completion (for across waves use later)
gen hh_survey_date=mdy(rivw_mm_1, rivw_dd_1, rivw_yy_1) if rhkw_1==1 | rhkw_1==2
replace hh_survey_date=mdy(rivw_mm_2, rivw_dd_2, rivw_yy_2) if hh_survey_date==. & rhkw_2==1 | rhkw_2==2
replace hh_survey_date=mdy(rivw_mm_3, rivw_dd_3, rivw_yy_3) if hh_survey_date==. & rhkw_3==1 | rhkw_3==2

gen hh_survey_month = ym(rivw_yy_1, rivw_mm_1) if rhkw_1==1 | rhkw_1==2
replace hh_survey_month= ym(rivw_yy_2, rivw_mm_2) if hh_survey_date==. & rhkw_2==1 | rhkw_2==2
replace hh_survey_month= ym(rivw_yy_3, rivw_mm_3) if hh_survey_date==. & rhkw_3==1 | rhkw_3==2

gen hh_survey_date_w1 = hh_survey_date
gen hh_survey_mon_w1 = hh_survey_month

gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"

keep panel_hh_id_back* hh_survey*w1
gen obs_type = 8

tempfile temphh
save `temphh'

drop *_w3
sort panel_hh_id_back_w2 obs_type
tempfile hh_surv_info_w1_w2
save `hh_surv_info_w1_w2'

use `temphh', clear
drop *_w2
sort panel_hh_id_back_w3 obs_type
tempfile hh_surv_info_w1_w3
save `hh_surv_info_w1_w3'


**************************************
//Table 1.2 indicators merge waves
**************************************
if `do_1_2_old_1_1' == 1 {


***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_1_2_vars_w2, clear

sort panel_id_w2

gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"

//Merging wave 2 info with household level wave 1 survey date information
sort panel_hh_id_back_w2
merge panel_hh_id_back_w2 using `hh_surv_info_w1_w2', _merge(_info_merge) uniqusing
tab _info_merge panel_hh, m

drop if _info_merge == 2
codebook rid if _info_merge == 3 & panel_hh == 0
replace hh_survey_date_w1 = . if _info_merge == 3 & panel_hh == 0
replace hh_survey_mon_w1 = . if _info_merge == 3 & panel_hh == 0

//Replacing the individual ids for those individuals who switched households between waves
//This allows us to connect them back to their wave 1 information recorded in the original household
replace panel_id_w2 = substr(panel_id,1,9) + "00" + rar00_07 if rar00_07 != "00" & rar00_07 != ""
sort panel_id_w2

//Matching child 0-36 months info across waves
merge panel_id_w2 using `child0to36_w1_w2', uniqusing _merge(merge_waves_child0to36)
tab merge_waves_child0to36 panel_2007, m
tab merge_waves_child0to36 panel_2007 if obs_type == 7, m
drop if merge_waves_child0to36 == 2
gen panel_ind_match_w2 = (merge_waves_child0to36 == 3)

sort panel_id_w2

merge panel_id_w2 using `child6to15_w1_w2', uniqusing _merge(merge_waves_child6to15)
tab merge_waves_child6to15 panel_2007, m
tab merge_waves_child6to15 panel_2007 if obs_type == 10, m
tab age_years merge_waves_child6to15 if obs_type == 10 & panel_2007 == 1, m
**Kids who were six years old at wave I survey would have been dropped from our data (b/c variables for 7-12, 13-15 year olds), so expect all the 7 years old and high number of 8 year olds (b/c could be 6 in wave I depending on time of year of birth) not to merge in, have very low numbers not merge in for other ages
drop if merge_waves_child6to15 == 2

replace panel_ind_match_w2 = 1 if merge_waves_child6to15 == 3
sort panel_id_w2

merge panel_id_w2 using `woman16to49_w1_w2', uniqusing _merge(merge_waves_woman16to49)
tab merge_waves_woman16to49 panel_2007, m
tab merge_waves_woman16to49 panel_2007 if obs_type == 6, m
*In each wave, only include women with preg/birth in previous 18months
*If panel_2007 == 1, which we generate from original icov3, indicates that you were present in the original survey, not nec our wave I final dataset
*To be present in wave I survey, need pregnancy in 24 months previous, to be present in our wave I data need pregnancy in 18 months previous, so should expect approximately 3/4 of obs to merge in, get roughly this

drop if merge_waves_woman16to49 == 2

replace panel_ind_match_w2 = 1 if merge_waves_woman16to49 == 3


order id rid panel* *_w2 *_w1

save table_1_2_vars_w2_with_w1controls, replace


***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_1_2_vars_generasi_w3, clear

sort panel_id_w3

gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"

//Merging wave 3 info with household level wave 1 survey date information
sort panel_hh_id_back_w3
merge panel_hh_id_back_w3 using `hh_surv_info_w1_w3', _merge(_info_merge) uniqusing
tab _info_merge panel_hh, m
**panel_hh variable in wave 2 means present in 2007, panel_hh in wave 3 means present in 2007 OR 2008 (this in original survey, not own construction), so small number of HHs not matching into wave I from those in 2008 only
sort rid
gen mark1 = (_info_merge == 1 & panel_hh == 1)
gen mark2 =(panel_2008 == 1 & panel_hh == 1 & _info_merge == 1)
bys rid: egen mark1_max = max(mark1)
bys rid: egen mark2_max = max(mark2)
tab mark1_max mark2_max, m
drop mark1* mark2*
drop if _info_merge == 2


//Replacing the individual ids for those individuals who switched households between wave1 and wave 3
//This allows us to connect them back to their wave 1 information recorded in the original household
replace panel_id_w3 = substr(panel_id_w3,1,9) + "00" + "00" + rar00_07 if rar00_07 != "00" & rar00_07 != ""
sort panel_id_w3

//Matching child 0-36 months info across waves
merge panel_id_w3 using `child0to36_w1_w3', uniqusing _merge(merge_waves_child0to36)
tab merge_waves_child0to36 panel_2007, m
tab merge_waves_child0to36 panel_2007 if obs_type == 7, m


drop if merge_waves_child0to36 == 2

gen panel_ind_match_w3 = (merge_waves_child0to36 == 3)

sort panel_id_w3

merge panel_id_w3 using `child6to15_w1_w3', uniqusing _merge(merge_waves_child6to15)
tab merge_waves_child6to15 panel_2007, m
tab merge_waves_child6to15 panel_2007 if obs_type == 10, m
tab age_years merge_waves_child6to15 if obs_type == 10 & panel_2007 == 1, m
**Kids who were six years old at wave I survey would have been dropped from our data (b/c variables for 7-12, 13-15 year olds), so expect all the 8 years old and high number of 9 year olds (b/c could be 6 in wave I depending on time of year of birth) not to merge in, have very low numbers not merge in for other ages
**Check on those who are 7 or 8 and panel_2007? just means they were in the survey and were actually younger than target age of surveyed because panel_2007 based on a survey answer (acov3) not searching our final wave I data
**Wouldn't expect them to have merge == 3 though b/c that indicates they were in our final data and would be 7 2 years ago, for 8 this could be plausible if on edges agewise but what about 7 year old?
drop if merge_waves_child6to15 == 2


replace panel_ind_match_w3 = 1 if merge_waves_child6to15 == 3
sort panel_id_w3

merge panel_id_w3 using `woman16to49_w1_w3', uniqusing _merge(merge_waves_woman16to49)
tab merge_waves_woman16to49 panel_2007, m
tab merge_waves_woman16to49 panel_2007 if obs_type == 6, m
*In each wave, only include women with preg/birth in previous 18months in our final data (have previous 24 originally)
*If panel_2007 == 1, which we generate from original icov3, indicates that you were present in the original survey, not nec our wave I final dataset
*To be present in wave I survey, need pregnancy in 24 months previous, to be present in our wave I data need pregnancy in 18 months previous, so should expect approximately 3/4 of obs to merge in, get roughly this

drop if merge_waves_woman16to49 == 2


replace panel_ind_match_w3 = 1 if merge_waves_woman16to49 == 3


order id rid panel* *_w3 *_w1

save table_1_2_vars_generasi_w3_with_w1controls, replace



}
 
*******************************************************
//Table 1.3 indicators merge waves
*******************************************************

if `do_1_3_old_1_2' == 1 {

***************************
***   Wave II merges   ***
***************************

cd ..\
cd "Wave II"

use table_1_3_vars_w2, clear

sort panel_id_w2


gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"

//Merging wave 2 info with household level wave 1 survey date information
sort panel_hh_id_back_w2
merge panel_hh_id_back_w2 using `hh_surv_info_w1_w2', _merge(_info_merge) uniqusing
tab _info_merge panel_hh, m
codebook rid if _info_merge == 3 & panel_hh == 0
replace hh_survey_date_w1 = . if _info_merge == 3 & panel_hh == 0
replace hh_survey_mon_w1 = . if _info_merge == 3 & panel_hh == 0

drop if _info_merge == 2


//Matching infant mortality info across waves (kec level info from wave 1)
sort Location_ID obs_type
merge Location_ID obs_type using `infant_mort_w1_w2', uniqusing _merge(merge_waves_infant_mort)
tab merge_waves_infant_mort if obs_type == 1, m


drop if merge_waves_infant_mort == 2


sort panel_id_w2 obs_type

//Matching infant morbidity info across waves
merge panel_id_w2 obs_type using `infant_morb_w1_w2', uniqusing _merge(merge_waves_infant_morbidity)
tab merge_waves_infant_morbidity panel_2007, m
tab merge_waves_infant_morbidity panel_2007 if obs_type == 2, m


drop if merge_waves_infant_morbidity == 2

gen panel_ind_match = (merge_waves_infant_morbidity == 3)

sort panel_id_w2 obs_type

//Matching infant z-score info across waves
merge panel_id_w2 obs_type using `nourish_w1_w2', uniqusing _merge(merge_waves_infant_nourish)
tab merge_waves_infant_nourish panel_2007, m
tab merge_waves_infant_nourish panel_2007 if obs_type == 3, m
drop if merge_waves_infant_nourish == 2

replace panel_ind_match = 1 if merge_waves_infant_nourish == 3

sort panel_id_w2 obs_type

order id rid panel* *_w2 *_w1

save table_1_3_vars_w2_with_w1controls, replace

***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_1_3_vars_generasi_w3, clear

sort panel_id


replace panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00" if panel_hh_id_back_w3 == ""

//Merging wave 2 info with household level wave 1 survey date information
sort panel_hh_id_back_w3
merge panel_hh_id_back_w3 using `hh_surv_info_w1_w3', _merge(_info_merge) uniqusing
tab _info_merge panel_hh, m
**panel_hh variable in wave 2 means present in 2007, panel_hh in wave 3 means present in 2007 OR 2008 (this in original survey, not own construction), so small number of HHs not matching into wave I from those in 2008 only + 14 hhs just not merging in
sort rid
gen mark1 = (_info_merge == 1 & panel_hh == 1)
gen mark2 =(panel_2008 == 1 & panel_hh == 1 & _info_merge == 1)
bys rid: egen mark1_max = max(mark1)
bys rid: egen mark2_max = max(mark2)
tab mark1_max mark2_max, m
drop mark1* mark2*
drop if _info_merge == 2

//Matching infant mortality info across waves (kec level info from wave 1)
sort Location_ID obs_type
merge Location_ID obs_type using `infant_mort_w1_w3', uniqusing _merge(merge_waves_infant_mort)
tab merge_waves_infant_mort if obs_type == 1, m
drop if merge_waves_infant_mort == 2

sort panel_id_w3 obs_type

//Matching infant morbidity info across waves
merge panel_id_w3 obs_type using `infant_morb_w1_w3', uniqusing _merge(merge_waves_infant_morbidity)
tab merge_waves_infant_morbidity panel_2007, m
tab merge_waves_infant_morbidity panel_2007 if obs_type == 2, m
drop if merge_waves_infant_morbidity == 2

gen panel_ind_match = (merge_waves_infant_morbidity == 3)

sort panel_id_w3 obs_type

//Matching infant z-score info across waves
merge panel_id_w3 obs_type using `nourish_w1_w3', uniqusing _merge(merge_waves_infant_nourish)
tab merge_waves_infant_nourish panel_2007, m
tab merge_waves_infant_nourish panel_2007 if obs_type == 3, m
drop if merge_waves_infant_nourish == 2

replace panel_ind_match = 1 if merge_waves_infant_nourish == 3

sort panel_id_w3 obs_type

//Matching home based test score info across waves
merge panel_id_w3 obs_type using `home_test_w1_w3', uniqusing _merge(merge_waves_home_test)
tab merge_waves_home_test panel_2007, m
tab merge_waves_home_test panel_2007 if obs_type == 4, m
tab age_years if panel_2007 == 1 & merge_waves_home_test == 1 & obs_type == 4
tab age_years if panel_2007 == 1 & merge_waves_home_test == 3 & obs_type == 4
tab age_years age_years_w1 if panel_2007 == 1 & merge_waves_home_test == 3 & obs_type == 4
drop if merge_waves_home_test == 2


//Checking those observations with implausible w1 info
gen age_diff = age_years - age_years_w1 if obs_type == 4
*count if name_w1 != name_w3 & (age_diff > 3 | age_diff < 1) & age_diff != .
**Almost all the same (when check one by one, some of the non-matches differ by a letter or two)
**So leave as matched
/*
foreach x of var *_std_w1 age_years_w1{
	replace `x' = . if age_diff > 3 | age_diff < 1
}
*/	

replace panel_ind_match = 1 if merge_waves_home_test == 3

sort panel_id_w3 obs_type

order id rid panel* *_w3 *_w1

save table_1_3_vars_generasi_w3_with_w1controls, replace


}


**************************************
//Table 1.4 variables merge waves
**************************************
if `do_1_4_old_1_3' == 1 {


cd ..\
cd "Wave I"

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 3

keep sid dropouts_0607_school_w1 obs_type
sort sid obs_type

tempfile tempschool
save `tempschool'


tempfile schools_w1_w2
save `schools_w1_w2'

use `tempschool', clear
tempfile schools_w1_w3
save `schools_w1_w3'

**

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 6

**B/C can have multiple pregnancies per mother
foreach x of var prenatal_serv_qual_w1 facility_deliv_w1 excess_pre_natal_w1{
	bys id: egen `x'_avg = mean(`x')
	**count if `x'_avg == . & `x' != .  **All 0, so fine
	replace `x' = `x'_avg
	drop `x'_avg
	}

keep id panel_id* rid prenatal_serv_qual_w1 facility_deliv_w1 excess_pre_natal_w1 obs_type  
duplicates drop

tempfile tempwom
save `tempwom'

drop *_w3
sort panel_id_w2 obs_type
tempfile wom16to49_w1_w2
save `wom16to49_w1_w2'

use `tempwom', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile wom16to49_w1_w3
save `wom16to49_w1_w3'

**

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 7

keep id panel_id* rid breastfed_1hr_w1 exclusive_breastfed_w1 excess_vit_A_w1 obs_type

tempfile tempchild
save `tempchild'

drop *_w3
sort panel_id_w2 obs_type
tempfile child0to36_w1_w2
save `child0to36_w1_w2'

use `tempchild', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile child0to36_w1_w3
save `child0to36_w1_w3'
**

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 9

keep id panel_id* rid live_birth_12mon_w1 family_planning_w1 mom_purch_decisions_w1 mom_child_decisions_w1 obs_type

tempfile tempwom2
save `tempwom2'

drop *_w3
sort panel_id_w2 obs_type
tempfile woman_w1_w2
save `woman_w1_w2' 

use `tempwom2', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile woman_w1_w3
save `woman_w1_w3'
**

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 10

keep id panel_id* rid hrs_school_w1 hrs_school_enroll_only_w1 hrs_work_wage_w1 hrs_work_house_w1 hrs_work_wage_dummy_w1 hrs_work_house_dummy_w1 dropout_w1 SMP_transition_w1 SMP_transition_def2_w1 SMP_distance_w1 SMP_time_oneway_w1 SMP_transcost_oneway_w1 obs_type

tempfile tempkid
save `tempkid'

drop *_w3
sort panel_id_w2 obs_type
tempfile kids6to15_w1_w2
save `kids6to15_w1_w2'

use `tempkid', clear
drop *_w2
sort panel_id_w3 obs_type
tempfile kids6to15_w1_w3
save `kids6to15_w1_w3'

**

use table_1_4_vars_generasi_w1, clear
keep if obs_type == 8

keep rid panel_hh_id* migrate_12_mons_hh_w1 obs_type

tempfile temphh
save `temphh'  

drop *_w3
sort panel_hh_id_back_w2 obs_type
tempfile hh_vars_w1_w2
save `hh_vars_w1_w2' 

use `temphh', clear
drop *_w2
sort panel_hh_id_back_w3 obs_type
tempfile hh_vars_w1_w3
save `hh_vars_w1_w3'


***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_1_4_vars_w2, clear

**Merging info across waves
sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `kids6to15_w1_w2', uniqusing _merge(_merge_kids6to15) update
tab _merge_kids6to15 panel_2007, m
tab _merge_kids6to15 panel_2007 if obs_type == 10, m
tab age_years _merge_kids6to15 if obs_type == 10 & panel_2007 == 1, m
**Have the panel_2007 == 1 not merging in because are 7 or 8 years old and would have been dropped from our final wave I dataset (only keep 7-12, 13-15 year olds)
**1 obs merge in when not expecting
foreach x of var hrs_*_w1 SMP_*_w1 dropout_w1{
	display "**`x'**"
	replace `x' = . if panel_2007 == 0 & _merge == 5
}


drop if _m == 2
drop _m

sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `woman_w1_w2', uniqusing _merge(_merge_woman) update
tab _merge_woman panel_2007, m
tab _merge_woman panel_2007 if obs_type == 9, m
drop if _m == 2
drop _m


sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `child0to36_w1_w2', uniqusing _merge(_merge_child0to36) update
tab _merge_child0to36 panel_2007, m
tab _merge_child0to36 panel_2007 if obs_type == 7, m
drop if _m == 2
drop _m


sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `wom16to49_w1_w2', uniqusing _merge(_merge_women16to49) update
tab _merge_women16to49 panel_2007, m
tab _merge_women16to49 panel_2007 if obs_type == 6, m
*In each wave, only include women with preg/birth in previous 18months
*If panel_2007 == 1, which we generate from original icov3, indicates that you were present in the original survey, not nec our wave I final dataset
*To be present in wave I survey, need pregnancy in 24 months previous, to be present in our wave I data need pregnancy in 18 months previous, so should expect approximately 3/4 of obs to merge in, get roughly this

drop if _m == 2
drop _m



sort sid obs_type
merge sid obs_type using `schools_w1_w2', uniqusing _merge(_merge_schools) update
tab _merge_schools, m
tab _merge_schools if obs_type == 3 & school_type == "SMP", m
drop if _m == 2
drop _m

sort panel_hh_id_back_w2 obs_type
merge panel_hh_id_back_w2 obs_type using `hh_vars_w1_w2', uniqusing _merge(_merge_hhs) update
tab _merge_hhs panel_hh, m
tab _merge_hhs panel_hh if obs_type == 8, m
**Deal with few obs that merge in when not expect
foreach x of var migrate_12_mons_hh_w1{
	replace `x' = . if panel_hh == 0 & _merge == 5
}
drop if _m == 2
drop _m

save table_1_4_vars_w2_with_w1controls, replace

***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_1_4_vars_generasi_w3, clear

**Merging info across waves
sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `kids6to15_w1_w3', uniqusing _merge(_merge_kids6to15) update
tab _merge_kids6to15 panel_2007, m
tab _merge_kids6to15 panel_2007 if obs_type == 10, m
tab age_years _merge_kids6to15 if obs_type == 10 & panel_2007 == 1, m
**Kids who were six years old at wave I survey would have been dropped from our data (b/c variables for 7-12, 13-15 year olds), so expect all the 8 years old and high number of 9 year olds (b/c could be 6 in wave I depending on time of year of birth) not to merge in, have very low numbers not merge in for other ages
**Check on those who are 7 or 8 and panel_2007? just means they were in the survey and were actually younger than target age of surveyed because panel_2007 based on a survey answer (acov3) not searching our final wave I data
**Wouldn't expect them to have merge == 3 though b/c that indicates they were in our final data and would be 7 2 years ago, for 8 this could be plausible if on edges agewise but what about 7 year old?  see if this persists with fuller data
**Have few obs that merge in when not expect
foreach x of var hrs_*_w1 SMP_*_w1 dropout_w1{
	replace `x' = . if panel_2007 == 0 & _merge == 5
}

drop if _m == 2
drop _m


sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `woman_w1_w3', uniqusing _merge(_merge_woman) update
tab _merge_woman panel_2007, m
tab _merge_woman panel_2007 if obs_type == 9, m
**Have few obs that merge in when not expect
foreach x of var live_birth_12mon_w1 family_planning_w1{
	replace `x' = . if panel_2007 == 0 & _merge == 5
}
drop if _m == 2
drop _m


sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `child0to36_w1_w3', uniqusing _merge(_merge_child0to36) update
tab _merge_child0to36 panel_2007, m
tab _merge_child0to36 panel_2007 if obs_type == 7, m
**Correct small number of obs that merge in when not expect
foreach x of var breastfed_1hr_w1 exclusive_breastfed_w1{
	replace `x' = . if panel_2007 == 0 & obs_type == 7 & _merge_child0to36 == 5
}

drop if _m == 2
drop _m


sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `wom16to49_w1_w3', uniqusing _merge(_merge_women16to49) update
tab _merge_women16to49 panel_2007, m
tab _merge_women16to49 panel_2007 if obs_type == 6, m
*In each wave, only include women with preg/birth in previous 18months in our final data (have previous 24 originally)
*If panel_2007 == 1, which we generate from original icov3, indicates that you were present in the original survey, not nec our wave I final dataset
*To be present in wave I survey, need pregnancy in 24 months previous, to be present in our wave I data need pregnancy in 18 months previous, so should expect approximately 3/4 of obs to merge in, get roughly this
**Return to this
drop if _m == 2
drop _m

/*
**Not worried about this part b/c we use the kids level dropout in the regressions
sort sid obs_type
merge sid obs_type using `schools_w1_w3', uniqusing _merge(_merge_schools) update
tab _merge_schools
tab _merge_schools if obs_type == 3 & school_type == "SMP"
drop if _m == 2
drop _m
*/

sort panel_hh_id_back_w3 obs_type
merge panel_hh_id_back_w3 obs_type using `hh_vars_w1_w3', uniqusing _merge(_merge_hhs) update
tab _merge_hhs panel_hh, m
tab _merge_hhs panel_hh if obs_type == 8, m
**panel_hh variable in wave 2 means present in 2007, panel_hh in wave 3 means present in 2007 OR 2008 (this in original survey, not own construction), so small number of HHs not matching into wave I expected from those in 2008 only
**Deal with few obs that merge in when not expect
foreach x of var migrate_12_mons_hh_w1{
	replace `x' = . if panel_hh == 0 & _merge == 5
}
drop if _m == 2
drop _m

save table_1_4_vars_generasi_w3_with_w1controls, replace

}


*******************************************************
//Table 3.5 variables merge waves
*******************************************************
**These simpler b/c we not have to worry about changes in individual id numbers as changing households etc

if `do_3_5' == 1 {

cd ..\
cd "Wave I"

use table_3_5_vars_generasi_w1, clear
keep if obs_type == 1

**The two non_merges below from: 053601 -> 053606 , 26101 -> 261606 in wave II
rename ea ea_code

tempfile x
save `x'


keep norm_*pusk_w1 pid obs_type ea_code
sort pid obs_type

tempfile puskesmas_w1
save `puskesmas_w1'

use `x', clear

keep ea_code *_pusk_kec_tot_w1 obs_type 
duplicates drop
sort ea_code obs_type

tempfile puskesmas_w1_kec
save `puskesmas_w1_kec'

***

use table_3_5_vars_generasi_w1, clear
keep if obs_type == 2

rename ea ea_code

tempfile x
save `x'


keep ANC*bid_w1 FP*bid_w1 norm_*bid_w1 bid obs_type ea_code
sort bid obs_type

tempfile bidans_w1
save `bidans_w1'

use `x', clear

keep ea_code *_bid_kec_tot_w1 obs_type
duplicates drop
sort ea_code obs_type

tempfile bidans_w1_kec
save `bidans_w1_kec'

***

use table_3_5_vars_generasi_w1, clear
keep if obs_type == 3

rename ea ea_code

tempfile x
save `x'


keep students*0?_w1 schoolfees*0607_w1 school_type SD SMP sid obs_type ea_code 
sort sid obs_type

tempfile schools_w1
duplicates drop
save `schools_w1'

use `x', clear

keep ea_code *0?_kec_tot_w1 obs_type
duplicates drop
sort ea_code obs_type

tempfile schools_w1_kec
save `schools_w1_kec'

***

use table_3_5_vars_generasi_w1, clear
keep if obs_type == 6

rename ea ea_code

tempfile temp_moth
save `temp_moth'

keep *moth_w1 panel_id_w2 obs_type ea_code 
duplicates drop

sort panel_id_w2 obs_type
tempfile mother_fees_w1_w2
save `mother_fees_w1_w2'

use `temp_moth'

keep *moth_w1 panel_id_w3 obs_type ea_code 
duplicates drop

sort panel_id_w3 obs_type
tempfile mother_fees_w1_w3
save `mother_fees_w1_w3'

***

use table_3_5_vars_generasi_w1, clear
keep if obs_type == 10

rename ea ea_code

tempfile temp_kid
save `temp_kid'

keep *sem_w1 panel_id_w2 obs_type ea_code 
duplicates drop

sort panel_id_w2 obs_type
tempfile kids_schoolfees_w1_w2
save `kids_schoolfees_w1_w2'

use `temp_kid'

keep *sem_w1 panel_id_w3 obs_type ea_code 
duplicates drop

sort panel_id_w3 obs_type
tempfile kids_schoolfees_w1_w3
save `kids_schoolfees_w1_w3'

***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_3_5_vars_w2, clear

sort pid obs_type
merge pid obs_type using `puskesmas_w1', uniqusing
replace panel_2007 = 1 if _m == 3 & obs_type == 1
replace panel_2007 = 0 if _m == 1 & obs_type == 1
tab _m, m
tab _m panel_2007 if obs_type == 1, m
drop if _m == 2
drop _m

sort ea_code obs_type
merge ea_code obs_type using `puskesmas_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 1, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort bid obs_type
merge bid obs_type using `bidans_w1', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m


sort ea_code obs_type
merge ea_code obs_type using `bidans_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 2, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort sid obs_type
merge sid obs_type using `schools_w1', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 3, m

drop if _m == 2
drop _m

sort ea_code obs_type
merge ea_code obs_type using `schools_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 3, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `kids_schoolfees_w1_w2', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 10, m
drop if _m == 2
drop _m

**

sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `mother_fees_w1_w2', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 6, m
drop if _m == 2
drop _m


save table_3_5_vars_w2_with_w1controls, replace


***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_3_5_vars_generasi_w3, clear


sort pid obs_type
merge pid obs_type using `puskesmas_w1', uniqusing
replace panel_2007 = 1 if _m == 3 & obs_type == 1
replace panel_2007 = 0 if _m == 1 & obs_type == 1
tab _m, m
tab _m panel_2007 if obs_type == 1, m
drop if _m == 2
drop _m

sort ea_code obs_type
merge ea_code obs_type using `puskesmas_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 1, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort bid obs_type
merge bid obs_type using `bidans_w1', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m


sort ea_code obs_type
merge ea_code obs_type using `bidans_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 2, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort sid obs_type
merge sid obs_type using `schools_w1', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 3, m

drop if _m == 2
drop _m

sort ea_code obs_type
merge ea_code obs_type using `schools_w1_kec', uniqusing
tab _m, m
tab _m if obs_type == 3, m
codebook ea_code if _m == 3
drop if _m == 2
drop _m

**

sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `kids_schoolfees_w1_w3', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 10, m
drop if _m == 2
drop _m

**

sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `mother_fees_w1_w3', uniqusing
tab _m, m
tab _m panel_2007 if obs_type == 6, m
drop if _m == 2
drop _m


save table_3_5_vars_generasi_w3_with_w1controls, replace


}

*******************************************************
//Table 3.3 variables merge waves
*******************************************************

if `do_3_3' == 1 {

cd ..\
cd "Wave I"

use table_3_3_vars_generasi_w1, clear
keep if obs_type == 1

rename ea ea_code
keep ea_code pid *pusk* obs_type
sort pid

tempfile pusk_w1
save `pusk_w1'

**

use table_3_3_vars_generasi_w1, clear
keep if obs_type == 2

rename ea ea_code
keep ea_code *bid* obs_type
sort bid

tempfile bidans_w1
save `bidans_w1'

**

use table_3_3_vars_generasi_w1, clear
keep if obs_type == 3

rename ea ea_code
keep ea_code sid teach* obs_type SMP
sort sid

tempfile schools_w1
save `schools_w1'

**

***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_3_3_vars_w2, clear

sort pid
merge pid using `pusk_w1', uniqusing
tab _m if obs_type == 1, m
drop if _m == 2
drop _m

sort bid
merge bid using `bidans_w1', uniqusing
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m

sort sid 
merge sid using `schools_w1', uniqusing
tab _m panel_2007 if obs_type == 3 & SMP == 1, m
drop if _m == 2
drop _m

save table_3_3_vars_w2_with_w1controls, replace

***************************
***   Wave III merges    ***
***************************

cd ..\
cd "Wave III"

use table_3_3_vars_generasi_w3, clear


sort pid
merge pid using `pusk_w1', uniqusing
tab _m if obs_type == 1, m
drop if _m == 2
drop _m

sort bid
merge bid using `bidans_w1', uniqusing
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m

sort sid 
merge sid using `schools_w1', uniqusing
tab _m panel_2007 if obs_type == 3 & SMP == 1, m
drop if _m == 2
drop _m

save table_3_3_vars_generasi_w3_with_w1controls, replace


}


*******************************************************
//Table 3.1 variables merge waves
*******************************************************

if `do_3_1' == 1 {

cd ..\
cd "Wave I"

use table_3_1_vars_generasi_w1, clear
keep if obs_type == 1

keep ea pid *_pusk_w1 obs_type
sort pid

tempfile pusk_w1
save `pusk_w1'

use table_3_1_vars_generasi_w1, clear
keep if obs_type == 3

keep ea sid teach* obs_type SMP
sort sid

tempfile schools_w1
save `schools_w1'

**
use table_3_1_vars_generasi_w1, clear
keep if obs_type == 5

keep ea lid *desa* obs_type
sort lid

tempfile desa_w1
save `desa_w1'

**

***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_3_1_vars_w2, clear

sort pid
merge pid using `pusk_w1', uniqusing
tab _m if obs_type == 1, m
drop if _m == 2
drop _m

**Checking merging here: okay because panel refers to households with village, not village itself
sort lid
merge lid using `desa_w1', uniqusing
tab _m panel if obs_type == 5, m
drop if _m == 2
drop _m

sort sid 
merge sid using `schools_w1', uniqusing
tab _m panel if obs_type == 3, m
drop if _m == 2
drop _m

**Don't want to keep in the 3202030 to 3202270 matches here (b/c they share ea_code across waves)
foreach x in bid_pract_desa pos_num_desa SD_pres_desa SMP_pres_desa teach_num_SMP teach_num_SMP_perm personnel_fullt_pusk personnel_all_pusk bidan_full_pusk bidan_all_pusk bid_full_pop_ratio_pusk bid_all_pop_ratio_pusk{
	replace `x'_w1 = . if ea == "053"
}

save table_3_1_vars_w2_with_w1controls, replace

***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_3_1_vars_generasi_w3, clear

sort pid
merge pid using `pusk_w1', uniqusing
tab _m panel if obs_type == 1, m
drop if _m == 2
drop _m

**Checking merging here: okay because panel refers to households with village, not village itself
sort lid
merge lid using `desa_w1', uniqusing
tab _m panel if obs_type == 5, m
drop if _m == 2
drop _m

sort sid 
merge sid using `schools_w1', uniqusing
tab _m panel if obs_type == 3, m
drop if _m == 2
drop _m

**Don't want to keep in the 3202030 to 3202270 matches here (b/c they share ea_code across waves)
foreach x in bid_pract_desa pos_num_desa SD_pres_desa SMP_pres_desa teach_num_SMP teach_num_SMP_perm personnel_fullt_pusk personnel_all_pusk bidan_full_pusk bidan_all_pusk bid_full_pop_ratio_pusk bid_all_pop_ratio_pusk{
	replace `x'_w1 = . if ea == "053"
}

save table_3_1_vars_generasi_w3_with_w1controls, replace



}

*******************************************************
//Table 3.2 variables merge waves
*******************************************************

if `do_3_2' == 1 {

cd ..\
cd "Wave I"

use table_3_2_vars_generasi_w1, clear
keep if obs_type == 3

keep ea sid obs_type *SMP*
sort sid

tempfile schools_w1
save `schools_w1'

**

use table_3_2_vars_generasi_w1, clear
keep if obs_type == 2

keep ea *bid* obs_type 
sort bid

tempfile bidans_w1
save `bidans_w1'

**

use table_3_2_vars_generasi_w1, clear
keep if obs_type == 1

keep ea pid vacc* obs_type
sort pid

tempfile pusk_w1
save `pusk_w1'

***************************
***   Wave II merges   ***
***************************

cd ..\
cd "Wave II"

use table_3_2_vars_w2, clear

sort sid
merge sid using `schools_w1', uniqusing
tab _m panel_2007 if obs_type == 3 & SMP == 1, m
drop if _m == 2
drop _m

sort bid
merge bid using `bidans_w1', uniqusing
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m

sort pid
merge pid using `pusk_w1', uniqusing
tab _m panel_2007 if obs_type == 1, m
drop if _m == 2
replace panel_2007 = 0 if obs_type == 1 & _m == 1
replace panel = 0 if obs_type == 1 & _m == 1
tab _m panel_2007 if obs_type == 1, m
drop _m

save table_3_2_vars_w2_with_w1controls, replace

***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_3_2_vars_generasi_w3, clear

sort sid
merge sid using `schools_w1', uniqusing
tab _m panel_2007 if obs_type == 3 & SMP == 1, m
drop if _m == 2
drop _m

sort bid
merge bid using `bidans_w1', uniqusing
tab _m panel_2007 if obs_type == 2, m
drop if _m == 2
drop _m

sort pid
merge pid using `pusk_w1', uniqusing
tab _m panel_2007 if obs_type == 1, m
drop if _m == 2
drop _m

save table_3_2_vars_generasi_w3_with_w1controls, replace


}




*******************************************************
//Table 3.4 variables merge waves
*******************************************************

if `do_3_4' == 1 {

cd ..\
cd "Wave I"

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 7
keep tid panel* *_w1 obs_type

sort panel_id_w2 obs_type
tempfile kids_w1_w2
save `kids_w1_w2'

sort panel_id_w3 obs_type
tempfile kids_w1_w3
save `kids_w1_w3'

**

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 9
keep iid panel* *_w1 obs_type

sort panel_id_w2 obs_type
tempfile women_w1_w2
save `women_w1_w2'

sort panel_id_w3 obs_type
tempfile women_w1_w3
save `women_w1_w3'
**

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 3


keep ea sid *SMP* obs_type
sort sid
tempfile schools_w1
save `schools_w1'

**

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 5

keep ea lid *desa* obs_type
sort lid
tempfile desa_w1
save `desa_w1'

**

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 8

keep ea rid *hh* obs_type

sort panel_hh_id_back_w2
tempfile hh_w1_w2
save `hh_w1_w2'

sort panel_hh_id_back_w3
tempfile hh_w1_w3
save `hh_w1_w3'

**

use table_3_4_vars_generasi_w1, clear
keep if obs_type == 11
keep panel* ea iid num_meetings* obs_type

sort panel_id_w2 obs_type
tempfile hhresp_w1_w2
save `hhresp_w1_w2'

sort panel_id_w3 obs_type
tempfile hhresp_w1_w3
save `hhresp_w1_w3'

***************************
***   Wave II merges    ***
***************************

cd ..\
cd "Wave II"

use table_3_4_vars_w2, clear


gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"


//Merging wave 2 info with household level wave 1 survey date information
sort panel_hh_id_back_w2 obs_type
merge panel_hh_id_back_w2 obs_type using `hh_surv_info_w1_w2', _merge(_info_merge) uniqusing update
tab _info_merge obs_type
tab _info_merge panel if obs_type == 8

drop if _info_merge == 2


//Matching kid info across waves
sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `kids_w1_w2', uniqusing _merge(merge_waves_kids) update
tab merge_waves_kids obs_type, m
drop if merge_waves_kids == 2
tab merge_waves_kids panel_2007 if obs_type == 7, m

//Matching woman info across waves
sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `women_w1_w2', uniqusing _merge(merge_waves_women) update
tab merge_waves_women obs_type, m
drop if merge_waves_women == 2
tab merge_waves_women panel if obs_type == 9, m

**Number of merge = 1 & panel = 1 b/c woman may not have been the main respondent last year
**Fourteen of merge = 3 & panel = 0 b/c woman may have changed household and been respondent

//Matching main household respondent info across waves
sort panel_id_w2 obs_type
merge panel_id_w2 obs_type using `hhresp_w1_w2', uniqusing _merge(merge_waves_hhresp) update
tab merge_waves_hhresp obs_type, m
drop if merge_waves_hhresp == 2
tab merge_waves_hhresp panel if obs_type == 11, m


sort sid
merge sid using `schools_w1', uniqusing update
tab _m panel_2007 if obs_type == 3 & SMP == 1, m 
drop if _m == 2
drop _m

sort lid
merge lid using `desa_w1', uniqusing update
tab _m if obs_type == 5, m
drop if _m == 2
gen panel_village = (_m == 4) if obs_type == 5
drop _m


sort panel_hh_id_back_w2
merge panel_hh_id_back_w2 using `hh_w1_w2', uniqusing update
tab _m panel if obs_type == 8, m
drop if _m == 2
drop _m

save table_3_4_vars_w2_with_w1controls, replace


***************************
***   Wave III merges   ***
***************************

cd ..\
cd "Wave III"

use table_3_4_vars_generasi_w3, clear


gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"


//Merging wave 2 info with household level wave 1 survey date information
sort panel_hh_id_back_w3 obs_type
merge panel_hh_id_back_w3 obs_type using `hh_surv_info_w1_w3', _merge(_info_merge) uniqusing update
tab _info_merge obs_type
tab _info_merge panel if obs_type == 8

drop if _info_merge == 2


//Matching kid info across waves
sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `kids_w1_w3', uniqusing _merge(merge_waves_kids) update
tab merge_waves_kids obs_type, m
drop if merge_waves_kids == 2
tab merge_waves_kids panel_2007 if obs_type == 7, m

//Matching woman info across waves
sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `women_w1_w3', uniqusing _merge(merge_waves_women) update
tab merge_waves_women obs_type, m
drop if merge_waves_women == 2
tab merge_waves_women panel if obs_type == 9, m

**Number of merge = 1 & panel = 1 b/c woman may not have been the main respondent last year
**Fourteen of merge = 3 & panel = 0 b/c woman may have changed household and been respondent

//Matching main household respondent info across waves
sort panel_id_w3 obs_type
merge panel_id_w3 obs_type using `hhresp_w1_w3', uniqusing _merge(merge_waves_hhresp) update
tab merge_waves_hhresp obs_type, m
drop if merge_waves_hhresp == 2
tab merge_waves_hhresp panel if obs_type == 11, m

sort sid
merge sid using `schools_w1', uniqusing update
tab _m panel_2007 if obs_type == 3 & SMP == 1, m 
drop if _m == 2
drop _m

sort lid
merge lid using `desa_w1', uniqusing update
tab _m if obs_type == 5, m
drop if _m == 2
gen panel_village = (_m == 4) if obs_type == 5
drop _m

sort panel_hh_id_back_w3
merge panel_hh_id_back_w3 using `hh_w1_w3', uniqusing update
tab _m panel if obs_type == 8, m
drop if _m == 2
drop _m

save table_3_4_vars_generasi_w3_with_w1controls, replace


}




                                                                                                                      
