clear
set more off

local do_3_1 = 1
local do_3_2 = 1
local do_3_3 = 1
local do_3_4 = 1
local do_3_5 = 1


cd "Wave I"
*****************************************************************************
*****Table 3.1
*****************************************************************************

if `do_3_1' == 1 {

set more off
cd ..\
cd "Wave I"


**

use Data\L_FKS1TYPE, clear

//Whether bidan practices in the village or not
gen bid_pract_desax = 		1 if lfks1type == 3 & lfks02 == 1
replace bid_pract_desax =	0 if lfks1type == 3 & lfks02 == 3

bys lid: egen bid_pract_desa = max(bid_pract_desax)

keep lid bid_pract_desa
duplicates drop

sort lid
tempfile bid_vill
save `bid_vill'

**

use Data\L_DN, clear

//Number of posyandu in the village
replace ldn07 = 0 if ldn07 > .
bys lid: egen pos_num_desa = total(ldn07)
bys lid: egen pos_max_desa = max(ldn07)

keep lid pos_num_desa
duplicates drop

sort lid
tempfile pos_vill
save `pos_vill'


**

use Data\L_FPDTYPE, clear

//Presence of SD and SMP in village (including satu atap, terbuka, and klas jauh)

replace lfpd02 = 0 if lfpd02 > .
replace lfpd03 = 0 if lfpd03 > .

gen subtotal = lfpd02
replace subtotal = lfpd02 + lfpd03 if lfpd03!= .
replace subtotal = lfpd03 if subtotal == .

gen SD_pres_desax = subtotal if lfpdtype == 2 | lfpdtype == 3 | lfpdtype == 4
gen SMP_pres_desax = subtotal if lfpdtype == 5 | lfpdtype == 6 | lfpdtype == 7 | lfpdtype == 8 | lfpdtype == 9 

bys lid: egen SD_pres_desa = total(SD_pres_desax)
bys lid: egen SMP_pres_desa = total(SMP_pres_desax)
replace SD_pres_desa = 1 if SD_pres_desa >= 1 & SD_pres_desa < .
replace SMP_pres_desa = 1 if SMP_pres_desa >= 1 & SD_pres_desa < .
 

keep lid SD_pres_desa SMP_pres_desa
duplicates drop

sort lid
tempfile school_vill
save `school_vill'

merge lid using `bid_vill', sort
tab _m
drop _m

merge lid using `pos_vill', sort
tab _m
drop _m

gen obs_type = 5
gen ea_code = substr(lid,1,3)

tempfile nums_desa
save `nums_desa'


****

use Data\S, clear

gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SMP == 1
keep SMP sid

tempfile school_info
save `school_info'

use Data\S_GR03, clear


gen number = 1
gen number_perm = 1 if sgr06 == 1
bys sid: egen teach_num_school = total(number)
bys sid: egen teach_num_school_perm = total(number_perm)

keep sid teach_num_school*
duplicates drop

sort sid
merge sid using `school_info', sort
tab _m
drop _m

gen teach_num_SMP =	teach_num_school if SMP == 1
gen teach_num_SMP_perm = teach_num_school_perm if SMP == 1

drop teach_num_school*
gen obs_type = 3
gen ea_code = substr(sid,1,3)

sort sid

tempfile nums_school
save `nums_school'

****

***************************
***Puskesmas Info
***************************
use Data\P, clear
gen wave1_pop = pip02c

keep wave1_pop pid
sort pid

tempfile pusk_pop
save `pusk_pop'

use Data\P_TKSTYPE, clear

gen count_full = ptks01 if ptkstype <= 9
gen count_all = ptks01 + ptks02 if ptkstype <= 9 

bys pid: egen personnel_fullt_pusk = total(count_full)
bys pid: egen personnel_all_pusk = total(count_all)

gen bid_full = ptks01 if ptkstype == 5 | ptkstype == 6
gen bid_all = ptks01 + ptks02 if ptkstype == 5 | ptkstype == 6

bys pid: egen bidan_full_pusk = total(bid_full)
bys pid: egen bidan_all_pusk = total(bid_all)

keep pid personnel* bidan*
duplicates drop

gen obs_type = 1
gen ea_code = substr(pid,1,3)
sort pid

merge pid using `pusk_pop', sort
tab _m
drop if _m == 2
drop _m

gen bid_full_pop_ratio_pusk = bidan_full_pusk / wave1_pop
gen bid_all_pop_ratio_pusk = bidan_all_pusk / wave1_pop

sort pid
****

append using `nums_school'
append using `nums_desa'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 4 "Posyandu" 5 "Desa"
label values obs_type obs_labelx

foreach x of var bid_pract_desa pos_num_desa SD_pres_desa SMP_pres_desa teach_num_SMP teach_num_SMP_perm personnel_fullt_pusk personnel_all_pusk bidan_full_pusk bidan_all_pusk bid_full_pop_ratio_pusk bid_all_pop_ratio_pusk{
	rename `x' `x'_w1
}

order ea_code lid sid obs_type *w1

rename ea_code ea
sort ea
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID
gen ea = Location_ID
sort ea

merge ea using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _m

sort ea

save table_3_1_vars_w1, replace

keep if type == 3

save table_3_1_vars_generasi_w1, replace
}

*****************************************************************************
*****Table 3.5
*****************************************************************************


if `do_3_5' == 1 {

set more off
cd ..\
cd "Wave I"



**********************************************
****Puskesmas
**********************************************

**Fees
use Data\P_KF2TYPE, clear

gen norm_birth_fee_puskx = pkf04 if pkf2type == 5
replace norm_birth_fee_puskx = . if pkf03 == 3 

bys pid: egen norm_birth_fee_pusk = max(norm_birth_fee_puskx)

keep pid norm_birth_fee_pusk
duplicates drop

gen ea_code = substr(pid,1,3)
sort ea_code

**79 of 80 missings because pfk03 == 3 (service not provided)

tempfile pusk_fee
save `pusk_fee'

use Data\P, clear

**We have 25 0's? check this
//Number of assisted normal births in puskesmas
gen norm_birth_pusk = plg10n
**These are missings because of indicating no provision of relevant services in previous sections, etc.
replace norm_birth_pusk = 0 if plg10n == .w

keep pid norm_birth_pusk
duplicates report

gen ea_code = substr(pid,1,3)

//dropping empty obs
drop if ea_code == "pid"
sort ea_code

tempfile pusk_num
save `pusk_num'

use Data\cct_puskesmas_verification, clear

//Number of puskesmas in kec
gen number = 1
bys ea_code: egen pusk_num_kec = total(number)
keep ea_code pusk_num_kec
duplicates drop

sort ea_code
tempfile pusk_num_kec
save `pusk_num_kec'

**Why two not merging in?  [plus additional ea_code == 083 without info in KF2TYPE to try to explain . missing]
merge ea_code using `pusk_num', uniqmaster
tab _m
tab ea_code if _m == 1
keep if _m == 3
drop _m

merge ea_code using `pusk_fee', sort
tab _m
keep if _m == 3
drop _m

//Number of assisted normal births in kec
//(Number of puskesmas in each kec) * (number of normal births in a puskesmas in each kec)
gen norm_birth_pusk_kec_tot = pusk_num * norm_birth_pusk

foreach x in norm_birth_pusk{
	rename `x' `x'_w1
	rename `x'_kec_tot `x'_kec_tot_w1
}

rename norm_birth_fee_pusk norm_birth_fee_pusk_w1

order pid ea_code *_w1
keep pid ea_code *_w1
sort pid	


gen obs_type = 1

tempfile pusk_info
save `pusk_info'



***************************************
****Bidans
***************************************
**FP_inject should all be missing in wave I, because that question was added for wave II


use Data\B_LG, clear


//Generating variables for number of bidan normal child births in previous month
gen norm_birth_govx =		blg02a if blg2type == 14
gen norm_birth_privx =		blg02b if blg2type == 14


//Generating variables for bidan ANC in previous month
gen ANC_gov1x =			blg02a if blg2type == 8
gen ANC_gov2x =			blg02a if blg2type == 9
gen ANC_priv1x =			blg02b if blg2type == 8
gen ANC_priv2x =			blg02b if blg2type == 9

foreach x of var norm_birth_govx norm_birth_privx ANC_gov1x ANC_gov2x ANC_priv1x ANC_priv2x{
	replace `x' = 0 if `x' > .
}

gen ANC_govx = 			ANC_gov1x + ANC_gov2x
replace ANC_govx = 		ANC_gov1x if ANC_govx == .
replace ANC_govx =		ANC_gov2x if ANC_gov1x == .
gen ANC_privx =			ANC_priv1x + ANC_priv2x 
replace ANC_privx = 		ANC_priv1x if ANC_privx == .
replace ANC_privx = 		ANC_priv2x if ANC_privx == .

//Generating variable for bidan family planning in previous month
gen FP_inject_govx =			blg02a if blg2type == 23
gen FP_inject_privx =			blg02b if blg2type == 23
	
order bid norm_birth* ANC* FP*

foreach x in norm_birth_gov norm_birth_priv ANC_gov ANC_priv FP_inject_gov FP_inject_priv{
	bys bid: egen `x'_bid = max(`x'x)
}


drop *x blg*
duplicates drop
sort bid

gen norm_birth_tot_bid = 		norm_birth_gov_bid + norm_birth_priv_bid
replace norm_birth_tot_bid =	 	norm_birth_gov_bid if norm_birth_tot_bid == .
replace norm_birth_tot_bid = 		norm_birth_priv_bid if norm_birth_tot_bid == .

gen ANC_tot_bid = 			ANC_gov_bid + ANC_priv_bid
replace ANC_tot_bid =			ANC_gov_bid if ANC_tot_bid == .
replace ANC_tot_bid = 			ANC_priv_bid if ANC_tot_bid == .

gen FP_inject_tot_bid =			FP_inject_gov_bid + FP_inject_priv_bid
replace FP_inject_tot_bid =		FP_inject_gov_bid if FP_inject_tot_bid == .
replace  FP_inject_tot_bid =		FP_inject_priv_bid if FP_inject_tot_bid == .

gen ea_code = substr(bid,1,3)

sort ea_code
tempfile bidan_num
save `bidan_num'


***Fees charged

use "Data\B_YK1TYPE", clear

//Childbirth
gen norm_birth_fee_gov_bidx =		byk02a if byk1type == 3
gen norm_birth_fee_priv_bidx = 	byk02b if byk1type == 3
gen ANC_fee_gov_bidx = 			byk02a if byk1type == 2
gen ANC_fee_priv_bidx = 		byk02b if byk1type == 2

foreach x in norm_birth ANC{
	foreach y in gov priv{
		replace `x'_fee_`y'_bidx = . if byk01 == 3
		bys bid: egen `x'_fee_`y'_bid = max(`x'_fee_`y'_bid)
	}
}

keep bid *_bid
duplicates drop

sort bid
tempfile bidan_fee
save `bidan_fee'



use Data\P_TKSTYPE, clear


//Midwives/village midwives
keep if ptkstype == 5 | ptkstype == 6

//Full and part timers combined
gen bidan_count = ptks01
replace bidan_count = bidan_count + ptks02 if ptks02 != .

//Midwives and village midwives combined
by pid: egen bidan_num_pusk = total(bidan_count) 

keep pid bidan_num_pusk
duplicates drop

gen ea_code = substr(pid,1,3)
sort ea_code
merge ea_code using `bidan_num', uniqmaster
tab _m
keep if _m == 3
drop _m

sort ea_code
merge ea_code using `pusk_num_kec', uniqusing
tab _m 
keep if _m == 3
drop _m

sort bid
merge bid using `bidan_fee', sort
tab _m
keep if _m == 3
drop _m

bys ea_code: egen norm_birth_tot_bid_kec_avg = 		mean(norm_birth_tot_bid)
bys ea_code: egen norm_birth_gov_bid_kec_avg = 		mean(norm_birth_gov_bid)
bys ea_code: egen norm_birth_priv_bid_kec_avg = 	mean(norm_birth_priv_bid)
bys ea_code: egen ANC_tot_bid_kec_avg = 			mean(ANC_tot_bid)
bys ea_code: egen ANC_gov_bid_kec_avg = 			mean(ANC_gov_bid)
bys ea_code: egen ANC_priv_bid_kec_avg = 			mean(ANC_priv_bid)
bys ea_code: egen FP_inject_tot_bid_kec_avg =		mean(FP_inject_tot_bid)
bys ea_code: egen FP_inject_gov_bid_kec_avg =		mean(FP_inject_gov_bid)
bys ea_code: egen FP_inject_priv_bid_kec_avg =		mean(FP_inject_priv_bid)


// (Average # service for bidan in each kec) * (# of bidan in a puskesmas in each kec) * (# of puskesmas in each kec)
gen norm_birth_tot_bid_kec_tot = norm_birth_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen norm_birth_gov_bid_kec_tot = norm_birth_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen norm_birth_priv_bid_kec_tot = norm_birth_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

gen ANC_tot_bid_kec_tot = ANC_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen ANC_gov_bid_kec_tot = ANC_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen ANC_priv_bid_kec_tot = ANC_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

gen FP_inject_tot_bid_kec_tot = FP_inject_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen FP_inject_gov_bid_kec_tot = FP_inject_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen FP_inject_priv_bid_kec_tot = FP_inject_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

foreach q in tot gov priv{
	gen FP_inject_fee_`q'_bid = .
}

foreach x in norm_birth ANC{
	gen `x'_gov_qp = `x'_fee_gov_bid * `x'_gov_bid
	gen `x'_priv_qp = `x'_fee_priv_bid * `x'_priv_bid
	egen `x'_tot_qp = rowtotal(`x'_gov_qp `x'_priv_qp)
	replace `x'_tot_qp = . if `x'_gov_qp == . & `x'_priv_qp == .
	gen `x'_fee_tot_bid = `x'_tot_qp / `x'_tot_bid
	egen `x'_fee_tot_bid_alt = rowmean(`x'_fee_gov_bid `x'_fee_priv_bid)
}

foreach x in norm_birth ANC FP_inject{
	foreach y in tot gov priv{
		rename `x'_`y'_bid `x'_`y'_bid_w1
		rename `x'_fee_`y'_bid `x'_fee_`y'_bid_w1
		rename `x'_`y'_bid_kec_tot `x'_`y'_bid_kec_tot_w1
	}
}


keep bid ea_code *_w1
sort bid

gen obs_type = 2

tempfile bidan_info
save `bidan_info'



****Mother fees paid info
//Identifying Askeskin households for exclusion from sample
use Data\R_AKTYPE, clear

keep if raktype == 2
gen askeskin_exclude = 1 if rak02 == 1 | rak02 == 8
keep if askeskin_exclude == 1
keep rid
sort rid

tempfile askeskin_hh
save `askeskin_hh'

use marriedwoman16to49years_w1, clear
sort rid

//Keeping only definite non-askeskin households
cap drop _m*
merge rid using `askeskin_hh', uniqusing
tab _m
keep if _m == 1

gen iid = id 
//Fee mother paid for delivery assisted by midwife at priv or public and at puskesmas
gen norm_birth_fee_tot_moth = ich28 if dummy_B == 1 & (ich24 == 1 | ich24 == 2 | ich24 == 4 | ich24 == 5)
gen norm_birth_fee_pusk_moth = ich28 if dummy_B == 1 & ich24 == 3

gen FP_inject_fee_moth = ikb05_n if ikb03 == 3 & (ikb06 == 4 | ikb06 == 6)

drop dummy_?

//Fee mother paid for prenatal care if ever went to bidan
cap multparse ich08
gen bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?
cap multparse ich10
replace bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?
cap multparse ich12
replace bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?

gen ANC_fee_moth = ich13 if bidan_prenat == 1

//Condensing to one obs per mother for merge to wave 2 info; use average value
foreach x of var norm_birth_fee_tot_moth norm_birth_fee_pusk_moth ANC_fee_moth FP_inject_fee_moth{
	bys id: egen `x'_x = mean(`x')
	replace `x' = `x'_x
	drop `x'_x
	rename `x' `x'_w1
}

gen ea_code = substr(id,1,3)

keep id *fee*w1 iid panel_id_w2 panel_id_w3 ea_code
duplicates drop
gen obs_type = 6
sort id

tempfile mother_bidan_fee_info
save `mother_bidan_fee_info'



********************************************
****Schools
********************************************


**SDs should be missing in Wave I, didn't survey until Wave II

use Data\S, clear


**Ask about SD/SMP classification?
gen school_type = 		"SMP" if (slk05 == 1 | slk05 == 2 | slk05 == 3)
replace school_type = 		"SD" if (slk05 == 4 | slk05 == 5)

keep sid school_type 
keep if school_type == "SMP" | school_type == "SD"

sort sid
tempfile school_type
save `school_type'

*****

//Fees
use Data\S_MSTYPE, clear

sort sid
merge sid using `school_type', uniqusing
tab _m
drop if _m == 1
drop _m

**keeping categories desired
keep if smstype <= 5 | smstype == 8 | smstype == 10 | smstype == 13

**converting to yearly cost
replace sms10 = sms10 * 11 if sms11 == 1
replace sms10 = sms10 / 3 if sms11 == 4 & school_type == "SD"
replace sms10 = sms10 / 6 if sms11 == 4 & school_type == "SMP"

bys sid: egen schoolfees_SD_0607 = total(sms10) if school_type == "SD"
bys sid: egen schoolfees_SMP_0607 = total(sms10) if school_type == "SMP"

keep sid schoolfees_SD_0607 schoolfees_SMP_0607
duplicates drop
sort sid

tempfile school_fee_info
save `school_fee_info'


use Data\S_DS3TYPE, clear

foreach x in sds14a sds14b sds15a sds15b{
	replace `x' = 0 if `x' > .
}

//Generating variables for total number of students registered for each year
**Missings are the same across genders
gen students_0506_class = sds15a + sds15b
gen students_0607_class = sds14a + sds14b

//Combining totals of each class for each school
bys sid: egen students_0506 = total(students_0506_class)
bys sid: egen students_0607 = total(students_0607_class)

bys sid: egen students_0506_max = max(students_0506_class)
bys sid: egen students_0607_max = max(students_0607_class) 

replace students_0506 = . if students_0506_max == .
replace students_0607 = . if students_0607_max == . 

keep sid students_0607 students_0506
duplicates drop

sort sid
merge sid using `school_type', sort
tab _merge
keep if _merge == 3
drop _merge

gen SMP = 1 if school_type == "SMP"
gen SD = 1 if school_type == "SD"

gen ea_code = substr(sid,1,3)
sort ea_code SMP

tempfile school_num
save `school_num'

*****

use Data\cct_schools_verification, clear

//Generating total number of SMP schools in kec
gen SMP = 1
gen number = 1
bys ea_code: egen SMP_num_kec = total(number)
keep ea_code SMP_num_kec SMP
duplicates drop

sort ea_code SMP
merge ea_code SMP using `school_num', uniqmaster
tab _m
drop if _m == 1
tab school_type _m, m
drop _m

sort ea_code
tempfile school_num2
save `school_num2'

//Number of villages per kecamatan
use Data\cct_villages_verification, clear


gen number = 1
bys ea_code: egen desa_num_kec = total(number)
keep ea_code desa_num_kec
duplicates drop


sort ea_code
tempfile desa_per_kec
save `desa_per_kec'

merge ea_code using `school_num2', uniqmaster
tab _m
drop if _m == 1
drop _m

sort ea_code SD
tempfile school_num3
save `school_num3'


*****

//Generating total number of SDs per kec from Wave I info


/*
use "..\Wave I\Private\L_FPD04.dta", clear
sort lid
*/

use "..\Wave I\Data\L_FPDTYPE.dta", clear
sort lid

keep if lfpdtype == 2 | lfpdtype == 3
replace lfpd02 = 0 if lfpd02 > .
replace lfpd03 = 0 if lfpd03 > .
gen lfpd_sum = lfpd02 + lfpd03

gen SD = 1
bys lid: egen SD_num_desa = total(lfpd_sum)
keep lid SD_num_desa SD
duplicates drop

merge lid using "..\Wave I\Data\L.dta", uniqusing _merge(_mz)
tab _mz
drop if _mz == 2


gen ea_code = substr(lid,1,3)



bys ea_code: egen SD_num_desa_kec_avg = mean(SD_num_desa)
keep ea_code SD SD_num_desa_kec_avg
duplicates drop



sort ea_code SD
merge ea_code SD using `school_num3', uniqmaster
tab _m
drop if _m == 1
tab school_type _m, m
drop _m

sort sid
merge sid using `school_fee_info', sort
tab _m

order sid
sort sid

tempfile school_num4
save `school_num4'

****

keep if school_type == "SD" | school_type == "SMP"


foreach x in SMP SD{
	gen students_`x'_0506 = students_0506 if school_type == "`x'"
	gen students_`x'_0607 = students_0607 if school_type == "`x'"
}

bys ea_code: egen students_SMP_0607_kec_avg = mean(students_SMP_0607)
bys ea_code: egen students_SMP_0506_kec_avg = mean(students_SMP_0506)

// (Average # students at SMP in each kec) * (Number of SMPs in each kec)
gen students_SMP_0607_kec_tot = students_SMP_0607_kec_avg * SMP_num_kec
gen students_SMP_0506_kec_tot = students_SMP_0506_kec_avg * SMP_num_kec


bys ea_code: egen students_SD_0607_kec_avg = mean(students_SD_0607) 
bys ea_code: egen students_SD_0506_kec_avg = mean(students_SD_0506) 

// (Average # students at SD in each kec) * (Average # of SD in a village in each kec) * (Number of villages in each kec)
gen students_SD_0607_kec_tot = students_SD_0607_kec_avg * SD_num_desa_kec_avg * desa_num_kec
gen students_SD_0506_kec_tot = students_SD_0506_kec_avg * SD_num_desa_kec_avg * desa_num_kec

foreach x in students_SD_0506 students_SD_0607 students_SMP_0506 students_SMP_0607{
	rename `x' `x'_w1
	rename `x'_kec_tot `x'_kec_tot_w1
	}

foreach x in schoolfees_SD_0607 schoolfees_SMP_0607{
	rename `x' `x'_w1
}

keep sid ea_code *_w1 school_type SD SMP
sort sid

gen obs_type = 3

tempfile school_info
save `school_info'


**School fee info from children
use children6to15years_w1, clear

keep id schoolfees_SD schoolfees_SMP ea_code enroll_SD_w1 enroll_SMP_w1 panel_id_w2 panel_id_w3
sort id

foreach x in schoolfees{
	foreach y in SD SMP{
		replace `x'_`y' = `x'_`y' / 2
		rename `x'_`y' `x'_`y'_sem_w1
	} 
}

gen obs_type = 10

tempfile kids_school_info
save `kids_school_info'


append using `pusk_info'
append using `bidan_info'
append using `school_info'
append using `mother_bidan_fee_info'


label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 6 "Married Woman 16-49 years" 10 "Child 6-15 years"

label values obs_type obs_labelx

gen rid = substr(id,1,3) + "1" + substr(id,5,5) if obs_type == 6 | obs_type == 10
sort rid
tempfile temphhtype
save `temphhtype'

use Data\R, clear

//Generate household type variable
rename rlk12 HH_type

keep rid HH_type
sort rid

merge rid using `temphhtype', uniqmaster
tab _m
tab _m if obs >= 6
drop if _m == 1
drop _m

rename ea_code ea
sort ea
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID
gen ea = Location_ID
sort ea

merge ea using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _m

sort ea


save table_3_5_vars_w1, replace

keep if type == 3

save table_3_5_vars_generasi_w1, replace



}

*****************************************************************************
*****Table 3.3
*****************************************************************************


if `do_3_3' == 1 {

set more off
cd ..\
cd "Wave I"


***Bidan Info

use Data\B_PH02, clear

//Variables for hours spent by bidan on services in previous 3 days

foreach p of var bph02_1 bph02_2 bph02_3{
	replace `p' = 0 if `p' == .w
}
**40 missing expected
gen hours_3days = bph02_1 + bph02_2 + bph02_3

gen nei_out_bidx =			hours_3days if bph_type == 2 | bph_type == 3
bys bid: egen nei_out_3day_bid = 	total(nei_out_bidx)
bys bid: egen nei_out_bid_miss = 	max(nei_out_bidx)
replace nei_out_3day_bid = . if nei_out_bid_miss == .

gen pub_serv_bidx = 			hours_3days if bph_type == 1
gen pri_serv_bidx = 			hours_3days if bph_type == 4
bys bid: egen pub_serv_3day_bid = 	max(pub_serv_bidx)
bys bid: egen pri_serv_3day_bid = 	max(pri_serv_bidx)

gen tot_hrs_bidx =			hours_3days if bph_type == 5
bys bid: egen tot_hrs_3day_bid =	max(tot_hrs_bidx)

gen tot_hrs_3day_bid2 = nei_out_3day_bid + pub_serv_3day_bid + pri_serv_3day_bid
egen tot_hrs_3day_bid3 = rowtotal(nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid)

keep bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid tot_hrs_3day_bid2 tot_hrs_3day_bid3
duplicates drop

count if tot_hrs_3day_bid != tot_hrs_3day_bid3

**Appears to be a number (15) of misadds in the within survey, but in almost all cases
**These two (the first is the within survey tally, the second is ours)
**are the same, so we should count the other missings as zero's too
replace pub_serv_3day_bid = 0 if pub_serv_3day_bid == .
replace pri_serv_3day_bid = 0 if pri_serv_3day_bid == .
replace nei_out_3day_bid = 0 if nei_out_3day_bid == .

drop tot_hrs_3day_bid2 tot_hrs_3day_bid

**different in Wave 2, because everything match up there, so not need this part (also do it in wave 3)
rename tot_hrs_3day_bid3 tot_hrs_3day_bid

sort bid
tempfile bidan_hrs_3days
save `bidan_hrs_3days'

use Data\B, clear

keep bid bpos01 bpos02 bpos04_h bpos04_m bph05* bph06  bph06_v

gen num_pos_1mon_bid = bpos02  
replace num_pos_1mon_bid = 0 if bpos01 == 3


gen hrs_pos_1mon_bid = bpos04_h + bpos04_m/60
replace hrs_pos_1mon_bid = bpos04_h if bpos04_m >= .
replace hrs_pos_1mon_bid = 0 if bpos01 == 3

egen total_reimburse_bid = rsum( bph05a_n bph05b_n bph05c_n)
replace total_reimburse_bid = . if  bph05a==6 & bph05b==6 & bph05c==6 

gen reimburse_bid_fixed = (substr(bph06,1,1)=="D" | substr(bph06,2,1)=="D" | substr(bph06,3,1)=="D" |substr(bph06,4,1)=="D")
replace reimburse_bid_fixed = . if bph06==""| substr(bph06,1,1)=="W" | substr(bph06,2,1)=="Y" 


keep bid num_pos_1mon_bid hrs_pos_1mon_bid *reimburse*
sort bid
tempfile reimburse_bid
save `reimburse_bid'

use Data\B_YK1TYPE, clear

keep if byk1type==3
rename byk02a rate_normaldelivery
replace rate_normaldelivery=. if rate_normaldelivery==.w

keep bid rate_normaldelivery
duplicates drop
sort bid
merge bid using `reimburse_bid'
tab _merge
drop _merge

gen s_reimburse_bid = total_reimburse_bid/rate_normaldelivery
gen s_reimburse_bid_fixed = s_reimburse_bid if reimburse_bid_fixed==1

sort bid
merge bid using `bidan_hrs_3days', sort
tab _m

gen obs_type = 2
gen ea_code = substr(bid,1,3)

tempfile bidan_info
save `bidan_info'


**Teacher info

use Data\S, clear

gen SMP = (slk05 == 1 | slk05 == 2 | slk05 == 3)

keep if SMP == 1

gen teach_pres_SMP_alt = sgr12 / (sgr12 + sgr13) if SMP == 1


gen ea_code = substr(sid,1,3)
sort sid

keep sid SMP ea_code teach_pres_SMP_alt

gen obs_type = 3

tempfile school_info
save `school_info'

***************************
***Puskesmas Info
***************************

use Data\R_RJ2TYPE, clear

//Dropping non-pusk facilities and those for which not know the facility code or tidak berlaku
keep if rrj07_id != "" & rrj07_id != ".w"

//Drop if member of facility visited household member at home
drop if rrj09 == 1

//Drop if not remember how long wait was
drop if rrj13 == 8

gen pid = rrj07_id

gen wait_time = 60*rrj13_uh + rrj13_um

//Generate average wait time for pusk
bys pid: egen ave_min_wait_pusk = mean(wait_time)

keep pid ave_min_wait_pusk
duplicates drop

//Restrict to puskesmas which were surveyed
sort pid
merge pid using Data\P, sort
tab _m
keep if _m == 3
drop _m

keep pid ave_min_wait_pusk

gen obs_type = 1
gen ea_code = substr(pid,1,3)

sort pid

***
append using `bidan_info'
append using `school_info'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School"
label values obs_type obs_labelx

drop _m


foreach x of var num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid teach_pres_SMP_alt ave_min_wait_pusk  rate_normaldelivery total_reimburse_bid reimburse_bid_fixed s_reimburse_bid s_reimburse_bid_fixed{
	rename `x' `x'_w1
}

order ea_code sid bid obs_type *w1

rename ea_code ea
sort ea
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID
gen ea = Location_ID
sort ea

merge ea using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _m

sort ea


save table_3_3_vars_w1, replace

keep if type == 3

save table_3_3_vars_generasi_w1, replace


}



*****************************************************************************
*****Table 3.2
*****************************************************************************

if `do_3_2' == 1 {

set more off
cd ..\
cd "Wave I"

use Data\B, clear

//Water source PAM, pump, well with 10m 
gen water_bid = (bir18 <= 4)
replace water_bid = 0 if bir19 == 3 & (bir20 > 10 & bir20 < .)
replace water_bid = . if bir18 == .

//Electricity
gen electr_bid = (bir22 == 1)
replace electr_bid = . if bir22 == .

sort bid
keep bid water_bid electr_bid
duplicates drop

tempfile bid_infra
save `bid_infra'

**

use Data\B_OV, clear

//Basic essential drugs
keep if bovtype >= 4 & bovtype <= 9
gen number = 1 if bov02 == 1
replace number = 0 if number != 1

bys bid: egen drug_pct_bid = mean(number)

keep bid drug_pct_bid
duplicates drop
sort bid

tempfile bid_drugs
save `bid_drugs'

**

use Data\B_AM, clear

drop if bamtype == 8 | bamtype == 9

//Tools
gen number = 1 if bam01_n > 0 & bam01_n < .
replace number = 0 if bam01_n == 0 | bam01_n > .

bys bid: egen tool_pct_bid = mean(number)

keep bid tool_pct_bid
duplicates drop
sort bid

tempfile bid_tools
save `bid_tools'

merge bid using `bid_infra', sort
tab _m
drop _m

merge bid using `bid_drugs', sort
tab _m
drop _m

gen obs_type = 2
gen ea_code = substr(bid,1,3)

sort bid
tempfile bid_info
save `bid_info'


****

use Data\S, clear


gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SMP == 1

gen classr_num_SMP =	sds08a if SMP == 1

gen denom_total = 0

//Condition of school (tables/chairs, floor, roof)
foreach x of var sol04 sol07 sol09 sol11{
	replace `x' =	. if `x' == 9
	replace `x' = 	0.5 if `x' == 2
	replace `x' =	0 if `x' == 3
	replace denom_total = denom_total + 1 if `x' != .	
}

gen cond_sum = 	sol04 + sol07 + sol09 + sol11
gen cond_school = cond_sum / denom_total

gen cond_SMP = 	cond_school if SMP == 1

gen latrine_pres = 	1 if sol24 == 1
replace latrine_pres = 0 if sol24 == 3

gen latrine_water = 	1 if sol26 == 1
replace latrine_water =	0 if (sol26 == 3 | latrine_pres == 0)

gen latrine_SMP =		latrine_pres if SMP == 1
gen latrine_wat_SMP = 	latrine_water if SMP == 1


keep sid classr_num_SMP SMP cond_SMP latrine_SMP latrine_wat_SMP

gen obs_type = 3
gen ea_code = substr(sid,1,3)

sort sid
tempfile schools_info
save `schools_info'


***************************
***Puskesmas Info
***************************

use Data\P_OV, clear

gen BCG = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 11
replace BCG = 0 if (pov03 == 0) & povtype == 11
gen DPT = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 12
replace DPT = 0 if (pov03 == 0) & povtype == 12
gen DPT_hepB_combo = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 13
replace DPT_hepB_combo = 0 if (pov03 == 0) & povtype == 13
gen polio = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 14
replace polio = 0 if (pov03 == 0) & povtype == 14
gen hepB = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 15
replace hepB = 0 if (pov03 == 0) & povtype == 15
gen measles = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 16
replace measles = 0 if (pov03 == 0) & povtype == 16

*Have 7 values for each type which are legitimately missing (.y, .z)

foreach x of var BCG DPT DPT_hepB_combo polio hepB measles{
	bys pid: egen `x'_miss = max(`x')
}

keep pid *_miss 
duplicates drop

gen DPT_hepB_miss = 1 if (DPT_miss == 1 | hepB_miss == 1)
replace DPT_hepB_miss = 0 if (DPT_miss == 0 & hepB_miss == 0)
replace DPT_hepB_miss = 0 if (DPT_hepB_combo_miss == 0)


egen vacc_min = rowmin(BCG_miss polio_miss  measles_miss DPT_hepB_miss)
egen vacc_max = rowmax(BCG_miss polio_miss  measles_miss DPT_hepB_miss)


**This is based only in last 1 month versus 2 months in Wave II and Wave III, so not directly comparable3
gen			vacc_stock_out_pusk = 1 if (BCG_miss == 1 | polio_miss == 1 | measles_miss == 1 | DPT_hepB_miss == 1)
replace vacc_stock_out_pusk = 0 if (BCG_miss == 0 & polio_miss == 0 & measles_miss == 0 & DPT_hepB_miss == 0)

tab vacc_stock_out vacc_min, m
tab vacc_stock_out vacc_max, m

keep pid vacc_stock_out_pusk 

gen ea_code = substr(pid,1,3)
gen obs_type = 1
sort pid

***

append using `schools_info'
append using `bid_info'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School"
label values obs_type obs_labelx

foreach x of var  tool_pct_bid water_bid electr_bid drug_pct_bid classr_num_SMP cond_SMP latrine_SMP latrine_wat_SMP vacc_stock_out_pusk{
	rename `x' `x'_w1
}

order ea_code bid sid obs_type *w1

rename ea_code ea
sort ea
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID
gen ea = Location_ID
sort ea

merge ea using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _m

sort ea


save table_3_2_vars_w1, replace

keep if type == 3

save table_3_2_vars_generasi_w1, replace

}


*****************************************************************************
*****Table 3.4
*****************************************************************************

if `do_3_4' == 1 {

set more off
cd ..\
cd "Wave I"

**

***************************
***Village Info
***************************

use Data\L, clear
keep lid 

sort lid
merge lid using Data\L_DN, uniqmaster
tab _m
drop _m

//Number of posyandu in the village
replace ldn07 = 0 if ldn07 > .
bys lid: egen pos_num_desa = total(ldn07)
bys lid: egen pos_max_desa = max(ldn07)

keep lid pos_num_desa
duplicates drop

gen ea_code = substr(lid,1,3)
gen obs_type = 5

sort lid
tempfile info_vill
save `info_vill'


***************************
***School Info
***************************

use Data\S, clear

gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SMP == 1

//Number of meetings with parents/teacher with school committee; number of school committee members
gen meet_parents_school = 		sms16c_n
replace meet_parents_school =		0 if sms16c == 3 | sms12 == 3
**All missings are TT or . in sms16c

gen comm_members_school = 		sms14
replace comm_members_school = 	0 if sms12 == 3

gen meet_teachers_school = 		sms16b_n
replace meet_teachers_school = 	0 if sms16b == 3 | sms12 == 3
**All missings are TT or . in sms16b

foreach x in meet_parents comm_members meet_teachers{
	gen `x'_SMP =	`x'_school if SMP == 1
	drop `x'_school
}

keep sid *_SMP SMP

gen ea_code = substr(sid,1,3)
gen obs_type = 3

sort sid
tempfile info_school
save `info_school'

**

***************************
***Household Info
***************************

use Data\R, clear

//No community activities available in last 12 months or not participation in last 12 months
gen hh_part = 0 if (rpm10 == 3 | rpm10a == 3)

keep rid hh_part
sort rid

merge rid using Data\R_PM14, uniqmaster
tab _m
//drop _m

//Person hours from HH for participation in gotong royong
gen hours = rpm15_n * rpm15_h
replace hours = 0 if rpm14 == 3

bys rid: egen hours_part_hh = 	total(hours)
bys rid: egen hours_max_hh =		max(hours)

replace hours_part_hh = . if hours_max_hh == .
replace hours_part_hh = 0 if hh_part == 0

keep rid hours_part_hh
duplicates drop

gen obs_type = 8

sort rid
tempfile hours_part_hh
save `hours_part_hh'

**

use Data\R_PM02, clear

gen number = 1
bys rid: egen num_groups_hh = total(number)

keep rid num_groups_hh
duplicates drop
sort rid

merge rid using Data\R, sort
tab _m

gen member_group = 0

foreach x in a b c d e f g h i v{
	replace member_group = 1 if rpm01`x' == 1
}

replace num_groups_hh = 0 if member_group == 0 & num_groups_hh == .

gen ea_code = substr(rid,1,3)

keep rid num_groups_hh ea_code

gen obs_type = 8

sort rid
tempfile num_groups_hh
save `num_groups_hh'

merge rid using `hours_part_hh', sort
tab _m
drop _m

order rid hours_part_hh num_groups_hh ea_code obs_type

tempfile info_hh
save `info_hh'

***************************
*** Main respondent info
***************************

use Data\R_PM02, clear

//Number of meeting main respondent participated in (only have rpm07 if rpm06 == 1)

bys rid: egen any_particip = min(rpm06)
bys rid: egen num_meetings_mainresp = total(rpm07), missing

keep rid any_particip num_meetings_mainresp
duplicates drop

codebook num_meetings_mainresp if any_particip == 1
codebook num_meetings_mainresp if any_particip != 1 

replace num_meetings_mainresp = 0 if any_particip == 3

drop any_particip

sort rid

merge rid using Data\R, sort
tab _m
drop if _m == 2
drop _m

keep num_meetings rid rresp_cd
sort rid

drop if rresp_cd == .
tostring rresp_cd, replace format(%02.0f)

gen iid = rid + rresp_cd
order iid

gen ea_code = substr(iid,1,3)

gen obs_type = 11

gen id = iid if obs_type == 11
sort id obs_type

tempfile info_resp
save `info_resp'

***************************
***Survey Date Info
***************************


use Data\R, clear

//Generate survey dates using first survey attempt with at least partial completion
gen survey_date=mdy(rivw_mm_1, rivw_dd_1, rivw_yy_1) if rhkw_1==1 | rhkw_1==2
replace survey_date=mdy(rivw_mm_2, rivw_dd_2, rivw_yy_2) if survey_date==. & rhkw_2==1 | rhkw_2==2
replace survey_date=mdy(rivw_mm_3, rivw_dd_3, rivw_yy_3) if survey_date==. & rhkw_3==1 | rhkw_3==2

gen survey_month = ym(rivw_yy_1, rivw_mm_1) if rhkw_1==1 | rhkw_1==2
replace survey_month= ym(rivw_yy_2, rivw_mm_2) if survey_month==. & rhkw_2==1 | rhkw_2==2
replace survey_month= ym(rivw_yy_3, rivw_mm_3) if survey_month==. & rhkw_3==1 | rhkw_3==2

keep rid survey_date survey_month
sort rid

tempfile survey_date_info
save `survey_date_info'

***

***************************
***Kids(0-36mons) Info
***************************

use Data\T, clear

gen KIA_kid = (tim03 == 1)
replace KIA_kid = . if tim03 == 8
gen KMS_kid = (tim01 == 1)
replace KMS_kid = . if tim01 == 8

gen rid = substr(tid,1,3) + "1" + substr(tid,5,5)

sort rid
merge rid using `survey_date_info', uniqusing _merge(_m2)
tab _m2
drop if _m2 == 2


//Replace missing days with 15 if neither month nor year values for children's birth dates missing
replace tir03_dd=15 if tir03_dd==. & tir03_mm!=. & tir03_yy!=.

//Replace nonleap year February 29's with February 28's
replace tir03_dd=28 if tir03_dd==29 & tir03_mm==2 & tir03_yy!=2004

//Generate birth dates
gen birth_date=mdy(tir03_mm, tir03_dd, tir03_yy)

//Generate age at time of survey
gen age = survey_date - birth_date
gen age_mons = floor(age / 30.4375)
gen age_years = floor(age / 365.25)

//Keeping only observations within desired age range (0-36 months)
keep if age >= 0 & age <= 1095.75

keep tid rid KIA KMS age 

gen ea_code = substr(tid,1,3)
gen obs_type = 7

tempfile KIA_KMS_kids
save `KIA_KMS_kids'

tempfile info_kids
save `info_kids'

***************************
***Woman Info
***************************

use Data\R, clear

//Any household member who participates in gov group (including the respondent, which what interested in)
gen hh_memb_part_gov_group = (rpm01f == 1)

sort rid

merge rid using Data\R_AR_01, uniqmaster
tab _m

//Keeping only respondents to the household survey
keep if rresp_cd == rar00

//Whether respondent is female or not
gen female_resp = (rar03 == 3)

keep rid hh_memb_part_gov_group female_resp rar00
duplicates drop

sort rid
tempfile resp_woman
save `resp_woman'

use Data\R_PM02, clear

//Numbers of government groups main respondent participated in
gen gov_group = 1 if (rpm04 == 6 & rpm06 == 1)


//Number of government and women's group meetings main respondent participated in
gen num_meetings = rpm07
gen num_gov_meetings = rpm07 if gov_group == 1

bys rid:egen num_gov_groups = total(gov_group)

keep rid num_gov_groups num_gov_meetings
duplicates drop
sort rid


merge rid using `resp_woman', uniqusing
tab _m
drop _m

//Keeping only female respondents
keep if female_resp == 1

bys rid: egen gov_meetings_wom = total(num_gov_meetings)
bys rid: egen min_gov_meetings_wom = min(num_gov_meetings)
replace gov_meetings_wom = . if min_gov_meetings_wom == .
replace gov_meetings_wom = 0 if num_gov_groups == 0 & gov_meetings_wom == .
replace gov_meetings_wom = 0 if hh_memb_part_gov_group == 0 & gov_meetings_wom == .

tostring rar00, replace format(%02.0f)

gen iid = rid + rar00
replace iid = substr(iid,1,3) + "2" + substr(iid,5,7) + rar00
order iid

keep rid iid gov_meetings_wom
duplicates drop

gen ea_code = substr(iid,1,3)
gen obs_type = 9

sort iid

tempfile info_wom
save `info_wom'

**

append using `info_vill'
append using `info_school'
append using `info_hh'
append using `info_kids'
append using `info_resp'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 4 "Posyandu" 5 "Desa" 6 "Married Woman 16-49 years" 7 "Child 0-36 months" 8 "Household" 9 "Woman" 11 "Household respondent"
label values obs_type obs_labelx

order sid lid iid tid rid ea_code obs_type *_SMP *_desa *_kid *_hh *_wom 

foreach x of var  meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp{
	rename `x' `x'_w1
}

gen panel_id_w2 	= substr(tid,1,4) + substr(tid,5,5) + "00" + substr(tid,10,2) if obs_type == 7
replace panel_id_w2 	= substr(iid,1,4) + substr(iid,5,5) + "00" + substr(iid,10,2) if obs_type == 9 | obs_type == 10 | obs_type == 11

gen panel_id_w3 	= substr(tid,1,4) + substr(tid,5,5) + "00" + "00" + substr(tid,10,2) if obs_type == 7
replace panel_id_w3 	= substr(iid,1,4) + substr(iid,5,5) + "00" + "00" + substr(iid,10,2) if obs_type == 9 | obs_type == 10 | obs_type == 11

gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00" if obs_type == 8
gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00" if obs_type == 8

sort rid
tempfile xx
save `xx'
***************************************
use Data\R, clear

//Generate household type variable
rename rlk12 HH_type

keep rid HH_type
sort rid

merge rid using `xx', uniqmaster
tab _m
tab _m if obs >= 6
drop if _m == 1
drop _m

***************************************



rename ea_code ea
sort ea
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID
gen ea = Location_ID
sort ea

merge ea using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _m

sort ea


save table_3_4_vars_w1, replace

keep if type == 3

save table_3_4_vars_generasi_w1, replace

}



**Next: check on panel_id_w2 for crosswave merge stuff for hhresp (obs_type 11)
