clear
set more off


cd "Wave III"

local do_3_1 = 1
local do_3_2 = 1
local do_3_3 = 1
local do_3_4 = 1
local do_3_5 = 1


**Bidan Sampling Type Information
use "..\Wave I\Data\B", clear

gen sample_type = blk12
keep bid sample_type

sort bid
tempfile bid_type_w1
save `bid_type_w1'

*****************************************************************************
*****Table 3.1
*****************************************************************************

if `do_3_1' == 1 {

set more off
cd ..\
cd "Wave III"



***************************
***Village Info
***************************



use Data\L, clear

duplicates drop
duplicates drop lid, force

gen panel = (lcov3 == 1)

keep lid panel
sort lid
tempfile vill_info
save `vill_info'

**

use Data\L_FKS1TYPE, clear

//Whether bidan practices in the village or not
gen bid_pract_desax = 		1 if lfks1type == 3 & lfks02 == 1
replace bid_pract_desax =	0 if lfks1type == 3 & lfks02 == 3

bys lid: egen bid_pract_desa = max(bid_pract_desax)

keep lid bid_pract_desa
duplicates drop

sort lid
tempfile bid_vill
save `bid_vill'

**

use Data\L_DN, clear

//Number of posyandu in the village
replace ldn07 = 0 if ldn07 >= .
bys lid: egen pos_num_desa = total(ldn07)
bys lid: egen pos_max_desa = max(ldn07)

keep lid pos_num_desa
duplicates drop

sort lid
tempfile pos_vill
save `pos_vill'


**

use Data\L_FPDTYPE, clear

//Presence of SD and SMP in village (including satu atap, terbuka, and klas jauh)

replace lfpd02 = "" if lfpd02 == "TT"
destring lfpd02, replace
destring lfpd03, replace

gen subtotal = lfpd02
replace subtotal = lfpd02 + lfpd03 if lfpd03!= .

gen SD_pres_desax = subtotal if lfpdtype == 2 | lfpdtype == 3 | lfpdtype == 4
gen SMP_pres_desax = subtotal if lfpdtype == 5 | lfpdtype == 6 | lfpdtype == 7 | lfpdtype == 8 | lfpdtype == 9 
bys lid: egen SD_pres_desa = total(SD_pres_desax)
bys lid: egen SMP_pres_desa = total(SMP_pres_desax)
replace SD_pres_desa = 1 if SD_pres_desa >= 1 & SD_pres_desa < .
replace SMP_pres_desa = 1 if SMP_pres_desa >= 1 & SD_pres_desa < .
 

keep lid SD_pres_desa SMP_pres_desa
duplicates drop

sort lid
tempfile school_vill
save `school_vill'

merge lid using `vill_info', sort
tab _m
drop _m

merge lid using `bid_vill', sort
tab _m
drop _m

merge lid using `pos_vill', sort
tab _m
drop _m


gen obs_type = 5
gen ea_code = substr(lid,1,3)

tempfile nums_desa
save `nums_desa'


****

***************************
***School Info
***************************


use Data\S, clear

duplicates drop
duplicates drop sid, force

gen panel = (scov3 == 1)

gen SD = (slk05 == 4 | slk05 == 5)
gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SD == 1 | SMP == 1
keep SD SMP panel sid

tempfile school_info
save `school_info'

**Return with new data
/*
use Data\S_GR03, clear

//Drop teachers if moved or on pension
drop if sgr04a == 2

gen number = 1
gen number_perm = 1 if sgr06 == 1
bys sid: egen teach_num_school = total(number)
bys sid: egen teach_num_school_perm = total(number_perm)

keep sid teach_num_school*
duplicates drop

sort sid
merge sid using `school_info', sort
tab _m
drop _m

gen teach_num_SD = 	teach_num_school if SD == 1
gen teach_num_SMP =	teach_num_school if SMP == 1

gen teach_num_SD_perm = teach_num_school_perm if SD == 1
gen teach_num_SMP_perm = teach_num_school_perm if SMP == 1

drop teach_num_school*
*/
gen obs_type = 3
gen ea_code = substr(sid,1,3)

sort sid

tempfile nums_school
save `nums_school'

****

***************************
***Puskesmas Info
***************************

use "..\Wave I\Data\P", clear
gen wave1_pop = pip02c

keep wave1_pop pid
sort pid

tempfile pusk_pop
save `pusk_pop'

use Data\P, clear

gen panel_2007 = (pcov3 == 1)
replace panel_2007 = . if pcov3 == .
gen panel_2008 = (pcov3 == 3)
replace panel_2008 = . if pcov3 == .
gen panel = (pcov3 == 1 | pcov3 == 3)
replace panel = . if pcov3 == .

keep pid panel* 
duplicates drop
sort pid

merge pid using Data\P_TKSTYPE, uniqmaster
tab _m
drop if _m == 1


gen count_full = ptks01 if ptkstype <= 9
gen count_all = ptks01 + ptks02 if ptkstype <= 9 

bys pid: egen personnel_fullt_pusk = total(count_full)
bys pid: egen personnel_all_pusk = total(count_all)

gen bid_full = ptks01 if ptkstype == 5 | ptkstype == 6
gen bid_all = ptks01 + ptks02 if ptkstype == 5 | ptkstype == 6

bys pid: egen bidan_full_pusk = total(bid_full)
bys pid: egen bidan_all_pusk = total(bid_all)

keep pid personnel* bidan*
duplicates drop

gen obs_type = 1
gen ea_code = substr(pid,1,3)
sort pid

merge pid using `pusk_pop', sort
tab _m
drop if _m == 2
drop _m 

gen bid_full_pop_ratio_pusk = bidan_full_pusk / wave1_pop
gen bid_all_pop_ratio_pusk = bidan_all_pusk / wave1_pop

sort pid

****

append using `nums_school'
append using `nums_desa'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 4 "Posyandu" 5 "Desa"
label values obs_type obs_labelx

foreach x of var bid_pract_desa pos_num_desa SD_pres_desa SMP_pres_desa /*teach_num_SD teach_num_SMP teach_num_SD_perm teach_num_SMP_perm*/ personnel_fullt_pusk personnel_all_pusk bidan_full_pusk bidan_all_pusk bid_full_pop_ratio_pusk bid_all_pop_ratio_pusk{
	rename `x' `x'_w3
}

order ea_code lid sid obs_type *w3

gen ea = ea_code
gen Location_ID = ea_code
sort Location_ID
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

merge Location_ID using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _merge

sort ea

save table_3_1_vars_w3, replace

keep if type == 3

save table_3_1_vars_generasi_w3, replace

}

*****************************************************************************
*****Table 3.2
*****************************************************************************

if `do_3_2' == 1 {

set more off
cd ..\
cd "Wave III"

***************************
***Bidan Info
***************************

use Data\B, clear

duplicates drop bid, force

gen panel_2007 = (bcov3 == 1)
replace panel_2007 = . if bcov3 == .
gen panel_2008 = (bcov3 == 2)
replace panel_2008 = . if bcov3 == .
gen panel = (bcov3 == 1 | bcov3 == 2)
replace panel = . if bcov3 == .


keep bid panel* bir10 bir16b bir18 bir19 bir20 bir22 

**All missings but one explained by bir16b == 3 (Not have private service)


destring bir20, replace


//Water source PAM, pump, well with 10m 

gen water_bid = (bir18 <= 4)
replace water_bid = 0 if bir19 == 3 & (bir20 > 10 & bir20 < .)
replace water_bid = . if bir18 == .


//Electricity

gen electr_bid = (bir22 == 1)
replace electr_bid = . if bir22 == .

sort bid
keep bid water_bid electr_bid panel*
duplicates drop

tempfile bid_infra
save `bid_infra'

**

//Basic essential drugs

use Data\B_OV, clear

keep if bovtype >= 4 & bovtype <= 9
gen number = 1 if bov02 == 1
replace number = 0 if number != 1

bys bid: egen drug_pct_bid = mean(number)

keep bid drug_pct_bid
duplicates drop
sort bid

tempfile bid_drugs
save `bid_drugs'

**

//Oxytocin

use Data\B_OV, clear

keep if bovtype == 11

duplicates drop bid, force

gen oxytocin_bid = 1 if bov02 == 1
replace oxytocin_bid = 0 if bov02 != 1

keep bid oxytocin_bid
sort bid

tempfile bid_oxytocin
save `bid_oxytocin'

**

//Tools

use Data\B_AM, clear

drop if bamtype == 8 | bamtype == 9

gen number = 1 if bam01_n > 0 & bam01_n < .
replace number = 0 if bam01_n == 0 | bam01_n > .

bys bid: egen tool_pct_bid = mean(number)

keep bid tool_pct_bid
duplicates drop
sort bid

tempfile bid_tools
save `bid_tools'

**

//Partograph use

use Data\B_YK04,clear

duplicates tag bid, gen(tag)
drop if tag == 5
drop tag

gen parto_use = (byk08a == 1)

gen parto_opp = 1
bys bid: egen parto_use_sum = total(parto_use)
bys bid: egen parto_opp_sum = total(parto_opp)

gen parto_proportion = parto_use_sum / parto_opp_sum

keep bid parto_proportion
duplicates drop
sort bid

tempfile bid_parto
save `bid_parto'

**

//Antenatal care service items

use Data\B_PK01, clear

duplicates drop bid bpk01a_row, force


gen antenatal_care_denom = 15
gen antenatal_care_numer = 0

foreach x in a b c d e f g h i j k l m n o{
	replace antenatal_care_numer = antenatal_care_numer + 1 if bpk01`x' == 1
}

gen antenat_care_public = antenatal_care_numer / antenatal_care_denom if bpk01a_row == 1	
gen antenat_care_private = antenatal_care_numer / antenatal_care_denom if bpk01a_row == 2

bys bid: egen ante_care_publ = max(antenat_care_public)
bys bid: egen ante_care_priv = max(antenat_care_private)

keep bid ante_care_*
duplicates drop
sort bid

tempfile bid_ante
save `bid_ante'

*************

merge bid using `bid_parto', sort
tab _m
drop _m

merge bid using `bid_tools',sort
tab _m
drop _m

merge bid using `bid_infra', sort
tab _m
drop _m

merge bid using `bid_drugs', sort
tab _m
drop _m

merge bid using `bid_oxytocin', sort
tab _m
drop _m


gen obs_type = 2
gen ea_code = substr(bid,1,3)

sort bid
merge bid using `bid_type_w1', sort
tab _m panel, m
drop if _m == 2
drop _m

replace sample_type = 3 if panel == 0

sort bid
tempfile bid_info
save `bid_info'

****

***************************
***School Info
***************************

use Data\S, clear

gen panel_2007 = (scov3 == 1)
replace panel_2007 = . if scov3 == .
gen panel_2008 = (scov3 == 2)
replace panel_2008 = . if scov3 == .
gen panel = (scov3 == 1 | scov3 == 2)
replace panel = . if scov3 == .

gen SD = (slk05 == 4 | slk05 == 5)
gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SD == 1 | SMP == 1

gen classr_num_SD =	sds08a if SD == 1
gen classr_num_SMP =	sds08a if SMP == 1

//Condition of school (tables/chairs, floor, wall, roof)

gen denom_total = 0

foreach x of var sol04 sol07 sol09 sol11{
	replace `x' =	. if `x' == 9
	replace `x' = 	0.5 if `x' == 2
	replace `x' =	0 if `x' == 3
	replace denom_total = denom_total + 1 if `x' != .
}

gen cond_sum = 	sol04 + sol07 + sol09 + sol11
gen cond_school = cond_sum / denom_total

gen cond_SD = 	cond_school if SD == 1
gen cond_SMP = 	cond_school if SMP == 1


gen latrine_pres = 	1 if sol24 == 1
replace latrine_pres = 0 if sol24 == 3


gen latrine_SD = 		latrine_pres if SD == 1
gen latrine_SMP =		latrine_pres if SMP == 1


keep sid panel* classr_num_SD classr_num_SMP SD SMP cond_SD cond_SMP latrine_SD latrine_SMP 

gen obs_type = 3
gen ea_code = substr(sid,1,3)

sort sid
tempfile schools_info
save `schools_info'


***************************
***Puskesmas Info
***************************
use Data\P, clear

gen panel_2007 = (pcov3 == 1)
replace panel_2007 = . if pcov3 == .
gen panel_2008 = (pcov3 == 3)
replace panel_2008 = . if pcov3 == .
gen panel = (pcov3 == 1 | pcov3 == 3)
replace panel = . if pcov3 == .

keep pid panel* 
duplicates drop
sort pid

merge pid using Data\P_OV, uniqmaster
tab _m
drop if _m == 1

gen BCG = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 11
replace BCG = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 11
gen DPT = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 12
replace DPT = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 12
gen DPT_hepB_combo = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 13
replace DPT_hepB_combo = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 13
gen polio = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 14
replace polio = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 14
gen hepB = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 15
replace hepB = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 15
gen measles = 1 if ((pov03 > 0 & pov03 < .) | pov02 == 6 | pov02 == 3) & povtype == 16
replace measles = 0 if (pov03 == 0 | (pov02a == 3 & pov02 != 3)) & povtype == 16

foreach x of var BCG DPT DPT_hepB_combo polio hepB measles{
	bys pid: egen `x'_miss = max(`x')
}

keep pid *_miss panel*
duplicates drop

gen DPT_hepB_miss = 1 if (DPT_miss == 1 | hepB_miss == 1)
replace DPT_hepB_miss = 0 if (DPT_miss == 0 & hepB_miss == 0)
replace DPT_hepB_miss = 0 if (DPT_hepB_combo_miss == 0)


egen vacc_min = rowmin(BCG_miss polio_miss  measles_miss DPT_hepB_miss)
egen vacc_max = rowmax(BCG_miss polio_miss  measles_miss DPT_hepB_miss)

gen			vacc_stock_out_pusk = 1 if (BCG_miss == 1 | polio_miss == 1 | measles_miss == 1 | DPT_hepB_miss == 1)
replace vacc_stock_out_pusk = 0 if (BCG_miss == 0 & polio_miss == 0 & measles_miss == 0 & DPT_hepB_miss == 0)

tab vacc_stock_out vacc_min, m
tab vacc_stock_out vacc_max, m

keep pid vacc_stock_out_pusk panel*

gen ea_code = substr(pid,1,3)
gen obs_type = 1
sort pid

****

append using `schools_info'
append using `bid_info'


label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School"
label values obs_type obs_labelx

foreach x of var  tool_pct_bid water_bid electr_bid drug_pct_bid oxytocin_bid classr_num_SD classr_num_SMP cond_SD cond_SMP latrine_SD latrine_SMP vacc_stock_out ante_care_publ ante_care_priv parto_proportion{
	rename `x' `x'_w3
}

order ea_code bid sid obs_type *w3

gen ea = ea_code
gen Location_ID = ea_code
sort Location_ID
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3

gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

merge Location_ID using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _merge


sort ea

save table_3_2_vars_w3, replace

keep if type == 3

save table_3_2_vars_generasi_w3, replace

}

*****************************************************************************
*****Table 3.5
*****************************************************************************

if `do_3_5' == 1 {

set more off
cd ..\
cd "Wave III"

**********************************************
****Puskesmas
**********************************************

**Fees
use Data\P_KF2TYPE, clear

gen norm_birth_fee_puskx = pkf04 if pkf2type == 5
replace norm_birth_fee_puskx = . if pkf03 == 3 

bys pid: egen norm_birth_fee_pusk = max(norm_birth_fee_puskx)

keep pid norm_birth_fee_pusk
duplicates drop

gen ea_code = substr(pid,1,3)
sort ea_code

**All 185 missings because pfk03 == 3 (service not provided)

tempfile pusk_fee
save `pusk_fee'


**Quantities
use Data\P, clear

gen panel_2007 = (pcov3 == 1)
replace panel_2007 = . if pcov3 == .
gen panel_2008 = (pcov3 == 3)
replace panel_2008 = . if pcov3 == .
gen panel = (pcov3 == 1 | pcov3 == 3)
replace panel = . if pcov3 == .

//Number of assisted normal births in puskesmas
gen norm_birth_pusk = plg10n

keep pid norm_birth_pusk panel*
duplicates report

gen ea_code = substr(pid,1,3)
sort ea_code

duplicates tag ea_code, gen(tag)
drop if tag == 1 & norm_birth_pusk == .
drop tag
duplicates report ea

tempfile pusk_num
save `pusk_num'

use "..\Wave I\Data\cct_puskesmas_verification", clear

//Number of puskesmas in kec
gen number = 1
bys ea_code: egen pusk_num_kec = total(number)
keep ea_code pusk_num_kec
duplicates drop
sort ea_code
tempfile pusk_num_kec
save `pusk_num_kec'

merge ea_code using `pusk_num', sort
tab _m
keep if _m == 3
drop _m

merge ea_code using `pusk_fee', sort
tab _m
keep if _m == 3
drop _m

//Number of assisted normal births in kec
//(Number of puskesmas in each kec) * (number of normal births in a puskesmas in each kec)
gen norm_birth_pusk_kec_tot = pusk_num * norm_birth_pusk

foreach x in norm_birth_pusk{
	rename `x' `x'_w3
	rename `x'_kec_tot `x'_kec_tot_w3
}

rename norm_birth_fee_pusk norm_birth_fee_pusk_w3

order pid ea_code *_w3
keep pid ea_code *_w3 panel*
sort pid	

gen obs_type = 1

tempfile pusk_info
save `pusk_info'



***************************************
****Bidans
***************************************

//Whether panel or not
use Data\B, clear
keep bid bcov3
gen panel_2007 = (bcov3 == 1) if bcov3 != .
gen panel_2008 = (bcov3 == 2) if bcov3 != .
gen panel = (bcov3 == 1 | bcov3 == 2) if bcov3 != .

duplicates drop bid, force

sort bid
tempfile bidan_panel_info
save `bidan_panel_info'


use Data\B_LG, clear

duplicates drop bid blg2type, force


//Generating variables for number of bidan normal child births in previous month
gen norm_birth_govx =		blg02a if blg2type == 15
gen norm_birth_privx =		blg02b if blg2type == 15

//Generating variables for bidan ANC in previous month
gen ANC_gov1x =			blg02a if blg2type == 9
gen ANC_gov2x =			blg02a if blg2type == 10
gen ANC_priv1x =			blg02b if blg2type == 9
gen ANC_priv2x =			blg02b if blg2type == 10

//Very small number of true "." missings versus ".w", ".x", etc.
foreach x of var norm_birth_govx norm_birth_privx ANC_gov1x ANC_gov2x ANC_priv1x ANC_priv2x{
	replace `x' = 0 if `x' > .
}

gen ANC_govx = 			ANC_gov1x + ANC_gov2x
replace ANC_govx = 		ANC_gov1x if ANC_govx == .
replace ANC_govx =		ANC_gov2x if ANC_gov1x == .
gen ANC_privx =			ANC_priv1x + ANC_priv2x 
replace ANC_privx = 		ANC_priv1x if ANC_privx == .
replace ANC_privx = 		ANC_priv2x if ANC_privx == .

//Generating variable for bidan family planning in previous month
gen FP_inject_govx =			blg02a if blg2type == 23
gen FP_inject_privx =			blg02b if blg2type == 23
	
order bid norm_birth* ANC* FP*

foreach x in norm_birth_gov norm_birth_priv ANC_gov ANC_priv FP_inject_gov FP_inject_priv{
	bys bid: egen `x'_bid = max(`x'x)
}


drop *x blg*
duplicates drop
sort bid

gen norm_birth_tot_bid = 		norm_birth_gov_bid + norm_birth_priv_bid
replace norm_birth_tot_bid =	 	norm_birth_gov_bid if norm_birth_tot_bid == .
replace norm_birth_tot_bid = 		norm_birth_priv_bid if norm_birth_tot_bid == .

gen ANC_tot_bid = 			ANC_gov_bid + ANC_priv_bid
replace ANC_tot_bid =			ANC_gov_bid if ANC_tot_bid == .
replace ANC_tot_bid = 			ANC_priv_bid if ANC_tot_bid == .

gen FP_inject_tot_bid =			FP_inject_gov_bid + FP_inject_priv_bid
replace FP_inject_tot_bid =		FP_inject_gov_bid if FP_inject_tot_bid == .
replace  FP_inject_tot_bid =		FP_inject_priv_bid if FP_inject_tot_bid == .

gen ea_code = substr(bid,1,3)

sort ea_code
tempfile bidan_num
save `bidan_num'


***Fees charged

use "Data\B_YK1TYPE", clear


duplicates drop bid byk1type, force
destring byk1type, replace

//Childbirth
gen norm_birth_fee_gov_bidx =		byk02a if byk1type == 3
gen norm_birth_fee_priv_bidx = 	byk02b if byk1type == 3
gen ANC_fee_gov_bidx = 			byk02a if byk1type == 2
gen ANC_fee_priv_bidx = 		byk02b if byk1type == 2
gen FP_inject_fee_gov_bidx =		byk02a if byk1type == 13
gen FP_inject_fee_priv_bidx = 	byk02b if byk1type == 13

foreach x in norm_birth ANC FP_inject{
	foreach y in gov priv{
		replace `x'_fee_`y'_bidx = . if byk01 == 3
		bys bid: egen `x'_fee_`y'_bid = max(`x'_fee_`y'_bid)
	}
}

keep bid *_bid
duplicates drop

sort bid
tempfile bidan_fee
save `bidan_fee'


use "Data\P_TKSTYPE", clear

//Midwives/village midwives
keep if ptkstype == 5 | ptkstype == 6

//Full and part timers combined
gen bidan_count = ptks01
replace bidan_count = bidan_count + ptks02 if ptks02 < .

//Midwives and village midwives combined
bys pid: egen bidan_num_pusk = total(bidan_count)

keep pid bidan_num_pusk
duplicates drop

gen ea_code = substr(pid,1,3)
sort ea_code
merge ea_code using `bidan_num', uniqmaster
tab _m
keep if _m == 3
drop _m

sort ea_code
merge ea_code using `pusk_num_kec', uniqusing
tab _m 
keep if _m == 3
drop _m

sort bid
merge bid using `bidan_fee', sort
tab _m
keep if _m == 3
drop _m



bys ea_code: egen norm_birth_tot_bid_kec_avg = 		mean(norm_birth_tot_bid)
bys ea_code: egen norm_birth_gov_bid_kec_avg = 		mean(norm_birth_gov_bid)
bys ea_code: egen norm_birth_priv_bid_kec_avg = 	mean(norm_birth_priv_bid)
bys ea_code: egen ANC_tot_bid_kec_avg = 			mean(ANC_tot_bid)
bys ea_code: egen ANC_gov_bid_kec_avg = 			mean(ANC_gov_bid)
bys ea_code: egen ANC_priv_bid_kec_avg = 			mean(ANC_priv_bid)
bys ea_code: egen FP_inject_tot_bid_kec_avg =		mean(FP_inject_tot_bid)
bys ea_code: egen FP_inject_gov_bid_kec_avg =		mean(FP_inject_gov_bid)
bys ea_code: egen FP_inject_priv_bid_kec_avg =		mean(FP_inject_priv_bid)


// (Average # service for bidan in each kec) * (# of bidan in a puskesmas in each kec) * (# of puskesmas in each kec)
gen norm_birth_tot_bid_kec_tot = norm_birth_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen norm_birth_gov_bid_kec_tot = norm_birth_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen norm_birth_priv_bid_kec_tot = norm_birth_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

gen ANC_tot_bid_kec_tot = ANC_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen ANC_gov_bid_kec_tot = ANC_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen ANC_priv_bid_kec_tot = ANC_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

gen FP_inject_tot_bid_kec_tot = FP_inject_tot_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen FP_inject_gov_bid_kec_tot = FP_inject_gov_bid_kec_avg * bidan_num_pusk * pusk_num_kec
gen FP_inject_priv_bid_kec_tot = FP_inject_priv_bid_kec_avg * bidan_num_pusk * pusk_num_kec

foreach x in norm_birth ANC FP_inject{
	gen `x'_gov_qp = `x'_fee_gov_bid * `x'_gov_bid
	gen `x'_priv_qp = `x'_fee_priv_bid * `x'_priv_bid
	egen `x'_tot_qp = rowtotal(`x'_gov_qp `x'_priv_qp)
	replace `x'_tot_qp = . if `x'_gov_qp == . & `x'_priv_qp == .
	gen `x'_fee_tot_bid = `x'_tot_qp / `x'_tot_bid
	egen `x'_fee_tot_bid_alt = rowmean(`x'_fee_gov_bid `x'_fee_priv_bid)
}

foreach x in norm_birth ANC FP_inject{
	foreach y in tot gov priv{ 
		rename `x'_`y'_bid `x'_`y'_bid_w3
		rename `x'_fee_`y'_bid `x'_fee_`y'_bid_w3
		rename `x'_`y'_bid_kec_tot `x'_`y'_bid_kec_tot_w3
	}
}


keep bid ea_code *_w3

gen obs_type = 2

sort bid
merge bid using `bidan_panel_info', sort
tab _m
drop if _m == 2
drop _m

sort bid
merge bid using `bid_type_w1', sort
tab _m panel, m
drop if _m == 2
drop _m

replace sample_type = 3 if panel_2007 == 0


tempfile bidan_info
save `bidan_info'


****Mother fees paid info
//Identifying Askeskin households for exclusion from sample
use Data\R_AKTYPE, clear

keep if raktype == 2
gen askeskin_exclude = 1 if rak02 == 1 | rak02 == 8
keep if askeskin_exclude == 1
keep rid
sort rid

tempfile askeskin_hh
save `askeskin_hh'

use marriedwoman16to49years_w3, clear
sort rid

//Keeping only definite non-askeskin households
merge rid using `askeskin_hh', uniqusing
tab _m
keep if _m == 1

gen iid = id

//Fee mother paid for delivery assisted by midwife at priv or public and at puskesmas
gen norm_birth_fee_tot_moth = ich28 if dummy_B == 1 & (ich24 == 1 | ich24 == 2 | ich24 == 4 | ich24 == 5)
gen norm_birth_fee_pusk_moth = ich28 if dummy_B == 1 & ich24 == 3

gen FP_inject_fee_moth = ikb05_n if ikb03 == 3 & (ikb06 == 4 | ikb06 == 6)

drop dummy_?

//Fee mother paid for prenatal care if ever went to bidan
cap multparse ich08
gen bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?
cap multparse ich10
replace bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?
cap multparse ich12
replace bidan_prenat = 1 if (_D == 1 | _F == 1)
drop _?

gen ANC_fee_moth = ich13 if bidan_prenat == 1

foreach x of var norm_birth_fee_tot_moth norm_birth_fee_pusk_moth ANC_fee_moth FP_inject_fee_moth{
	rename `x' `x'_w3
}

keep id panel_id_w3 panel_hh panel_hh_id *w3 iid rid panel_2007 panel_2008
gen obs_type = 6
gen ea_code = substr(id,1,3)
sort id

tempfile mother_bidan_fee_info
save `mother_bidan_fee_info'

********************************************
****Schools
********************************************


use Data\S, clear

gen panel_2007 = (scov3 == 1) if scov3 != .
gen panel_2008 = (scov3 == 2) if scov3 != .
gen panel = (scov3 == 1 | scov3 == 2) if scov3 != .

duplicates drop sid, force


gen school_type = 		"SMP" if (slk05 == 1 | slk05 == 2 | slk05 == 3)
replace school_type = 		"SD" if (slk05 == 4 | slk05 == 5)

keep sid school_type panel
keep if school_type == "SMP" | school_type == "SD"

sort sid
tempfile school_type
save `school_type'

*****

//Fees
use Data\S_MSTYPE, clear

sort sid
merge sid using `school_type', uniqusing
tab _m
drop if _m == 1
drop _m

**keeping categories desired
keep if smstype <= 5 | smstype == 8 | smstype == 10 | smstype == 13

**converting to yearly cost
replace sms10 = sms10 * 11 if sms11 == 1
replace sms10 = sms10 / 3 if sms11 == 4 & school_type == "SD"
replace sms10 = sms10 / 6 if sms11 == 4 & school_type == "SMP"

bys sid: egen schoolfees_SD_0809 = total(sms10) if school_type == "SD"
bys sid: egen schoolfees_SMP_0809 = total(sms10) if school_type == "SMP"

keep sid schoolfees_SD_0809 schoolfees_SMP_0809
duplicates drop
sort sid

tempfile school_fee_info
save `school_fee_info'


use Data\S_DS3TYPE, clear

foreach x in sds13a_a sds13a_b{
	replace `x' = 0 if `x' > .
}

//Generating variables for total number of students registered for each year
**Missings are the same across genders
gen students_0910_class = sds13a_a + sds13a_b

//Combining totals of each class for each school
bys sid: egen students_0910 = total(students_0910_class)

bys sid: egen students_0910_max = max(students_0910_class)

replace students_0910 = . if students_0910_max == .

keep sid students_0910
duplicates drop

sort sid
merge sid using `school_type', sort
tab _merge
keep if _merge == 3
drop _merge

sort sid
tempfile school_ynum
save `school_ynum'

use Data\S_DS4TYPE, clear

foreach x in sds14a sds14b{
	replace `x' = 0 if `x' > .
}

//Generating variables for total number of students registered for each year
**Missings are the same across genders
gen students_0809_class = sds14a + sds14b

//Combining totals of each class for each school
bys sid: egen students_0809 = total(students_0809_class)

bys sid: egen students_0809_max = max(students_0809_class) 

replace students_0809 = . if students_0809_max == . 

keep sid students_0809
duplicates drop

sort sid
merge sid using `school_ynum', sort
tab _merge
keep if _merge == 3
drop _merge

gen SMP = 1 if school_type == "SMP"
gen SD = 1 if school_type == "SD"

gen ea_code = substr(sid,1,3)
sort ea_code SMP

tempfile school_num
save `school_num'


*****

use "..\Wave I\Data\cct_schools_verification", clear

//Generating total number of SMP schools in kec
gen SMP = 1
gen number = 1
bys ea_code: egen SMP_num_kec = total(number)
keep ea_code SMP_num_kec SMP
duplicates drop

sort ea_code SMP
merge ea_code SMP using `school_num', uniqmaster
tab _m
drop if _m == 1
tab school_type _m, m
drop _m

sort ea_code
tempfile school_num2
save `school_num2'


//Number of villages per kecamatan
use "..\Wave I\Data\cct_villages_verification", clear

gen number = 1
bys ea_code: egen desa_num_kec = total(number)
keep ea_code desa_num_kec
duplicates drop


sort ea_code
tempfile desa_per_kec
save `desa_per_kec'


**Wait for new data to have this info back
merge ea_code using `school_num2', uniqmaster
tab _m
drop if _m == 1
drop _m

sort ea_code SD
tempfile school_num3
save `school_num3'


*****

//Generating total number of SDs per kec from Wave I info


use "..\Wave I\Data\L_FPDTYPE.dta", clear
sort lid

keep if lfpdtype == 2 | lfpdtype == 3
replace lfpd02 = 0 if lfpd02 > .
replace lfpd03 = 0 if lfpd03 > .
gen lfpd_sum = lfpd02 + lfpd03

gen SD = 1
bys lid: egen SD_num_desa = total(lfpd_sum)
keep lid SD_num_desa SD
duplicates drop

merge lid using "..\Wave I\Data\L.dta", uniqusing _merge(_mz)
tab _mz
drop if _mz == 2



gen ea_code = substr(lid,1,3)


bys ea_code: egen SD_num_desa_kec_avg = mean(SD_num_desa)
keep ea_code SD SD_num_desa_kec_avg
duplicates drop


sort ea_code SD
merge ea_code SD using `school_num3', uniqmaster
tab _m
drop if _m == 1
tab school_type _m, m
drop _m


sort sid
merge sid using `school_fee_info', sort
tab _m

order sid
sort sid

tempfile school_num4
save `school_num4'

****

keep if school_type == "SD" | school_type == "SMP"

foreach x in SMP SD{
	gen students_`x'_0910 = students_0910 if school_type == "`x'"
	gen students_`x'_0809 = students_0809 if school_type == "`x'"
}

bys ea_code: egen students_SMP_0910_kec_avg = mean(students_SMP_0910) 
bys ea_code: egen students_SMP_0809_kec_avg = mean(students_SMP_0809)

// (Average # students at SMP in each kec) * (Number of SMPs in each kec)
gen students_SMP_0910_kec_tot = students_SMP_0910_kec_avg * SMP_num_kec
gen students_SMP_0809_kec_tot = students_SMP_0809_kec_avg * SMP_num_kec


bys ea_code: egen students_SD_0910_kec_avg = mean(students_SD_0910) 
bys ea_code: egen students_SD_0809_kec_avg = mean(students_SD_0809)

// (Average # students at SD in each kec) * (Average # of SD in a village in each kec) * (Number of villages in each kec)
gen students_SD_0910_kec_tot = students_SD_0910_kec_avg * SD_num_desa_kec_avg * desa_num_kec
gen students_SD_0809_kec_tot = students_SD_0809_kec_avg * SD_num_desa_kec_avg * desa_num_kec

foreach x in students_SD_0910 students_SD_0809 students_SMP_0910 students_SMP_0809{
	rename `x' `x'_w3
	rename `x'_kec_tot `x'_kec_tot_w3
}

foreach x in schoolfees_SD_0809 schoolfees_SMP_0809{
	rename `x' `x'_w3
}

keep sid ea_code *_w3 school_type SD SMP panel
sort sid

gen obs_type = 3

tempfile school_info
save `school_info'

**School fee info from children
use children6to15years_w3, clear

keep id schoolfees_SD schoolfees_SMP panel_hh panel_hh_id panel_id_w3 ea_code enroll_SD_w3 enroll_SMP_w3 rid age_years panel_2007 panel_2008
sort id

foreach x in schoolfees{
	foreach y in SD SMP{
		replace `x'_`y' = `x'_`y' / 2
		rename `x'_`y' `x'_`y'_sem_w3
	} 
}

gen obs_type = 10

tempfile kids_school_info
save `kids_school_info'



*********************************************************
***Posyandu
*********************************************************
use Data\K_JPTYPE, clear

**If don't provide the service, we make zeros okay?

//Number of times at last posyandu occurrence for each
gen kids_weix = kjp03_n if kjptype == 1
replace kids_weix = 0 if kjp02 == 3 & kjptype == 1

gen kids_fedx = kjp03_n if kjptype == 2
replace kids_fedx = 0 if kjp02 == 3 & kjptype == 2

gen kids_immx = kjp03_n if kjptype == 3
replace kids_immx = 0 if kjp02 == 3 & kjptype == 3

gen ANCx = kjp03_n if kjptype == 4
replace ANCx = 0 if kjp02 == 3 & kjptype == 4

gen kids_ironx = kjp03_n if kjptype == 5
replace kids_ironx = 0 if kjp02 == 3 & kjptype == 5

gen kids_vitAx = kjp03_n if kjptype == 6
replace kids_vitAx = 0 if kjp02 == 3 & kjptype == 6

gen FP_pillx = kjp03_n if kjptype == 7
replace FP_pillx = 0 if kjp02 == 3 & kjptype == 7

gen FP_injectx = kjp03_n if kjptype == 8
replace FP_injectx = 0 if kjp02 == 3 & kjptype == 8

//All Tidak Tahus
local counter = 1
foreach x in kids_wei kids_fed kids_imm ANC kids_iron kids_vitA FP_pill FP_inject{
	codebook kjp03 if `x'x== . & kjptype == `counter'
	local counter = `counter' + 1
}


foreach x in kids_wei kids_fed kids_imm ANC kids_iron kids_vitA FP_pill FP_inject{
	bys kid: egen `x'_pos = max(`x'x)
}

keep kid *_pos
duplicates report
duplicates drop	

sort kid
tempfile posyandu_num
save `posyandu_num'


use Data\K, clear

duplicates drop kid, force

//All posyandu new in 2008, so none panel_2007
gen panel_2007 = 0
gen panel_2008 = (kcov3 == 1) if kcov3 != .
gen panel = (kcov3 == 1) if kcov3 != .


gen visit_fee_pos = kjp01_n

keep kid kidp03 visit_fee_pos  panel*

merge kid using `posyandu_num', sort
tab _m
drop _m


gen ea_code = substr(kid,1,3)

sort ea_code
tempfile posyandu_num2
save `posyandu_num2'


//Calculating number of posyandu per village
use Data\L, clear

duplicates drop lid, force

gen ea_code = substr(lid,1,3)

keep lid ea_code 
sort lid
tempfile xx
save `xx'

use Data\L_DN
sort lid
merge lid using `xx', uniqusing
tab _m
drop _m


bys lid: egen pos_num_desa = total(ldn07)
keep lid ea_code pos_num_desa
duplicates drop

bys ea_code: egen pos_num_desa_kec_avg = mean(pos_num_desa)

keep ea_code pos_num_desa_kec_avg
duplicates drop

sort ea_code
merge ea_code using `posyandu_num2', uniqmaster
tab _m
keep if _m == 3
drop _m

sort ea_code

merge ea_code using `desa_per_kec', uniqusing
tab _m
drop if _m == 2
drop _m

foreach x in kids_wei kids_fed kids_imm ANC kids_iron kids_vitA FP_pill FP_inject{
	bys ea_code: egen `x'_pos_kec_avg = mean(`x'_pos)
}

// (Average # kids weighed at a posyandu in each kec) * (Average # of posyandu in a village in each kec) * (Number of villages in each kec)
foreach x in kids_wei kids_fed kids_imm ANC kids_iron kids_vitA FP_pill FP_inject{
	gen `x'_pos_kec_tot = `x'_pos_kec_avg * pos_num_desa_kec_avg * desa_num_kec
}

foreach x in kids_wei kids_fed kids_imm ANC kids_iron kids_vitA FP_pill FP_inject{
	rename `x'_pos `x'_pos_w3
	rename `x'_pos_kec_tot `x'_pos_kec_tot_w3
}

rename visit_fee_pos visit_fee_pos_w3

sort kid

keep kid ea_code *_w3 panel*

gen obs_type = 4



tempfile posyandu_info
save `posyandu_info'


append using `pusk_info'
append using `bidan_info'
append using `school_info'
append using `kids_school_info'
append using `mother_bidan_fee_info'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 4 "Posyandu" 6 "Married Woman 16-49 years" 10 "Child 6-15 years"
label values obs_type obs_labelx

sort rid
tempfile xx
save `xx'

***************************************
use Data\R, clear

//Generate household type variable
rename rlk12 HH_type

keep rid HH_type rar00x
duplicates drop
sort rid

merge rid using `xx', uniqmaster
tab _m
tab _m if obs >= 6
drop if _m == 1
drop _m

***************************************

gen ea = ea_code
gen Location_ID = ea_code
sort Location_ID
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

merge Location_ID using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _merge

sort ea

save table_3_5_vars_w3, replace

keep if type == 3

save table_3_5_vars_generasi_w3, replace

}


*****************************************************************************
*****Table 3.3
*****************************************************************************

if `do_3_3' == 1 {

set more off
cd ..\
cd "Wave III"

***************************
***Bidan Info
***************************

use Data\B, clear

keep bid bir10 bph01
sort bid

duplicates drop bid, force
sort bid

merge bid using Data\B_PH02, uniqmaster
tab _m
drop if _m == 1
drop _m

//Variables for hours spent by bidan on services in previous 3 days

foreach p of var bph02_1 bph02_2 bph02_3{
	replace `p' = 0 if `p' == .w
}

**187-190 missing expected
gen hours_3days = bph02_1 + bph02_2 + bph02_3

gen nei_out_bidx =			hours_3days if bph_type == 2 | bph_type == 3
bys bid: egen nei_out_3day_bid = 	total(nei_out_bidx)
bys bid: egen nei_out_bid_miss = 	max(nei_out_bidx)
replace nei_out_3day_bid = . if nei_out_bid_miss == .

gen pub_serv_bidx = 			hours_3days if bph_type == 1
gen pri_serv_bidx = 			hours_3days if bph_type == 4
bys bid: egen pub_serv_3day_bid = 	max(pub_serv_bidx)
bys bid: egen pri_serv_3day_bid = 	max(pri_serv_bidx)

gen tot_hrs_bidx =			hours_3days if bph_type == 5
bys bid: egen tot_hrs_3day_bid =	max(tot_hrs_bidx)

gen tot_hrs_3day_bid2 = nei_out_3day_bid + pub_serv_3day_bid + pri_serv_3day_bid
egen tot_hrs_3day_bid3 = rowtotal(nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid)

keep bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid tot_hrs_3day_bid2 tot_hrs_3day_bid3 bph01 bir10
duplicates drop

count if tot_hrs_3day_bid != tot_hrs_3day_bid3
replace pub_serv_3day_bid = 0 if pub_serv_3day_bid == .
replace pri_serv_3day_bid = 0 if pri_serv_3day_bid == .
replace nei_out_3day_bid = 0 if nei_out_3day_bid == .

drop tot_hrs_3day_bid2 tot_hrs_3day_bid

rename tot_hrs_3day_bid3 tot_hrs_3day_bid 

sort bid
tempfile bidan_hrs_3days
save `bidan_hrs_3days'


use Data\B, clear

duplicates drop bid, force

gen panel_2007 = (bcov3 == 1)
replace panel_2007 = . if bcov3 == .
gen panel_2008 = (bcov3 == 2)
replace panel_2008 = . if bcov3 == .
gen panel = (bcov3 == 1 | bcov3 == 2)
replace panel_2008 = . if bcov3 == .

gen ea_code = substr(bid,1,3)

keep bid bpos01 bpos02 bpos04_h bpos04_m panel* ea_code bph06d bph06d_n bph06e bph06e_n bph06f bph06f_n

gen num_pos_1mon_bid = bpos02  
replace num_pos_1mon_bid = 0 if bpos01 == 3


gen hrs_pos_1mon_bid = bpos04_h + bpos04_m/60
replace hrs_pos_1mon_bid = bpos04_h if bpos04_m >= .
replace hrs_pos_1mon_bid = 0 if bpos01 == 3

gen incentive_bid = bph06d_n if bph06d==1
gen incentive_bid_bpercent = bph06e_n if bph06e==1  
gen incentive_bid_bnpatient = bph06f_n if bph06f==1

replace incentive_bid_bpercent = 0 if incentive_bid_bpercent==.
replace incentive_bid = 0 if incentive_bid == .
replace incentive_bid_bnpatient = 0 if incentive_bid_bnpatient==.

keep bid num_pos_1mon_bid hrs_pos_1mon_bid panel* ea_code incentive*
sort bid

tempfile reimburse_bid
save `reimburse_bid'

use Data\B_YK1TYPE, clear

keep if byk1type=="3"
rename byk02a rate_normaldelivery
replace rate_normaldelivery=. if rate_normaldelivery==.w

keep bid rate_normaldelivery
duplicates drop
sort bid
merge bid using `reimburse_bid'
tab _merge
drop _merge

sort bid
merge bid using `bidan_hrs_3days', sort
tab _m
drop _m

sort bid
merge bid using `bid_type_w1', sort
tab _m panel_2007
drop if _m == 2
drop _m

replace sample_type = 3 if panel_2007 == 0

gen obs_type = 2

tempfile bidan_info
save `bidan_info'



***************************
***Teacher Info
***************************

use Data\S, clear

duplicates drop sid, force


gen panel_2007 = (scov3 == 1)
replace panel_2007 = . if scov3 == .
gen panel_2008 = (scov3 == 2)
replace panel_2008 = . if scov3 == .
gen panel = (scov3 == 1 | scov3 == 2)
replace panel = . if scov3 == .

gen SD = (slk05 == 4 | slk05 == 5)
gen SMP = (slk05 == 1 | slk05 == 2 | slk05 == 3)

keep if SD == 1 | SMP == 1

gen teach_pres_SD_alt = sgr12 / (sgr12 + sgr13) if SD == 1
gen teach_pres_SMP_alt = sgr12 / (sgr12 + sgr13) if SMP == 1

gen ea_code = substr(sid,1,3)
sort sid

gen pct_teach = (sol27 == 1)
replace pct_teach = . if sol27 == .

gen pct_teach_SD = 	pct_teach if SD == 1
gen pct_teach_SMP =	pct_teach if SMP == 1

keep sid SD SMP ea_code teach_pres_SD* teach_pres_SMP* pct_teach_SD pct_teach_SMP panel*

gen obs_type = 3

sort sid
tempfile teach_nums
save `teach_nums'



use Data\S_GR03, clear

//Drop teachers if moved or on pension
drop if sgr04a == 2

gen teach_presn = (sgr09a == 1)
replace teach_presn = . if sgr09a == 98 | sgr09a == 99 | sgr09a == 2

gen teach_presy = (sgr09a == 1)
replace teach_presy = . if sgr09a == 98 | sgr09a == 99 

bys sid: egen teach_pres_2noinc = mean(teach_presn)
bys sid: egen teach_pres_2yesinc = mean(teach_presy)

keep sid teach_pres_2*
duplicates drop
 
sort sid
merge sid using `teach_nums', sort
tab _m
drop _m

gen teach_pres_SD_2noinc = teach_pres_2noinc if SD == 1
gen teach_pres_SD_2yesinc = teach_pres_2yesinc if SD == 1
gen teach_pres_SMP_2noinc = teach_pres_2noinc if SMP == 1
gen teach_pres_SMP_2yesinc = teach_pres_2yesinc if SMP == 1
drop teach_pres_2*


tempfile school_info
save `school_info'


***************************
***Puskesmas Info
***************************

use Data\P_TKS04, clear

//Drop small number of complete duplicates
duplicates drop

//Dropping one empty obs
drop if ptks06 == .

//Dropping if status is tranfer/retired
drop if ptks07a == 2

//Keeping only obs for providers assigned to community health centre (don't have info on presence for those at auxiliary centre or village maternity hut)
keep if ptks09 == 1
gen provider_pres = (ptks09a == 1)

bys pid: egen provider_pres_pusk = mean(provider_pres) 

keep pid provider_pres_pusk
duplicates drop


tempfile prov_abs_pusk
save `prov_abs_pusk'

**

use Data\R_RJ2TYPE, clear

//Dropping non-pusk facilities and those for which not know the facility code or tidak berlaku
keep if rrj07_id != "" & rrj07_id != "EX" & rrj07_id != "TB" & rrj07_id != "TT"

//Drop if member of facility visited household member at home
drop if rrj09 == 1

//Drop if not remember how long wait was
drop if rrj13 == 8

gen pid = rrj07_id

gen wait_time = 60*rrj13_uh + rrj13_um

//Generate average wait time for pusk
bys pid: egen ave_min_wait_pusk = mean(wait_time)

keep pid ave_min_wait_pusk
duplicates drop

//Restrict to puskesmas which were surveyed
sort pid
merge pid using Data\P, sort
tab _m
keep if _m == 3
drop _m


keep pid ave_min_wait_pusk 

sort pid
merge pid using `prov_abs_pusk', sort
tab _m
drop _m

sort pid
merge pid using Data\P, uniqusing
tab _m
drop if _m == 2
drop _m


gen panel_2007 = (pcov3 == 1)
replace panel_2007 = . if pcov3 == .
gen panel_2008 = (pcov3 == 3)
replace panel_2008 = . if pcov3 == .
gen panel = (pcov3 == 1 | pcov3 == 3)
replace panel = . if pcov3 == .

keep pid ave_min_wait_pusk provider_pres_pusk panel* 

gen obs_type = 1
gen ea_code = substr(pid,1,3)
sort pid

***

append using `bidan_info'
append using `school_info'

label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School"
label values obs_type obs_labelx

foreach x of var num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid teach_pres_SD_2noinc teach_pres_SD_2yesinc teach_pres_SD_alt teach_pres_SMP_2noinc teach_pres_SMP_2yesinc teach_pres_SMP_alt pct_teach_SD pct_teach_SMP provider_pres_pusk ave_min_wait_pusk  rate_normaldelivery incentive_bid incentive_bid_bpercent incentive_bid_bnpatient {
	rename `x' `x'_w3
}

order ea_code sid bid obs_type *w3

gen ea = ea_code
gen Location_ID = ea_code

sort Location_ID
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

merge Location_ID using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _merge

sort ea

save table_3_3_vars_w3, replace

keep if type == 3

save table_3_3_vars_generasi_w3, replace

}




*****************************************************************************
*****Table 3.4
*****************************************************************************

if `do_3_4' == 1 {

set more off
cd ..\
cd "Wave III"

**
**********************************************************
**Linking individuals (kids and women) across waves info
**********************************************************

use Data\R_AR_01, clear
duplicates drop

tostring rar00_07 rar00, replace format(%02.0f)
gen id = substr(rid,1,3) + "2" + substr(rid,5,9) + rar00
gen obs_type = 6

keep rar00 rar00_07 rar01a id obs_type rid

sort id obs_type
tempfile women_merge1
save `women_merge1'

replace obs_type = 9

sort id obs_type
tempfile women_merge2
save `women_merge2'

replace id = substr(id,1,3) + "4" + substr(id,5,9) + rar00
replace obs_type = 7

sort id obs_type
tempfile kid_merge
save `kid_merge'


***************************
***Village Info
***************************

use Data\L, clear
keep lid lcov3

duplicates drop lid, force

gen panel = (lcov3 == 1)

sort lid
merge lid using Data\L_DN, uniqmaster
tab _m
drop _m

//Number of posyandu in the village
replace ldn07 = 0 if ldn07 > .
bys lid: egen pos_num_desa = total(ldn07)
bys lid: egen pos_max_desa = max(ldn07)

keep lid pos_num_desa panel
duplicates drop

gen ea_code = substr(lid,1,3)
gen obs_type = 5

sort lid
tempfile info_vill
save `info_vill'


**

***************************
***Posyandu Info
***************************

use Data\K, clear

//Number of meetings, kader posyandu, sweepings
gen meet_num_pos 	= 		kidp03
gen kader_num_pos = 		kidp04
gen sweep_num_pos = 		kidp06
replace sweep_num_pos =		0 if kidp05 == 3

keep kid meet_num_pos kader_num_pos sweep_num_pos

gen ea_code = substr(kid,1,3)
gen obs_type = 4

sort kid
tempfile info_pos
save `info_pos'

**

***************************
***School Info
***************************

use Data\S, clear

gen panel_2007 = (scov3 == 1)
replace panel_2007 = . if scov3 == .
gen panel_2008 = (scov3 == 2)
replace panel_2008 = . if scov3 == .
gen panel = (scov3 == 1 | scov3 == 2)
replace panel = . if scov3 == .

gen SD = (slk05 == 4 | slk05 == 5)
gen SMP = (slk05 == 1 | slk05 == 2| slk05 == 3)

keep if SD == 1 | SMP == 1

//Number of meetings with parents/teacher with school committee; number of school committee members
gen meet_parents_school = 		sms16_cn
replace meet_parents_school =		0 if sms16_c == 3 | sms12 == 3

gen comm_members_school = 		sms14
replace comm_members_school = 	0 if sms12 == 3

gen meet_teachers_school = 		sms16_bn
replace meet_teachers_school = 	0 if sms16_b == 3 | sms12 == 3

foreach x in meet_parents comm_members meet_teachers{
	gen `x'_SD = 	`x'_school if SD == 1
	gen `x'_SMP =	`x'_school if SMP == 1
	drop `x'_school
}

keep sid panel* *_SD *_SMP SD SMP

gen ea_code = substr(sid,1,3)
gen obs_type = 3

sort sid
tempfile info_school
save `info_school'

**

***************************
***Household Info
***************************

use Data\R, clear

//No community activities available in last 12 months or not participation in last 12 months
gen hh_part = 0 if (rpm10 == 3 | rpm10a == 3)

**return to this if need, don't have the 2007/2008 type distinction
gen panel = (rar00x == 1 | rar00x == 2)

keep rid hh_part panel
duplicates drop

sort rid

merge rid using Data\R_PM14, uniqmaster
tab _m

//Person hours from HH for participation in gotong royong
gen hours = rpm15_n * rpm15_h
replace hours = 0 if rpm14 == 3

bys rid: egen hours_part_hh = 	total(hours)
bys rid: egen hours_max_hh =		max(hours)

replace hours_part_hh = . if hours_max_hh == .
replace hours_part_hh = 0 if hh_part == 0

keep rid hours_part_hh panel
duplicates drop

gen obs_type = 8

sort rid
tempfile hours_part_hh
save `hours_part_hh'

**

use Data\R_PM02, clear

gen number = 1
bys rid: egen num_groups_hh = total(number)

keep rid num_groups_hh
duplicates drop
sort rid
tempfile xyz
save `xyz'

use Data\R, clear
duplicates drop rid, force
merge rid using `xyz', sort
tab _m


gen member_group = 0

foreach x in a b c d e f g h i v{
	replace member_group = 1 if rpm01`x' == 1
}

replace num_groups_hh = 0 if member_group == 0 & num_groups_hh == .


gen panel = (rar00x == 1 | rar00x == 2)
gen ea_code = substr(rid,1,3)


//Participation in 2009 general election
gen elec09_part_hh = 1 if rpm24 == 1
replace elec09_part_hh = 0 if rpm24 == 3

keep rid num_groups_hh elec09_part_hh panel ea_code

gen obs_type = 8

sort rid
tempfile num_groups_hh
save `num_groups_hh'

**

//Households view services as improved in last 2 years

use Data\R_PM3TYPE, clear

gen health_serv = (rpm29 == 1) if rpm3type == 1
gen educ_serv = (rpm29 == 1) if rpm3type == 2

bys rid: egen health_serv_improve_hh = max(health_serv)
bys rid: egen educ_serv_improve_hh = max(educ_serv)

drop *_serv

keep rid health educ
duplicates drop

gen obs_type = 8
sort rid

merge rid using `hours_part_hh', sort
tab _m
drop _m

sort rid

merge rid using `num_groups_hh'
tab _m
drop _m

order rid hours_part_hh num_groups_hh health_serv_improve_hh educ_serv_improve_hh panel ea_code obs_type

tempfile info_hh
save `info_hh'

***************************
*** Main respondent info
***************************

use Data\R_PM02, clear

//Number of meeting main respondent participated in (only have rpm07 if rpm06 == 1)

bys rid: egen any_particip = min(rpm06)
bys rid: egen num_meetings_mainresp = total(rpm07), missing

keep rid any_particip num_meetings_mainresp
duplicates drop

codebook num_meetings_mainresp if any_particip == 1
codebook num_meetings_mainresp if any_particip != 1 

replace num_meetings_mainresp = 0 if any_particip == 3

drop any_particip

sort rid
tempfile xyz
save `xyz'

use Data\R, clear
duplicates drop rid, force
merge rid using `xyz', sort
tab _m
drop if _m == 1
drop _m

**Be careful with this, this is just an approximation b/c in panel_hh, more because if this panel = 0 then woman can't be panel, but could be in panel_hh but not be a panel_obs
gen panel = (rar00x == 1 | rar00x == 2)
replace panel = . if rar00x == .

keep num_meetings panel rid rresp_cd
sort rid

drop if rresp_cd == .
tostring rresp_cd, replace format(%02.0f)

gen iid = rid + rresp_cd
order iid

gen ea_code = substr(iid,1,3)

gen obs_type = 11

gen id = iid if obs_type == 11

sort id obs_type

tempfile info_resp
save `info_resp'


***************************
***Survey Date Info
***************************
use Data\R, clear

//Generate survey dates
gen survey_start_day = substr(rstart_d,1,2)
destring survey_start_day, replace 
gen survey_start_mon = substr(rstart_d,4,2)
destring survey_start_mon, replace 
gen survey_start_year = substr(rstart_d,7,2)
destring survey_start_year, replace 
replace survey_start_year = survey_start_year + 2000

gen survey_finish_day = substr(rfinish_d,1,2)
destring survey_finish_day, replace 
gen survey_finish_mon = substr(rfinish_d,4,2)
destring survey_finish_mon, replace 
gen survey_finish_year = substr(rfinish_d,7,2)
destring survey_finish_year, replace 
replace survey_finish_year = survey_finish_year + 2000

gen survey_start_date=	mdy(survey_start_mon, survey_start_day, survey_start_year) 
gen survey_finish_date=	mdy(survey_finish_mon, survey_finish_day, survey_finish_year)
gen survey_days_elapse = survey_finish_date - survey_start_date

summ survey_days_elapse, d

gen survey_date = survey_start_date
gen survey_month = ym(survey_start_year, survey_start_mon) 

drop survey_start* survey_finish*


keep rid survey_date survey_month
duplicates drop
sort rid

tempfile survey_date_info
save `survey_date_info'

***

***************************
***Kids(0-36mons) Info
***************************

use Data\T, clear

duplicates drop tid, force

gen panel_2007 = (tcov3 == 1)
replace panel_2007 = . if tcov3 == .
gen panel_2008 = (tcov3 == 3)
replace panel_2008 = . if tcov3 == .
gen panel = (tcov3 == 1 | tcov3 == 3)
replace panel = . if tcov3 == .

gen KIA_kid = (tim03 == 1)
replace KIA_kid = . if tim03 == 8
gen KMS_kid = (tim01 == 1)
replace KMS_kid = . if tim01 == 8

gen rid = substr(tid,1,3) + "1" + substr(tid,5,9)

sort rid
merge rid using `survey_date_info', uniqusing _merge(_m2)
tab _m2
drop if _m2 == 2


//Replace missing days with 15 if neither month nor year values for children's birth dates missing
replace tir03_dd=15 if tir03_dd==. & tir03_mm!=. & tir03_yy!=.

//Replace nonleap year February 29's with February 28's
replace tir03_dd=28 if tir03_dd==29 & tir03_mm==2 & tir03_yy!=2004 & tir03_yy != 2008

//Generate birth dates
gen birth_date=mdy(tir03_mm, tir03_dd, tir03_yy)

//Generate age at time of survey
gen age = survey_date - birth_date
gen age_mons = floor(age / 30.4375)
gen age_years = floor(age / 365.25)

//Keeping only observations within desired age range (0-36 months)
keep if age >= 0 & age <= 1095.75

keep tid rid KIA KMS age panel*

gen ea_code = substr(tid,1,3)
gen obs_type = 7

tempfile KIA_KMS_kids
save `KIA_KMS_kids'


**

use Data\T, clear

duplicates drop tid, force 

gen panel_2007 = (tcov3 == 1)
replace panel_2007 = . if tcov3 == .
gen panel_2008 = (tcov3 == 3)
replace panel_2008 = . if tcov3 == .
gen panel = (tcov3 == 1 | tcov3 == 3)
replace panel = . if tcov3 == .

gen health_ed_pos_kid = (tpos19 == 1)
replace health_ed_pos_kid = . if tpos19 == . & tpos01 == .
replace health_ed_pos_kid = 0 if tpos01 == 3

gen rid = substr(tid,1,3) + "1" + substr(tid,5,9)

sort rid
merge rid using `survey_date_info', uniqusing _merge(_m2)
tab _m2
drop if _m2 == 2

//Replace missing days with 15 if neither month nor year values for children's birth dates missing
replace tir03_dd=15 if tir03_dd==. & tir03_mm!=. & tir03_yy!=.

//Replace nonleap year February 29's with February 28's
replace tir03_dd=28 if tir03_dd==29 & tir03_mm==2 & tir03_yy!=2004 & tir03_yy != 2008

//Generate birth dates
gen birth_date=mdy(tir03_mm, tir03_dd, tir03_yy)

//Generate age at time of survey
gen age = survey_date - birth_date
gen age_mons = floor(age / 30.4375)
gen age_years = floor(age / 365.25)

//Keeping only observations within desired age range (0-36 months)
keep if age >= 0 & age <= 1095.75

keep tid rid health_ed_pos_kid age panel*

gen ea_code = substr(tid,1,3)
gen obs_type = 7

sort tid
tempfile health_ed_kids
save `health_ed_kids'


use `KIA_KMS_kids', clear
merge tid using `health_ed_kids', sort
tab _m
drop _m


************
gen id 	= tid if obs_type == 7

sort id obs_type
merge id obs_type using `kid_merge', uniqmaster _merge(_ind_roster_info_merge3)
tab _ind_roster_info_merge3 obs_type, m
drop if _ind_roster_info_merge3 == 2

************

tempfile info_kids
save `info_kids'


***************************
***Mothers Info
***************************


use births_18_okay_w3, clear
keep iid
duplicates drop

tempfile preg_list18_id
save `preg_list18_id'

**

//Creating variables for health education to mothers for last pregnancy and delivery

use Data\I, clear


duplicates drop iid, force

gen panel_2007 = (icov3 == 1)
replace panel_2007 = . if icov3 == .
gen panel_2008 = (icov3 == 2)
replace panel_2008 = . if icov3 == .
gen panel = (icov3 == 1 | icov3 == 2)
replace panel = . if icov3 == .

multparse ich37 preg
multparse ich45 delv

gen health_ed_preg_moth = (preg_C == 1)
replace health_ed_preg_moth = . if ich36 >= 8

gen health_ed_delv_moth = (delv_C == 1)
replace health_ed_delv_moth = . if ich44 >= 8

keep iid panel* health_ed*

gen obs_type = 6
gen ea_code = substr(iid,1,3)

//Keeping mothers with pregnancy within the last 18 months
sort iid
merge iid using `preg_list18_id', sort
tab _m
keep if _m == 3
drop _m


**********

gen id = iid if obs_type == 6
gen rid = substr(iid,1,3) + "1" + substr(iid,5,9)

sort id obs_type
merge id obs_type using `women_merge1', uniqmaster _merge(_ind_roster_info_merge1)
tab _ind_roster_info_merge1 obs_type, m
drop if _ind_roster_info_merge1 == 2

**********

tempfile info_mothers
save `info_mothers'

***************************
***Woman Info
***************************

use Data\R, clear
duplicates drop rid, force

//Any household member who participates in gov group (including the respondent, which what interested in)
gen hh_memb_part_gov_group = (rpm01f == 1)
replace hh_memb_part_gov_group = . if rpm01f == .

//Any household member who participates in any group (including the respondent, which what interested in)
egen any_group = rowmin(rpm01?)
gen hh_memb_part_any_group = (any_group == 1)
replace hh_memb_part_any_group = . if any_group == .


**Be careful with this, this is just an approximation b/c in panel_hh, more because if this panel = 0 then woman can't be panel, but could be in panel_hh but not be a panel_obs
gen panel = (rar00x == 1 | rar00x == 2)
replace panel = . if rar00x == .

sort rid

merge rid using Data\R_AR_01, uniqmaster
tab _m

//Keeping only respondents to the household survey
keep if rresp_cd == rar00


//Whether respondent is female or not
gen female_resp = (rar03 == 3)

keep panel* rid hh_memb_part_gov_group hh_memb_part_any_group female_resp rar00
duplicates drop 

sort rid
tempfile resp_woman
save `resp_woman'

use Data\R_PM02, clear

//Numbers of government groups main respondent participated in
gen gov_group = 1 if (rpm04 == 6 & rpm06 == 1)


//Number of women's groups main respondent participated in
bys rpm03: egen denom_sum = total(rpm08)
bys rpm03: egen numer_sum = total(rpm08a)
gen group_pct_wom = numer_sum / denom_sum
gen womens_group = (group_pct_wom >= .75)

//Number of government and women's group meetings main respondent participated in
gen num_meetings = rpm07
gen num_gov_meetings = rpm07 if gov_group == 1
gen num_wom_meetings = rpm07 if womens_group == 1

bys rid:egen num_womens_groups = total(womens_group)
bys rid:egen num_gov_groups = total(gov_group)


keep rid num_gov_meetings num_wom_meetings num_womens_groups num_gov_groups
duplicates drop
sort rid

merge rid using `resp_woman', uniqusing
tab _m
drop _m

//Keeping only female respondents
keep if female_resp == 1

bys rid: egen gov_meetings_wom = total(num_gov_meetings)
bys rid: egen min_gov_meetings_wom = min(num_gov_meetings)
replace gov_meetings_wom = . if min_gov_meetings_wom == .
replace gov_meetings_wom = 0 if num_gov_groups == 0 & gov_meetings_wom == .
replace gov_meetings_wom = 0 if hh_memb_part_gov_group == 0 & gov_meetings_wom == .

bys rid: egen wom_meetings_wom = total(num_wom_meetings)
bys rid: egen min_wom_meetings_wom = min(num_wom_meetings)
replace wom_meetings_wom = . if min_wom_meetings_wom == .
replace wom_meetings_wom = 0 if num_womens_groups == 0 & wom_meetings_wom == .
replace wom_meetings_wom = 0 if hh_memb_part_any_group == 0 & wom_meetings_wom == .



tostring rar00, replace format(%02.0f)

gen iid = rid + rar00
replace iid = substr(iid,1,3) + "2" + substr(iid,5,9) + rar00
order iid

keep rid iid panel* gov_meetings_wom wom_meetings_wom
duplicates drop


gen ea_code = substr(iid,1,3)
gen obs_type = 9

sort iid

*******

gen id = iid if obs_type == 9 

sort id obs_type
merge id obs_type using `women_merge2', uniqmaster _merge(_ind_roster_info_merge2)
tab _ind_roster_info_merge2 obs_type, m
drop if _ind_roster_info_merge2 == 2

********

tempfile info_wom
save `info_wom'



******************************************
******************************************
******************************************

append using `info_vill'
append using `info_pos'
append using `info_school'
append using `info_hh'
append using `info_kids'
append using `info_mothers'
append using `info_resp'


label define obs_labelx 1 "Puskesmas" 2 "Bidan" 3 "School" 4 "Posyandu" 5 "Desa" 6 "Married Woman 16-49 years" 7 "Child 0-36 months" 8 "Household" 9 "Woman" 11 "Household respondent"
label values obs_type obs_labelx

order sid kid lid iid tid rid ea_code obs_type *_SD *_SMP *_pos *_desa *_moth *_kid *_hh *_wom panel*

foreach x of var meet_parents_SD comm_members_SD meet_teachers_SD meet_parents_SMP comm_members_SMP meet_teachers_SMP meet_num_pos kader_num_pos sweep_num_pos pos_num_desa health_ed_preg_moth health_ed_delv_moth /*kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth*/ KIA_kid KMS_kid health_ed_pos_kid /*kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid*/ hours_part_hh num_groups_hh elec09_part_hh health_serv_improve_hh educ_serv_improve_hh num_meetings_mainresp gov_meetings_wom wom_meetings_wom{
	rename `x' `x'_w3
}

sort rid
tempfile xx
save `xx'

***************************************
use Data\R, clear

//Generate household type variable
rename rlk12 HH_type

keep rid HH_type rar00x
duplicates drop 

sort rid

merge rid using `xx', uniqmaster
tab _m
tab _m if obs >= 6
drop if _m == 1
drop _m

***************************************

gen panel_id_w3 = id
gen art_split = substr(id,10,2)

**
replace panel_id_w3 = substr(panel_id_w3,1,9) + "00" + "00" + rar00_07 if rar00_07 != "00" & rar00_07 != ""
sort panel_id_w3
**

***************************************


gen ea = ea_code
gen Location_ID = ea_code
sort Location_ID
tempfile temp
save `temp'

//Combine kecamatan type info with indicator info
use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3
gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

merge Location_ID using `temp', uniqmaster
tab _merge
drop if _merge==1
drop _merge

sort ea


save table_3_4_vars_w3, replace

keep if type == 3

save table_3_4_vars_generasi_w3, replace

}



