set more off


cd "Wave I"

//Load relevant variables for language scores for 7 to 12 year olds
use Data\AA, clear

/*drop aa_nms*/
rename aa_umr age
rename aa_kls class
rename aaid id
sort id

tempfile test_results
save `test_results', replace
clear

//Load relevant variables for math scores for 7 to 12 year olds
use Data\AC, clear

/*drop ac_nms*/

rename ac_umr age2
rename ac_kls class2
rename acid id
sort id

//Merge language and math test answers for 7 to 12 year olds 
merge id using `test_results', unique
tab _merge
drop _merge

//Replace "EX" with "" in test answers
foreach x of var aa1a aa1b aa1c aa1d aa1e aa2 aa3 aa4 aa5 aa6 aa7 aa8 aa9 aa10 aa11 aa12 aa13 aa14 aa15 ac1 ac2 ac3 ac4 ac5 ac6 ac7 ac8 ac9 ac10 ac11 ac12 ac13 ac14 ac15 ac16 ac17 ac18 ac19 ac20{
replace `x' = "" if `x' == "EX"
}

order id age class aa1a aa1b aa1c aa1d aa1e aa2 aa3 aa4 aa5 aa6 aa7 aa8 aa9 aa10 aa11 aa12 aa13 aa14 aa15 ac1 ac2 ac3 ac4 ac5 ac6 ac7 ac8 ac9 ac10 ac11 ac12 ac13 ac14 ac15 ac16 ac17 ac18 ac19 ac20

//Input correct answers for 7 to 12 year old language and math tests
gen str2 aa1a_ans = "D"
gen str2 aa1b_ans = "F"
gen str2 aa1c_ans = "H"
gen str2 aa1d_ans = "K"
gen str2 aa1e_ans = "O"
gen str2 aa2_ans = "B"
gen str2 aa3_ans = "S"
gen str2 aa4_ans = "B"
gen str2 aa5_ans = "S"
gen str2 aa6_ans = "C"
gen str2 aa7_ans = "B"
gen str2 aa8_ans = "A"
gen str2 aa9_ans = "C"
gen str2 aa10_ans = "D"
gen str2 aa11_ans = "A"
gen str2 aa12_ans = "C"
gen str2 aa13_ans = "D"
gen str2 aa14_ans = "C"
gen str2 aa15_ans = "A"
gen str2 ac1_ans = "B"
gen str2 ac2_ans = "D"
gen str2 ac3_ans = "B"
gen str2 ac4_ans = "C"
gen str2 ac5_ans = "B"
gen str2 ac6_ans = "C"
gen str2 ac7_ans = "A"
gen str2 ac8_ans = "C"
gen str2 ac9_ans = "A"
gen str2 ac10_ans = "A"
gen str2 ac11_ans = "D"
gen str2 ac12_ans = "D"
gen str2 ac13_ans = "D"
gen str2 ac14_ans = "B"
gen str2 ac15_ans = "A"
gen str2 ac16_ans = "D"
gen str2 ac17_ans = "C"
gen str2 ac18_ans = "A"
gen str2 ac19_ans = "A"
gen str2 ac20_ans = "C"

tempfile test_results2
save `test_results2', replace
clear

//Load relevant variables for language scores for 13 to 15 year olds
use Data\AB, clear

/*drop ab_nms*/
rename ab_umr age
rename ab_kls class
rename abid id
sort id

tempfile temp1
save `temp1'
clear

//Load relevant variables for math scores for 13 to 15 year olds
use Data\AD, clear

/*drop ad_nms*/
rename ad_umr age2
rename ad_kls class2
rename adid id
sort id

//Merge language and math test answers for 13 to 15 year olds
merge id using `temp1', unique
tab _merge
drop _merge

//Replace "EX" with "" in test answers
foreach x of var ab1 ab2 ab3 ab4 ab5 ab6 ab7 ab8 ab9 ab10 ab11 ab12 ab13 ab14 ab15 ad1 ad2 ad3 ad4 ad5 ad6 ad7 ad8 ad9 ad10 ad11 ad12 ad13 ad14 ad15 ad16 ad17 ad18 ad19 ad20{
replace `x' = "" if `x' =="EX"
}

order id age class ab1 ab2 ab3 ab4 ab5 ab6 ab7 ab8 ab9 ab10 ab11 ab12 ab13 ab14 ab15 ad1 ad2 ad3 ad4 ad5 ad6 ad7 ad8 ad9 ad10 ad11 ad12 ad13 ad14 ad15 ad16 ad17 ad18 ad19 ad20

//Input correct answers for 13 to 15 year old language and math tests
gen str2 ab1_ans = "D"
gen str2 ab2_ans = "A"
gen str2 ab3_ans = "C"
gen str2 ab4_ans = "D"
gen str2 ab5_ans = "C"
gen str2 ab6_ans = "D"
gen str2 ab7_ans = "D"
gen str2 ab8_ans = "C"
gen str2 ab9_ans = "D"
gen str2 ab10_ans = "A"
gen str2 ab11_ans = "C"
gen str2 ab12_ans = "A"
gen str2 ab13_ans = "D"
gen str2 ab14_ans = "A"
gen str2 ab15_ans = "D"
gen str2 ad1_ans = "C"
gen str2 ad2_ans = "A"
gen str2 ad3_ans = "D"
gen str2 ad4_ans = "B"
gen str2 ad5_ans = "A"
gen str2 ad6_ans = "D"
gen str2 ad7_ans = "B"
gen str2 ad8_ans = "A"
gen str2 ad9_ans = "D"
gen str2 ad10_ans = "D"
gen str2 ad11_ans = "A"
gen str2 ad12_ans = "A"
gen str2 ad13_ans = "A"
gen str2 ad14_ans = "D"
gen str2 ad15_ans = "A"
gen str2 ad16_ans = "C"
gen str2 ad17_ans = "D"
gen str2 ad18_ans = "A"
gen str2 ad19_ans = "B"
gen str2 ad20_ans = "C"

//Combine test results for 7 to 12 year olds with those for 13 to 15 year olds
append using `test_results2'
sort id

//Generate overall scores by section and total
gen lang_score_7to12 = 0
gen math_score_7to12 = 0
gen totl_score_7to12 = 0
gen lang_score_13to15 = 0
gen math_score_13to15 = 0
gen totl_score_13to15 = 0

foreach x of var aa1a aa1b aa1c aa1d aa1e aa2 aa3 aa4 aa5 aa6 aa7 aa8 aa9 aa10 aa11 aa12 aa13 aa14 aa15{
gen `x'_correct = 1 if `x' == `x'_ans
replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
replace lang_score_7to12 = lang_score_7to12 + `x'_correct if `x'_correct != .
}
replace lang_score_7to12 = . if aa1a == "" & aa1b == "" & aa1c == "" & aa1d == "" & aa1e== "" & aa2== "" & aa3 == "" & aa4 == "" & aa5 == "" & aa6 == "" & aa7 == "" & aa8 == "" & aa9 == "" & aa10 == "" & aa11 == "" & aa12 == "" & aa13 == "" & aa14 == "" & aa15 == ""

foreach x of var ac1 ac2 ac3 ac4 ac5 ac6 ac7 ac8 ac9 ac10 ac11 ac12 ac13 ac14 ac15 ac16 ac17 ac18 ac19 ac20{
gen `x'_correct = 1 if `x' == `x'_ans
replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
replace math_score_7to12 = math_score_7to12 + `x'_correct if `x'_correct != .
}
replace math_score_7to12 = . if ac1== "" & ac2== "" & ac3 == "" & ac4 == "" & ac5 == "" & ac6 == "" & ac7 == "" & ac8 == "" & ac9 == "" & ac10 == "" & ac11 == "" & ac12 == "" & ac13 == "" & ac14 == "" & ac15 == "" & ac16 == "" & ac17 == "" & ac18 == "" & ac19 == "" & ac20 == ""

foreach x of var ab1 ab2 ab3 ab4 ab5 ab6 ab7 ab8 ab9 ab10 ab11 ab12 ab13 ab14 ab15{
gen `x'_correct = 1 if `x' == `x'_ans
replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
replace lang_score_13to15 = lang_score_13to15 + `x'_correct if `x'_correct != .
}
replace lang_score_13to15 = . if ab1== "" & ab2== "" & ab3 == "" & ab4 == "" & ab5 == "" & ab6 == "" & ab7 == "" & ab8 == "" & ab9 == "" & ab10 == "" & ab11 == "" & ab12 == "" & ab13 == "" & ab14 == "" & ab15 == ""

foreach x of var ad1 ad2 ad3 ad4 ad5 ad6 ad7 ad8 ad9 ad10 ad11 ad12 ad13 ad14 ad15 ad16 ad17 ad18 ad19 ad20{
gen `x'_correct = 1 if `x' == `x'_ans
replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
replace math_score_13to15 = math_score_13to15 + `x'_correct if `x'_correct != .
}
replace math_score_13to15 = . if ad1== "" & ad2== "" & ad3 == "" & ad4 == "" & ad5 == "" & ad6 == "" & ad7 == "" & ad8 == "" & ad9 == "" & ad10 == "" & ad11 == "" & ad12 == "" & ad13 == "" & ad14 == "" & ad15 == "" & ad16 == "" & ad17 == "" & ad18 == "" & ad19 == "" & ad20 == ""

foreach x of var lang_score_7to12 math_score_7to12{
replace totl_score_7to12 = totl_score_7to12 + `x' if `x' != .
}
replace totl_score_7to12 = . if lang_score_7to12 == . | math_score_7to12 ==.

foreach x of var lang_score_13to15 math_score_13to15{
replace totl_score_13to15 = totl_score_13to15 + `x' if `x' != .
}
replace totl_score_13to15 = . if lang_score_13to15 == . | math_score_13to15 == .

//Generate overall percentage correct by section and total
gen lang_pct_7to12 = lang_score_7to12 / 19
gen math_pct_7to12 = math_score_7to12 / 20
gen totl_pct_7to12 = totl_score_7to12 / 39
gen lang_pct_13to15 = lang_score_13to15 / 15
gen math_pct_13to15 = math_score_13to15 / 20
gen totl_pct_13to15 = totl_score_13to15 / 35


tempfile test_results3
save `test_results3', replace

//Load relevant variables
use Data\A
rename aid id

//Replace missing days with 15 if neither month nor year values for children's birth dates missing
replace air03_dd=15 if air03_dd==. & air03_mm!=. & air03_yy!=.

//Replace nonleap year February 29's with February 28's
replace air03_dd=28 if air03_dd==29 & air03_mm==2 & air03_yy!=1992 & air03_yy!=1996 & air03_yy!=2000

//Generate child's birth dates
gen birth_date=mdy(air03_mm,air03_dd,air03_yy)

//Generate survey dates using first survey attempt with at least partial completion
gen survey_date=mdy(aivw_mm_1, aivw_dd_1, aivw_yy_1) if aahkw_1==1 | aahkw_1==2
replace survey_date=mdy(aivw_mm_2, aivw_dd_2, aivw_yy_2) if survey_date==. & (aahkw_2==1 | aahkw_2==2)
replace survey_date=mdy(aivw_mm_3, aivw_dd_3, aivw_yy_3) if survey_date==. & (aahkw_3==1 | aahkw_3==2)

//Generate child's age at time of survey
gen age = survey_date - birth_date

//Generate age in years
replace age = age / 365.25
replace age = floor(age)
keep if age != .
rename age age3
keep id age3
sort id

//Merge age info from original survey for comparison
merge id using `test_results3', uniqmaster
tab _merge
drop if _merge == 1
drop _merge

//Determine correct age from values from language section (age), math section (age2), and original survey (age3)
replace age = age3 if age != age2 & age3 != .
replace age2 = age3 if age != age2 & age3 != .
replace age = age2 if age == . & age2 != . & age3 == .
replace age2 = age if age2 == . & age != . & age3 == .
replace age = age3 if age == . & age2 == . & age3 != .
replace age2 = age3 if age == age3 & age2 == .
replace age = age2 if age3 == . & age2 > age
replace age2 = age if age3 == . & age > age2

//Look for nonmatching ages
list age age2 age3 if age != age2

drop if age < 7 | age > 15

//drop age2 age3

sort id
tempfile test_results4
save `test_results4', replace

//Load relevant variables
use Data\A
keep aid adla05
rename aid id
rename adla05 class3
sort id

//Merge class info from original survey for comparison
merge id using `test_results4', uniqmaster
tab _merge
drop if _merge == 1
drop _merge

//Determine correct class from values from language section (class), math section (class2), and original survey (class3)
replace class = class3 if class != class2 & class3 != .
replace class2 = class3 if class != class2 & class3 != .
replace class = class2 if class == . & class2 != . & class3 == .
replace class2 = class if class2 == . & class != . & class3 == .
replace class = class3 if class == . & class2 == . & class3 != .
replace class2 = class3 if class == class3 & class2 == .

//Look for nonmatching classes
list class class2 class3 if class != class2


drop class2 class3

sort id
keep id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 
order id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 

//Generate household identification variable
gen HH_id= substr(id,1,3) + substr(id,5,5)

sort HH_id

tempfile test_results5
save `test_results5', replace

clear

use Data\R
keep rid 


gen Location_ID= substr(rid,1,3)

gen HH_id = substr(rid,1,3) + substr(rid,5,5)
keep HH_id Location_ID 

//Drop misentered duplicates in HH_id
drop if HH_id=="65300601" & Location_ID=="5309073"
drop if HH_id=="65300602" & Location_ID=="5309073"
drop if HH_id=="65300605" & Location_ID=="5309073"

sort HH_id
merge HH_id using `test_results5', uniqmaster
tab _merge

drop if _merge == 1
codebook id if _merge == 2
tab _merge
rename _merge _merge2

sort Location_ID
tempfile test_results6
save `test_results6', replace

use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id

sort Location_ID

//Merge kecamatan type info with test result info
merge Location_ID using `test_results6', uniqmaster

tab _merge
drop if _merge==1
codebook id if _merge==2
tab _merge
drop _merge*

gen age_years = age

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	**Handling the splitting of some test results (lang vs math) across duplicate id observations
	bys id age class: egen `var'_max = max(`var')
	replace `var' = `var'_max
	drop `var'_max
}

gen age_years_w1 = age_years


keep id type prov_id kab_id Location_ID HH_id age_years* class lang_* totl_* math_* 
duplicates drop

duplicates tag id, gen(tag)
sort id
order id age_years class

**Dropping clearly different observations for which have same id numbers (36), because will be problematic for merging across waves and number very small compared to total
drop if tag == 1
sort id

gen obs_type = 4

foreach var of varlist lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	egen `var'_std= std(`var')

	}

	//Generate language, math, and total test score variables for age groups combined
	gen lang_score_std = lang_score_7to12_std if age_years>=7 & age_years<=12
	gen math_score_std = math_score_7to12_std if age_years>=7 & age_years<=12
	gen totl_score_std = totl_score_7to12_std if age_years>=7 & age_years<=12
	replace lang_score_std = lang_score_13to15_std if age_years>=13 & age_years<=15
	replace math_score_std = math_score_13to15_std if age_years>=13 & age_years<=15
	replace totl_score_std = totl_score_13to15_std if age_years>=13 & age_years<=15


foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	rename `var'_std `var'_std_w1
	
	}


//Generating variables to look panel individuals across waves
gen rid= substr(id,1,3) + "1" + substr(id,5,5)
gen panel_id_w2 = substr(id,1,4) + substr(id,5,5) + "00" + substr(id,10,2) 
gen panel_id_w3 = substr(id,1,4) + substr(id,5,5) + "00" + "00" + substr(id,10,2)



tempfile temp_test
save `temp_test'

keep id type prov_id kab_id Location_ID HH_id age* class *_w1 obs_type panel_id* rid 
sort id


compress
save test_results_w1, replace

use `temp_test', clear

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	drop `var'_std
	}

keep if type==3

foreach var of varlist lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	egen `var'_std= std(`var')
	}

	//Generate language, math, and total test score variables for age groups combined
	gen lang_score_std = lang_score_7to12_std if age_years>=7 & age_years<=12
	gen math_score_std = math_score_7to12_std if age_years>=7 & age_years<=12
	gen totl_score_std = totl_score_7to12_std if age_years>=7 & age_years<=12
	replace lang_score_std = lang_score_13to15_std if age_years>=13 & age_years<=15
	replace math_score_std = math_score_13to15_std if age_years>=13 & age_years<=15
	replace totl_score_std = totl_score_13to15_std if age_years>=13 & age_years<=15

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	rename `var'_std `var'_std_w1
	}
	
keep id type prov_id kab_id Location_ID HH_id age* class *_w1 obs_type rid panel_id* 
duplicates drop

sort id

save test_results_generasi_w1, replace
 


