set more off

cd "Wave III"

//Load relevant variables for language and math scores for 7 to 12 year olds
use Data\A1, clear



rename a_age age
rename a_cls class
rename aid id
sort id

//Replace "EX" "MS" "MM" with "" in test answers
foreach x of var  ab01_1 ab01_2 ab01_3 ab01_4 ab01_5 ab01_6 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20{
	replace `x' = "" if `x' == "EX"
	replace `x' = "" if `x' == "MS"
	replace `x' = "" if `x' == "MM"
}

keep id age class ab01_1 ab01_2 ab01_3 ab01_4 ab01_5 ab01_6 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20
order id age class ab01_1 ab01_2 ab01_3 ab01_4 ab01_5 ab01_6 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20

//Input correct answers for 7 to 12 year old language and math tests
gen str2 ab01_1_ans = "C"
gen str2 ab01_2_ans = "E"
gen str2 ab01_3_ans = "H"
gen str2 ab01_4_ans = "L"
gen str2 ab01_5_ans = "O"
gen str2 ab01_6_ans = "Q"
gen str2 ab02_ans = "S"
gen str2 ab03_ans = "S"
gen str2 ab04_ans = "S"
gen str2 ab05_ans = "B"
gen str2 ab06_ans = "C"
gen str2 ab07_ans = "B"
gen str2 ab08_ans = "A"
gen str2 ab09_ans = "C"
gen str2 ab10_ans = "B"
gen str2 ab11_ans = "D"
gen str2 ab12_ans = "A"
gen str2 ab13_ans = "A"
gen str2 ab14_ans = "B"
gen str2 ab15_ans = "C"
gen str2 am01_ans = "A"
gen str2 am02_ans = "C"
gen str2 am03_ans = "C"
gen str2 am04_ans = "D"
gen str2 am05_ans = "B"
gen str2 am06_ans = "B"
gen str2 am07_ans = "C"
gen str2 am08_ans = "D"
gen str2 am09_ans = "B"
gen str2 am10_ans = "A"
gen str2 am11_ans = "C"
gen str2 am12_ans = "A"
gen str2 am13_ans = "D"
gen str2 am14_ans = "D"
gen str2 am15_ans = "C"
gen str2 am16_ans = "D"
gen str2 am17_ans = "D"
gen str2 am18_ans = "A"
gen str2 am19_ans = "B"
gen str2 am20_ans = "C"

//Generate overall scores by section and total
gen lang_score_7to12 = 0
gen math_score_7to12 = 0
gen totl_score_7to12 = 0

foreach x of var ab01_1 ab01_2 ab01_3 ab01_4 ab01_5 ab01_6 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15{
	gen `x'_correct = 1 if `x' == `x'_ans
	replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
	replace lang_score_7to12 = lang_score_7to12 + `x'_correct if `x'_correct != .
}
replace lang_score_7to12 = . if ab01_1 == "" & ab01_2 == "" & ab01_3 == "" & ab01_4 == "" & ab01_5== "" & ab01_6== "" & ab02== "" & ab03 == "" & ab04 == "" & ab05 == "" & ab06 == "" & ab07 == "" & ab08 == "" & ab09 == "" & ab10 == "" & ab11 == "" & ab12 == "" & ab13 == "" & ab14 == "" & ab15 == ""

foreach x of var am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20{
	gen `x'_correct = 1 if `x' == `x'_ans
	replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
	replace math_score_7to12 = math_score_7to12 + `x'_correct if `x'_correct != .
}
replace math_score_7to12 = . if am01== "" & am02== "" & am03 == "" & am04 == "" & am05 == "" & am06 == "" & am07 == "" & am08 == "" & am09 == "" & am10 == "" & am11 == "" & am12 == "" & am13 == "" & am14 == "" & am15 == "" & am16 == "" & am17 == "" & am18 == "" & am19 == "" & am20 == ""

foreach x of var lang_score_7to12 math_score_7to12{
	replace totl_score_7to12 = totl_score_7to12 + `x' if `x' != .
}
replace totl_score_7to12 = . if lang_score_7to12 == . | math_score_7to12 ==.

//Generate overall percentage correct by section and total
gen lang_pct_7to12 = lang_score_7to12 / 20
gen math_pct_7to12 = math_score_7to12 / 20
gen totl_pct_7to12 = totl_score_7to12 / 40


bys id: keep if _n==1


sort id
keep id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 
order id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12  

tempfile test_results2
save `test_results2', replace
clear

//Load relevant variables for language and math scores for 13 to 15 year olds
use Data\A2, clear

duplicates drop aid, force

rename a_age age
rename a_cls class
rename aid id
sort id

//Replace "EX" "MS" "MM" with "" in test answers
foreach x of var  ab01 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20{
	replace `x' = "" if `x' == "EX"
	replace `x' = "" if `x' == "MS"
	replace `x' = "" if `x' == "MM"
}

keep id age class ab01 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20
order id age class ab01 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20

//Input correct answers for 13 to 15 year old language and math tests
gen str2 ab01_ans = "B"
gen str2 ab02_ans = "D"
gen str2 ab03_ans = "A"
gen str2 ab04_ans = "B"
gen str2 ab05_ans = "B"
gen str2 ab06_ans = "B"
gen str2 ab07_ans = "B"
gen str2 ab08_ans = "A"
gen str2 ab09_ans = "C"
gen str2 ab10_ans = "C"
gen str2 ab11_ans = "D"
gen str2 ab12_ans = "B"
gen str2 ab13_ans = "A"
gen str2 ab14_ans = "A"
gen str2 ab15_ans = "B"
gen str2 am01_ans = "D"
gen str2 am02_ans = "B"
gen str2 am03_ans = "A"
gen str2 am04_ans = "C"
gen str2 am05_ans = "A"
gen str2 am06_ans = "D"
gen str2 am07_ans = "D"
gen str2 am08_ans = "C"
gen str2 am09_ans = "D"
gen str2 am10_ans = "D"
gen str2 am11_ans = "A"
gen str2 am12_ans = "B"
gen str2 am13_ans = "A"
gen str2 am14_ans = "A"
gen str2 am15_ans = "C"
gen str2 am16_ans = "C"
gen str2 am17_ans = "A"
gen str2 am18_ans = "D"
gen str2 am19_ans = "D"
gen str2 am20_ans = "C"


//Generate overall scores by section and total
gen lang_score_13to15 = 0
gen math_score_13to15 = 0
gen totl_score_13to15 = 0

foreach x of var ab01 ab02 ab03 ab04 ab05 ab06 ab07 ab08 ab09 ab10 ab11 ab12 ab13 ab14 ab15 {
	gen `x'_correct = 1 if `x' == `x'_ans
	replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
	replace lang_score_13to15 = lang_score_13to15 + `x'_correct if `x'_correct != .
}
replace lang_score_13to15 = . if ab01 == "" & ab02== "" & ab03 == "" & ab04 == "" & ab05 == "" & ab06 == "" & ab07 == "" & ab08 == "" & ab09 == "" & ab10 == "" & ab11 == "" & ab12 == "" & ab13 == "" & ab14 == "" & ab15 == ""

foreach x of var am01 am02 am03 am04 am05 am06 am07 am08 am09 am10 am11 am12 am13 am14 am15 am16 am17 am18 am19 am20{
	gen `x'_correct = 1 if `x' == `x'_ans
	replace `x'_correct = 0 if `x' != `x'_ans & `x' != ""
	replace math_score_13to15 = math_score_13to15 + `x'_correct if `x'_correct != .
}
replace math_score_13to15 = . if am01== "" & am02== "" & am03 == "" & am04 == "" & am05 == "" & am06 == "" & am07 == "" & am08 == "" & am09 == "" & am10 == "" & am11 == "" & am12 == "" & am13 == "" & am14 == "" & am15 == "" & am16 == "" & am17 == "" & am18 == "" & am19 == "" & am20 == ""


foreach x of var lang_score_13to15 math_score_13to15{
	replace totl_score_13to15 = totl_score_13to15 + `x' if `x' != .
}
replace totl_score_13to15 = . if lang_score_13to15 == . | math_score_13to15 == .

//Generate overall percentage correct by section and total
gen lang_pct_13to15 = lang_score_13to15 / 15
gen math_pct_13to15 = math_score_13to15 / 20
gen totl_pct_13to15 = totl_score_13to15 / 35


bys id: keep if _n==1


sort id
keep id age class lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 
order id age class lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 

//Combine test results for 7 to 12 year olds with those for 13 to 15 year olds
append using `test_results2'
sort id

tempfile test_results3
save `test_results3', replace

//Load relevant variables
use children6to15years_w3, clear
keep id age

//Generate age in years
replace age = age / 365.25
replace age = floor(age)
keep if age != .
rename age age3
sort id

/* drop double observations */
bys id: keep if _n==1

//Merge age info from original survey for comparison
merge id using `test_results3', uniqmaster
tab _merge
drop if _merge == 1
drop _merge


//Determine correct age from values from language & math section (age), and original survey (age3)
replace age = age3 if age == . & age3 != .


drop age3

drop if age < 7 | age > 15

foreach x of var *_13to15{
	replace `x' = . if age < 13
}
foreach x of var *_7to12{
	replace `x' = . if age > 12
}	


sort id
tempfile test_results4
save `test_results4', replace

//Load relevant variables
use Data\A
keep aid adla05 acov3
rename aid id
rename adla05 class3
sort id

/* drop double observations */
bys id: keep if _n==1

//Merge class info from original survey for comparison
merge id using `test_results4', uniqmaster
tab _merge
drop if _merge == 1
drop _merge



//Determine correct class from values from language and math section (class), and original survey (class3)
replace class = class3 if class == . & class3 != .

drop class3

sort id
keep id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 acov3
order id age class lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 acov3

//Generate household identification variable
gen HH_id= substr(id,1,3) + substr(id,5,9)

sort HH_id

tempfile test_results5
save `test_results5', replace

clear

use Data\R
keep rid 


gen Location_ID= substr(rid,1,3)

gen HH_id = substr(rid,1,3) + substr(rid,5,9)
keep HH_id Location_ID 


/* drop double observations */
bys HH_id: keep if _n==1

sort HH_id
merge HH_id using `test_results5', uniqmaster

tab _merge

drop if _merge == 1
codebook id if _merge == 2
tab _merge
rename _merge _merge2

sort Location_ID
tempfile test_results6
save `test_results6', replace

use ..\kecs_info_clean
egen generasi = rowmax(gen_year1 gen_year2)
gen type = 3



gen kab_id = llk02_cd
gen prov_id = llk01_cd

keep Location_ID type kab_id prov_id
sort Location_ID

//Merge kecamatan type info with test result info
merge Location_ID using `test_results6', uniqmaster

tab _merge
drop if _merge==1
codebook id if _merge==2
tab _merge
drop _merge*

gen panel_2007 = (acov3 == 1)
replace panel_2007 = . if acov3 == .
gen panel_2008 = (acov3 == 2)
replace panel_2008 = . if acov3 == .
gen panel = (acov3 == 1 | acov3 == 2)
replace panel = . if acov3 == .

gen age_years = age

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	**Handling the splitting of some test results (lang vs math) across duplicate id observations
	bys id age class: egen `var'_max = max(`var')
	replace `var' = `var'_max
	drop `var'_max
}

sort id

sort id
tempfile temp_xx
save `temp_xx'


**Generating for merges with children alive and living with mother (we have kid's id for those observations)
use Data\R_AR_01, clear
duplicates drop

tostring rar00_07 rar00, replace format(%02.0f)
gen id = substr(rid,1,3) + "3" + substr(rid,5,9) + rar00

keep rar00 rar00_07 rar01a id rid

sort id
merge id using `temp_xx', uniqmaster _merge(_ind_roster_info_merge2)
tab _ind_roster_info_merge2
drop if _ind_roster_info_merge2 == 1

gen panel_id_w3 = id
gen art_split_w3 = substr(id,10,2)

**
replace panel_id_w3 = substr(panel_id,1,9) + "00" + "00" + rar00_07 if rar00_07 != "00" & rar00_07 != ""
**
gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"



order id panel_id_w3
sort panel_id_w3

keep id type prov_id kab_id Location_ID HH_id age_years class lang_* totl_* math_* panel* 
duplicates drop

duplicates tag id, gen(tag)
sort id
order id age_years class

**Dropping clearly different observations for which have same id numbers (58), because will be problematic for merging across waves and number very small compared to total
drop if tag == 1
sort id

gen obs_type = 4

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	egen `var'_std= std(`var')
}

	//Generate language, math, and total test score variables for age groups combined
	gen lang_score_std = lang_score_7to12_std if age_years>=7 & age_years<=12
	gen math_score_std = math_score_7to12_std if age_years>=7 & age_years<=12
	gen totl_score_std = totl_score_7to12_std if age_years>=7 & age_years<=12
	replace lang_score_std = lang_score_13to15_std if age_years>=13 & age_years<=15
	replace math_score_std = math_score_13to15_std if age_years>=13 & age_years<=15
	replace totl_score_std = totl_score_13to15_std if age_years>=13 & age_years<=15


foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	rename `var'_std `var'_std_w3
}

tempfile temp_test
save `temp_test'

keep id type prov_id kab_id Location_ID HH_id age* class *_w3 obs_type panel*
sort id 

compress
save test_results_w3, replace


use `temp_test', clear

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	drop `var'_std
	}

keep if type==3

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15{
	egen `var'_std= std(`var')
}

	//Generate language, math, and total test score variables for age groups combined
	gen lang_score_std = lang_score_7to12_std if age_years>=7 & age_years<=12
	gen math_score_std = math_score_7to12_std if age_years>=7 & age_years<=12
	gen totl_score_std = totl_score_7to12_std if age_years>=7 & age_years<=12
	replace lang_score_std = lang_score_13to15_std if age_years>=13 & age_years<=15
	replace math_score_std = math_score_13to15_std if age_years>=13 & age_years<=15
	replace totl_score_std = totl_score_13to15_std if age_years>=13 & age_years<=15

foreach var in lang_score_7to12 math_score_7to12 totl_score_7to12 lang_pct_7to12 math_pct_7to12 totl_pct_7to12 lang_score_13to15 math_score_13to15 totl_score_13to15 lang_pct_13to15 math_pct_13to15 totl_pct_13to15 lang_score math_score totl_score{
	rename `var'_std `var'_std_w3
}

keep id type prov_id kab_id Location_ID HH_id age* class *_w3 obs_type panel*
duplicates drop


sort id

save test_results_generasi_w3, replace
 


