clear
cd\
cd "SPECIFY_PATH\PublicData\"



//Call do-file for indicators 9-12 and child labor variable
do "Do Files\131218 children6to15years_w1.do"
	*Does: Generates variables for school enrollment and child labor
	*Data Input: A.dta, A_DLA1TYPE.dta
	*Data Output: children6to15years_w1.dta
	
//Call do-file for indicators 5-8
cd ..\
do "Do Files\131218 children0to36months_w1.do"
	*Does: Generates variables for immunization, vitamin A, weighings, and anthopometric indicators
	*Data Input: T.dta, T_IM1TYPE.dta, T_IM13.dta, and WHO igrowup macro 
	*Data Output: children0to36months_w1.dta
	**If have difficulty running this, then open a new stata and run it, the WHO program has difficulty being rerun in the same window at times
	
	
//Call do-file for indicators 1-4
cd ..\
do "Do Files\131218 marriedwoman16to49years_w1.do"
	*Does: Generates variables for pre-natal and post-natal visits, iron-pills, and good assisted delivery for pregnancies in the last 18 months
	*Data Input: I.dta, I_CH.dta, I_RH13.dta, I_RH19.dta, I_RH23.dta
	*Data Output: marriedwoman16to49years_w1.dta
	
//Call do-file for test results
cd ..\
do "Do Files\131218 test_results_w1.do"
	*Does: Generates variables for standardized test scores (language, math, and total) for 7-12 year olds, 13-15 year old, and combined; adds kecamatan type info; outputs in both complete and generasi-only forms
	*Data Input: A.dta, AA.dta, AB.dta, AC.dta, AD.dta, R.dta, kecs_info_clean.dta
	*Data Output: test_results_w1.dta, test_results_generasi_w1.dta

//Call do-file for infant morbidity variables
cd ..\
do "Do Files\131218 infant_morbidity_w1.do"
	*Does: Generates variables for infant morbidity; adds kecamatan type info; saves in both complete and generasi-only form
	*Data Input: T.dta, R.dta, kecs_info_clean.dta
	*Data Output: infant_morbidity.dta, infant_morbidity_generasi.dta
	
//Call do-file for infant mortality variables
cd ..\
do "Do Files\131218 infant_mortality_w1.do"
	*Does: Generates infant mortality for 0-11 months (for children born in last 24 months) and for 0-28 days (for children born in last 18 months); adds kecamatan type info; outputs both in complete and generasi-only form
	*Data Input: I.dta, I_RH07.dta, I_RH13.dta, R.dta, T.dta, kecs_info_clean.dta, 
	*Data Output: infant_mortality.dta, infant_mortality_generasi.dta
	
//Call do-file for combined indicators
cd ..\
do "Do Files\131218 indicators_w1.do"
	*Does: Combines the three datasets for different individuals; adds kecamatan type info; saves in both complete and generasi-only form
	*Data Input: children6to15years.dta, children0to36months.dta, marriedwoman16to49years.dta
	*Data Output: indicators.dta, indicators_generasi.dta	
	
//Call do-file for provider variables
cd ..\
do "Do Files\131218 provider_vars_w1.do"
	*Does: Creates datasets for different provider variables
	*Data Input:
	*Data Output: table_3_?_variables_*_w1	
	
//Call do-file for school budget variables
cd ..\
do "Do Files\131218 school_budget_vars_w1.do"
	*Does: Generates variables for school budgets, fees etc.
	*Data Input:
	*Data Output: school_budget_vars_w1.dta	
	
**********************************************
**********************************************	

//Call do-file for indicators 1-4
cd ..\
do "Do Files\131218 marriedwoman16to49years_w2.do"
	*Does: Generates variables for pre-natal and post-natal visits, iron-pills, and good assisted delivery for pregnancies in the last 18 months
	*Data Input: I.dta, I_CH.dta, I_RH13.dta, I_RH19.dta, I_RH23.dta
	*Data Output: marriedwoman16to49years_w2.dta
	
//Call do-file for indicators 5-8
cd ..\
do "Do Files\131218 children0to36months_w2.do"
	*Does: Generates variables for immunization, vitamin A, weighings, and anthopometric indicators
	*Data Input: T.dta, T_IM1TYPE.dta, T_IM13.dta, and WHO igrowup macro 
	*Data Output: children0to36months_w2.dta
	**If have difficulty running this, then open a new stata and run it, the WHO program has difficulty being rerun in the same window at times

//Call do-file for indicators 9-12 and child labor variable
cd ..\
do "Do Files\131218 children6to15years_w2.do"
	*Does: Generates variables for school enrollment and child labor
	*Data Input: A.dta, A_DLA1TYPE.dta
	*Data Output: children6to15years_w2.dta

//Call do-file for infant mortality variables
cd ..\
do "Do Files\131218 infant_mortality_w2.do"
	*Does: Generates variables for infant mortality measures
	*Data Input: Data\I.dta, I_CH.dta, I_RH13.dta, R.dta, R_AR_01.dta
	*Data Output: infant_mortality_w2.dta

//Call do-file for infant morbidity variables
cd ..\
do "Do Files\131218 infant_morbidity_w2.do"
	*Does: Generates variables for infant morbidity measure
	*Data Input: Data\T.dta, R.dta, kecs_info_clean.dta, R_AR_01.dta
	*Data Ouput: infant_morbidity_w2.dta

//Call do-file for combined indicators
cd ..\
do "Do Files\131218 indicators_w2.do"
	*Does: Combines the three datasets for different individuals; adds kecamatan type info
	*Data Input: children6to15years_w2.dta, children0to36months_w2.dta, marriedwoman16to49years_w2.dta
	*Data Output: indicators_w2.dta

//Call do-file for provider variables
cd ..\
do "Do Files\131218 provider_vars_w2.do"
	*Does: Creates datasets for different provider variables
	*Data Input: Wave I\Data\B.dta; Data\P_KF2TYPE.dta, P.dta, B.dta, B_LG.dta, B_YK1TYPE.dta, P_TKSTYPE.dta, R_AKTYPE.dta, S.dta, S_MSTYPE.dta, S_D3TYPE.dta, L_FPDTYPE.dta, K_JP.dta, K.dta, L.dta, L_DN.dta, R.dta, B_PHTYPE.dta, S_GR03.dta, L_FKS1TYPE.dta, L_DN.dta, B_OV.dta, B_AM.dta, R_AR_01.dta, K.dta, T.dta, T_PG.dta, I.dta, R_PM02.dta ;cct_puskesmas_verification.dta, marriedwoman16to49years_w2, cct_schools_verification.dta, births_18_okay_w2
	*Data Output: prov_variables_*_*_w2  where *_* = 3_1, 3_2, 3_3, 3_4, or 3_5

//Call do-file for school budget variables
cd ..\
do "Do Files\131218 school_budget_vars_w2.do"
	*Does: Generates variables for school budgets, fees etc.
	*Data Input: Data\ S.dta, S_MSTYPE.dta
	*Data Output: school_budget_vars_w2.dta
	
**********************************************
**********************************************	
	
//Call do-file for indicators 1-4
cd ..\
do "Do Files\131218 marriedwoman16to49years_w3.do"
	*Does: Generates variables for pre-natal and post-natal visits, iron-pills, and good assisted delivery for pregnancies in the last 18 months
	*Data Input: I.dta, I_CH.dta, I_RH13.dta, I_RH19.dta, I_RH23.dta
	*Data Output: marriedwoman16to49years_w3.dta

//Call do-file for indicators 5-8
cd ..\
do "Do Files\131218 children0to36months_w3.do"
	*Does: Generates variables for immunization, vitamin A, weighings, and anthopometric indicators
	*Data Input: T.dta, T_IM1TYPE.dta, T_IM13.dta, and WHO igrowup macro 
	*Data Output: children0to36months_w3.dta
	**If have difficulty running this, then open a new stata and run it, the WHO program has difficulty being rerun in the same window at times

//Call do-file for indicators 9-12 and child labor variable
cd ..\
do "Do Files\131218 children6to15years_w3.do"
	*Does: Generates variables for school enrollment and child labor
	*Data Input: A.dta, A_DLA1TYPE.dta
	*Data Output: children6to15years_w3.dta

//Call do-file for test results 
cd ..\
do "Do Files\131218 test_results_w3.do"
	*Does: Generates variables for standardized test scores (language, math, and total) for 7-12 year olds, 13-15 year old, and combined; adds kecamatan type info; outputs in both complete and generasi-only forms
	*Data Input: A.dta, AA.dta, AB.dta, AC.dta, AD.dta, R.dta, kecs_info_clean.dta
	*Data Output: test_results_w3.dta, test_results_generasi_w3.dta

//Call do-file for infant mortality variables
cd ..\
do "Do Files\131218 infant_mortality_w3.do"
	*Does: Generates variables for infant mortality measures
	*Data Input: Data\I.dta, I_CH.dta, I_RH13.dta, R.dta, R_AR_01.dta
	*Data Output: infant_mortality_w3.dta

//Call do-file for infant morbidity variables
cd ..\
do "Do Files\131218 infant_morbidity_w3.do"
	*Does: Generates variables for infant morbidity measure
	*Data Input: Data\T.dta, R.dta, kecs_info_clean.dta, R_AR_01.dta
	*Data Ouput: infant_morbidity_w3.dta
	
//Call do-file for combined indicators
cd ..\
do "Do Files\131218 indicators_w3.do"
	*Does: Combines the three datasets for different individuals; adds kecamatan type info
	*Data Input: children6to15years_w3.dta, children0to36months_w3.dta, marriedwoman16to49years_w3.dta
	*Data Output: indicators_w3.dta
	
//Call do-file for provider variables
cd ..\
do "Do Files\131218 provider_vars_w3.do"
	*Does: Creates datasets for different provider variables
	*Data Input: Large number of source data files in Data\ directory including but not limited to Wave I\Data\B.dta; Data\P_KF2TYPE.dta, P.dta, B.dta, B_LG.dta, B_YK1TYPE.dta, P_TKSTYPE.dta, R_AKTYPE.dta, S.dta, S_MSTYPE.dta, S_D3TYPE.dta, L_FPDTYPE.dta, K_JP.dta, K.dta, L.dta, L_DN.dta, R.dta, B_PHTYPE.dta, S_GR03.dta, L_FKS1TYPE.dta, L_DN.dta, B_OV.dta, B_AM.dta, R_AR_01.dta, K.dta, T.dta, T_PG.dta, I.dta, R_PM02.dta ;cct_puskesmas_verification.dta, marriedwoman16to49years_w3, cct_schools_verification.dta, births_18_okay_w3
	*Data Output: table_3_?_variables_*_w3


//Call do-file for including wave 1 controls
cd ..\
do "Do Files\131218 crosswaves_merges.do"
	*Does: Combines wave 2 and wave 1 datasets & wave 3 and wave 1 datasets
	*Data Input: indicators_w2, indicators_w3 ;Wave I\children0to36months_w1.dta, children6t015years_w1.dta, marriedwoman16to49years_w1.dta, R.dta; prov_variables_*_w2.dta, prov_variables_*_w1.dta
	*Data Output: indicators_w2_with_w1controls.dta, prov_variables_*_w2_with_w1controls.dta, indicators_w3_generasi_with_w1controls.dta
	
**********************************************
**********************************************	
	
//Call do-file for generating tables for paper

cd ..\
do "Do Files\131228 tables_final.do"
	*Does: Creates Tables 1-13 
	
