local rundir "SPECIFY_PATH\Generasi_Files\PublicData\"


cd\
cd `rundir'

	
local do_table3 = 1
local do_table4 = 1
local do_table5 = 1
local do_table6 = 1
local do_table7 = 1
local do_table8 = 1
local do_table9 = 1
local do_table10A = 1
local do_table10B = 1 
local do_table11 = 1

local do_table12A = 1
local do_table12B = 1
local do_table12C = 1
local do_table13 = 1


*****


clear
set more off
set mem 400m
set matsize 6000


*********
* Generate w1 kec means of the 12 main indicators to use as controls in all specifications
*********
	use "kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov = llk01_cd
	keep Location_ID kab_id drop
	sort Location_ID
	tempfile temp
	save `temp', replace
	
	***B/C we need to substitute in kabupaten avg for kecamatan in some cases where missing (for school variables, b/c not have kids in some kec), want to make sure we have only proper non-dropping kecs going into average
	use "Wave II\table_1_2_vars_w2", clear
	keep Location_ID kab_id
	duplicates drop

	cap drop _merge
	sort Location_ID
	merge Location_ID using `temp', uniqusing
	tab _m
	cap codebook Location_ID if _m == 2
	drop _m
	drop if drop == 1
	keep Location_ID kab_id
	sort Location_ID
	
	tempfile kecs_match_for_avg
	save `kecs_match_for_avg', replace
	
	use "Wave I\table_1_2_vars_generasi_w1", clear	
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the 12 indicator variables
	foreach x of var  pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 { 
		bys Location_ID: egen k12_`x' = mean(`x')
		bys kab_id:		egen ka12`x' = mean(`x')	
		replace k12_`x' = ka12`x' if k12_`x' == .	
	}
	
	keep Location_ID k12_*_w1 ka12*_w1
	duplicates drop 
	
	sort Location_ID
	tempfile k12_avg_w1
	save `k12_avg_w1', replace
	
	
	**Identify kab_id and Location_ID info based on ea_code (for those .dta files for which not already have merged in at this point)
	use "Wave I\table_1_2_vars_w1", clear
	keep ea_code kab_id Location_ID
	drop if ea_code == ""
	duplicates drop
	sort ea_code
	tempfile kab_info
	save `kab_info', replace

	

*******************************************************
//Carrying out regressions for Table 3 indicators
******************************************************

if `do_table3' == 1 {
	set more off	
	cd\
	cd `rundir'
	cd "Wave I"
	
	use table_1_2_vars_generasi_w1, clear
	
	//Keeping only non-drop kecamatan
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the 12 indicator variables (+ 4 other alt specs) [not want to do the kab average fill in for the gross enrollment kec variables, since doing regression at kec level]
	foreach x of var  pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1{ 
		bys Location_ID: egen kec_`x' = mean(`x')
		bys kab_id:		egen kab_`x' = mean(`x')	
		replace kec_`x' = kab_`x' if kec_`x' == .
	}
	
	drop _merge
	keep Location_ID kec_*_w1 kab_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	****
	
	use Data\R, clear
	
	gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile tempback
	save `tempback'

	drop panel_hh_id_back_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'
	
	use `tempback'
	drop panel_hh_id_back_w2
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	
	********************************************
	*****           Wave II                ***** 
	********************************************
	
	
	cd ..\
	cd "Wave II"
	
	use table_1_2_vars_w2_with_w1controls, clear
	
	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 2 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	
	****
	**Incorporating kab level averages for kec 3202270 since not have kec level w1 values for it

	foreach x of var pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1{ 
		**Grabbing the kabupaten average for 3202270
		bys kab_id:		egen ka`x' = mean(ka12`x')	
		replace k12_`x' = ka`x' if Location_ID == "3202270"
		drop ka`x' ka12`x'
	}


	foreach x of var pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1{ 
		**just using this for kec 3202270, so mean will just be the kab value we already have for the other kecs in the kab
		bys kab_id:		egen ka`x' = mean(kab_`x')
		replace kec_`x' = ka`x' if Location_ID == "3202270"
		drop kab_`x' ka`x'
	}

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
		
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	
	********
	* create differenced versions
	********

**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	
	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w2 = `q'_w2 - kec_`q'_w1
	 
		g di_`q'_w2 = `q'_w2 - kec_`q'_w1
		replace di_`q'_w2 = `q'_w2 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w2 = gross_SD_enroll_kec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w2 = gross_SMP_enroll_kec_w2 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w2 = gross_SD_enroll_kec_crsec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w2 = gross_SMP_enroll_kec_crsec_w2 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	

	
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w2 -gross_SD_enroll_kec_w2 -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
		
	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
								
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1
				rename times_weighed_last3months_w2 times_weighed_last3m_w2
				rename dk_times_weighed_last3months_w2 dk_times_weighed_last3m_w2
				rename di_times_weighed_last3months_w2 di_times_weighed_last3m_w2

	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	
	save table_1_2_vars_w2_full_suest, replace
	
	tempfile temp
	save `temp'
	
	drop if gen_year2 == 1
	save table_1_2_vars_w2_full_suest_no_genyear2, replace
	
	use `temp', clear
	
	drop if gen_year1 == 1
	
	save table_1_2_vars_w2_full_suest_no_genyear1, replace
	
	
	
	
	********************************************
	*****           Wave III               ***** 
	********************************************
	
	
	cd ..\
	cd "Wave III"
	
	use table_1_2_vars_generasi_w3_with_w1controls, clear

	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 3 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	***XBEN: changed this to keep kec 3202270, which wasn't surveyed in baseline
	drop _merge
	
	
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	
	****
	**Incorporating kab level averages for kec 3202270 since not have kec level w1 values for it
	
	foreach x of var pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1{ 
		**Grabbing the kabupaten average for 3202270
		bys kab_id:		egen ka`x' = mean(ka12`x')	
		replace k12_`x' = ka`x' if Location_ID == "3202270"
		drop ka`x' ka12`x'
	}


	foreach x of var pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1{ 
		**just using this for kec 3202270, so mean will just be the kab value we already have for the other kecs in the kab
		bys kab_id:		egen ka`x' = mean(kab_`x')
		replace kec_`x' = ka`x' if Location_ID == "3202270"
		drop kab_`x' ka`x'
	}

	****

	** New household - Wave III info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	
	********
	* create differenced versions
	********

	**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w3 = `q'_w3 - kec_`q'_w1
	 
		g di_`q'_w3 = `q'_w3 - kec_`q'_w1
		replace di_`q'_w3 = `q'_w3 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w3 = gross_SD_enroll_kec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w3 = gross_SMP_enroll_kec_w3 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w3 = gross_SD_enroll_kec_crsec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w3 = gross_SMP_enroll_kec_crsec_w3 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
	
	
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3 -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	

	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
				
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1				
				rename times_weighed_last3months_w3 times_weighed_last3m_w3
				rename dk_times_weighed_last3months_w3 dk_times_weighed_last3m_w3
				rename di_times_weighed_last3months_w3 di_times_weighed_last3m_w3

	
	save table_1_2_vars_generasi_w3_full_suest, replace	
	
	
	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_1_2_vars_w2_full_suest", clear
	
	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 id panel_hh obs_type HH_id rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x /*PNPM* control_pnpmyr2*/

	tempfile temp
	save `temp'	
	
	use table_1_2_vars_generasi_w3_full_suest, clear
	

	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 id panel_hh HH_id obs_type rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x /*PNPM* control_pnpmyr2*/
	append using `temp'
	
	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
					
			rename age13to15_fullattend_twoweeks_w1 age13to15_fullattend_2weeks_w1	
			
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_m1_group "ind_*_m1"
			local group_kec_w1 "*_w1"
				
			foreach q of varlist `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_m1_group' `group_kec_w1'{
				gen `q'w = wave_3 * `q'
				}

	
	save table_1_2_vars_pooled_full_suest, replace
	
	
	************************************************************************
	************************************************************************



foreach w in table_1_2_vars_w2_full_suest table_1_2_vars_generasi_w3_full_suest table_1_2_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{
		
			if "`w'" == "table_1_2_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_1_2_vars_w2_full_suest", clear
			}
			if "`w'" == "table_1_2_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_1_2_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel
	
			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .
		
			gen include_obs = .

			gen indicator_name_avgSE 				= ""
			gen control_avgSE_`wave' 				= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
			
			gen mod3_genplusA_avgPE_`wave' = ""
			gen mod3_gen_avgPE_`wave' = ""
			gen mod3_genvA_avgPE_`wave' = ""
			
				
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}

			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_2_vars_generasi_w1", clear	

			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
			}
		
			sort Location_ID
			merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop

	
			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3
			
			rename  times_weighed_last3months_w1  times_weighed_last3m_w1
			rename  times_weighed_last2months_w1  times_weighed_last2m_w1


			**Generating baseline means
			foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
				cap drop avg_`x'_w1 se_`x'_w1
				summ `x'_w1 [weight = baseline_weight]
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}

			foreach x in gross_SMP_enroll_kec gross_SD_enroll_kec{
				cap drop avg_`x'_w1 se_`x'_w1
				cap drop include_x_w1
				bys obs_type Location_ID: gen include_x_w1 = 1 if _n == 1 & obs_type == 10 
				summ `x'_w1 if include_x_w1 == 1
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}		

			keep avg_*w1 se_*w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm	  
	
			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
	
			local pick = 1
			

			
			local vars_list "pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks "

			gen wave3 = (wave == 3)
	
		
			foreach x in `vars_list'{
	
			if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){
				gen wv_`x'_int = `x'_w1 * wave3
			}
			else{
				gen wv_`x'_int = ind_`x'_w1 * wave3
			}
			
				disp "*******`x'_`wave'**********"

				
				
				**Condensing to one observation per kec
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){ 
					replace include_obs = include_x
				}
				else{
					replace include_obs = 1
				}
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)
	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "kec_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1"
					local ind_val_m1_wave "ind_`x'_m1"
					local kab_wave "kab_id"
					local gross_kec_w1 "`x'_w1"
					local gross_k12_wl "k12_*_w1"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "kec_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1*"
					local ind_val_m1_wave "ind_`x'_m1*"
					local kab_wave "kab_wave"
					local gross_kec_w1 "`x'_w1*"
				}
						
				
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				**Including kec level control for variable not found in original 12	
				if ("`x'" == "cond_age13to15_pct_2wks" | "`x'" == "enroll_age13to15_SMP" | "`x'" == "enroll_age7to12_SD" | "`x'" == "enroll_age13to15_other")  & ("`z'" == "indallkeccontrols"  | "`z'" == "allkeccontrols") {
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"			
				}
			
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "allkeccontrols") {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `gross_kec_w1"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	

				if "`z'" == "indcontrols_17vill" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave' control_pnpmyr2"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "keccontrols"){
					local yvar "`x'_`wave'"
					local kec_val_w1 "`gross_kec_w1'"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
						
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "differenceskec") {
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
				
	
				if ("`x'" == "gross_SD_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
	
				if ("`x'" == "gross_SMP_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SD_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SMP_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}	
	
	
				if ("`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec"){
					local control_add "& panel_hh == 0"
				}	
	
	
	
				if "`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec" | "`x'" == "pre_natal_visits" | "`x'" == "iron_pills_categ" | "`x'" == "good_assisted_delivery" | "`x'" == "post_natal_visits" {
					local age_vals ""		
				}
				if "`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec" & "`x'" != "pre_natal_visits" & "`x'" != "iron_pills_categ" & "`x'" != "good_assisted_delivery" & "`x'" != "post_natal_visits" & "`z'" != "nocontrols"{
					local age_vals "`age_vals_wave'"
				}



				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			

				
				*************************
				//create points weights for regression coefficients
				if "`x'" == "pre_natal_visits" {
				local pw_`var_num' = 132518*12 
				}
				if "`x'" == "good_assisted_delivery"{
				local pw_`var_num' = 132518*100
				}
				if "`x'" == "post_natal_visits"{
				local pw_`var_num' = 132518*25
				}
				if "`x'" == "iron_pills_categ"{
				local pw_`var_num' = 132518*7
				}
				if "`x'" == "imm_uptak_pct_23mons"{
				local pw_`var_num' = 132518*48
				}
				if "`x'" == "times_weighed_last3m"{
				local pw_`var_num' = 676092*8
				}
				if "`x'" == "vitA_total_6mons_2years"{
				local pw_`var_num' = 271787*10
				}
				if "`x'" == "mal_weightforage"{
				local pw_`var_num' = 404305*48
				}
				if "`x'" == "enroll_age7to12" {
				local pw_`var_num' = 811197*25 
				}  
				if "`x'" == "enroll_age13to15"{
				local pw_`var_num' = 337154*50
				}
				if "`x'" == "age7to12_pct_twoweeks"{
				local pw_`var_num' = 811197*20
				}
				if "`x'" == "age13to15_pct_twoweeks"{
				local pw_`var_num' = 337154*50
				}
				
		
				****
				
				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1, cluster(Location_ID)
				

				replace num_obs = e(N) in `number'
				
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					local basemean1_`var_num' = r(mean)
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}
				
				**Cross sectional observations 						
				summ `control_mean' `control_add' 
				local mean1_`var_num' = r(mean)
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'
				
				
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				**************************
				replace indicator_name = "`x'" in `number'
	

				**************************

				**Repeat without clustering for use in suest (which adds clustering there)
				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1
				
				noi estimates store var`var_num'_eg1vA	

				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)	
					
				
				
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1
		
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}			
	
	
			}
	
			outsheet indicator_name baseline_mean control_mean mod*_gen* num_obs in 1/75 using `direc'table3_coba_`z'_`b'_`wave', replace			

			**No cluster here b/c include with suest below
			
			
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			

	 				suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA, cluster(Location_ID)
	 			
	 			
	 				
	 				*Total
					*SE, Gen
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 12)
									
					gen mod3_gen_b 		=r(estimate) 
					gen mod3_gen_se 		= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8)
					drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 4)
					drop mod?_gen_b mod?_gen_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'			= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'			= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					
		
					*Total
					*SE, VA
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12)
					gen mod3_genvA_b 		= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					*Total
					*SE, VA + Gen
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12)
					gen mod3_genplusA_b 		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
					
					
					
					****
					* POINTS
					****

				
					display "HERE"
					display `pw_1'
					display `pw_2'
					display `pw_3'
					display `pw_4'
					display `pw_5'
					display `pw_6'
					display `pw_7'
					display `pw_8'
					display `pw_9'
					display `pw_10'
					display `pw_11'
					display `pw_12'
					local pointnorm = 1000000
					
					*Total points effect
					*SE, Gen
					lincom (([var1_eg1vA_mean]`generasi'* `pw_1' + [var2_eg1vA_mean]`generasi'* `pw_2' + [var3_eg1vA_mean]`generasi'* `pw_3' + [var4_eg1vA_mean]`generasi'* `pw_4' + [var5_eg1vA_mean]`generasi'* `pw_5' + [var6_eg1vA_mean]`generasi'* `pw_6' + [var7_eg1vA_mean]`generasi'* `pw_7' - [var8_eg1vA_mean]`generasi'* `pw_8' + [var9_eg1vA_mean]`generasi'* `pw_9' + [var10_eg1vA_mean]`generasi'* `pw_10' + [var11_eg1vA_mean]`generasi'* `pw_11' + [var12_eg1vA_mean]`generasi'* `pw_12') )
					gen mod3_gen_PE_b 		= r(estimate) / `pointnorm'
					gen mod3_gen_PE_se 		= r(se) / `pointnorm'
					tostring mod3_gen_PE_b, replace format(%10.4f) force
					tostring mod3_gen_PE_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi'* `pw_1' + [var2_eg1vA_mean]`generasi'* `pw_2' + [var3_eg1vA_mean]`generasi'* `pw_3' + [var4_eg1vA_mean]`generasi'* `pw_4' + [var5_eg1vA_mean]`generasi'* `pw_5' + [var6_eg1vA_mean]`generasi'* `pw_6' + [var7_eg1vA_mean]`generasi'* `pw_7' - [var8_eg1vA_mean]`generasi'* `pw_8' + [var9_eg1vA_mean]`generasi'* `pw_9' + [var10_eg1vA_mean]`generasi'* `pw_10' + [var11_eg1vA_mean]`generasi'* `pw_11' + [var12_eg1vA_mean]`generasi'* `pw_12') ) = 0			
					local p_val			=  r(p)
					replace mod3_gen_avgPE_`wave'		= mod3_gen_PE_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgPE_`wave'		= "(" + mod3_gen_PE_se + ")" in `line_num_plus1'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "***" if `p_val' < 0.01 in `line_num'

					*Health points effect
		
					lincom (([var1_eg1vA_mean]`generasi'* `pw_1' + [var2_eg1vA_mean]`generasi'* `pw_2' + [var3_eg1vA_mean]`generasi'* `pw_3' + [var4_eg1vA_mean]`generasi'* `pw_4' + [var5_eg1vA_mean]`generasi'* `pw_5' + [var6_eg1vA_mean]`generasi'* `pw_6' + [var7_eg1vA_mean]`generasi'* `pw_7' - [var8_eg1vA_mean]`generasi'* `pw_8') )
					drop mod?_gen*_PE_b mod?_gen*_PE_se
					gen mod3_gen_PE_b			= r(estimate) / `pointnorm'
					gen mod3_gen_PE_se 		= r(se) / `pointnorm'
					tostring mod3_gen_PE_b, replace format(%10.4f) force
					tostring mod3_gen_PE_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi'* `pw_1' + [var2_eg1vA_mean]`generasi'* `pw_2' + [var3_eg1vA_mean]`generasi'* `pw_3' + [var4_eg1vA_mean]`generasi'* `pw_4' + [var5_eg1vA_mean]`generasi'* `pw_5' + [var6_eg1vA_mean]`generasi'* `pw_6' + [var7_eg1vA_mean]`generasi'* `pw_7' - [var8_eg1vA_mean]`generasi'* `pw_8') ) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgPE_`wave'		= mod3_gen_PE_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgPE_`wave'		= "(" + mod3_gen_PE_se + ")" in `line_num_plus3'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education points effect
					
					lincom (([var9_eg1vA_mean]`generasi'* `pw_9' + [var10_eg1vA_mean]`generasi'* `pw_10' + [var11_eg1vA_mean]`generasi'* `pw_11' + [var12_eg1vA_mean]`generasi'* `pw_12'))
					drop mod?_gen*_PE_b mod?_gen*_PE_se
					gen mod3_gen_PE_b			= r(estimate) / `pointnorm'
					gen mod3_gen_PE_se 		= r(se) / `pointnorm'
					tostring mod3_gen_PE_b, replace format(%10.4f) force
					tostring mod3_gen_PE_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi'* `pw_9' + [var10_eg1vA_mean]`generasi'* `pw_10' + [var11_eg1vA_mean]`generasi'* `pw_11' + [var12_eg1vA_mean]`generasi'* `pw_12') ) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgPE_`wave'		= mod3_gen_PE_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgPE_`wave'		= "(" + mod3_gen_PE_se + ")" in `line_num_plus5'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgPE_`wave'	 	= mod3_gen_PE_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
		
		
					
					*Total points effect
					*SE, VA
					lincom (([var1_eg1vA_mean]`generasi_vA'* `pw_1' + [var2_eg1vA_mean]`generasi_vA'* `pw_2' + [var3_eg1vA_mean]`generasi_vA'* `pw_3' + [var4_eg1vA_mean]`generasi_vA'* `pw_4' + [var5_eg1vA_mean]`generasi_vA'* `pw_5' + [var6_eg1vA_mean]`generasi_vA'* `pw_6' + [var7_eg1vA_mean]`generasi_vA'* `pw_7' - [var8_eg1vA_mean]`generasi_vA'* `pw_8' + [var9_eg1vA_mean]`generasi_vA'* `pw_9' + [var10_eg1vA_mean]`generasi_vA'* `pw_10' + [var11_eg1vA_mean]`generasi_vA'* `pw_11' + [var12_eg1vA_mean]`generasi_vA'* `pw_12') )
					gen mod3_genvA_PE_b 		= r(estimate) / `pointnorm'
					gen mod3_genvA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genvA_PE_b, replace format(%10.4f) force
					tostring mod3_genvA_PE_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi_vA'* `pw_1' + [var2_eg1vA_mean]`generasi_vA'* `pw_2' + [var3_eg1vA_mean]`generasi_vA'* `pw_3' + [var4_eg1vA_mean]`generasi_vA'* `pw_4' + [var5_eg1vA_mean]`generasi_vA'* `pw_5' + [var6_eg1vA_mean]`generasi_vA'* `pw_6' + [var7_eg1vA_mean]`generasi_vA'* `pw_7' - [var8_eg1vA_mean]`generasi_vA'* `pw_8' + [var9_eg1vA_mean]`generasi_vA'* `pw_9' + [var10_eg1vA_mean]`generasi_vA'* `pw_10' + [var11_eg1vA_mean]`generasi_vA'* `pw_11' + [var12_eg1vA_mean]`generasi_vA'* `pw_12') ) = 0			
					local p_val			=  r(p)
					replace mod3_genvA_avgPE_`wave'		= mod3_genvA_PE_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgPE_`wave'		= "(" + mod3_genvA_PE_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "***" if `p_val' < 0.01 in `line_num'

					*Health points effect
		
					lincom (([var1_eg1vA_mean]`generasi_vA'* `pw_1' + [var2_eg1vA_mean]`generasi_vA'* `pw_2' + [var3_eg1vA_mean]`generasi_vA'* `pw_3' + [var4_eg1vA_mean]`generasi_vA'* `pw_4' + [var5_eg1vA_mean]`generasi_vA'* `pw_5' + [var6_eg1vA_mean]`generasi_vA'* `pw_6' + [var7_eg1vA_mean]`generasi_vA'* `pw_7' - [var8_eg1vA_mean]`generasi_vA'* `pw_8') )
					drop mod?_gen*_PE_b mod?_gen*_PE_se
					gen mod3_genvA_PE_b			= r(estimate) / `pointnorm'
					gen mod3_genvA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genvA_PE_b, replace format(%10.4f) force
					tostring mod3_genvA_PE_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi_vA'* `pw_1' + [var2_eg1vA_mean]`generasi_vA'* `pw_2' + [var3_eg1vA_mean]`generasi_vA'* `pw_3' + [var4_eg1vA_mean]`generasi_vA'* `pw_4' + [var5_eg1vA_mean]`generasi_vA'* `pw_5' + [var6_eg1vA_mean]`generasi_vA'* `pw_6' + [var7_eg1vA_mean]`generasi_vA'* `pw_7' - [var8_eg1vA_mean]`generasi_vA'* `pw_8') ) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgPE_`wave'		= mod3_genvA_PE_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgPE_`wave'		= "(" + mod3_genvA_PE_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education points effect
					
					lincom (([var9_eg1vA_mean]`generasi_vA'* `pw_9' + [var10_eg1vA_mean]`generasi_vA'* `pw_10' + [var11_eg1vA_mean]`generasi_vA'* `pw_11' + [var12_eg1vA_mean]`generasi_vA'* `pw_12'))
					drop mod?_gen*_PE_b mod?_gen*_PE_se
					gen mod3_genvA_PE_b			= r(estimate) / `pointnorm'
					gen mod3_genvA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genvA_PE_b, replace format(%10.4f) force
					tostring mod3_genvA_PE_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi_vA'* `pw_9' + [var10_eg1vA_mean]`generasi_vA'* `pw_10' + [var11_eg1vA_mean]`generasi_vA'* `pw_11' + [var12_eg1vA_mean]`generasi_vA'* `pw_12') ) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgPE_`wave'		= mod3_genvA_PE_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgPE_`wave'		= "(" + mod3_genvA_PE_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgPE_`wave'	 	= mod3_genvA_PE_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
		
		
					*SE, VA + Gen
					
					
					*Total points effect
		
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')* `pw_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')*`pw_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')* `pw_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')* `pw_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')* `pw_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')* `pw_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')* `pw_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')* `pw_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')* `pw_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')* `pw_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')* `pw_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')* `pw_12') )
					drop mod?_gen*_b mod?_gen*_se	
					gen mod3_genplusA_PE_b 		= r(estimate) / `pointnorm'
					gen mod3_genplusA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genplusA_PE_b, replace format(%10.4f) force
					tostring mod3_genplusA_PE_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')* `pw_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')*`pw_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')* `pw_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')* `pw_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')* `pw_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')* `pw_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')* `pw_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')* `pw_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')* `pw_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')* `pw_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')* `pw_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')* `pw_12') ) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgPE_`wave'		= mod3_genplusA_PE_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgPE_`wave'		= "(" + mod3_genplusA_PE_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health points effect
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')* `pw_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')*`pw_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')* `pw_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')* `pw_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')* `pw_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')* `pw_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')* `pw_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')* `pw_8') )
					drop mod?_gen*_PE_b mod?_gen*_PE_se				
					gen mod3_genplusA_PE_b		= r(estimate) / `pointnorm'
					gen mod3_genplusA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genplusA_PE_b, replace format(%10.4f) force
					tostring mod3_genplusA_PE_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')* `pw_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')*`pw_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')* `pw_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')* `pw_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')* `pw_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')* `pw_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')* `pw_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')* `pw_8') ) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgPE_`wave'		= mod3_genplusA_PE_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgPE_`wave'		= "(" + mod3_genplusA_PE_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	points effect

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')* `pw_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')* `pw_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')* `pw_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')* `pw_12') )
					drop mod?_gen*_PE_b mod?_gen*_PE_se
					gen mod3_genplusA_PE_b		= r(estimate) / `pointnorm'
					gen mod3_genplusA_PE_se 		= r(se) / `pointnorm'
					tostring mod3_genplusA_PE_b, replace format(%10.4f) force
					tostring mod3_genplusA_PE_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')* `pw_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')* `pw_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')* `pw_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')* `pw_12') ) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgPE_`wave'		= mod3_genplusA_PE_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgPE_`wave'		= "(" + mod3_genplusA_PE_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgPE_`wave'	 	= mod3_genplusA_PE_b + "***" if `p_val' < 0.01 in `line_num_plus4'
					
					
		
				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* *avgPE* in 1/10 using `direc'table3_suest_avgSE_POINTS_`z'_`b'_`wave', replace

			}
		}	
	
	
	}

}


*******************************************************
//Carrying out regressions for Table 4 indicators
******************************************************


if `do_table4' == 1 {
	set more off
	cd\
	cd `rundir'
	cd "Wave I"
	
	use table_1_2_vars_generasi_w1, clear
	
	//Keeping only non-drop kecamatan
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the 12 indicator variables (+ 4 other alt specs) [not want to do the kab average fill in for the gross enrollment kec variables, since doing regression at kec level]
	foreach x of var  pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1{ 
		bys Location_ID: egen kec_`x' = mean(`x')
		bys kab_id:		egen kab_`x' = mean(`x')	
		replace kec_`x' = kab_`x' if kec_`x' == .
	}
	
	drop _merge
	keep Location_ID kec_*_w1 kab_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	****
	
	use Data\R, clear
	
	gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile tempback
	save `tempback'

	drop panel_hh_id_back_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'
	
	use `tempback'
	drop panel_hh_id_back_w2
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	
	********************************************
	*****           Wave II                ***** 
	********************************************
	
	
	cd ..\
	cd "Wave II"
	
	use table_1_2_vars_w2_with_w1controls, clear
	
	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 2 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
		
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	
	********
	* create differenced versions
	********

**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	
	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w2 = `q'_w2 - kec_`q'_w1
	 
		g di_`q'_w2 = `q'_w2 - kec_`q'_w1
		replace di_`q'_w2 = `q'_w2 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w2 = gross_SD_enroll_kec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w2 = gross_SMP_enroll_kec_w2 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w2 = gross_SD_enroll_kec_crsec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w2 = gross_SMP_enroll_kec_crsec_w2 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
	
	
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w2 -gross_SD_enroll_kec_w2 -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	
	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2


  foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_pooled gen_pooled_versi_A{
		local vv = 1
		foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other gross_SD_enroll_kec gross_SMP_enroll_kec{
			if "`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec"{
				gen pr_ind`vv'_`C' = kec_`x'_w1 * `C'
			}
			if "`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"{
				gen pr_ind`vv'_`C' = `x'_w1 * `C'
			}	
			local vv = `vv' + 1
		}	
	}

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
								
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1
				rename times_weighed_last3months_w2 times_weighed_last3m_w2
				rename dk_times_weighed_last3months_w2 dk_times_weighed_last3m_w2
				rename di_times_weighed_last3months_w2 di_times_weighed_last3m_w2

	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	
	save table_2_1_preperiod_for_1_2_vars_w2_full_suest, replace
	
	
	********************************************
	*****           Wave III               ***** 
	********************************************
	
	
	cd ..\
	cd "Wave III"
	
	use table_1_2_vars_generasi_w3_with_w1controls, clear

	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 3 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	


	****

	** New household - Wave III info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	
	********
	* create differenced versions
	********

	**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w3 = `q'_w3 - kec_`q'_w1
	 
		g di_`q'_w3 = `q'_w3 - kec_`q'_w1
		replace di_`q'_w3 = `q'_w3 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w3 = gross_SD_enroll_kec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w3 = gross_SMP_enroll_kec_w3 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w3 = gross_SD_enroll_kec_crsec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w3 = gross_SMP_enroll_kec_crsec_w3 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
	
	
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3 -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	

	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)


  foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A gen_pooled gen_pooled_versi_A{
		local vv = 1
		foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other gross_SD_enroll_kec gross_SMP_enroll_kec{
			if "`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec"{
				gen pr_ind`vv'_`C' = kec_`x'_w1 * `C'
			}
			if "`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"{
				gen pr_ind`vv'_`C' = `x'_w1 * `C'
			}	
			local vv = `vv' + 1
		}	
	}

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
								
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1				
				rename times_weighed_last3months_w3 times_weighed_last3m_w3
				rename dk_times_weighed_last3months_w3 dk_times_weighed_last3m_w3
				rename di_times_weighed_last3months_w3 di_times_weighed_last3m_w3

	
	save table_2_1_preperiod_for_1_2_vars_generasi_w3_full_suest, replace	
	
	
	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_2_1_preperiod_for_1_2_vars_w2_full_suest", clear
	
	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 id panel_hh obs_type HH_id rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x pr_ind*

	tempfile temp
	save `temp'	
	
	use table_2_1_preperiod_for_1_2_vars_generasi_w3_full_suest, clear
	

	**If doing differences regressions specs, comeback and check why some stuff is starred off here and not in wave 2 for loop?
	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec /*dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage*/ dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 id panel_hh HH_id obs_type rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x pr_ind*

	append using `temp'
	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
					
			rename age13to15_fullattend_twoweeks_w1 age13to15_fullattend_2weeks_w1	
		
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_m1_group "ind_*_m1"
			local group_kec_w1 "*_w1"
						
			foreach q of varlist `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_m1_group' `group_kec_w1'{
				gen `q'w = wave_3 * `q'
				}
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_po -gross_SD_enroll_kec_po -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1

	save table_2_1_preperiod_for_1_2_vars_pooled_full_suest, replace
	

	
	************************************************************************
	************************************************************************
	

foreach w in table_2_1_preperiod_for_1_2_vars_w2_full_suest table_2_1_preperiod_for_1_2_vars_generasi_w3_full_suest table_2_1_preperiod_for_1_2_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{
		
			if "`w'" == "table_2_1_preperiod_for_1_2_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_2_1_preperiod_for_1_2_vars_w2_full_suest", clear
			}
			if "`w'" == "table_2_1_preperiod_for_1_2_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_2_1_preperiod_for_1_2_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel

			gen indicator_name 	= ""
			gen baseline_mean = ""
			gen control_mean_`wave'	= ""
			gen mod3_genplusA_preprd_`wave' = ""			
			gen mod3_gen_preprd_`wave' = ""
			gen mod3_genvA_preprd_`wave' = ""
			gen mod3_genvA_plus10preprd_`wave' = ""
			gen num_obs_`wave' 		= .						

			gen indicator_name_SE 	= ""
			gen mod3_genplusA_preprd_SE`wave' = ""
			gen mod3_gen_preprd_SE`wave' = ""
			gen mod3_genvA_preprd_SE`wave' = ""
			gen mod3_genvA_plus10preprd_SE`wave' = ""	
			
			gen include_obs = .
		
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}

			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_2_vars_generasi_w1", clear	
		
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75			
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
			}
		
			sort Location_ID
			merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop

	
			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3

			rename  times_weighed_last3months_w1  times_weighed_last3m_w1
			rename  times_weighed_last2months_w1  times_weighed_last2m_w1

			**Generating baseline means
			foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
				cap drop avg_`x'_w1 se_`x'_w1
				summ `x'_w1 [weight = baseline_weight]
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}

			foreach d in gross_SMP_enroll_kec gross_SD_enroll_kec{
				cap drop avg_`d'_w1 se_`d'_w1
				cap drop include_x_w1
				bys obs_type Location_ID: gen include_x_w1 = 1 if _n == 1 & obs_type == 10 
				summ `d'_w1 if include_x_w1 == 1
				gen avg_`d'_w1 = r(mean)
				gen se_`d'_w1 = r(sd)
			}		

			keep avg_*w1 se_*w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm	  
	
			local marker = 0
			local count = 1
			local countx = 1			
			local number = 1
			local number_plus1 = 2
			local var_num = 1
	
			local pick = 1
			
			sort Location_ID


			local vars_list "pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks "
			
			gen wave3 = (wave == 3)
	

			
			cap drop kab_wave* 
			sort kab_id wave
			egen kab_wave = group(prov_id kab_id wave)
			tab kab_wave, gen(kab_wave_)		
			sort Location_ID
		
			foreach x in `vars_list'{
	
			if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){
				gen wv_`x'_int = `x'_w1 * wave3
			}
			else{
				gen wv_`x'_int = ind_`x'_w1 * wave3
			}
			
			
			**NOTE: NOT DONE indallkec or allkeccontrols specifications for results this time, if do at some point need to update this code to handle the k12/kec thing mentioned below (in pooled regression, need an additional fix)
				**Doing this so the k12 variable for the indicator being used is not included in its regression (will rename to normal at bottom)
				**b/c already have this variable included as kec_`x'_w1 b/c of interaction
			//	rename k12_`x'_w1 q_`x'_w1
			
				disp "*******`x'_`wave'**********"

				
				
				**Condensing to one observation per kec
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){ 
					replace include_obs = include_x
				}
				else{
					replace include_obs = 1
				}
	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "kec_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1"
					local ind_val_m1_wave "ind_`x'_m1"
					local kab_wave "kab_id"
					local gross_kec_w1 "`x'_w1"
					local gross_k12_wl "k12_*_w1"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "kec_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1 wv_`x'_int"
					local ind_val_m1_wave "ind_`x'_m1*"
					local kab_wave "kab_wave"
					local gross_kec_w1 "`x'_w1*"
				}						
						
				
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				**Including kec level control for variable not found in original 12	
				if ("`x'" == "cond_age13to15_pct_2wks" | "`x'" == "enroll_age13to15_SMP" | "`x'" == "enroll_age7to12_SD" | "`x'" == "enroll_age13to15_other")  & ("`z'" == "indallkeccontrols"  | "`z'" == "allkeccontrols") {
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"			
				}
			
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "allkeccontrols") {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `gross_kec_w1"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "keccontrols"){
					local yvar "`x'_`wave'"
					local kec_val_w1 "`gross_kec_w1'"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
						
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "differenceskec") {
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
				
	
				if ("`x'" == "gross_SD_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
	
				if ("`x'" == "gross_SMP_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SD_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SMP_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}	
	
	
				if ("`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec"){
					local control_add "& panel_hh == 0"
					local kec_w1 "kec_`x'_w1"
				}	
	
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){
					local kec_w1 "`x'_w1"
				}
	
				if "`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec" | "`x'" == "pre_natal_visits" | "`x'" == "iron_pills_categ" | "`x'" == "good_assisted_delivery" | "`x'" == "post_natal_visits" {
					local age_vals ""		
				}
				if "`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec" & "`x'" != "pre_natal_visits" & "`x'" != "iron_pills_categ" & "`x'" != "good_assisted_delivery" & "`x'" != "post_natal_visits" & "`z'" != "nocontrols"{
					local age_vals "`age_vals_wave'"
				}



				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			
		
				****
				
				quie      reg `yvar' `generasi' pr_ind`countx'_`generasi' `generasi_vA' pr_ind`countx'_`generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1
				
				noi estimates store var`var_num'_eg1vA

				replace num_obs = e(N) in `number'
				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)	
	
								
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}
				
				**Cross sectional observations 						
				summ `control_mean' & panel_hh == 0 
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'

				gen mod3_gen_preprd_b 		=_b[pr_ind`countx'_`generasi'] 
				gen mod3_gen_preprd_se 		= _se[pr_ind`countx'_`generasi'] 
				tostring mod3_gen_preprd_b, replace format(%10.4f) force
				tostring mod3_gen_preprd_se, replace format(%10.4f) force
	
				test pr_ind`countx'_`generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_preprd_`wave'	= mod3_gen_preprd_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_preprd_`wave'	= "(" + mod3_gen_preprd_se + ")" in `number_plus1'
				replace mod3_gen_preprd_`wave'	= mod3_gen_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_preprd_`wave'	= mod3_gen_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_preprd_`wave'	= mod3_gen_preprd_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_preprd_b 		=_b[pr_ind`countx'_`generasi_vA'] 
				gen mod3_genvA_preprd_se 	= _se[pr_ind`countx'_`generasi_vA'] 
				tostring mod3_genvA_preprd_b, replace format(%10.4f) force
				tostring mod3_genvA_preprd_se, replace format(%10.4f) force
		
				test pr_ind`countx'_`generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_preprd_`wave'	= mod3_genvA_preprd_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_preprd_`wave'	= "(" + mod3_genvA_preprd_se + ")" in `number_plus1'
				replace mod3_genvA_preprd_`wave'	= mod3_genvA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_preprd_`wave'	= mod3_genvA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_preprd_`wave'	= mod3_genvA_preprd_b + "***" if `p_val' < 0.01 in `number'
	
				lincom pr_ind`countx'_`generasi' + pr_ind`countx'_`generasi_vA'
				gen mod3_genplusA_preprd_b 	= r(estimate)
				gen mod3_genplusA_preprd_se 	= r(se)
				tostring mod3_genplusA_preprd_b, replace format(%10.4f) force
				tostring mod3_genplusA_preprd_se, replace format(%10.4f) force
	
				test pr_ind`countx'_`generasi' + pr_ind`countx'_`generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_preprd_`wave'	= mod3_genplusA_preprd_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_preprd_`wave'	= "(" + mod3_genplusA_preprd_se + ")" in `number_plus1'
				replace mod3_genplusA_preprd_`wave'	= mod3_genplusA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_preprd_`wave'	= mod3_genplusA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_preprd_`wave'	= mod3_genplusA_preprd_b + "***" if `p_val' < 0.01 in `number'
				
							
				cap drop kec_counter
				by Location_ID: g kec_counter = _n
				summ `kec_w1' if kec_counter == 1, d
				local pct10_`var_num' = r(p10)
				if "`x'" == "mal_weightforage"{
					local pct10_`var_num' = r(p90)
					
				}			
								
				lincom `generasi_vA' + `pct10_`var_num''*pr_ind`countx'_`generasi_vA'			
				gen mod3_genAplus10_b 	= r(estimate)
				gen mod3_genAplus10_se 	= r(se)
				tostring mod3_genAplus10_b, replace format(%10.4f) force
				tostring mod3_genAplus10_se, replace format(%10.4f) force

				test `generasi_vA' + `pct10_`var_num''*pr_ind`countx'_`generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genvA_plus10preprd_`wave'	= mod3_genAplus10_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_plus10preprd_`wave'	= "(" + mod3_genAplus10_se + ")" in `number_plus1'
				replace mod3_genvA_plus10preprd_`wave'	= mod3_genAplus10_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_plus10preprd_`wave'	= mod3_genAplus10_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_plus10preprd_`wave'	= mod3_genAplus10_b + "***" if `p_val' < 0.01 in `number'
				
				**************************
				replace indicator_name = "`x'" in `number'
	

				**************************

				local marker = 1
				local count = `count' + 1
				local countx = `countx' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1		
		
	
				*drop *mod?_gen*_b mod?_gen*_se control_mean_? *mod?_preprd*_b *mod?_preprd*_se			
				drop *mod?_gen*_b mod?_gen*_se control_mean_? 						
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}			
	
	
			}
	

			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5

			
			local kec1_w1 = "kec_pre_natal_visits_w1"
			local kec2_w1 = "kec_good_assisted_delivery_w1"
			local kec3_w1 = "kec_post_natal_visits_w1"
			local kec4_w1 = "kec_iron_pills_categ_w1"
			local kec5_w1 = "kec_imm_uptak_pct_23mons_w1"
			local kec6_w1 = "kec_times_weighed_last3m_w1"
			local kec7_w1 = "kec_vitA_total_6mons_2years_w1"
			local kec8_w1 = "kec_mal_weightforage_w1"
			local kec9_w1 = "kec_enroll_age7to12_w1"
			local kec10_w1 = "kec_enroll_age13to15_w1"
			local kec11_w1 = "kec_age7to12_pct_twoweeks_w1"
			local kec12_w1 = "kec_age13to15_pct_twoweeks_w1"			
			
				
	 			suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA, cluster(Location_ID)
	 			*****
	 				*Total

				*****		
					*Total
			
					lincom (([var1_eg1vA_mean]pr_ind1_`generasi'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi'/`sd1vA_6'  + [var7_eg1vA_mean]pr_ind7_`generasi'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi'/`sd1vA_8' + [var9_eg1vA_mean]pr_ind9_`generasi'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi'/`sd1vA_12') / 12)

					gen mod3_gen_preprd_b 		= r(estimate) 
					gen mod3_gen_preprd_se 		= r(se) 
					tostring mod3_gen_preprd_b, replace format(%10.4f) force
					tostring mod3_gen_preprd_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]pr_ind1_`generasi'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi'/`sd1vA_6'  + [var7_eg1vA_mean]pr_ind7_`generasi'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi'/`sd1vA_8' + [var9_eg1vA_mean]pr_ind9_`generasi'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_gen_preprd_SE`wave'		= mod3_gen_preprd_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_preprd_SE`wave'		= "(" + mod3_gen_preprd_se + ")" in `line_num_plus1'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom (([var1_eg1vA_mean]pr_ind1_`generasi'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi'/`sd1vA_6'  + [var7_eg1vA_mean]pr_ind7_`generasi'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_preprd_b			= r(estimate) 
					gen mod3_gen_preprd_se 		= r(se) 
					tostring mod3_gen_preprd_b, replace format(%10.4f) force
					tostring mod3_gen_preprd_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]pr_ind1_`generasi'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi'/`sd1vA_6'  + [var7_eg1vA_mean]pr_ind7_`generasi'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_preprd_SE`wave'		= mod3_gen_preprd_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_preprd_SE`wave'		= "(" + mod3_gen_preprd_se + ")" in `line_num_plus3'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom (([var9_eg1vA_mean]pr_ind9_`generasi'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_preprd_b			= r(estimate) 
					gen mod3_gen_preprd_se 		= r(se) 
					tostring mod3_gen_preprd_b, replace format(%10.4f) force
					tostring mod3_gen_preprd_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]pr_ind9_`generasi'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_preprd_SE`wave'		= mod3_gen_preprd_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_preprd_SE`wave'		= "(" + mod3_gen_preprd_se + ")" in `line_num_plus5'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_preprd_SE`wave'	 	= mod3_gen_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				****

					*Total
			
					lincom (([var1_eg1vA_mean]pr_ind1_`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]pr_ind7_`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]pr_ind9_`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi_vA'/`sd1vA_12') / 12)
					gen mod3_genvA_preprd_b 		= r(estimate) 
					gen mod3_genvA_preprd_se 		= r(se) 
					tostring mod3_genvA_preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_preprd_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]pr_ind1_`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]pr_ind7_`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]pr_ind9_`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi_vA'/`sd1vA_12') / 12) = 0	
					local p_val			=  r(p)
					replace mod3_genvA_preprd_SE`wave'		= mod3_genvA_preprd_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_preprd_SE`wave'		= "(" + mod3_genvA_preprd_se + ")" in `line_num_plus1'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom (([var1_eg1vA_mean]pr_ind1_`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]pr_ind7_`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi_vA'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_preprd_b			= r(estimate) 
					gen mod3_genvA_preprd_se 		= r(se) 
					tostring mod3_genvA_preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_preprd_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]pr_ind1_`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]pr_ind2_`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]pr_ind3_`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]pr_ind4_`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]pr_ind5_`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]pr_ind6_`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]pr_ind7_`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]pr_ind8_`generasi_vA'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_preprd_SE`wave'		= mod3_genvA_preprd_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_preprd_SE`wave'		= "(" + mod3_genvA_preprd_se + ")" in `line_num_plus3'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom (([var9_eg1vA_mean]pr_ind9_`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi_vA'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_preprd_b			= r(estimate) 
					gen mod3_genvA_preprd_se 		= r(se) 
					tostring mod3_genvA_preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_preprd_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]pr_ind9_`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]pr_ind10_`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]pr_ind11_`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]pr_ind12_`generasi_vA'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_preprd_SE`wave'		= mod3_genvA_preprd_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_preprd_SE`wave'		= "(" + mod3_genvA_preprd_se + ")" in `line_num_plus5'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_preprd_SE`wave'	 	= mod3_genvA_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				****
					*Total
		
					lincom ((([var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]pr_ind1_`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]pr_ind2_`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]pr_ind3_`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]pr_ind4_`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]pr_ind5_`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]pr_ind6_`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]pr_ind7_`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]pr_ind8_`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]pr_ind9_`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]pr_ind10_`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]pr_ind11_`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]pr_ind12_`generasi')/`sd1vA_12') / 12)
					gen mod3_genplusA_preprd_b 		= r(estimate) 
					gen mod3_genplusA_preprd_se 		= r(se) 
					tostring mod3_genplusA_preprd_b, replace format(%10.4f) force
					tostring mod3_genplusA_preprd_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]pr_ind1_`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]pr_ind2_`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]pr_ind3_`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]pr_ind4_`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]pr_ind5_`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]pr_ind6_`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]pr_ind7_`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]pr_ind8_`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]pr_ind9_`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]pr_ind10_`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]pr_ind11_`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]pr_ind12_`generasi')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_preprd_SE`wave'		= mod3_genplusA_preprd_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_preprd_SE`wave'		= "(" + mod3_genplusA_preprd_se + ")" in `line_num_plus1'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]pr_ind1_`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]pr_ind2_`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]pr_ind3_`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]pr_ind4_`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]pr_ind5_`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]pr_ind6_`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]pr_ind7_`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]pr_ind8_`generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_preprd_b		= r(estimate) 
					gen mod3_genplusA_preprd_se 		= r(se) 
					tostring mod3_genplusA_preprd_b, replace format(%10.4f) force
					tostring mod3_genplusA_preprd_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]pr_ind1_`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]pr_ind2_`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]pr_ind3_`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]pr_ind4_`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]pr_ind5_`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]pr_ind6_`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]pr_ind7_`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]pr_ind8_`generasi')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_preprd_SE`wave'		= mod3_genplusA_preprd_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_preprd_SE`wave'		= "(" + mod3_genplusA_preprd_se + ")" in `line_num_plus3'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]pr_ind9_`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]pr_ind10_`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]pr_ind11_`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]pr_ind12_`generasi')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_preprd_b		= r(estimate) 
					gen mod3_genplusA_preprd_se 		= r(se) 
					tostring mod3_genplusA_preprd_b, replace format(%10.4f) force
					tostring mod3_genplusA_preprd_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]pr_ind9_`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]pr_ind10_`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]pr_ind11_`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]pr_ind12_`generasi')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_preprd_SE`wave'		= mod3_genplusA_preprd_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_preprd_SE`wave'		= "(" + mod3_genplusA_preprd_se + ")" in `line_num_plus5'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_preprd_SE`wave'	 	= mod3_genplusA_preprd_b + "***" if `p_val' < 0.01 in `line_num_plus4'



				****
					*Total
		
					lincom (((`pct10_1'*[var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]`generasi_vA')/`sd1vA_1' + (`pct10_2'*[var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]`generasi_vA')/`sd1vA_2' + (`pct10_3'*[var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]`generasi_vA')/`sd1vA_3' + (`pct10_4'*[var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]`generasi_vA')/`sd1vA_4' + (`pct10_5'*[var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]`generasi_vA')/`sd1vA_5' + (`pct10_6'*[var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]`generasi_vA')/`sd1vA_6' + (`pct10_7'*[var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]`generasi_vA')/`sd1vA_7' - (`pct10_8'*[var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]`generasi_vA')/`sd1vA_8' + (`pct10_9'*[var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]`generasi_vA')/`sd1vA_9' + (`pct10_10'*[var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]`generasi_vA')/`sd1vA_10' + (`pct10_11'*[var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]`generasi_vA')/`sd1vA_11' + (`pct10_12'*[var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]`generasi_vA')/`sd1vA_12') / 12)
					gen mod3_genvA_plus10preprd_b 		= r(estimate) 
					gen mod3_genvA_plus10preprd_se 		= r(se) 
					tostring mod3_genvA_plus10preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_plus10preprd_se, replace format(%10.4f) force
	
					test (((`pct10_1'*[var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]`generasi_vA')/`sd1vA_1' + (`pct10_2'*[var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]`generasi_vA')/`sd1vA_2' + (`pct10_3'*[var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]`generasi_vA')/`sd1vA_3' + (`pct10_4'*[var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]`generasi_vA')/`sd1vA_4' + (`pct10_5'*[var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]`generasi_vA')/`sd1vA_5' + (`pct10_6'*[var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]`generasi_vA')/`sd1vA_6' + (`pct10_7'*[var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]`generasi_vA')/`sd1vA_7' - (`pct10_8'*[var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]`generasi_vA')/`sd1vA_8' + (`pct10_9'*[var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]`generasi_vA')/`sd1vA_9' + (`pct10_10'*[var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]`generasi_vA')/`sd1vA_10' + (`pct10_11'*[var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]`generasi_vA')/`sd1vA_11' + (`pct10_12'*[var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]`generasi_vA')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plus10preprd_SE`wave'		= mod3_genvA_plus10preprd_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_plus10preprd_SE`wave'		= "(" + mod3_genvA_plus10preprd_se + ")" in `line_num_plus1'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom (((`pct10_1'*[var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]`generasi_vA')/`sd1vA_1' + (`pct10_2'*[var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]`generasi_vA')/`sd1vA_2' + (`pct10_3'*[var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]`generasi_vA')/`sd1vA_3' + (`pct10_4'*[var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]`generasi_vA')/`sd1vA_4' + (`pct10_5'*[var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]`generasi_vA')/`sd1vA_5' + (`pct10_6'*[var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]`generasi_vA')/`sd1vA_6' + (`pct10_7'*[var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]`generasi_vA')/`sd1vA_7' - (`pct10_8'*[var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]`generasi_vA')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genvA_plus10preprd_b		= r(estimate) 
					gen mod3_genvA_plus10preprd_se 		= r(se) 
					tostring mod3_genvA_plus10preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_plus10preprd_se, replace format(%10.4f) force
	
					test (((`pct10_1'*[var1_eg1vA_mean]pr_ind1_`generasi_vA' + [var1_eg1vA_mean]`generasi_vA')/`sd1vA_1' + (`pct10_2'*[var2_eg1vA_mean]pr_ind2_`generasi_vA' + [var2_eg1vA_mean]`generasi_vA')/`sd1vA_2' + (`pct10_3'*[var3_eg1vA_mean]pr_ind3_`generasi_vA' + [var3_eg1vA_mean]`generasi_vA')/`sd1vA_3' + (`pct10_4'*[var4_eg1vA_mean]pr_ind4_`generasi_vA' + [var4_eg1vA_mean]`generasi_vA')/`sd1vA_4' + (`pct10_5'*[var5_eg1vA_mean]pr_ind5_`generasi_vA' + [var5_eg1vA_mean]`generasi_vA')/`sd1vA_5' + (`pct10_6'*[var6_eg1vA_mean]pr_ind6_`generasi_vA' + [var6_eg1vA_mean]`generasi_vA')/`sd1vA_6' + (`pct10_7'*[var7_eg1vA_mean]pr_ind7_`generasi_vA' + [var7_eg1vA_mean]`generasi_vA')/`sd1vA_7' - (`pct10_8'*[var8_eg1vA_mean]pr_ind8_`generasi_vA' + [var8_eg1vA_mean]`generasi_vA')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plus10preprd_SE`wave'		= mod3_genvA_plus10preprd_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_plus10preprd_SE`wave'		= "(" + mod3_genvA_plus10preprd_se + ")" in `line_num_plus3'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom (((`pct10_9'*[var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]`generasi_vA')/`sd1vA_9' + (`pct10_10'*[var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]`generasi_vA')/`sd1vA_10' + (`pct10_11'*[var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]`generasi_vA')/`sd1vA_11' + (`pct10_12'*[var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]`generasi_vA')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_plus10preprd_b		= r(estimate) 
					gen mod3_genvA_plus10preprd_se 		= r(se) 
					tostring mod3_genvA_plus10preprd_b, replace format(%10.4f) force
					tostring mod3_genvA_plus10preprd_se, replace format(%10.4f) force
		
					test (((`pct10_9'*[var9_eg1vA_mean]pr_ind9_`generasi_vA' + [var9_eg1vA_mean]`generasi_vA')/`sd1vA_9' + (`pct10_10'*[var10_eg1vA_mean]pr_ind10_`generasi_vA' + [var10_eg1vA_mean]`generasi_vA')/`sd1vA_10' + (`pct10_11'*[var11_eg1vA_mean]pr_ind11_`generasi_vA' + [var11_eg1vA_mean]`generasi_vA')/`sd1vA_11' + (`pct10_12'*[var12_eg1vA_mean]pr_ind12_`generasi_vA' + [var12_eg1vA_mean]`generasi_vA')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plus10preprd_SE`wave'		= mod3_genvA_plus10preprd_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_plus10preprd_SE`wave'		= "(" + mod3_genvA_plus10preprd_se + ")" in `line_num_plus5'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_plus10preprd_SE`wave'	 	= mod3_genvA_plus10preprd_b + "***" if `p_val' < 0.01 in `line_num_plus4'



				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_SE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *SE* in 1/10 using `direc'table4_suest_avgSE_`z'_`b'_`wave', replace

		}	
	
	
	}
}
}

*******************************************************
//Carrying out regressions for Table 5 indicators
******************************************************

if `do_table5' == 1 {
	set more off
	cd\
	cd `rundir'
	cd "Wave I"
	
	use table_1_3_vars_generasi_w1, clear
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the indicator variables
	foreach x of var dead_0to12_mons_last24_w1 dead_0to28_days_last18_w1 dead_0to12_mons_12to24_w1 dead_0to12_mons_last21_w1 dead_0to12_mons_12to21_w1 diarrhea_or_ARI_w1 lang_score_7to12_std_w1 math_score_7to12_std_w1 totl_score_7to12_std_w1 lang_score_13to15_std_w1 math_score_13to15_std_w1 totl_score_13to15_std_w1 mal_weightforage_w1 severe_weightforage_w1 mal_heightforage_w1 severe_heightforage_w1 mal_weightforheight_w1 severe_weightforheight_w1 z_weightforage_w1 z_weightforheight_w1 z_heightforage_w1 dead_1to12_mons_last24{
		bys Location_ID: egen kec_`x' = mean(`x')
		bys kab_id:		egen kab_`x' = mean(`x')	
		replace kec_`x' = kab_`x' if kec_`x' == .			
	}
	
	drop _merge
	keep Location_ID kec_*_w1 kab_*_w1
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	****
	
	use Data\R, clear
	
	gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile tempback
	save `tempback'

	drop panel_hh_id_back_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'
	
	use `tempback'
	drop panel_hh_id_back_w2
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	
	********************************************
	*****           Wave II                ***** 
	********************************************

	
	****
	
	cd ..\
	cd "Wave II"
	
	use table_1_3_vars_w2_with_w1controls, clear
	
	drop _merge
	
	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
		
	//Dropping observations from the drop kec list
	drop if drop == 1
	drop _m*
	

	capture drop kec_*_w1
	sort Location_ID
	//Merging in kec level wave 1 values to the wave 2 data
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
			
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m3)
	tab _m3 panel_hh, m
	
	drop if _m3 == 2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	
	****
	**Don't have individual level wave 1 controls for these variables
	gen dead_0to28_days_last18_w1 = .
	gen dead_0to12_mons_last24_w1 = .
	gen dead_0to12_mons_12to24_w1 = .
	gen dead_0to12_mons_12to21_w1 = .
	gen dead_0to12_mons_last21_w1 = .
	gen dead_1to12_mons_last24_w1 = .




	****
	****
	
	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****

	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/7{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	replace age_years = 8888 if age_years == .
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	
	********
	* create differenced versions
	********
	
	***d_kec and d_ind will be the same for the mortality variables b/c don't have individual level controls for them
	
	foreach q in dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 diarrhea_or_ARI mal_weightforage severe_weightforage dead_1to12_mons_last24{
		g dk_`q' = `q'_w2 - kec_`q'_w1
	  
		g di_`q' = `q'_w2 - kec_`q'_w1
		replace di_`q' = `q'_w2 - `q'_w1 if `q'_w1 != .
	
	}
	
	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 diarrhea_or_ARI mal_weightforage severe_weightforage mal_heightforage severe_heightforage mal_weightforheight severe_weightforheight z_weightforage dead_1to12_mons_last24{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
		}
	***

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
				
	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	
	save table_1_3_vars_w2_full_suest, replace
		
		

	********************************************
	*****           Wave III               ***** 
	********************************************
	
	cd ..\
	cd "Wave III"
	
	use table_1_3_vars_generasi_w3_with_w1controls, clear
	
	drop _merge
	
	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
		
	//Dropping observations from the drop kec list
	drop if drop == 1
	drop _m*
	

	capture drop kec_*_w1
	sort Location_ID
	//Merging in kec level wave 1 values to the wave 2 data
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
			
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m3)
	tab _m3 panel_hh, m
	
	drop if _m3 == 2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	
	****
	**Don't have individual level wave 1 controls for these variables
	gen dead_0to28_days_last18_w1 = .
	gen dead_0to12_mons_last24_w1 = .
	gen dead_0to12_mons_12to24_w1 = .
	gen dead_0to12_mons_12to21_w1 = .
	gen dead_0to12_mons_last21_w1 = .
	gen dead_1to12_mons_last24_w1 = .

	****
	****
	
	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
		
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/7{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	replace age_years = 8888 if age_years == .
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
		
	
	********
	* create differenced versions
	********
	
	***d_kec and d_ind will be the same for the mortality variables b/c don't have individual level controls for them  [in future also may want to think about the test score variables, do we want to get more matching by grabbing those who were in 7-12 in wave 1 and 13-15 in wave III?]
	
	foreach q in dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 diarrhea_or_ARI mal_weightforage severe_weightforage mal_heightforage severe_heightforage mal_weightforheight severe_weightforheight lang_score_7to12_std math_score_7to12_std totl_score_7to12_std lang_score_13to15_std math_score_13to15_std totl_score_13to15_std dead_1to12_mons_last24{
		g dk_`q' = `q'_w3 - kec_`q'_w1
	  
		g di_`q' = `q'_w3 - kec_`q'_w1
		replace di_`q' = `q'_w3 - `q'_w1 if `q'_w1 != .
	
	}
	
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 diarrhea_or_ARI mal_weightforage severe_weightforage mal_heightforage severe_heightforage mal_weightforheight severe_weightforheight lang_score_7to12_std math_score_7to12_std totl_score_7to12_std lang_score_13to15_std math_score_13to15_std totl_score_13to15_std z_weightforage z_weightforheight z_heightforage dead_1to12_mons_last24{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
		}
	***
	
	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				drop age_years_w1
				tab age_years, gen(age_years_)

	
	save table_1_3_vars_generasi_w3_full_suest, replace	


	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_1_3_vars_w2_full_suest", clear
	
	
	foreach q in  Diarrhea Fever Cough Cough_rapid_breath ARI Illness diarrhea_or_ARI dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 mal_weightforage severe_weightforage z_weightforage dead_1to12_mons_last24{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 id panel_hh HH_id rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x

	tempfile temp
	save `temp'	
	
	use table_1_3_vars_generasi_w3_full_suest, clear
	
	foreach q in Diarrhea Fever Cough Cough_rapid_breath ARI Illness diarrhea_or_ARI dead_0to12_mons_last24 dead_0to28_days_last18 dead_0to12_mons_12to24 dead_0to12_mons_last21 dead_0to12_mons_12to21 lang_score_7to12_std math_score_7to12_std totl_score_7to12_std lang_score_13to15_std math_score_13to15_std totl_score_13to15_std mal_weightforage severe_weightforage mal_heightforage severe_heightforage mal_weightforheight severe_weightforheight z_weightforage z_weightforheight z_heightforage dead_1to12_mons_last24{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 id panel_hh HH_id rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x
	append using `temp'

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
					
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */		
			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local kec_val_w1_group "kec_*_w1"
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_group "ind_*_w1"
			local ind_val_m1_group "ind_*_m1"
	
			foreach q of varlist `k12_val_w1_group' `kec_val_w1_group' `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_group' `ind_val_m1_group'{
				gen `q'w = wave_3 * `q'
				}
	
	save table_1_3_vars_pooled_full_suest, replace


cd ..\
cd "Wave III"	
	************************************************************************
	************************************************************************
	
foreach w in table_1_3_vars_w2_full_suest table_1_3_vars_generasi_w3_full_suest table_1_3_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{

			if "`w'" == "table_1_3_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_1_3_vars_w2_full_suest", clear
			}
			if "`w'" == "table_1_3_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_1_3_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel

			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .

			gen indicator_name_avgSE 				= ""
			gen control_avgSE_`wave' 				= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
					
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}


			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_3_vars_generasi_w1", clear	
	
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
			}
			if "`b'" == "ntt"{
				keep if prov == 53						
			}
		
			sort Location_ID
			merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop


			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3
		

			foreach x of var dead_0to12_mons_last24_w1 dead_0to28_days_last18_w1 dead_0to12_mons_12to24_w1 dead_0to12_mons_last21_w1 dead_0to12_mons_12to21_w1 diarrhea_or_ARI_w1 mal_weightforage_w1 severe_weightforage_w1 mal_heightforage_w1 severe_heightforage_w1 mal_weightforheight_w1 severe_weightforheight_w1 lang_score_7to12_std_w1 math_score_7to12_std_w1 totl_score_7to12_std_w1 lang_score_13to15_std_w1 math_score_13to15_std_w1 totl_score_13to15_std_w1  z_weightforage_w1 z_weightforheight_w1 z_heightforage_w1 dead_1to12_mons_last24_w1{	 	
				**Creating overall wave 1 average of each variable for table
				cap drop avg_`x' se_`x'
				summ `x' [weight = baseline_weight]
				gen avg_`x' = r(mean) 
				gen se_`x' = (r(sd)/(r(N)^0.5))
				
			}

			keep avg_*_w1 se_*_w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm
	


			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
				
			gen include_obs = 1
		
		
			if "`wave'" == "w3" | "`wave'" == "po"{
				local vars_list "mal_weightforage severe_weightforage mal_weightforheight severe_weightforheight mal_heightforage severe_heightforage diarrhea_or_ARI dead_0to28_days_last18 dead_0to12_mons_last24 lang_score_7to12_std math_score_7to12_std totl_score_7to12_std lang_score_13to15_std math_score_13to15_std totl_score_13to15_std z_weightforage z_weightforheight z_heightforage dead_1to12_mons_last24"
			}
			
			**Only have home-based test score info for wave I and wave III
			if "`wave'" == "w2"{	
				local vars_list "mal_weightforage severe_weightforage diarrhea_or_ARI dead_0to28_days_last18 dead_0to12_mons_last24 z_weightforage dead_1to12_mons_last24"		
			}				
			
			foreach x in `vars_list'{
				
	
				disp "*******`x'_`wave'**********"
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "kec_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1"
					local ind_val_m1_wave "ind_`x'_m1"
					local kab_wave "kab_id"
				}
						
				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "kec_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1*"
					local ind_val_m1_wave "ind_`x'_m1*"
					local kab_wave "kab_wave"
				}	
				
							
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
								
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}					
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
											
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
					
				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			

				
				****
				
								
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					local basemean1_`var_num' = r(mean)
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}
				
				**Cross-sectional households	
				summ `control_mean' & panel_hh == 0 
				local mean1_`var_num' = r(mean)
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'
				
					
				****
				
				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1, cluster(Location_ID)
				
								
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				**************************
				replace indicator_name = "`x'" in `number'
	
				**************************

				**Repeat without clustering for use in suest (which adds clustering there)
				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1
				
				noi estimates store var`var_num'_eg1vA	
				
				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)
				
				
				
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1		
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}				
			}
		
			outsheet indicator_name baseline_mean control_mean mod*_gen* num_obs in 1/70 using `direc'table5_coba_`z'_`b'_`wave', replace

			if "`wave'" == "w3"| "`wave'" == "po"{
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA  var13_eg1vA var14_eg1vA var15_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA"
				
				local Total_mod3_gen "((((-[var1_eg1vA_mean]`generasi'/`sd1vA_1' - [var2_eg1vA_mean]`generasi'/`sd1vA_2' - [var3_eg1vA_mean]`generasi'/`sd1vA_3' - [var4_eg1vA_mean]`generasi'/`sd1vA_4' - [var5_eg1vA_mean]`generasi'/`sd1vA_5' - [var6_eg1vA_mean]`generasi'/`sd1vA_6' -[var7_eg1vA_mean]`generasi'/`sd1vA_7')/7) + ((-[var8_eg1vA_mean]`generasi'/`sd1vA_8'- [var9_eg1vA_mean]`generasi'/`sd1vA_9' )/2) + (([var13_eg1vA_mean]`generasi'/`sd1vA_13'+[var14_eg1vA_mean]`generasi'/`sd1vA_14'+ [var15_eg1vA_mean]`generasi'/`sd1vA_15'+ [var10_eg1vA_mean]`generasi'/`sd1vA_10'+ [var11_eg1vA_mean]`generasi'/`sd1vA_11'+ [var12_eg1vA_mean]`generasi'/`sd1vA_12')/6)) / 3)"
				local Health_mod3_gen "(((-[var1_eg1vA_mean]`generasi'/`sd1vA_1' - [var2_eg1vA_mean]`generasi'/`sd1vA_2' - [var3_eg1vA_mean]`generasi'/`sd1vA_3' - [var4_eg1vA_mean]`generasi'/`sd1vA_4' - [var5_eg1vA_mean]`generasi'/`sd1vA_5' - [var6_eg1vA_mean]`generasi'/`sd1vA_6' -[var7_eg1vA_mean]`generasi'/`sd1vA_7')/7) + ((-[var8_eg1vA_mean]`generasi'/`sd1vA_8'- [var9_eg1vA_mean]`generasi'/`sd1vA_9' )/2) / 2)"
				local Education_mod3_gen "(([var13_eg1vA_mean]`generasi'/`sd1vA_13'+[var14_eg1vA_mean]`generasi'/`sd1vA_14'+ [var15_eg1vA_mean]`generasi'/`sd1vA_15'+ [var10_eg1vA_mean]`generasi'/`sd1vA_10'+ [var11_eg1vA_mean]`generasi'/`sd1vA_11'+ [var12_eg1vA_mean]`generasi'/`sd1vA_12')/6)"
						
				local Total_mod3_genvA "((((-[var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' - [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' - [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' - [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' - [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' - [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' -[var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/7) + ((-[var8_eg1vA_mean]`generasi_vA'/`sd1vA_8'- [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' )/2) + (([var13_eg1vA_mean]`generasi_vA'/`sd1vA_13'+[var14_eg1vA_mean]`generasi_vA'/`sd1vA_14'+ [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15'+ [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10'+ [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11'+ [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12')/6)) / 3)"
				local Health_mod3_genvA "(((-[var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' - [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' - [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' - [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' - [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' - [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' -[var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/7) + ((-[var8_eg1vA_mean]`generasi_vA'/`sd1vA_8'- [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' )/2) / 2)"
				local Education_mod3_genvA "(([var13_eg1vA_mean]`generasi_vA'/`sd1vA_13'+[var14_eg1vA_mean]`generasi_vA'/`sd1vA_14'+ [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15'+ [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10'+ [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11'+ [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12')/6)"

				local Total_mod3_genplusA "((((-([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' - ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' - ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' - ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' - ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5'-([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6'-([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7')/7) + ((-([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8'-([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9')/2)+ ((([var13_eg1vA_mean]`generasi_vA' + [var13_eg1vA_mean]`generasi')/`sd1vA_13'+ ([var14_eg1vA_mean]`generasi_vA' + [var14_eg1vA_mean]`generasi')/`sd1vA_14'+([var15_eg1vA_mean]`generasi_vA' + [var15_eg1vA_mean]`generasi')/`sd1vA_15'+([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10'+([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11'+([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12')/6)) / 3)"
				local Health_mod3_genplusA "(((-([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' - ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' - ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' - ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' - ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5'-([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6'-([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7')/7) + ((-([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8'-([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9')/2) / 2)"
				local Education_mod3_genplusA "((([var13_eg1vA_mean]`generasi_vA' + [var13_eg1vA_mean]`generasi')/`sd1vA_13'+ ([var14_eg1vA_mean]`generasi_vA' + [var14_eg1vA_mean]`generasi')/`sd1vA_14'+([var15_eg1vA_mean]`generasi_vA' + [var15_eg1vA_mean]`generasi')/`sd1vA_15'+([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10'+([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11'+([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12')/6)"
			}
			
			if "`wave'" == "w2" {	
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA"

				local Total_mod3_gen "((((-[var1_eg1vA_mean]`generasi'/`sd1vA_1' - [var2_eg1vA_mean]`generasi'/`sd1vA_2' - [var3_eg1vA_mean]`generasi'/`sd1vA_3')/3) + (- [var4_eg1vA_mean]`generasi'/`sd1vA_4' - [var5_eg1vA_mean]`generasi'/`sd1vA_5' )/2) / 2)"
				local Health_mod3_gen "((((-[var1_eg1vA_mean]`generasi'/`sd1vA_1' - [var2_eg1vA_mean]`generasi'/`sd1vA_2' - [var3_eg1vA_mean]`generasi'/`sd1vA_3')/3) + (- [var4_eg1vA_mean]`generasi'/`sd1vA_4' - [var5_eg1vA_mean]`generasi'/`sd1vA_5' )/2) / 2)"
				local Education_mod3_gen ""
			
				local Total_mod3_genvA "((((-[var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' - [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' - [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3')/3) + ( - [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' - [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' )/2) / 2)"
				local Health_mod3_genvA "((((-[var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' - [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' - [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3')/3) + ( - [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' - [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' )/2) / 2)"
				local Education_mod3_genvA ""
				
				local Total_mod3_genplusA "((((-([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' - ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' - ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3')/3) + (- ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' - ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' )/2) / 2)"
				local Health_mod3_genplusA "((((-([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' - ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' - ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3')/3) + (- ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' - ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' )/2) / 2)"
				local Education_mod3_genplusA ""
			}
			
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
								
				
	 				suest `var_eg1vA', cluster(Location_ID)
	 			
	 				*Total

					lincom `Total_mod3_gen'									
					gen mod3_gen_b 		=r(estimate) 
					gen mod3_gen_se 		= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	
					test `Total_mod3_gen' = 0			
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom `Health_mod3_gen'
					drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test `Health_mod3_gen' = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
				
				if "`wave'" == "w3"| "`wave'" == "po"{		
					lincom `Education_mod3_gen'
					drop mod?_gen_b mod?_gen_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test `Education_mod3_gen' = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'			= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'			= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				}
				
					*Total
			
					lincom `Total_mod3_genvA'
					gen mod3_genvA_b 		= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test `Total_mod3_genvA' = 0			
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom `Health_mod3_genvA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test `Health_mod3_genvA' = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
				
				if "`wave'" == "w3"| "`wave'" == "po"{	
					lincom `Education_mod3_genvA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test `Education_mod3_genvA' = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				}
					
					*Total
		
					lincom `Total_mod3_genplusA'
					gen mod3_genplusA_b 		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test `Total_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom `Health_mod3_genplusA'
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test `Health_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	
				
				if "`wave'" == "w3"| "`wave'" == "po"{
					lincom `Education_mod3_genplusA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
		
					test `Education_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				}
							
				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se


				outsheet *avgSE* in 1/10 using `direc'table5_suest_avgSE_`z'_`b'_`wave', replace
		
				
		}
	}	
}	
}


*******************************************************
//Carrying out regressions for Table 6 indicators
******************************************************

if `do_table6' == 1{

	set more off

	cd \
	cd `rundir'
	cd "Wave I"

	//Load relevant variables for program expenses from MIS data
	use "..\Wave III\MIS Data\rekap per desa-2007 l3_clean.dta", clear

	gen id_activity1 = substr(id_activity,1,1)
	gen id_activity2 = substr(id_activity,1,2)

	gen health_exp = sum_blm if id_activity1=="K"
	gen health_durables = sum_blm if id_activity2=="KA" |id_activity2=="KB" 
	gen health_bene_prov = sum_blm if id_activity2=="KD"

	gen transfers_total= sum_blm if id_activity2=="PC" | id_activity2=="KC" | id_activity2=="KF" | id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05"
	gen transfers_E_goodies = sum_blm  if  id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05"
	gen transfers_nutrition = sum_blm if id_activity2=="KF"
	gen transfers_subsidies = sum_blm if id_activity2=="PC" | id_activity2=="KC" 


	gen H_subsidized_care = sum_blm if id_activity=="KC01" |id_activity=="KC02"|id_activity=="KC03"|id_activity=="KC04"|id_activity=="KC05"|id_activity=="KC95"     
	gen H_nutrition_sup = sum_blm if id_activity=="KF01" |id_activity=="KF02"|id_activity=="KF03"|id_activity=="KF95"     
	gen H_drugs_equipment = sum_blm if id_activity=="KB02" |id_activity=="KB03"     
	gen H_wages_transport = sum_blm if id_activity=="KD01" |id_activity=="KD02"|id_activity=="KD03"|id_activity=="KD04"|id_activity=="KD95"|id_activity=="KC06"|id_activity=="KC07"|id_activity=="KC08"|id_activity=="KC09"|id_activity=="KC10"     
	gen H_infra_furniture = sum_blm if id_activity=="KA01" |id_activity=="KA02"|id_activity=="KA03"|id_activity=="KA04"|id_activity=="KA95"|id_activity=="KB01"|id_activity=="KB95"     
	gen H_training = sum_blm if id_activity=="KE01" |id_activity=="KE02"|id_activity=="KE95"     
	gen H_transfers = sum_blm if id_activity2=="KF" | id_activity2=="KC" 
	gen H_nontransfers = sum_blm if !(id_activity2=="KF" | id_activity2=="KC") & id_activity1 == "K"


	gen E_scholarship = sum_blm if id_activity=="PC01" |id_activity=="PC02"|id_activity=="PC04"|id_activity=="PC95"|id_activity=="PB02"|id_activity=="PB04"|id_activity=="PB05"     
	gen E_uniform = sum_blm if id_activity=="PB03"     
	gen E_training = sum_blm if id_activity=="PE01" |id_activity=="PE02"|id_activity=="PE95"     
	gen E_wages_transport = sum_blm if id_activity=="PD01" |id_activity=="PD02"|id_activity=="PD95"|id_activity=="PC03"     
	gen E_infra_furniture = sum_blm if id_activity=="PA01" |id_activity=="PA02"|id_activity=="PA03"|id_activity=="PA04"|id_activity=="PA05"|id_activity=="PA95"|id_activity=="PB01"|id_activity=="PB06"|id_activity=="PB95"     
	gen E_transfers = sum_blm if id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05" | id_activity2=="PC"
	gen E_nontransfers = sum_blm if !(id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05" | id_activity2=="PC") & id_activity1 == "P"

	gen sum_bene_uniform = sum_bene if id_activity=="PB03" 
	collapse (sum) sum_blm health_exp health_durables health_bene_prov transfers* H* E* sum_bene*, by(ea id_desa_clean)

	gen uniform_price = E_uniform/sum_bene_uniform

	gen Location_ID = ea
	sort Location_ID
	tempfile a
	save `a', replace

	//Merge kecamatan type info with program expenses info
	use ..\kecs_info_clean.dta
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd

	merge Location_ID using `a', uniqmaster

	tab _merge
	drop if _merge==1
	tab _merge
	drop _m

	save program_expenses_w1, replace


	************

	set more off

	cd ..\
	cd "Wave II"

	//Load relevant variables for program expenses from MIS data
	use "..\Wave III\MIS Data\rekap per desa-2008 l3_clean.dta", clear

	gen id_activity1 = substr(id_activity,1,1)
	gen id_activity2 = substr(id_activity,1,2)

	gen health_exp = sum_blm if id_activity1=="K"
	gen health_durables = sum_blm if id_activity2=="KA" |id_activity2=="KB" 
	gen health_bene_prov = sum_blm if id_activity2=="KD"

	gen transfers_total= sum_blm if id_activity2=="PC" | id_activity2=="KC" | id_activity2=="KF" | id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05"
	gen transfers_E_goodies = sum_blm  if  id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05"
	gen transfers_nutrition = sum_blm if id_activity2=="KF"
	gen transfers_subsidies = sum_blm if id_activity2=="PC" | id_activity2=="KC" 


	gen H_subsidized_care = sum_blm if id_activity=="KC01" |id_activity=="KC02"|id_activity=="KC03"|id_activity=="KC04"|id_activity=="KC05"|id_activity=="KC95"     
	gen H_nutrition_sup = sum_blm if id_activity=="KF01" |id_activity=="KF02"|id_activity=="KF03"|id_activity=="KF95"     
	gen H_drugs_equipment = sum_blm if id_activity=="KB02" |id_activity=="KB03"     
	gen H_wages_transport = sum_blm if id_activity=="KD01" |id_activity=="KD02"|id_activity=="KD03"|id_activity=="KD04"|id_activity=="KD95"|id_activity=="KC06"|id_activity=="KC07"|id_activity=="KC08"|id_activity=="KC09"|id_activity=="KC10"     
	gen H_infra_furniture = sum_blm if id_activity=="KA01" |id_activity=="KA02"|id_activity=="KA03"|id_activity=="KA04"|id_activity=="KA95"|id_activity=="KB01"|id_activity=="KB95"     
	gen H_training = sum_blm if id_activity=="KE01" |id_activity=="KE02"|id_activity=="KE95"     
	gen H_transfers = sum_blm if id_activity2=="KF" | id_activity2=="KC" 
	gen H_nontransfers = sum_blm if !(id_activity2=="KF" | id_activity2=="KC") & id_activity1 == "K"


	gen E_scholarship = sum_blm if id_activity=="PC01" |id_activity=="PC02"|id_activity=="PC04"|id_activity=="PC95"|id_activity=="PB02"|id_activity=="PB04"|id_activity=="PB05"     
	gen E_uniform = sum_blm if id_activity=="PB03"     
	gen E_training = sum_blm if id_activity=="PE01" |id_activity=="PE02"|id_activity=="PE95"     
	gen E_wages_transport = sum_blm if id_activity=="PD01" |id_activity=="PD02"|id_activity=="PD95"|id_activity=="PC03"     
	gen E_infra_furniture = sum_blm if id_activity=="PA01" |id_activity=="PA02"|id_activity=="PA03"|id_activity=="PA04"|id_activity=="PA05"|id_activity=="PA95"|id_activity=="PB01"|id_activity=="PB06"|id_activity=="PB95"     
	gen E_transfers = sum_blm if id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05" | id_activity2=="PC"
	gen E_nontransfers = sum_blm if !(id_activity == "PB03" | id_activity == "PB04" | id_activity == "PB05" | id_activity2=="PC") & id_activity1 == "P"

	gen sum_bene_uniform = sum_bene if id_activity=="PB03" 

	collapse (sum) sum_blm health_exp health_durables health_bene_prov transfers* H* E* sum_bene*, by(ea id_desa_clean)

	gen uniform_price = E_uniform/sum_bene_uniform

	gen Location_ID= ea

	sort Location_ID
	tempfile a
	save `a', replace

	//Merge kecamatan type info with program expenses info
	use "..\kecs_info_clean.dta"
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd

	merge Location_ID using `a', uniqmaster

	tab _merge
	drop if _merge==1
	tab _merge
	drop _m

	save program_expenses_w2, replace
	
	
	*******************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	cd  ..\
	cd "Wave II"
	use "program_expenses_w2", clear
	gen wave=3
	
	append using "..\Wave I\program_expenses_w1"
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	replace gen_pooled = 1 if gen_year1==1 & gen_year2==.
	replace gen_pooled = 1 if gen_year1==. & gen_year2==1
	
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)	
	replace gen_pooled_versi_A  = 1 if gen_year1_versi_A ==1 & gen_year2_versi_A ==.
	replace gen_pooled_versi_A  = 1 if gen_year1_versi_A ==. & gen_year2_versi_A ==1
	
	cd ..\
	cd "Wave III"
	save program_expenses_pooled, replace

****************************************************************************************
cd ..\
cd "Wave III"
			
 
foreach w in program_expenses_w1 program_expenses_w2 program_expenses_pooled{
	foreach z in TPcontrols{
		foreach b in all{
		
		if "`w'" == "program_expenses_w1"{
				local wave "w2"
				use "..\Wave I\program_expenses_w1", clear
			}
		
		if "`w'" == "program_expenses_w2"{
				local wave "w3"
				use "..\Wave II\program_expenses_w2", clear
			}			

		if "`w'" == "program_expenses_pooled"{
				local wave "po"
				use "program_expenses_pooled", clear
			}	

	
//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*


	****
	destring prov_id, replace
	destring kab_id, replace
	
	cap drop categ
	gen categ = ""
	cap drop sub_categ
	gen sub_categ = ""
	cap drop VersiB_mean_`wave'
	gen VersiB_mean_`wave'=.
	cap drop VersiA_mean_`wave'
	gen VersiA_mean_`wave'=.
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	
	if "`wave'"=="w2"{
	cap drop wave2
	gen wave=2
	}
	
	if "`wave'"=="w3"{
	cap drop wave2
	cap drop gen_year1or2
	cap drop gen_year1or2_versi_A
	g wave=3
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	}
	
	if "`wave'"=="po"{
	cap drop wave_3
	gen wave_3= wave==3
	replace wave=2 if wave!=3
	}
	***Creating variables to create draft tables for export to excel
	
			cap drop indicator_name
			gen indicator_name 			= ""
			cap drop mod1_genvA_`wave'
			gen mod1_genvA_`wave'		= ""
			cap drop num_obs_`wave'
			gen num_obs_`wave'=.	

			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}
	
			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2

			local pick = 1
			
			//generare expenditures as share of grant
			foreach x in health_exp health_durables health_bene_prov transfers_total transfers_E_goodies transfers_nutrition transfers_subsidies{				
				cap drop share_`x'
				gen share_`x' = `x' / sum_blm
		}
		
			local vars_list "health_exp health_durables health_bene_prov transfers_total transfers_E_goodies transfers_nutrition transfers_subsidies uniform_price"				

			foreach x in `vars_list'{

				disp "*******`x'_`wave'**********"
				
				
				cap drop kab_wave 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local prov_P_wave "i.prov_P"
					local kab_wave "kab_id"
				}

				if "`wave'" == "po"{	
					local prov_P_wave "i.wave*i.prov_P"
					local kab_wave "kab_wave"
				}

				if "`x'" != "uniform_price" {
					if "`z'" == "allTPcontrols"{
						local yvar "share_`x'"
						local prov_P "`prov_P_wave'"
					}	
	
					if "`z'" == "TPcontrols"{
						local yvar "share_`x'"
						local prov_P "`prov_P_wave'"
					}	
	
					if "`z'" == "nocontrols"{
						local yvar "share_`x'"
						local prov_P ""
					}
				}

				if "`x'"== "uniform_price" {
					if "`z'" == "allTPcontrols"{
						local yvar "`x'"
						local prov_P "`prov_P_wave'"
					}	
	
					if "`z'" == "TPcontrols"{
						local yvar "`x'"
						local prov_P "`prov_P_wave'"
					}	
	
					if "`z'" == "nocontrols"{
						local yvar "`x'"
						local prov_P ""
					}
				}
								
				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			


				****
				
				xi: areg `yvar'  `generasi_vA'  `prov_P', absorb(`kab_wave') cluster(Location_ID)
				
				replace num_obs = e(N) in `number'
			
				gen mod1_genvA_b 		=_b[ `generasi_vA'] 
				gen mod1_genvA_se 		= _se[ `generasi_vA'] 
				tostring mod1_genvA_b, replace format(%10.4f) force
				tostring mod1_genvA_se, replace format(%10.4f) force
	
				test  `generasi_vA'	
				local p_val			= r(p) 
				replace mod1_genvA_`wave'		= mod1_genvA_b if `p_val' >= 0.1 in `number'
				replace mod1_genvA_`wave'		= "(" + mod1_genvA_se + ")" in `number_plus1'
				replace mod1_genvA_`wave'	 	= mod1_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod1_genvA_`wave'	 	= mod1_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod1_genvA_`wave'	 	= mod1_genvA_b + "***" if `p_val' < 0.01 in `number'
			
				*****
				replace indicator_name = "`x'" in `number'
				summ `yvar' if `generasi_vA'==1
				replace VersiA_mean_`wave' = r(mean) in `number'
				
				summ `yvar' if `generasi_vA'==0
				replace VersiB_mean_`wave' = r(mean) in `number'

				*****

				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
		
	
				drop *mod?_gen*_b mod?_gen*_se 
				
	
				}
	
			outsheet indicator_name VersiA_mean* VersiB_mean* mod*_gen* num_obs in 1/60 using `direc'table6_`z'_`b'_`wave', replace
			
			}	
		}
	}				
}
 
 
*******************************************************
//Carrying out regressions for Table 7 indicators
******************************************************

if `do_table7' == 1 {

	set more off
	cd\
	cd `rundir'
	cd "Wave II"


	****

	use "..\Wave I\Data\R", clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile temphh
	save `temphh'
	
	drop *_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'

	drop *_w2
	use `temphh', clear
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	****

	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp', replace
	
	****
	
	********************************************
	*****           Wave II                ***** 
	********************************************

	cd ..\
	cd "Wave II"

	use table_1_1_vars_w2, clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	


	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*


		** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	cap drop _m*


	****

	destring prov_id, replace

	destring kab_id, replace



//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m3)
	tab rar00x _m3 
	drop if _m3 == 2

	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
		
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****




	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10)
	replace age_years = 8888 if age_years == . & (obs_type == 7 | obs_type == 10)		

	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)	
			tab age_years, gen(age_years_)
	
	save table_1_1_vars_w2_full_suest, replace

	********************************************
	*****           Wave III               ***** 
	********************************************

	cd ..\
	cd "Wave III"

	use table_1_1_vars_generasi_w3, clear
	
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	

	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*


		** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	cap drop _m*


	****
	destring prov_id, replace
	destring kab_id, replace




//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m3)
	tab rar00x _m3 
	drop if _m3 == 2

	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
		
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****




	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10)
	replace age_years = 8888 if age_years == . & (obs_type == 7 | obs_type == 10)		

	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)	
			tab age_years, gen(age_years_)
	
	save table_1_1_vars_generasi_w3_full_suest, replace


	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_1_1_vars_w2_full_suest", clear
	
	foreach q in health_subs deliv_subs health_subs_dum deliv_subs_dum scholarship_ed uniforms other_school_suppl transport other_school PMT_school scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_w1 *_po id panel_hh age_years rid kab_id Location_ID HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x
	tempfile temp
	save `temp'	
	
	use table_1_1_vars_generasi_w3_full_suest, clear
	

	foreach q in health_subs deliv_subs health_subs_dum deliv_subs_dum scholarship_ed uniforms other_school_suppl transport other_school PMT_school scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 id panel_hh age_years rid kab_id Location_ID HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x
	append using `temp'

	
		**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
			
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
								
			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
	
			foreach q of varlist `k12_val_w1_group' `prov_P_group' `type_panel_group' `age_vals_group'{
				gen `q'w = wave_3 * `q'
				}
				
	save table_1_1_vars_pooled_full_suest, replace


 **w3 was made generasi in the merging in with kecs_info b/c that only for generasi kec and we keep if _m == 3
 
foreach w in table_1_1_vars_w2_full_suest table_1_1_vars_generasi_w3_full_suest table_1_1_vars_pooled_full_suest{
	foreach z in TPcontrols{
		foreach b in  all {
		
			if "`w'" == "table_1_1_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_1_1_vars_w2_full_suest", clear
			}
			if "`w'" == "table_1_1_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_1_1_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel
	
			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .

			gen indicator_name_avgSE 				= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
			
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}
	
			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
			
			local pick = 1
		
			*Uniforms value not included in avg_SE calculation b/c not specified in analysis pre-plan
	 		local vars_list "scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive health_subs_dum deliv_subs_dum uniforms"				
 

			
			foreach x in `vars_list'{

				disp "*******`x'_`wave'**********"

				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)
	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave ""
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave ""
					local ind_val_m1_wave ""
					local kab_wave "kab_id"
				}
				
				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave ""
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave ""
					local ind_val_m1_wave ""
					local kab_wave "kab_wave"
				}
	
				if "`z'" == "allTPcontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}	
	
				if "`z'" == "TPcontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}	
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}
			
				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			


				
				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' `prov_P' kab_wave_*, cluster(Location_ID)
				
				tempvar samplevar
				g `samplevar' = e(sample)		
				if "`x'" == "scholarship_ed_dum" | "`x'" == "uniforms_dum"| "`x'" == "uniforms" | "`x'" == "other_school_suppl_dum" | "`x'" == "PMT_pos" | "`x'" == "PMT_intensive" | "`x'" == "health_subs_dum" | "`x'" == "deliv_subs_dum" {
					summ `yvar' if `samplevar' == 1 & intervention == "3" & panel_hh == 0
				}
				
				if "`x'" == "transport_dum" |"`x'" == "other_school_dum" |"`x'" == "PMT_school_dum" {
					summ `yvar' if `samplevar' == 1  & panel_hh == 0 
				}
				
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= (r(sd)/(r(N)^0.5)) 
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' 	= control_mean_1 in `number'
				replace control_mean_`wave'		= "(" + control_mean_2 + ")" in `number_plus1'
								
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				*****
				replace indicator_name = "`x'" in `number'
				*****

				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' `prov_P' kab_wave_*
				
				noi estimates store var`var_num'_eg1vA	
		
				tempvar samplevar
				g `samplevar' = e(sample)		
				if "`x'" == "scholarship_ed_dum" | "`x'" == "uniforms_dum"| "`x'" == "uniforms" | "`x'" == "other_school_suppl_dum" | "`x'" == "PMT_pos" | "`x'" == "PMT_intensive" | "`x'" == "health_subs_dum" | "`x'" == "deliv_subs_dum" {
					summ `yvar' if `samplevar' == 1 & intervention == "3" & panel_hh == 0
				}
				
				if "`x'" == "transport_dum" |"`x'" == "other_school_dum" |"`x'" == "PMT_school_dum" {
					summ `yvar' if `samplevar' == 1  & panel_hh == 0 
				}
				local sd1vA_`var_num' = r(sd)	
				
				******	
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1				
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_? 
	
				}
	
			outsheet indicator_name control_mean mod*_gen* num_obs in 1/60 using `direc'table7_coba_`z'_`b'_`wave', replace

			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5

			if "`wave'" == "w2"| "`wave'" == "w3"{
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"
								
				local Total_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 10)"
				local Health_mod3_gen "(([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 5)"
				local Education_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' ) /5)"
						
				local Total_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 10)"
				local Health_mod3_genvA "(([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 5)"
				local Education_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' ) / 5)"

				local Total_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' ) / 10)"
				local Health_mod3_genplusA "((([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' ) / 5)"
				local Education_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5') / 5)"
			}
			
			if "`wave'" == "po" {	
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var9_eg1vA var10_eg1vA"

				local Total_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 8)"
				local Health_mod3_gen "(([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 3)"
				local Education_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' ) /5)"
						
				local Total_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 8)"
				local Health_mod3_genvA "(([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6'  + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 3)"
				local Education_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' ) / 5)"

				local Total_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' ) / 8)"
				local Health_mod3_genplusA "((([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6'+ ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' ) / 3)"
				local Education_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5') / 5)"
			}


	 				suest `var_eg1vA', cluster(Location_ID)
	 			
	 				*Total

					lincom `Total_mod3_gen'
									
					gen mod3_gen_b 		=r(estimate) 
					gen mod3_gen_se 		= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	
					test `Total_mod3_gen' = 0			
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom `Health_mod3_gen'
					drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test `Health_mod3_gen' = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom `Education_mod3_gen'
					drop mod?_gen_b mod?_gen_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test `Education_mod3_gen' = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'			= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'			= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					*Total
			
					lincom `Total_mod3_genvA'
					gen mod3_genvA_b 		= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test `Total_mod3_genvA' = 0			
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom `Health_mod3_genvA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test `Health_mod3_genvA' = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom `Education_mod3_genvA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test `Education_mod3_genvA' = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					*Total
		
					lincom `Total_mod3_genplusA'
					gen mod3_genplusA_b 		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test `Total_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom `Health_mod3_genplusA'
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test `Health_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom `Education_mod3_genplusA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
		
					test `Education_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* in 1/10 using `direc'table7_suest_avgSE_`z'_`b'_`wave', replace	

			}	
		}
	}				
}

*******************************************************
//Carrying out regressions for Table 8 indicators
******************************************************

if `do_table8' == 1 {

	set more off
	cd\
	cd `rundir'
	cd "Wave II"
	
	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp', replace



	****
	**Generate w1 kecamatan averages
	
	use "..\Wave I\table_3_3_vars_generasi_w1", clear
	rename ea ea_code
	sort ea_code
	merge ea_code using `kab_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m
	
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	
	//Creating kecamatan level Wave 1 averages of 7 provider level quantity variables and pusk var(b/c no SD information or pct_teach in Wave I)
	foreach x in teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid ave_min_wait_pusk{ 
		bys Location_ID: egen k_`x'_w1 = mean(`x'_w1)
		bys kab_id:		egen kb_`x'_w1 = mean(`x'_w1)	
		replace k_`x'_w1 = kb_`x'_w1 if k_`x'_w1 == .	
		
	}

	**Generating place holder variables for those 5 which not have Wave I info
	foreach x in pct_teach_SD pct_teach_SMP teach_pres_SMP_2noinc teach_pres_SD_2noinc teach_pres_SMP_2yesinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk{
		gen k_`x'_w1 = .
		gen kb_`x'_w1 = .
	}	

	
	keep Location_ID k_*_w1 kb_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	
	********************************************
	*****           Wave II                ***** 
	********************************************
	cd ..\
	cd "Wave II"
	
	use table_3_3_vars_w2_with_w1controls, clear

	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m

	drop if drop == 1

	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	
	********
	
	destring prov_id, replace

	destring kab_id, replace
	
		
	*********


	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/14{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	**For all nonbidan obs, we give a unique value so are not included with bidans with missing type value
	replace sample_type = 9999 if obs_type != 2
	egen type_and_panel = group(sample_type panel_2007), missing
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	********
	* create differenced versions
	********


	***d_kec and d_ind will be missing for the pct_teach, SD, and pusk variables b/c don't wave I values



	**Generating place holder variables for those 7 which not have Wave I info
	foreach x in pct_teach_SD pct_teach_SMP teach_pres_SMP_2noinc teach_pres_SD_2noinc teach_pres_SMP_2yesinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk{
		gen `x'_w1 = .
	}

	foreach q in teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid ave_min_wait_pusk{
		display "**`q' kec***"
		g dkec_`q' = `q'_w2 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w2 - k_`q'_w1
		count if `q'_w2 != . & panel_2007 == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w2 - `q'_w1 if `q'_w1 != .

	}

	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in teach_pres_SMP_2noinc teach_pres_SMP_2yesinc teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid pct_teach_SD pct_teach_SMP teach_pres_SD_2noinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk ave_min_wait_pusk{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 == .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 == .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 == .)
		replace k_`x'_w1 = 0 if k_`x'_w1 == .
	}


	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2
	
	replace panel = 1 if obs_type == 1

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab type_and_panel, gen(type_and_panel_)
				
	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore

	save table_3_3_vars_w2_full_suest, replace

	keep if panel_2007 == 1
	keep bid sid pid obs_type panel_2007 SMP SD
	sort bid sid pid obs_type	
	tempfile panel_obs_ids_w2
	save `panel_obs_ids_w2'

	********************************************
	*****           Wave III               ***** 
	********************************************
	
	cd ..\
	cd "Wave III"
	
	use table_3_3_vars_generasi_w3_with_w1controls, clear
	
	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	

	drop if drop == 1

	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	********
	
	destring prov_id, replace

	destring kab_id, replace
	
	

		
	*********


	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/14{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	**For all nonbidan obs, we give a unique value so are not included with bidans with missing type value
	replace sample_type = 9999 if obs_type != 2
	egen type_and_panel = group(sample_type panel_2007), missing
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	********
	* create differenced versions
	********


	***d_kec and d_ind will be missing for the pct_teach, SD, and pusk variables b/c don't wave I values


	**Generating place holder variables for those 7 which not have Wave I info
	foreach x in pct_teach_SD pct_teach_SMP teach_pres_SMP_2noinc teach_pres_SD_2noinc teach_pres_SMP_2yesinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk{
		gen `x'_w1 = .
	}

	foreach q in teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid ave_min_wait_pusk{
		display "**`q' kec***"
		g dkec_`q' = `q'_w3 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w3 - k_`q'_w1
		count if `q'_w3 != . & panel_2007 == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w3 - `q'_w1 if `q'_w1 != .

	}

	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in teach_pres_SMP_2noinc teach_pres_SMP_2yesinc teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid pct_teach_SD pct_teach_SMP teach_pres_SD_2noinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk ave_min_wait_pusk{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 == .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 == .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 == .)
		replace k_`x'_w1 = 0 if k_`x'_w1 == .
	}


	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	replace panel = 1 if obs_type == 1

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab type_and_panel, gen(type_and_panel_)

	save table_3_3_vars_generasi_w3_full_suest, replace

	keep if panel_2007 == 1 | panel_2007 == .
	keep bid sid pid obs_type panel_2007 SMP SD
	sort bid sid pid obs_type	
	tempfile panel_obs_ids_w3
	save `panel_obs_ids_w3'


	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_3_3_vars_w2_full_suest", clear
		
	foreach q in teach_pres_SMP_2noinc teach_pres_SMP_2yesinc teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid pct_teach_SD pct_teach_SMP teach_pres_SD_2noinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk ave_min_wait_pusk{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}


	keep wave *_po *_w1 *_m1 bid sid pid kab_id Location_ID prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A panel* type_and_panel

	tempfile temp_wave
	save `temp_wave'	

	use table_3_3_vars_generasi_w3_full_suest, clear
	

	**Update to include teacher presence when get full data
	foreach q in teach_pres_SMP_2noinc teach_pres_SMP_2yesinc teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid pct_teach_SD pct_teach_SMP teach_pres_SD_alt provider_pres_pusk ave_min_wait_pusk{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 bid sid pid kab_id Location_ID prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A panel* type_and_panel
	append using `temp_wave'

		**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab type_and_panel, gen(type_and_panel_)
				
			gen wave_3 = wave==3
			
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
								
			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local kec_val_w1_group "k_*_w1"
			local prov_P_group "prov_P_*"
			local type_panel_group "type_and_panel_*"
			local ind_val_group "i_*_w1"
			local ind_val_m1_group "i_*_m1"
			local kec_val_m1_group "k_*_m1"
	
			foreach q of varlist `k12_val_w1_group' `kec_val_w1_group' `prov_P_group' `type_panel_group' `ind_val_group' `ind_val_m1_group' `kec_val_m1_group'{
				gen `q'w = wave_3 * `q'
				}
	
	save table_3_3_vars_pooled_full_suest, replace


foreach w in table_3_3_vars_w2_full_suest table_3_3_vars_generasi_w3_full_suest table_3_3_vars_pooled_full_suest{
	foreach z in indcontrols {
		foreach b in all{
		
			if "`w'" == "table_3_3_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_3_3_vars_w2_full_suest", clear
			}
			if "`w'" == "table_3_3_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_3_3_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel
	
			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .

			gen indicator_name_avgSE 				= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
				
		if "`b'" == "java"{
			keep if prov_id == 32 | prov_id == 35
			local direc "..\Output\java\"
		}
		if "`b'" == "sulawesi"{
			keep if prov_id == 71 | prov_id == 75
			local direc "..\Output\sulawesi\"
		}
		if "`b'" == "ntt"{
			keep if prov_id == 53
			local direc "..\Output\ntt\"
		}
		if "`b'" == "all"{
			local direc "..\Output\all\"
		}
		
**
		cap drop _m*
		sort prov_id
		tempfile tempz
		save	`tempz'

		//Bringing in Wave 1 overall control values
		use "..\Wave I\table_3_3_vars_generasi_w1", clear	
		destring prov_id, replace

		**Merging in Location_ID, kab_id info
		rename ea ea_code
		sort ea_code
		merge ea_code using `temp', uniqusing
		tab _merge
		drop if _merge == 2
		drop _merge
		
		sort Location_ID
		merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
		tab _mergenodrop
		keep if _mergenodrop == 3
		drop _mergenodrop
		
		
		**Merging in with w2, w3 ids to determine which obs are panel in either wave, to keep for baseline calcs	
		**Obs are all either bidan, puskemas, or school, so no weighting issue; want panel obs for comparison  [almost all SMPs are panel (had 30 generasi wave I not resampled and 10 new generasi Wave II which newly sampled, so want to keep 741 panel SMP for control and baseline (slightly fewer b/c of "drop" kecs omission))				
		
		sort bid sid pid obs_type
		merge bid sid pid obs_type using `panel_obs_ids_w2', sort update
		tab _m
		
		gen panel_keep = 1 if _m == 3
		drop panel_2007 SD SMP

		sort bid sid pid obs_type
		merge bid sid pid obs_type using `panel_obs_ids_w3', sort _merge(_m2) update
		tab _m2
		
		replace panel_keep = 1 if _m2 == 3
		drop panel_2007 SD SMP _m*
		
		keep if panel_keep == 1
			
		if "`b'" == "java"{
			keep if prov_id == 32 | prov_id == 35
		}
		if "`b'" == "sulawesi"{				
			keep if prov_id == 71 | prov_id == 75
		}
		if "`b'" == "ntt"{
			keep if prov_id == 53						
		}
		
		//Creating kecamatan level Wave 1 averages of 7 provider level quantity variables (b/c no pct_teach or SD information in Wave I)
		foreach x in teach_pres_SMP_alt num_pos_1mon_bid hrs_pos_1mon_bid nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid ave_min_wait_pusk{ 	
			**Creating overall wave 1 average of each variable for table
			cap drop avg_`x'_w1 se_`x'_w1
			summ `x'_w1 if panel == 1
			gen avg_`x'_w1 = r(mean)
			gen se_`x'_w1 = r(sd)
		}

		foreach x in pct_teach_SD pct_teach_SMP teach_pres_SMP_2noinc teach_pres_SD_2noinc teach_pres_SMP_2yesinc teach_pres_SD_2yesinc teach_pres_SD_alt provider_pres_pusk{
			gen avg_`x'_w1 = .
			gen se_`x'_w1 = .
		}	
				
		keep avg_*_w1 se_*_w1 prov_id
		duplicates drop
		sort prov_id
		merge prov_id using `tempz', uniqmaster
		tab _m
		drop if _m == 1
		drop _m
		
**

			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
			
			local pick = 1
		
			
			local vars_list	"nei_out_3day_bid pub_serv_3day_bid pri_serv_3day_bid tot_hrs_3day_bid num_pos_1mon_bid hrs_pos_1mon_bid ave_min_wait_pusk provider_pres_pusk teach_pres_SD_alt teach_pres_SMP_alt pct_teach_SD pct_teach_SMP"

			foreach x in `vars_list'{

				disp "*******`x'_`wave'**********"
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "k_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "type_and_panel_*"
					local age_vals_wave ""
					local ind_val_wave "i_`x'_w1"
					local ind_val_m1_wave "i_`x'_m1"
					local kec_val_m1_wave "k_`x'_m1"
					local kab_wave "kab_id"
				}
					

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "k_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "type_and_panel_*"
					local age_vals_wave ""
					local ind_val_wave "i_`x'_w1*"
					local ind_val_m1_wave "i_`x'_m1*"
					local kec_val_m1_wave "k_`x'_m1*"
					local kab_wave "kab_wave"
				}
						
				
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local kec_val_m1 "`kec_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	

	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 "`kec_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
								
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local kec_val_m1 "`kec_val_m1_wave'"		
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 "`kec_val_m1_wave'"			
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}					
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
											
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""					
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""					
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}			
					
			if "`x'" == "teach_pres_SMP_alt" | "`x'" == "num_pos_1mon_bid" | "`x'" == "hrs_pos_1mon_bid" | "`x'" == "nei_out_3day_bid" | "`x'" == "pub_serv_3day_bid" | "`x'" == "pri_serv_3day_bid" | "`x'" == "tot_hrs_3day_bid" | "`x'" == "ave_min_wait_pusk" {
				local control_mean "`yvar' if e(sample) == 1 & intervention == "3" & panel_2007 == 1"
			}

				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			

				
				****
																
				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_*, cluster(Location_ID)
				

				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}
				
				summ `control_mean' 
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'
				
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				**************************
				replace indicator_name = "`x'" in `number'
	
				**************************

				reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_*
				
				noi estimates store var`var_num'_eg1vA	
				
				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)		
				
				*********
				
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1				
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}				
			}
	
			outsheet indicator_name baseline_mean control_mean mod*_gen* num_obs in 1/99 using `direc'table8_coba_`z'_`b'_`wave', replace

			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			

	 				suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA  var11_eg1vA var12_eg1vA, cluster(Location_ID)
	 			
	 				*Total

					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 12)
									
					gen mod3_gen_b 		=r(estimate) 
					gen mod3_gen_se 		= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12'/12) = 0			
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6'+ [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8)
					drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6'+ [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12' ) / 4)
					drop mod?_gen_b mod?_gen_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12' ) / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'			= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'			= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 		= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					*Total
			
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10'+ [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12)
					gen mod3_genvA_b 		= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
					*Total
		
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12' ) / 12)
					gen mod3_genplusA_b 		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12' ) / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6'  + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' ) / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12'  ) / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12' ) / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* in 1/10 using `direc'table8_suest_avgSE_`z'_`b'_`wave', replace	
			}	
		}
	}	
}

*******************************************************
//Carrying out regressions for Table 9 indicators
******************************************************


if `do_table9' == 1 {


	*******************
	***  Wave II    ***
	*******************
	
	set more off
	cd\
	cd `rundir'
	cd "Wave II"


	****

	use "..\Wave I\Data\R", clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back_w2 HH_type_fill
	duplicates drop
	sort panel_hh_id_back
	tempfile hhtype
	save `hhtype'

	****

	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp', replace

	****
	**Generate w1 kecamatan averages
	
	use "..\Wave I\table_3_4_vars_generasi_w1", clear
	rename ea ea_code
	sort ea_code
	merge ea_code using `kab_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m
	
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	
	//Creating kecamatan level Wave 1 averages of 10 provider level quantity variables (b/c no SD information in Wave I)
	foreach x in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp{ 
		bys Location_ID: egen k_`x'_w1 = mean(`x'_w1)
		bys kab_id:		egen kb_`x'_w1 = mean(`x'_w1)	
		replace k_`x'_w1 = kb_`x'_w1 if k_`x'_w1 == .	
		
	}

	//Generating place holder variables for those 17 which not have Wave I info
	foreach x in meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh wom_meetings_wom{
		gen k_`x'_w1 = .
		gen kb_`x'_w1 = .
	}

	keep Location_ID k_*_w1 kb_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	

	****
	
	use table_3_4_vars_w2_with_w1controls, clear
		
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	

	drop if drop == 1


	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	********
	destring prov_id, replace
	destring kab_id, replace
	********
	
	//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype', uniqusing _merge(_m3)
	tab rar00x _m3 if obs_type >= 6, m
	drop if _m3 == 2


	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****

	gen age_years = floor(age/365.25)
	//Creating dummy group for those kids with missing years of age and non-applicable obs (non-kid)
	replace age_years = 8888 if age_years == . & obs_type == 7 
	replace age_years = 9999 if obs_type != 7 

	
	**Panel and split are panel HH's (obs_type < 6 are not HH type obs)
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2) if obs_type >= 6

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**All posyandu are non-panel
	replace panel = 0 if obs_type == 4

	gen panel_info = panel if obs_type < 6
	replace panel_info = panel_hh if obs_type >= 6

	egen HH_type_and_panel = group(HH_type panel_info), missing
	
	****



	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/26{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	


	
	********
	* create differenced versions
	********


	***d_kec and d_ind will be missing for the SD, kuponm, health_ed, and posyandu variables b/c don't wave I values

	foreach x in meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh wom_meetings_wom{
		capture drop `x'_w1
		gen `x'_w1 = .
	}


	foreach q in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp{
		display "**`q' kec***"
		g dkec_`q' = `q'_w2 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w2 - k_`q'_w1
		count if `q'_w2 != . & panel == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w2 - `q'_w1 if `q'_w1 != .

	}

	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom wom_meetings_wom num_meetings_mainresp meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 >= .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 >= .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 >= .)
		replace k_`x'_w1 = 0 if k_`x'_w1 >= .
	}


	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
				
	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep ea_code
	duplicates drop
	sort ea_code
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	

	save table_3_4_vars_w2_full_suest, replace
	
	keep if (panel_2007 == 1 & obs_type == 3) | (panel_village == 1 & obs_type == 5)
	keep lid sid obs_type panel_2007 panel_village SMP SD
	sort lid sid obs_type	
	tempfile panel_obs_ids_w2
	save `panel_obs_ids_w2'
	

	*******************
	***  Wave III   ***
	*******************
	
	set more off
	cd ..\
	cd "Wave III"


	****

	use "..\Wave I\Data\R", clear
	
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back_w3 HH_type_fill
	duplicates drop
	sort panel_hh_id_back
	tempfile hhtype
	save `hhtype'

	****

	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp', replace
	
	****
	**Generate w1 kecamatan averages
	
	use "..\Wave I\table_3_4_vars_generasi_w1", clear
	rename ea ea_code
	sort ea_code
	merge ea_code using `kab_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m
	
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	
	//Creating kecamatan level Wave 1 averages of 10 provider level quantity variables (b/c no SD information in Wave I)
	foreach x in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom{ 
		bys Location_ID: egen k_`x'_w1 = mean(`x'_w1)
		bys kab_id:		egen kb_`x'_w1 = mean(`x'_w1)	
		replace k_`x'_w1 = kb_`x'_w1 if k_`x'_w1 == .	
		
	}

	//Generating place holder variables for those 20 which not have Wave I info
	foreach x in meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh wom_meetings_wom num_meetings_mainresp{
		gen k_`x'_w1 = .
		gen kb_`x'_w1 = .
	}

	keep Location_ID k_*_w1 kb_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	

	****
	
	use table_3_4_vars_generasi_w3_with_w1controls, clear
		
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	
	drop if drop == 1


	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	
	********
	destring prov_id, replace
	destring kab_id, replace
	********
	
	//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype', uniqusing _merge(_m3)
	tab rar00x _m3 if obs_type >= 6, m
	drop if _m3 == 2


	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****

	gen age_years = floor(age/365.25)
	//Creating dummy group for those kids with missing years of age and non-applicable obs (non-kid)
	replace age_years = 8888 if age_years == . & obs_type == 7 
	replace age_years = 9999 if obs_type != 7 

	
	**Panel and split are panel HH's (obs_type < 6 are not HH type obs)
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2) if obs_type >= 6

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**All posyandu are non-panel
	replace panel = 0 if obs_type == 4

	gen panel_info = panel if obs_type < 6
	replace panel_info = panel_hh if obs_type >= 6

	egen HH_type_and_panel = group(HH_type panel_info), missing
	
	****



	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/26{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	


	
	********
	* create differenced versions
	********


	***d_kec and d_ind will be missing for the SD, kuponm, health_ed, and posyandu variables b/c don't wave I values

	foreach x in meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh wom_meetings_wom{
		capture drop `x'_w1
		gen `x'_w1 = .
	}


	foreach q in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp{
		display "**`q' kec***"
		g dkec_`q' = `q'_w3 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w3 - k_`q'_w1
		count if `q'_w3 != . & panel == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w3 - `q'_w1 if `q'_w1 != .

	}

	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom wom_meetings_wom num_meetings_mainresp meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid health_serv_improve_hh educ_serv_improve_hh elec09_part_hh{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 >= .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 >= .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 >= .)
		replace k_`x'_w1 = 0 if k_`x'_w1 >= .
	}

	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)


	save table_3_4_vars_generasi_w3_full_suest, replace
	
	keep if (panel_2007 == 1 & obs_type == 3) | (panel_village == 1 & obs_type == 5)
	keep lid sid obs_type panel_2007 panel_village SMP SD
	sort lid sid obs_type	
	tempfile panel_obs_ids_w3
	save `panel_obs_ids_w3'
	
	
	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_3_4_vars_w2_full_suest", clear
	
	foreach q in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 age_years obs_type HH_type_and_panel panel_hh kab_id Location_ID prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A type gen_pooled gen_pooled_versi_A panel_2007 panel SD SMP

	tempfile tempwave
	save `tempwave'	
	
	use table_3_4_vars_generasi_w3_full_suest, clear
	

	foreach q in meet_parents_SMP comm_members_SMP meet_teachers_SMP pos_num_desa KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom wom_meetings_wom num_meetings_mainresp meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos health_ed_preg_moth health_ed_delv_moth /*kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth*/ health_ed_pos_kid /*kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid*/ health_serv_improve_hh educ_serv_improve_hh elec09_part_hh{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 age_years obs_type HH_type_and_panel panel_hh kab_id Location_ID prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A type gen_pooled gen_pooled_versi_A panel_2007 panel_2008 panel SD SMP
	append using `tempwave'

		**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
			
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
								
			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local kec_val_w1_group "k_*_w1"
			local prov_P_group "prov_P_*"
			local age_vals_group "age_years_*"
			local type_panel_group "HH_type_and_panel_*"
			local ind_val_group "i_*_w1"
			local ind_val_m1_group "i_*_m1"
			local kec_val_m1_group "k_*_m1"
	
			foreach q of varlist `k12_val_w1_group' `kec_val_w1_group' `prov_P_group' `age_vals_groups' `type_panel_group' `ind_val_group' `ind_val_m1_group' `kec_val_m1_group'{
				gen `q'w = wave_3 * `q'
				}
						
	save table_3_4_vars_pooled_full_suest, replace	
	
foreach w in table_3_4_vars_w2_full_suest table_3_4_vars_generasi_w3_full_suest table_3_4_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{

			if "`w'" == "table_3_4_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_3_4_vars_w2_full_suest", clear
			}
			if "`w'" == "table_3_4_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_3_4_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel

			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .

			gen indicator_name_avgSE 				= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
				
		if "`b'" == "java"{
			keep if prov_id == 32 | prov_id == 35
			local direc "..\Output\java\"
		}
		if "`b'" == "sulawesi"{
			keep if prov_id == 71 | prov_id == 75
			local direc "..\Output\sulawesi\"
		}
		if "`b'" == "ntt"{
			keep if prov_id == 53
			local direc "..\Output\ntt\"
		}
		if "`b'" == "all"{
			local direc "..\Output\all\"
		}

		cap drop _m*
		sort prov_id
		tempfile tempz
		save	`tempz'

		//Bringing in Wave 1 overall control values
		use "..\Wave I\table_3_4_vars_generasi_w1", clear	
		destring prov_id, replace

		**Merging in Location_ID, kab_id info
		rename ea ea_code
		sort ea_code
		merge ea_code using `temp', uniqusing
		tab _merge
		drop if _merge == 2
		drop _merge
		
		sort ea_code
		merge ea_code using `nodrop_kecs', uniqusing _merge(_mergenodrop)
		tab _mergenodrop
		keep if _mergenodrop == 3
		drop _mergenodrop
		
		**Keeping only school or desa obs
		keep if obs_type == 3 | obs_type == 5
				
		**Merging in with w2, w3 ids to determine which obs are panel in either wave, to keep for baseline calcs	
		**Obs are all either school or desa, so no weighting issue; want panel obs for comparison  [almost all SMPs are panel (had 30 generasi wave I not resampled and 10 new generasi Wave II which newly sampled, so want to keep 741 panel SMP for control and baseline (slightly fewer b/c of "drop" kecs omission))				
		
		sort lid sid obs_type	
		merge lid sid obs_type using `panel_obs_ids_w2', sort update
		tab _m
		
		gen panel_keep = 1 if _m == 3
		drop panel_village panel_2007 SD SMP

		sort lid sid obs_type	
		merge lid sid obs_type using `panel_obs_ids_w3', sort _merge(_m2) update
		tab _m2
		
		replace panel_keep = 1 if _m2 == 3
		drop panel_village panel_2007 SD SMP _m*
		
		keep if panel_keep == 1
			
		if "`b'" == "java"{
			keep if prov_id == 32 | prov_id == 35
		}
		if "`b'" == "sulawesi"{				
			keep if prov_id == 71 | prov_id == 75
		}
		if "`b'" == "ntt"{
			keep if prov_id == 53						
		}
		
		foreach x in meet_parents_SMP comm_members_SMP meet_teachers_SMP{ 	
			**Creating overall wave 1 average of each variable for table
			cap drop avg_`x'_w1 se_`x'_w1
			summ `x'_w1
			gen avg_`x'_w1 = r(mean)
			gen se_`x'_w1 = r(sd)
		}
		
		foreach x in pos_num_desa{
			cap drop avg_`x'_w1 se_`x'_w1
			summ `x'_w1
			gen avg_`x'_w1 = r(mean)
			gen se_`x'_w1 = r(sd)
		} 

		foreach x in meet_parents_SD comm_members_SD meet_teachers_SD meet_num_pos kader_num_pos sweep_num_pos{
			gen avg_`x'_w1 = .
			gen se_`x'_w1 = .
		}				
				

		keep avg_*w1 se_*w1 prov_id
		duplicates drop
		sort prov_id
		cap drop _m*
		merge prov_id using `tempz', uniqmaster _merge(_mm)
		tab _mm
		drop if _mm == 1
		drop _mm

		sort prov_id
		tempfile tempy
		save `tempy'

		//Bringing in Wave 1 overall control values
		use "..\Wave I\table_3_4_vars_generasi_w1", clear
			
		destring prov_id, replace

		if "`b'" == "java"{
			keep if prov_id == 32 | prov_id == 35
		}
		if "`b'" == "sulawesi"{
			keep if prov_id == 71 | prov_id == 75
		}
		if "`b'" == "ntt"{
			keep if prov_id == 53
		}

		rename ea ea_code
		sort ea_code
		merge ea_code using `nodrop_kecs', uniqusing _merge(_mergenodrop)
		keep if _mergenodrop == 3
		drop _mergenodrop
			

		gen 		baseline_weight = 3/2 if HH_type == 1
		replace baseline_weight = 1/2 if HH_type == 2
		replace baseline_weight = 1   if HH_type == 3

		foreach x in KIA_kid KMS_kid hours_part_hh num_groups_hh gov_meetings_wom num_meetings_mainresp{ 
			**Creating overall wave 1 average of each variable for table
			cap drop avg_`x'_w1 se_`x'_w1
			summ `x'_w1 [weight = baseline_weight]
			gen avg_`x'_w1 = r(mean)
			gen se_`x'_w1 = r(sd)
		}

	 	foreach x in health_ed_preg_moth health_ed_delv_moth kupon_use_main_moth kupon_use_alt_moth kupon_main_moth kupon_alt_moth health_ed_pos_kid kupon_use_main_kid kupon_use_alt_kid kupon_main_kid kupon_alt_kid wom_meetings_wom health_serv_improve_hh educ_serv_improve_hh elec09_part_hh{
			gen avg_`x'_w1 = .
			gen se_`x'_w1 = .
		}

		keep avg_*_w1 se_*_w1 prov_id
		duplicates drop
		sort prov_id
		merge prov_id using `tempy', uniqmaster
		tab _m
		drop if _m == 1
		drop _m


			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
			
			local pick = 1
		
			if "`wave'" == "w2"{
				local vars_list "pos_num_desa meet_num_pos kader_num_pos sweep_num_pos meet_parents_SD meet_parents_SMP comm_members_SD comm_members_SMP meet_teachers_SD meet_teachers_SMP"
			}
			
			if "`wave'" == "w3"{
				local vars_list "pos_num_desa meet_num_pos kader_num_pos sweep_num_pos meet_parents_SD meet_parents_SMP comm_members_SD comm_members_SMP meet_teachers_SD meet_teachers_SMP"
			}

			if "`wave'" == "po"{
				local vars_list "pos_num_desa meet_num_pos kader_num_pos sweep_num_pos meet_parents_SD meet_parents_SMP comm_members_SD comm_members_SMP meet_teachers_SD meet_teachers_SMP"
			}
			
			foreach x in `vars_list'{

				disp "*******`x'_`wave'**********"
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)	
	
				
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "k_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "i_`x'_w1"
					local ind_val_m1_wave "i_`x'_m1"
					local kec_val_m1_wave "k_`x'_m1"
					local kab_wave "kab_id"
				}
				
				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "k_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "i_`x'_w1*"
					local ind_val_m1_wave "i_`x'_m1*"
					local kec_val_m1_wave "k_`x'_m1*"
					local kab_wave "kab_wave"
				}

	
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local kec_val_m1 "`kec_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	

	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 "`kec_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local kec_val_m1 "`kec_val_m1_wave'"		
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 "`kec_val_m1_wave'"			
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
			
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}			
			
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""					
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""					
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}			
														
				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			

				
				****				
				
				if "`x'" == "health_ed_pos_kid"{
					local age_vals ""
				}
				
				***Info on control mean panel/panel_hh obs restrictions
				
				if "`x'" == "meet_parents_SMP" | "`x'" == "comm_members_SMP" | "`x'" == "meet_teachers_SMP" {
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3" & panel == 1"
				}	

				if "`x'" == "KIA_kid" | "`x'" == "KMS_kid" | "`x'" == "health_serv_improve_hh" | "`x'" == "educ_serv_improve_hh" | "`x'" == "hours_part_hh" | "`x'" == "num_groups_hh" | "`x'" == "num_meetings_hhresp" | "`x'" == "gov_meetings_wom" | "`x'" == "wom_meetings_wom" | "`x'" == "health_ed_preg_moth" | "`x'" == "health_ed_delv_moth" | "`x'" == "kupon_use_main_moth" | "`x'" == "kupon_use_alt_moth" | "`x'" == "kupon_main_moth" | "`x'" == "kupon_alt_moth" | "`x'" == "health_ed_pos_kid" | "`x'" == "kupon_use_main_kid" | "`x'" == "kupon_use_alt_kid" | "`x'" == "kupon_main_kid" | "`x'" == "kupon_alt_kid"{
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3" & panel_hh == 0"
				}				

											
				****
				
				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' `prov_P' kab_wave_*, cluster(Location_ID)
				

				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}
				
				summ `control_mean'
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'
				
				
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				**************************
				replace indicator_name = "`x'" in `number'
	
				**************************

				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' `prov_P' kab_wave_*
				
				noi estimates store var`var_num'_eg1vA	
								
				**Restricting participation in meetings about health education variables to incentive/nonincentive in Wave II
				
				if "`wave'" == "w2" & "`x'" == " health_ed_preg_moth" | "`x'" == "health_ed_delv_moth" | "`x'" == "health_ed_pos_kid"{
					quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' `prov_P' kab_wave_*
					noi estimates store var`var_num'_eg1vA				
				}			

				
				******
				
				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)	
				
				
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1			
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}				
			}
	
			outsheet indicator_name baseline_mean control_mean mod*_gen* num_obs in 1/99 using `direc'table9_coba_`z'_`b'_`wave', replace
	
			if "`wave'" == "w2"{
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"
				
				local Total_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12'+ [var13_eg1vA_mean]`generasi'/`sd1vA_13' + [var14_eg1vA_mean]`generasi'/`sd1vA_14' + [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' ) / 18)"
				local Community_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 10)"
				local Health_Education_mod3_gen "(([var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12'+ [var13_eg1vA_mean]`generasi'/`sd1vA_13' + [var14_eg1vA_mean]`generasi'/`sd1vA_14' + [var15_eg1vA_mean]`generasi'/`sd1vA_15') / 5)"
				local Other_mod3_gen "(([var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' ) / 3)"
				
				local Total_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' + [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' + [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' + [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' ) / 18)"
				local Community_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 10)"
				local Health_Education_mod3_genvA "(([var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' + [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' + [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' + [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15') / 5)"
				local Other_mod3_genvA "(([var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' ) / 3)"
				
				local Total_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12' + ([var13_eg1vA_mean]`generasi_vA' + [var13_eg1vA_mean]`generasi')/`sd1vA_13' + ([var14_eg1vA_mean]`generasi_vA' + [var14_eg1vA_mean]`generasi')/`sd1vA_14' + ([var15_eg1vA_mean]`generasi_vA' + [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA' + [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA' + [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA' + [var18_eg1vA_mean]`generasi')/`sd1vA_18') / 18)"
				local Community_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10') / 10)"
				local Health_Education_mod3_genplusA "((([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12' + ([var13_eg1vA_mean]`generasi_vA' + [var13_eg1vA_mean]`generasi')/`sd1vA_13' + ([var14_eg1vA_mean]`generasi_vA' + [var14_eg1vA_mean]`generasi')/`sd1vA_14' + ([var15_eg1vA_mean]`generasi_vA' + [var15_eg1vA_mean]`generasi')/`sd1vA_15') / 5)"
				local Other_mod3_genplusA "((([var16_eg1vA_mean]`generasi_vA' + [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA' + [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA' + [var18_eg1vA_mean]`generasi')/`sd1vA_18') / 3)"
			}

			if "`wave'" == "w3"{
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"
				
				local Community_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 10)"
				local Community_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 10)"
				local Community_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10') / 10)"
			}
			
			if "`wave'" == "po"{
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"
										
				local Community_mod3_gen "(([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' + [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10') / 10)"
				local Community_mod3_genvA "(([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10') / 10)"
				local Community_mod3_genplusA "((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' + ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10') / 10)"
			}

			
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			local line_num_plus6 = `line_num' + 6
			local line_num_plus7 = `line_num' + 7
			


	 				suest `var_eg1vA', cluster(Location_ID)
	 			
	
	
					*Community	
	
					lincom `Community_mod3_gen'
					cap drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test `Community_mod3_gen' = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	

					*Community
		
					lincom `Community_mod3_genvA'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test `Community_mod3_genvA' = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
							
					*Community
			
					lincom `Community_mod3_genplusA'
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test `Community_mod3_genplusA' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

			
							
				local count_line = 1
				foreach w in avg_std_effect_community_effort{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* in 1/10 using `direc'table9_suest_avgSE_`z'_`b'_`wave', replace
	
			}	
		}
	}	
}

*******************************************************
//Carrying out regressions for Table 10 Panel A 
******************************************************


if `do_table10A' == 1 {

	set more off
	cd \
	cd `rundir'
	cd "Wave I"
	
	***
	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea
	tempfile ea_info
	save `ea_info'

	
	***
	**Expenditure info for calculating quintiles
	
	cd ..\
	cd "Wave II"

	use Data\R, clear

	gen panel_hh_id_w2 = substr(rid, 1,3) + substr(rid,5,7)
	gen panel_hh = (rar00x == 1 | rar00x == 2)
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"

	gen ea = substr(rid,1,3)

	sort ea
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if panel_hh == 1 & nodrop_kec == 1
	keep panel_hh panel_hh_id_back_w2 ea Location_ID
	duplicates drop
	sort panel_hh_id_back_w2
	tempfile panel_hh_w2
	save `panel_hh_w2'

	***
	cd ..\
	cd "Wave III"

	use Data\R, clear

	gen panel_hh_id_w3 = substr(rid, 1,3) + substr(rid,5,9)
	gen panel_hh = (rar00x == 1 | rar00x == 2)
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"

	gen ea = substr(rid,1,3)

	sort ea
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if panel_hh == 1 & nodrop_kec == 1
	keep panel_hh panel_hh_id_back_w3 ea Location_ID
	duplicates drop
	sort panel_hh_id_back_w3
	tempfile panel_hh_w3
	save `panel_hh_w3'

	*********

	use "..\Wave I\Data\HH_Exp_w1", clear

	rename hid rid

	gen panel_hh_id_back_w2 = panel_hh_id_back
	
	sort rid
	merge rid using "..\Wave I\Data\whh", sort
	tab _m
	drop _m

	**Inverting from probability of being sampled
	gen hh_weight = 1/whh

	**Keeping generasi kecs only
	keep if SamplingMethod == 3
	
	sort ea	
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if nodrop_kec == 1
	
	xtile hhexp_quintile = logPCexp [pweight = hh_weight], nquantiles(5)
	gen top3quint = 1 if hhexp_quintile >= 3 & hhexp_quintile < .
	replace top3quint = 0 if hhexp_quintile <= 2 
	
	keep logPCexp hh_weight panel_hh_id_back_w2 top3quint

	sort panel_hh_id_back_w2
	tempfile logPCexp_quints_w1_w2
	save `logPCexp_quints_w1_w2'
	
	****
	
	use "..\Wave I\Data\HH_Exp_w1", clear

	rename hid rid

	gen panel_hh_id_back_w3 = panel_hh_id_back + "00"
	
	sort rid
	merge rid using "..\Wave I\Data\whh", sort
	tab _m
	drop _m

	**Inverting from probability of being sampled
	gen hh_weight = 1/whh

	**Keeping generasi kecs only
	keep if SamplingMethod == 3
	
	sort ea	
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if nodrop_kec == 1
	
	xtile hhexp_quintile = logPCexp [pweight = hh_weight], nquantiles(5)
	gen top3quint = 1 if hhexp_quintile >= 3 & hhexp_quintile < .
	replace top3quint = 0 if hhexp_quintile <= 2 

	keep logPCexp hh_weight panel_hh_id_back_w3 top3quint

	sort panel_hh_id_back_w3
	tempfile logPCexp_quints_w1_w3
	save `logPCexp_quints_w1_w3'
	
	****	


	*********	
	cd ..\
	cd "Wave II"


	****
	use "..\Wave I\Data\R", clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile temphh
	save `temphh'
	
	drop *_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'

	drop *_w2
	use `temphh', clear
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	****

	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp', replace
	

	****
	
	********************************************
	*****           Wave II                ***** 
	********************************************

	cd ..\
	cd "Wave II"

	use table_1_1_vars_w2, clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	gen panel_hh = (rar00x == 1 | rar00x == 2) if rar00x != .
	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	

	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*


	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	cap drop _m*

	***

	keep if panel_hh == 1
		
	** Merge in wave 1 HH logPCexp values and HH weights
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `logPCexp_quints_w1_w2', uniqusing
	tab _merge panel_hh, m
	drop if _merge == 2
	drop _m

	****

	destring prov_id, replace
	destring kab_id, replace



//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m3)
	tab rar00x _m3 
	drop if _m3 == 2

	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
		
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****




	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10)
	replace age_years = 8888 if age_years == . & (obs_type == 7 | obs_type == 10)			
	

	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)


	foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_pooled gen_pooled_versi_A{
			gen top3quint_`C' = top3quint * `C'
	}		

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
	
	save table_2_3_for_1_1_vars_w2_full_suest, replace

	********************************************
	*****           Wave III               ***** 
	********************************************

	cd ..\
	cd "Wave III"

	use table_1_1_vars_generasi_w3, clear
	
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	gen panel_hh = (rar00x == 1 | rar00x == 2) if rar00x != .
	
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _m
	keep if _m == 3
	drop _m
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*


	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	cap drop _m*

	****
	
	keep if panel_hh == 1
		
	** Merge in wave 1 HH logPCexp values and HH weights
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `logPCexp_quints_w1_w3', uniqusing
	tab _merge panel_hh, m
	keep if _merge == 3
	drop _m
	

	****
	destring prov_id, replace
	destring kab_id, replace





	//Merging in hh_type info for panel HH and individual level obs

	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m3)
	tab rar00x _m3 
	drop if _m3 == 2

	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
		
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****




	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
		
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10)
	replace age_years = 8888 if age_years == . & (obs_type == 7 | obs_type == 10)		


	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A gen_pooled gen_pooled_versi_A{
			gen top3quint_`C' = top3quint * `C'
	}	

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
		
	save table_2_3_for_1_1_vars_generasi_w3_full_suest, replace



	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_2_3_for_1_1_vars_w2_full_suest", clear
	
	foreach q in health_subs deliv_subs health_subs_dum deliv_subs_dum scholarship_ed uniforms other_school_suppl transport other_school PMT_school scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_w1 *_po id panel_hh age_years rid kab_id Location_ID HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x top3quint*
	tempfile temp
	save `temp'	
	
	use table_2_3_for_1_1_vars_generasi_w3_full_suest, clear
	

	foreach q in health_subs deliv_subs health_subs_dum deliv_subs_dum scholarship_ed uniforms other_school_suppl transport other_school PMT_school scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 id panel_hh age_years rid kab_id Location_ID HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x top3quint*
	append using `temp'

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
					
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */		

			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
						
			foreach q of varlist `k12_val_w1_group' `prov_P_group' `type_panel_group' `age_vals_group'{
				gen `q'w = wave_3 * `q'
				}		

	
	save table_2_3_for_1_1_vars_pooled_full_suest, replace



 
	foreach w in table_2_3_for_1_1_vars_w2_full_suest table_2_3_for_1_1_vars_generasi_w3_full_suest table_2_3_for_1_1_vars_pooled_full_suest{
		foreach z in TPcontrols{
			foreach b in  all{
		
				if "`w'" == "table_2_3_for_1_1_vars_w2_full_suest"{
					local wave "w2"
					use "..\Wave II\table_2_3_for_1_1_vars_w2_full_suest", clear
				}
				if "`w'" == "table_2_3_for_1_1_vars_generasi_w3_full_suest"{
					local wave "w3"
					use `w', clear
				}			
				if "`w'" == "table_2_3_for_1_1_vars_pooled_full_suest"{
					local wave "po"
					use `w', clear
				}			

	
			  gen indicator_name 	= ""
				gen baseline_mean = ""
				gen control_mean_`wave' = ""
				gen mod1_gen_`wave' = ""
				gen mod1_gen_top3quint_`wave' = ""
				gen mod1_gen_plustop3quint_`wave' = ""
				gen mod1_top3quint_`wave' = ""
				gen mod3_genvA_`wave'	= ""
				gen mod3_genvA_top3quint_`wave' = ""
				gen mod3_genvA_plustop3quint_`wave' = ""
				gen mod3_gen_`wave' = ""
				gen mod3_gen_top3quint_`wave' = ""
				gen mod3_gen_plustop3quint_`wave' = ""
				gen mod3_genplusA_`wave' 	= ""
				gen mod3_genplusA_top3quint_`wave' = ""
				gen mod3_genplusA_plustop3quint_`wave'  = ""
				gen mod3_top3quint_`wave' = ""
				gen num_obs 		= .

			  gen indicator_name_SE 	= ""
				gen mod1_gen_SE`wave' = ""
				gen mod1_gen_top3quint_SE`wave' = ""
				gen mod1_gen_plustop3quint_SE`wave' = ""
				gen mod1_top3quint_SE`wave' = ""
				gen mod3_genvA_SE`wave'	= ""
				gen mod3_genvA_top3quint_SE`wave' = ""
				gen mod3_genvA_plustop3quint_SE`wave' = ""
				gen mod3_gen_SE`wave' = ""
				gen mod3_gen_top3quint_SE`wave' = ""
				gen mod3_gen_plustop3quint_SE`wave' = ""
				gen mod3_genplusA_SE`wave' 	= ""
				gen mod3_genplusA_top3quint_SE`wave' = ""
				gen mod3_genplusA_plustop3quint_SE`wave'  = ""
				gen mod3_top3quint_SE`wave' = ""
				
				if "`b'" == "java"{
					keep if prov_id == 32 | prov_id == 35
					local direc "..\Output\java\"
				}
				if "`b'" == "sulawesi"{
					keep if prov_id == 71 | prov_id == 75
					local direc "..\Output\sulawesi\"
				}
				if "`b'" == "ntt"{
					keep if prov_id == 53
					local direc "..\Output\ntt\"
				}
				if "`b'" == "all"{
					local direc "..\Output\all\"
				}
	
				local marker = 0
				local count = 1
				local number = 1
				local number_plus1 = 2
				local var_num = 1
				local pick = 1
		
				local vars_list "scholarship_ed_dum uniforms_dum other_school_suppl_dum transport_dum other_school_dum PMT_school_dum PMT_pos PMT_intensive health_subs_dum deliv_subs_dum"
								
			
								
			foreach x in `vars_list'{

				disp "*******`x'_`wave'**********"

				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)		

				cap drop Location_wave* 
				egen Location_wave = group(Location_ID wave)
				tab Location_wave, gen(Location_wave_)		
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave ""
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave ""
					local ind_val_m1_wave ""
					local kab_wave "kab_id"
					local Location_wave "Location_ID"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave ""
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave ""
					local ind_val_m1_wave ""
					local kab_wave "kab_wave"
					local Location_wave "Location_wave"
				}
	
				if "`z'" == "allTPcontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}	
	
				if "`z'" == "TPcontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}	
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local kec_val_m1 ""
				}
			
				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
					local top3quint_generasi "top3quint_gen_year1"
					local top3quint_generasi_vA "top3quint_gen_year1_versi_A"
					local top3quint "top3quint"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
					local top3quint_generasi "top3quint_gen_year1or2"
					local top3quint_generasi_vA "top3quint_gen_year1or2_versi_A"
					local top3quint "top3quint"	
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
					local top3quint_generasi "top3quint_gen_pooled"
					local top3quint_generasi_vA "top3quint_gen_pooled_versi_A"					
					local top3quint "top3quint"
				}			

			
				
				quie reg `yvar' `generasi' `top3quint_generasi' `top3quint' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' 
			
				

			
				replace num_obs = e(N) in `number'
		
				//Control mean 
				tempvar samplevar
				g `samplevar' = e(sample)
				
				summ `yvar' if `samplevar' == 1 & intervention == "3" & Location_ID != "3202270"
				
				if r(sd) == 0 {
					summ `yvar' if `samplevar' == 1 & Location_ID != "3202270"
					local sd1_`var_num' = r(sd)	
				
				}
				else {
					local sd1_`var_num' = r(sd)	
				}
				
				
				
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= (r(sd)/(r(N)^0.5)) 
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' 	= control_mean_1 in `number'
				replace control_mean_`wave'		= "[" + control_mean_2 + "]" in `number_plus1'
			
				* deamean all varaibles
				sort Location_wave
				
				for var `yvar' `generasi' `top3quint_generasi' `top3quint' `generasi_vA' `top3quint_generasi' `top3quint_generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel': by Location_wave: egen temp = mean(X) \ replace X = X - temp \ drop temp
				
				quie reg `yvar' `generasi' `generasi_vA' `top3quint_generasi' `top3quint_generasi_vA' `top3quint' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' 

				
				noi estimates store var`var_num'_eg1vA


				tempvar samplevar
				g `samplevar' = e(sample)

				summ `yvar' if `samplevar' == 1 & intervention == "3" & Location_ID != "3202270"
				
				local sd1vA_`var_num' = `sd1_`var_num''

				gen mod3_gen_top3quint_b 		=_b[`top3quint_generasi'] 
				gen mod3_gen_top3quint_se 		= _se[`top3quint_generasi'] 
				tostring mod3_gen_top3quint_b, replace format(%10.4f) force
				tostring mod3_gen_top3quint_se, replace format(%10.4f) force
	
				test `top3quint_generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_top3quint_`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_top3quint_`wave'		= "(" + mod3_gen_top3quint_se + ")" in `number_plus1'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_top3quint_b 		=_b[`top3quint_generasi_vA'] 
				gen mod3_genvA_top3quint_se 	= _se[`top3quint_generasi_vA'] 
				tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
				tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
				test `top3quint_generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_top3quint_`wave'	= "(" + mod3_genvA_top3quint_se + ")" in `number_plus1'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `top3quint_generasi' + `top3quint_generasi_vA' 
				gen mod3_genplusA_top3quint_b 	= r(estimate)
				gen mod3_genplusA_top3quint_se 	= r(se)
				tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
				tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
	
				test `top3quint_generasi' + `top3quint_generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_top3quint_`wave'	= "(" + mod3_genplusA_top3quint_se + ")" in `number_plus1'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `number'

				*****
				replace indicator_name = "`x'" in `number'
				*****

				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1					
	
				*drop *mod?_gen*_b mod?_gen*_se control_mean_? *mod?_top3quint*_b *mod?_top3quint*_se
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
	
				}
	
	
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5

			if "`wave'" == "w3" | "`wave'" == "po"{
				local var_eg1 "var1_eg1 var2_eg1 var3_eg1 var4_eg1 var5_eg1 var6_eg1 var7_eg1 var8_eg1 var9_eg1 var10_eg1"
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"

				local T_mod1_gen_top3quint "(([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6'  + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' + [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10') / 10)"
				local H_mod1_gen_top3quint "(([var6_eg1_mean]`top3quint_generasi'/`sd1_6'  + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' + [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10') / 5)"
				local E_mod1_gen_top3quint "(([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' ) / 5)"

				local T_mod3_gen_top3quint "(([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10') / 10)"
				local H_mod3_gen_top3quint "(([var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10') / 5)"
				local E_mod3_gen_top3quint "(([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' ) / 5)"

				local T_mod3_genvA_top3quint "(([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' ) / 10)"
				local H_mod3_genvA_top3quint "(([var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' ) / 5)"
				local E_mod3_genvA_top3quint "(([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' ) / 5)"

				local T_mod3_genplusA_top3quint "((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' + ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' ) / 10)"
				local H_mod3_genplusA_top3quint "((([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' + ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' ) / 5)"
				local E_mod3_genplusA_top3quint "((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5') / 5)"
			}
				
			if "`wave'" == "w2"{	
				local var_eg1 "var1_eg1 var2_eg1 var3_eg1 var4_eg1 var6_eg1 var7_eg1 var8_eg1 var9_eg1 var10_eg1"
				local var_eg1vA "var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA"

				local T_mod1_gen_top3quint "(([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6'  + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' + [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10') / 9)"
				local H_mod1_gen_top3quint "(([var6_eg1_mean]`top3quint_generasi'/`sd1_6'  + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' + [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10') / 5)"
				local E_mod1_gen_top3quint "(([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' ) / 4)"

				local T_mod3_gen_top3quint "(([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10') / 9)"
				local H_mod3_gen_top3quint "(([var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10') / 5)"
				local E_mod3_gen_top3quint "(([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' ) / 4)"

				local T_mod3_genvA_top3quint "(([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' ) / 9)"
				local H_mod3_genvA_top3quint "(([var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' ) / 5)"
				local E_mod3_genvA_top3quint "(([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' ) / 4)"

				local T_mod3_genplusA_top3quint "((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' + ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' ) / 9)"
				local H_mod3_genplusA_top3quint "((([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' + ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' ) / 5)"
				local E_mod3_genplusA_top3quint "((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' ) / 4)"
			}



	 			suest `var_eg1vA', cluster(Location_ID)

	 			*****
	 				*Total
					display "`T_mod3_gen_top3quint'"
					lincom `T_mod3_gen_top3quint'

					gen mod3_gen_top3quint_b 		=r(estimate) 
					gen mod3_gen_top3quint_se 		= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
	
					test `T_mod3_gen_top3quint' = 0			
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_top3quint_SE`wave'		= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus1'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom `H_mod3_gen_top3quint'
					drop mod?_gen*_b mod?_gen*_se		
					gen mod3_gen_top3quint_b	=r(estimate) 
					gen mod3_gen_top3quint_se 	= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
		
					test `H_mod3_gen_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'		= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus3'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education

					lincom `E_mod3_gen_top3quint'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_top3quint_b	=r(estimate) 
					gen mod3_gen_top3quint_se 	= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
		
					test `E_mod3_gen_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'			= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'			= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus5'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'

	 			*****
	 				*Total

					lincom `T_mod3_genvA_top3quint'
									
					gen mod3_genvA_top3quint_b 		=r(estimate) 
					gen mod3_genvA_top3quint_se 		= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
	
					test `T_mod3_genvA_top3quint' = 0			
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'		= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_top3quint_SE`wave'		= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus1'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom `H_mod3_genvA_top3quint'
					drop mod?_gen*_b mod?_gen*_se		
					gen mod3_genvA_top3quint_b	=r(estimate) 
					gen mod3_genvA_top3quint_se 	= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
					test `H_mod3_genvA_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'		= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'		= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus3'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education

					lincom `E_mod3_genvA_top3quint'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_top3quint_b	=r(estimate) 
					gen mod3_genvA_top3quint_se 	= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
					test `E_mod3_genvA_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'			= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'			= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus5'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				*****
					*Total
		
					lincom `T_mod3_genplusA_top3quint'
					gen mod3_genplusA_top3quint_b 		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force

					test `T_mod3_genplusA_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus1'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom `H_mod3_genplusA_top3quint'
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_top3quint_b		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
	
					test `H_mod3_genplusA_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus3'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom `E_mod3_genplusA_top3quint'
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_top3quint_b		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
		
					test `E_mod3_genplusA_top3quint' = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus5'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'	
				
		
		
				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_SE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet indicator_name_SE mod3_genplusA_top3quint_SE`wave' mod3_gen_top3quint_SE`wave' mod3_genvA_top3quint_SE`wave' in 1/10 using `direc'table10A_suest_avgSE_`z'_`b'_`wave', replace



			}	
		}
	}				
}


				




*******************************************************
//Carrying out regressions for Table 10B 
******************************************************


if `do_table10B' == 1 {
	
	set more off
	cd\
	cd `rundir'
	cd "Wave I"
	
	***
	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea
	tempfile ea_info
	save `ea_info'
	
	
	
	***
	**Expenditure info for calculating quintiles
	
	cd ..\
	cd "Wave II"

	use Data\R, clear

	gen panel_hh_id_w2 = substr(rid, 1,3) + substr(rid,5,7)
	gen panel_hh = (rar00x == 1 | rar00x == 2)
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"

	gen ea = substr(rid,1,3)

	sort ea
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if panel_hh == 1 & nodrop_kec == 1
	keep panel_hh panel_hh_id_back_w2 ea Location_ID
	duplicates drop
	sort panel_hh_id_back_w2
	tempfile panel_hh_w2
	save `panel_hh_w2'

	***
	cd ..\
	cd "Wave III"

	use Data\R, clear

	gen panel_hh_id_w3 = substr(rid, 1,3) + substr(rid,5,9)
	gen panel_hh = (rar00x == 1 | rar00x == 2)
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"

	gen ea = substr(rid,1,3)

	sort ea
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if panel_hh == 1 & nodrop_kec == 1
	keep panel_hh panel_hh_id_back_w3 ea Location_ID
	duplicates drop
	sort panel_hh_id_back_w3
	tempfile panel_hh_w3
	save `panel_hh_w3'

	*********

	use "..\Wave I\Data\HH_Exp_w1", clear

	rename hid rid

	gen panel_hh_id_back_w2 = panel_hh_id_back
	
	sort rid
	merge rid using "..\Wave I\Data\whh", sort
	tab _m
	drop _m

	**Inverting from probability of being sampled
	gen hh_weight = 1/whh

	**Keeping generasi kecs only
	keep if SamplingMethod == 3
	
	sort ea	
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if nodrop_kec == 1
	
	xtile hhexp_quintile = logPCexp [pweight = hh_weight], nquantiles(5)
	gen top3quint = 1 if hhexp_quintile >= 3 & hhexp_quintile < .
	replace top3quint = 0 if hhexp_quintile <= 2 
	
	keep logPCexp hh_weight panel_hh_id_back_w2 top3quint

	sort panel_hh_id_back_w2
	tempfile logPCexp_quints_w1_w2
	save `logPCexp_quints_w1_w2'
	
	****
	
	use "..\Wave I\Data\HH_Exp_w1", clear

	rename hid rid

	gen panel_hh_id_back_w3 = panel_hh_id_back + "00"
	
	sort rid
	merge rid using "..\Wave I\Data\whh", sort
	tab _m
	drop _m

	**Inverting from probability of being sampled
	gen hh_weight = 1/whh

	**Keeping generasi kecs only
	keep if SamplingMethod == 3
	
	sort ea	
	merge ea using `ea_info', uniqusing
	tab _m
	drop if _m == 2
	drop _m


	sort Location_ID
	merge Location_ID using	`kecs_match_for_avg', uniqusing
	tab _m
	gen nodrop_kec = 1 if _m == 3
	drop if _m == 2
	drop _m

	keep if nodrop_kec == 1
	
	xtile hhexp_quintile = logPCexp [pweight = hh_weight], nquantiles(5)
	gen top3quint = 1 if hhexp_quintile >= 3 & hhexp_quintile < .
	replace top3quint = 0 if hhexp_quintile <= 2 

	keep logPCexp hh_weight panel_hh_id_back_w3 top3quint

	sort panel_hh_id_back_w3
	tempfile logPCexp_quints_w1_w3
	save `logPCexp_quints_w1_w3'
	
	****	

	use "..\Wave I\Data\R", clear
	
	gen panel_hh_id_back_w2 = substr(rid, 1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid, 1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile temphh
	save `temphh'
	
	drop *_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'

	drop *_w2
	use `temphh', clear
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'
	****

	use "..\kecs_info_clean", clear
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp'

	****
	
	cd ..\
	cd "Wave I"
	
	use table_1_2_vars_generasi_w1, clear
	
	//Keeping only non-drop kecamatan
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the 12 indicator variables (+ 4 other alt specs) [not want to do the kab average fill in for the gross enrollment kec variables, since doing regression at kec level]
	foreach x of var  pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1{ 
		bys Location_ID: egen kec_`x' = mean(`x')
		bys kab_id:		egen kab_`x' = mean(`x')	
		replace kec_`x' = kab_`x' if kec_`x' == .
	}
	
	drop _merge
	keep Location_ID kec_*_w1 kab_*_w1 
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	

	********************************************
	*****           Wave II                ***** 
	********************************************
	
	
	cd ..\
	cd "Wave II"
	
	use table_1_2_vars_w2_with_w1controls, clear
	
	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 2 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	**ONLY KEEPING PANEL HHs FOR THIS ANALYSIS
	keep if panel_hh == 1
				
	** Merge in wave 1 HH logPCexp quintiles
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `logPCexp_quints_w1_w2', uniqusing
	tab _merge panel_hh, m
	keep if _merge == 3
	drop _m

	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	
	********
	* create differenced versions
	********

**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	
	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w2 = `q'_w2 - kec_`q'_w1
	 
		g di_`q'_w2 = `q'_w2 - kec_`q'_w1
		replace di_`q'_w2 = `q'_w2 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w2 = gross_SD_enroll_kec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w2 = gross_SMP_enroll_kec_w2 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w2 = gross_SD_enroll_kec_crsec_w2 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w2 = gross_SMP_enroll_kec_crsec_w2 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
		
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w2 -gross_SD_enroll_kec_w2 -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	
	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2



	foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_pooled gen_pooled_versi_A{
			gen top3quint_`C' = top3quint * `C'
	}	

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
								
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1
				rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1
				rename times_weighed_last3months_w2 times_weighed_last3m_w2
				rename dk_times_weighed_last3months_w2 dk_times_weighed_last3m_w2
				rename di_times_weighed_last3months_w2 di_times_weighed_last3m_w2

	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	
	save table_2_3_for_1_2_vars_w2_full_suest, replace
	
	

	********************************************
	*****           Wave III               ***** 
	********************************************
	
	
	cd ..\
	cd "Wave III"
	
	use table_1_2_vars_generasi_w3_with_w1controls, clear

	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 3 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	**ONLY KEEPING PANEL HHs FOR THIS ANALYSIS
	keep if panel_hh == 1
		
	** Merge in wave 1 HH logPCexp values and HH weights
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `logPCexp_quints_w1_w3', uniqusing
	tab _merge panel_hh, m
	drop if _merge == 2
	drop _m
	
	****
	
	
	** New household - Wave III info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	
	********
	* create differenced versions
	********

	**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	foreach q in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		g dk_`q'_w3 = `q'_w3 - kec_`q'_w1
	 
		g di_`q'_w3 = `q'_w3 - kec_`q'_w1
		replace di_`q'_w3 = `q'_w3 - `q'_w1 if `q'_w1 != .
			
	}
	
	g dk_gross_SD_enroll_kec_w3 = gross_SD_enroll_kec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_w3 = gross_SMP_enroll_kec_w3 - gross_SMP_enroll_kec_w1
	
	g dk_gross_SD_enroll_kec_crsec_w3 = gross_SD_enroll_kec_crsec_w3 - gross_SD_enroll_kec_w1
	g dk_gross_SMP_enroll_kec_crsec_w3 = gross_SMP_enroll_kec_crsec_w3 - gross_SMP_enroll_kec_w1
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
		
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3 -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	

	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	foreach C in gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A gen_pooled gen_pooled_versi_A{
			gen top3quint_`C' = top3quint * `C'
	}	

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
								
				rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
				rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1
				rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1
				rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
				rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
				rename times_weighed_last3months_w1 times_weighed_last3m_w1				
				rename times_weighed_last3months_w3 times_weighed_last3m_w3
				rename dk_times_weighed_last3months_w3 dk_times_weighed_last3m_w3
				rename di_times_weighed_last3months_w3 di_times_weighed_last3m_w3


	save table_2_3_for_1_2_vars_generasi_w3_full_suest, replace	
	
	
	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_2_3_for_1_2_vars_w2_full_suest", clear
	
	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 id panel_hh obs_type HH_id rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x top3quint*

	tempfile temp
	save `temp'	
	
	use table_2_3_for_1_2_vars_generasi_w3_full_suest, clear
	

	foreach q in pre_natal_visits pre_natal_dummy iron_pills_dummy iron_pills_categ good_assisted_delivery post_natal_visits post_natal_dummy vitA_total vitA_total_6mons_2years vitA_dummy vitA_opp vitA_uptak_percent imm_age_complete imm_uptak_pct_23mons_all imm_uptak_pct_23mons imm_total_complete imm_total_comp10month z_weightforage notmal_weightforage mal_weightforage severe_weightforage visit_and_weigh_lastmonth weigh_last_calendarmonth times_weighed_last2months times_weighed_last3m enroll_age7to12 enroll_age7to12_SD enroll_age13to15 enroll_age13to15_SMP enroll_age13to15_other enroll_SD enroll_SMP age7to12_pct_lastweek age13to15_pct_lastweek age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks age7to12_85_twoweeks age7to12_fullattend_twoweeks age13to15_85_twoweeks age13to15_fullattend_twoweeks gross_SD_enroll_kec gross_SMP_enroll_kec gross_SD_enroll_kec_crsec gross_SMP_enroll_kec_crsec /*dk_pre_natal_visits di_pre_natal_visits dk_good_assisted_delivery di_good_assisted_delivery dk_post_natal_visits di_post_natal_visits dk_iron_pills_categ di_iron_pills_categ dk_imm_uptak_pct_23mons di_imm_uptak_pct_23mons dk_times_weighed_last3m di_times_weighed_last3m dk_vitA_total_6mons_2years di_vitA_total_6mons_2years dk_mal_weightforage di_mal_weightforage*/ dk_enroll_age7to12 di_enroll_age7to12 dk_enroll_age13to15 di_enroll_age13to15 dk_age7to12_pct_twoweeks di_age7to12_pct_twoweeks dk_age13to15_pct_twoweeks di_age13to15_pct_twoweeks dk_cond_age13to15_pct_2wks di_cond_age13to15_pct_2wks dk_enroll_age13to15_SMP di_enroll_age13to15_SMP dk_enroll_age7to12_SD di_enroll_age7to12_SD dk_enroll_age13to15_other di_enroll_age13to15_other dk_gross_SD_enroll_kec dk_gross_SMP_enroll_kec dk_gross_SD_enroll_kec_crsec dk_gross_SMP_enroll_kec_crsec{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 id panel_hh HH_id obs_type rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x include_x top3quint*
	append using `temp'
	
	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
					
			rename age13to15_fullattend_twoweeks_w1 age13to15_fullattend_2weeks_w1	
		
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_m1_group "ind_*_m1"
			local group_kec_w1 "*_w1"
	
			foreach q of varlist `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_m1_group' `group_kec_w1'{
				gen `q'w = wave_3 * `q'
				}

	
	save table_2_3_for_1_2_vars_pooled_full_suest, replace
	

	
	************************************************************************
	************************************************************************

foreach w in table_2_3_for_1_2_vars_w2_full_suest table_2_3_for_1_2_vars_generasi_w3_full_suest table_2_3_for_1_2_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{
		
			if "`w'" == "table_2_3_for_1_2_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_2_3_for_1_2_vars_w2_full_suest", clear
			}
			if "`w'" == "table_2_3_for_1_2_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_2_3_for_1_2_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			
			g obscounter = _n
			sort obscounter 
	
			  gen indicator_name 	= ""
				gen baseline_mean = ""
				gen control_mean_`wave' = ""
				gen mod1_gen_`wave' = ""
				gen mod1_gen_top3quint_`wave' = ""
				gen mod1_gen_plustop3quint_`wave' = ""
				gen mod1_top3quint_`wave' = ""
				gen mod3_genvA_`wave'	= ""
				gen mod3_genvA_top3quint_`wave' = ""
				gen mod3_genvA_plustop3quint_`wave' = ""
				gen mod3_gen_`wave' = ""
				gen mod3_gen_top3quint_`wave' = ""
				gen mod3_gen_plustop3quint_`wave' = ""
				gen mod3_genplusA_`wave' 	= ""
				gen mod3_genplusA_top3quint_`wave' = ""
				gen mod3_genplusA_plustop3quint_`wave'  = ""
				gen mod3_top3quint_`wave' = ""
				gen num_obs 		= .

			  gen indicator_name_SE 	= ""
				gen mod1_gen_SE`wave' = ""
				gen mod1_gen_top3quint_SE`wave' = ""
				gen mod1_gen_plustop3quint_SE`wave' = ""
				gen mod1_top3quint_SE`wave' = ""
				gen mod3_genvA_SE`wave'	= ""
				gen mod3_genvA_top3quint_SE`wave' = ""
				gen mod3_genvA_plustop3quint_SE`wave' = ""
				gen mod3_gen_SE`wave' = ""
				gen mod3_gen_top3quint_SE`wave' = ""
				gen mod3_gen_plustop3quint_SE`wave' = ""
				gen mod3_genplusA_SE`wave' 	= ""
				gen mod3_genplusA_top3quint_SE`wave' = ""
				gen mod3_genplusA_plustop3quint_SE`wave'  = ""
				gen mod3_top3quint_SE`wave' = ""
		
		
			gen include_obs = .
		
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}

			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_2_vars_generasi_w1", clear	
			destring prov_id, replace

			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
			}
			
			sort Location_ID
			merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop
			
			**Keeping only observations from panel_hhs
			drop _m*
			sort panel_hh_id_back_w2
			merge panel_hh_id_back_w2 using `panel_hh_w2', uniqusing
			tab _m
			gen panel_hh_mark_w2 = (_m == 3)
			drop panel_hh
			drop _m
			
			sort panel_hh_id_back_w3
			merge panel_hh_id_back_w3 using `panel_hh_w3', uniqusing
			tab _m
			gen panel_hh_mark_w3 = (_m == 3)
			drop panel_hh
			drop _m
			
			keep if panel_hh_mark_w2 == 1 | panel_hh_mark_w3 == 1
		
			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3

			rename  times_weighed_last3months_w1  times_weighed_last3m_w1
			rename  times_weighed_last2months_w1  times_weighed_last2m_w1

			**Generating baseline means
			foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other{
				cap drop avg_`x'_w1 se_`x'_w1
				summ `x'_w1 [weight = baseline_weight]
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}


			keep avg_*w1 se_*w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm	  
	
			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
				
			local pick = 1
			
			
			gen wave3 = (wave == 3)
	
			local vars_list "pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks "
			
			
			foreach x in `vars_list'{
	
			if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){
				gen wv_`x'_int = `x'_w1 * wave3
			}
			else{
				gen wv_`x'_int = ind_`x'_w1 * wave3
			}
			
				disp "*******`x'_`wave'**********"

								
				**Condensing to one observation per kec
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){ 
					replace include_obs = include_x
				}
				else{
					replace include_obs = 1
				}
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)		

				cap drop Location_wave* 
				egen Location_wave = group(Location_ID wave)
				tab Location_wave, gen(Location_wave_)		
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "kec_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave ""/*"age_years_*"*/
					local ind_val_wave "ind_`x'_w1"
					local ind_val_m1_wave "ind_`x'_m1"
					local kab_wave "kab_id"
					local gross_kec_w1 "`x'_w1"
					local gross_k12_wl "k12_*_w1"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "kec_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1 wv_`x'_int"
					local ind_val_m1_wave "ind_`x'_m1*"
					local kab_wave "kab_wave"
					local gross_kec_w1 "`x'_w1*"
				}						
				
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				**Including kec level control for variable not found in original 12	
				if ("`x'" == "cond_age13to15_pct_2wks" | "`x'" == "enroll_age13to15_SMP" | "`x'" == "enroll_age7to12_SD" | "`x'" == "enroll_age13to15_other")  & ("`z'" == "indallkeccontrols"  | "`z'" == "allkeccontrols") {
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"			
				}
			
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "allkeccontrols") {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `gross_kec_w1"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "" /*"`age_vals_wave'"*/
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
				
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "keccontrols"){
					local yvar "`x'_`wave'"
					local kec_val_w1 "`gross_kec_w1'"
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
						
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec") & ("`z'" == "differenceskec") {
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
				
	
				if ("`x'" == "gross_SD_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
	
				if ("`x'" == "gross_SMP_enroll_kec") & ("`z'" != "differenceskec") & ("`z'" != "differencesind"){
					local control_mean "gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SD_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SD_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}
				if ("`x'" == "gross_SMP_enroll_kec") & (("`z'" == "differenceskec") | ("`z'" == "differencesind")){
					local control_mean "d_kec_gross_SMP_enroll_kec_crsec_`wave' if e(sample) == 1 & intervention == "3""
					local control_add ""
				}	
	
	
				if ("`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec"){
					local control_add "& panel_hh == 0"
				}	
	
	
	
				if "`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec" | "`x'" == "pre_natal_visits" | "`x'" == "iron_pills_categ" | "`x'" == "good_assisted_delivery" | "`x'" == "post_natal_visits" {
					local age_vals ""		
				}
				if "`x'" != "gross_SD_enroll_kec" & "`x'" != "gross_SMP_enroll_kec" & "`x'" != "pre_natal_visits" & "`x'" != "iron_pills_categ" & "`x'" != "good_assisted_delivery" & "`x'" != "post_natal_visits" & "`z'" != "nocontrols"{
					*local age_vals "`age_vals_wave'"
					local age_vals ""		
				}



				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
					local top3quint_generasi "top3quint_gen_year1"
					local top3quint_generasi_vA "top3quint_gen_year1_versi_A"
					local top3quint "top3quint"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
					local top3quint_generasi "top3quint_gen_year1or2"
					local top3quint_generasi_vA "top3quint_gen_year1or2_versi_A"
					local top3quint "top3quint"	
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
					local top3quint_generasi "top3quint_gen_pooled"
					local top3quint_generasi_vA "top3quint_gen_pooled_versi_A"					
					local top3quint "top3quint"
				}			

				****
						
				reg `yvar' `generasi' `top3quint_generasi' `top3quint' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' 
				
				noi estimates store var`var_num'_eg1
				
				replace num_obs = e(N) in `number'
				tempvar samplevar
				g `samplevar' = e(sample)		
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1_`var_num' = r(sd)	

				
				
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
				}

				//Control mean 
				summ `control_mean' 
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= (r(sd)/(r(N)^0.5)) 
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' 	= control_mean_1 in `number'
				replace control_mean_`wave'		= "[" + control_mean_2 + "]" in `number_plus1'
		
				
				* demean all varaibles
				
				sort Location_wave
				
				for var `yvar' `generasi' `top3quint_generasi' `top3quint' `generasi_vA' `top3quint_generasi' `top3quint_generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel': by Location_wave: egen temp = mean(X) \ replace X = X - temp \ drop temp
				sort obscounter 
				
				gen mod1_gen_b 		=_b[`generasi'] 
				gen mod1_gen_se 		= _se[`generasi'] 
				tostring mod1_gen_b, replace format(%10.4f) force
				tostring mod1_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 
				replace mod1_gen_`wave'		= mod1_gen_b if `p_val' >= 0.1 in `number'
				replace mod1_gen_`wave'		= "(" + mod1_gen_se + ")" in `number_plus1'
				replace mod1_gen_`wave'	 	= mod1_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod1_gen_`wave'	 	= mod1_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod1_gen_`wave'	 	= mod1_gen_b + "***" if `p_val' < 0.01 in `number'

				gen mod1_gen_top3quint_b 			=_b[`top3quint_generasi'] 
				gen mod1_gen_top3quint_se 		= _se[`top3quint_generasi'] 
				tostring mod1_gen_top3quint_b, replace format(%10.4f) force
				tostring mod1_gen_top3quint_se, replace format(%10.4f) force
	
				test `top3quint_generasi'
				local p_val			= r(p) 
				replace mod1_gen_top3quint_`wave'		= mod1_gen_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod1_gen_top3quint_`wave'		= "(" + mod1_gen_top3quint_se + ")" in `number_plus1'
				replace mod1_gen_top3quint_`wave'	 	= mod1_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod1_gen_top3quint_`wave'	 	= mod1_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod1_gen_top3quint_`wave'	 	= mod1_gen_top3quint_b + "***" if `p_val' < 0.01 in `number'
				
				gen mod1_top3quint_b 		=_b[`top3quint'] 
				gen mod1_top3quint_se 		= _se[`top3quint'] 
				tostring mod1_top3quint_b, replace format(%10.4f) force
				tostring mod1_top3quint_se, replace format(%10.4f) force
	
				test `top3quint'	
				local p_val			= r(p) 
				replace mod1_top3quint_`wave'		= mod1_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod1_top3quint_`wave'		= "(" + mod1_top3quint_se + ")" in `number_plus1'
				replace mod1_top3quint_`wave'	 	= mod1_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod1_top3quint_`wave'	 	= mod1_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod1_top3quint_`wave'	 	= mod1_top3quint_b + "***" if `p_val' < 0.01 in `number'

				lincom `generasi' + `top3quint_generasi'
				gen mod1_genplustop3_b 	= r(estimate)
				gen mod1_genplustop3_se 	= r(se)
				tostring mod1_genplustop3_b, replace format(%10.4f) force
				tostring mod1_genplustop3_se, replace format(%10.4f) force
	
				test `generasi' + `top3quint_generasi' = 0
				local p_val			=  r(p)
				replace mod1_gen_plustop3quint_`wave'	= mod1_genplustop3_b if `p_val' >= 0.1 in `number'
				replace mod1_gen_plustop3quint_`wave'	= "(" + mod1_genplustop3_se + ")" in `number_plus1'
				replace mod1_gen_plustop3quint_`wave'	= mod1_genplustop3_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod1_gen_plustop3quint_`wave'	= mod1_genplustop3_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod1_gen_plustop3quint_`wave'	= mod1_genplustop3_b + "***" if `p_val' < 0.01 in `number'			
							
				****
				
				quie reg `yvar' `generasi' `generasi_vA' `top3quint_generasi' `top3quint_generasi_vA' `top3quint' `ind_val' `ind_val_m1' `kec_val_w1' `kec_val_m1' `age_vals' `type_panel' 
				
				noi estimates store var`var_num'_eg1vA

				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = `sd1_`var_num'' 
	
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				gen mod3_gen_top3quint_b 		=_b[`top3quint_generasi'] 
				gen mod3_gen_top3quint_se 		= _se[`top3quint_generasi'] 
				tostring mod3_gen_top3quint_b, replace format(%10.4f) force
				tostring mod3_gen_top3quint_se, replace format(%10.4f) force
	
				test `top3quint_generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_top3quint_`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_top3quint_`wave'		= "(" + mod3_gen_top3quint_se + ")" in `number_plus1'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_top3quint_`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_top3quint_b 		=_b[`top3quint_generasi_vA'] 
				gen mod3_genvA_top3quint_se 	= _se[`top3quint_generasi_vA'] 
				tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
				tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
				test `top3quint_generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_top3quint_`wave'	= "(" + mod3_genvA_top3quint_se + ")" in `number_plus1'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_top3quint_`wave'	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `top3quint_generasi' + `top3quint_generasi_vA' 
				gen mod3_genplusA_top3quint_b 	= r(estimate)
				gen mod3_genplusA_top3quint_se 	= r(se)
				tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
				tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
	
				test `top3quint_generasi' + `top3quint_generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_top3quint_`wave'	= "(" + mod3_genplusA_top3quint_se + ")" in `number_plus1'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_top3quint_`wave'	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `number'
				
				gen mod3_top3quint_b 		=_b[`top3quint'] 
				gen mod3_top3quint_se 		= _se[`top3quint'] 
				tostring mod3_top3quint_b, replace format(%10.4f) force
				tostring mod3_top3quint_se, replace format(%10.4f) force
	
				test `top3quint'
				local p_val			= r(p) 
				replace mod3_top3quint_`wave'		= mod3_top3quint_b if `p_val' >= 0.1 in `number'
				replace mod3_top3quint_`wave'		= "(" + mod3_top3quint_se + ")" in `number_plus1'
				replace mod3_top3quint_`wave'	 	= mod3_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_top3quint_`wave'	 	= mod3_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_top3quint_`wave'	 	= mod3_top3quint_b + "***" if `p_val' < 0.01 in `number'				
				
				lincom `generasi' + `top3quint_generasi'
				gen mod3_genplustop3_b 	= r(estimate)
				gen mod3_genplustop3_se 	= r(se)
				tostring mod3_genplustop3_b, replace format(%10.4f) force
				tostring mod3_genplustop3_se, replace format(%10.4f) force
	
				test `generasi' + `top3quint_generasi' = 0
				local p_val			=  r(p)
				replace mod3_gen_plustop3quint_`wave'	= mod3_genplustop3_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_plustop3quint_`wave'	= "(" + mod3_genplustop3_se + ")" in `number_plus1'
				replace mod3_gen_plustop3quint_`wave'	= mod3_genplustop3_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_plustop3quint_`wave'	= mod3_genplustop3_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_plustop3quint_`wave'	= mod3_genplustop3_b + "***" if `p_val' < 0.01 in `number'
				
				lincom `generasi_vA' + `top3quint_generasi_vA'
				gen mod3_genAplustop3_b 	= r(estimate)
				gen mod3_genAplustop3_se 	= r(se)
				tostring mod3_genAplustop3_b, replace format(%10.4f) force
				tostring mod3_genAplustop3_se, replace format(%10.4f) force
	
				test `generasi_vA' + `top3quint_generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genvA_plustop3quint_`wave'	= mod3_genAplustop3_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_plustop3quint_`wave'	= "(" + mod3_genAplustop3_se + ")" in `number_plus1'
				replace mod3_genvA_plustop3quint_`wave'	= mod3_genAplustop3_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_plustop3quint_`wave'	= mod3_genAplustop3_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_plustop3quint_`wave'	= mod3_genAplustop3_b + "***" if `p_val' < 0.01 in `number'

				lincom `generasi' + `top3quint_generasi' + `generasi_vA' + `top3quint_generasi_vA'
				gen mod3_genplustop3A_b 	= r(estimate)
				gen mod3_genplustop3A_se 	= r(se)
				tostring mod3_genplustop3A_b, replace format(%10.4f) force
				tostring mod3_genplustop3A_se, replace format(%10.4f) force
	
				test `generasi' + `top3quint_generasi' + `generasi_vA' + `top3quint_generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_plustop3quint_`wave'	= mod3_genplustop3A_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_plustop3quint_`wave'	= "(" + mod3_genplustop3A_se + ")" in `number_plus1'
				replace mod3_genplusA_plustop3quint_`wave'	= mod3_genplustop3A_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_plustop3quint_`wave'	= mod3_genplustop3A_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_plustop3quint_`wave'	= mod3_genplustop3A_b + "***" if `p_val' < 0.01 in `number'				

				*****
				replace indicator_name = "`x'" in `number'
				*****

				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1		

				drop *mod?_gen*_b mod?_gen*_se control_mean_? *mod?_top3quint*_b *mod?_top3quint*_se
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}	
			}


			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			
				suest var1_eg1 var2_eg1 var3_eg1 var4_eg1 var5_eg1 var6_eg1 var7_eg1 var8_eg1 var9_eg1 var10_eg1 var11_eg1 var12_eg1, cluster(Location_ID)

				*****			
					*Total
					
					lincom (([var1_eg1_mean]`generasi'/`sd1_1' + [var2_eg1_mean]`generasi'/`sd1_2' + [var3_eg1_mean]`generasi'/`sd1_3' + [var4_eg1_mean]`generasi'/`sd1_4' + [var5_eg1_mean]`generasi'/`sd1_5' + [var6_eg1_mean]`generasi'/`sd1_6'  + [var7_eg1_mean]`generasi'/`sd1_7' - [var8_eg1_mean]`generasi'/`sd1_8' + [var9_eg1_mean]`generasi'/`sd1_9' + [var10_eg1_mean]`generasi'/`sd1_10' + [var11_eg1_mean]`generasi'/`sd1_11' + [var12_eg1_mean]`generasi'/`sd1_12') / 12)

					gen mod1_gen_b	=r(estimate) 
					gen mod1_gen_se 	= r(se) 
					tostring mod1_gen_b, replace format(%10.4f) force
					tostring mod1_gen_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`generasi'/`sd1_1' + [var2_eg1_mean]`generasi'/`sd1_2' + [var3_eg1_mean]`generasi'/`sd1_3' + [var4_eg1_mean]`generasi'/`sd1_4' + [var5_eg1_mean]`generasi'/`sd1_5' + [var6_eg1_mean]`generasi'/`sd1_6' + [var7_eg1_mean]`generasi'/`sd1_7' - [var8_eg1_mean]`generasi'/`sd1_8' + [var9_eg1_mean]`generasi'/`sd1_9' + [var10_eg1_mean]`generasi'/`sd1_10' + [var11_eg1_mean]`generasi'/`sd1_11' + [var12_eg1_mean]`generasi'/`sd1_12' ) / 12) = 0
					local p_val			=  r(p)
					replace mod1_gen_SE`wave'		= mod1_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod1_gen_SE`wave'		= "(" + mod1_gen_se + ")" in `line_num_plus1'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
					
					lincom (([var1_eg1_mean]`generasi'/`sd1_1' + [var2_eg1_mean]`generasi'/`sd1_2' + [var3_eg1_mean]`generasi'/`sd1_3' + [var4_eg1_mean]`generasi'/`sd1_4' + [var5_eg1_mean]`generasi'/`sd1_5' + [var6_eg1_mean]`generasi'/`sd1_6' + [var7_eg1_mean]`generasi'/`sd1_7' - [var8_eg1_mean]`generasi'/`sd1_8' ) / 8)
					drop mod?_gen_b mod?_gen_se					
					gen mod1_gen_b	=r(estimate) 
					gen mod1_gen_se 	= r(se) 
					tostring mod1_gen_b, replace format(%10.4f) force
					tostring mod1_gen_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`generasi'/`sd1_1' + [var2_eg1_mean]`generasi'/`sd1_2' + [var3_eg1_mean]`generasi'/`sd1_3' + [var4_eg1_mean]`generasi'/`sd1_4' + [var5_eg1_mean]`generasi'/`sd1_5' + [var6_eg1_mean]`generasi'/`sd1_6' + [var7_eg1_mean]`generasi'/`sd1_7' - [var8_eg1_mean]`generasi'/`sd1_8' ) / 8) = 0
					local p_val			=  r(p)
					replace mod1_gen_SE`wave'		= mod1_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod1_gen_SE`wave'		= "(" + mod1_gen_se + ")" in `line_num_plus3'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'

			
					*Education
					
					lincom (([var9_eg1_mean]`generasi'/`sd1_9' + [var10_eg1_mean]`generasi'/`sd1_10' + [var11_eg1_mean]`generasi'/`sd1_11' + [var12_eg1_mean]`generasi'/`sd1_12') / 4)
					drop mod?_gen_b mod?_gen_se	
					gen mod1_gen_b	=r(estimate) 
					gen mod1_gen_se 	= r(se) 
					tostring mod1_gen_b, replace format(%10.4f) force
					tostring mod1_gen_se, replace format(%10.4f) force
	 
					test (([var9_eg1_mean]`generasi'/`sd1_9' + [var10_eg1_mean]`generasi'/`sd1_10' + [var11_eg1_mean]`generasi'/`sd1_11' + [var12_eg1_mean]`generasi'/`sd1_12') / 4) = 0
					local p_val			=  r(p)
					replace mod1_gen_SE`wave'		= mod1_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod1_gen_SE`wave'		= "(" + mod1_gen_se + ")" in `line_num_plus5'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod1_gen_SE`wave'	 	= mod1_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				*****			
					*Total
					
					lincom (([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6'  + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' - [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10' + [var11_eg1_mean]`top3quint_generasi'/`sd1_11' + [var12_eg1_mean]`top3quint_generasi'/`sd1_12') / 12)

					gen mod1_gen_top3quint_b	=r(estimate) 
					gen mod1_gen_top3quint_se 	= r(se) 
					tostring mod1_gen_top3quint_b, replace format(%10.4f) force
					tostring mod1_gen_top3quint_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6' + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' - [var8_eg1_mean]`top3quint_generasi'/`sd1_8' + [var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10' + [var11_eg1_mean]`top3quint_generasi'/`sd1_11' + [var12_eg1_mean]`top3quint_generasi'/`sd1_12' ) / 12) = 0
					local p_val			=  r(p)
					replace mod1_gen_top3quint_SE`wave'		= mod1_gen_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod1_gen_top3quint_SE`wave'		= "(" + mod1_gen_top3quint_se + ")" in `line_num_plus1'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
					
					lincom (([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6' + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' - [var8_eg1_mean]`top3quint_generasi'/`sd1_8' ) / 8)
					drop mod?_gen_top3quint_b mod?_gen_top3quint_se					
					gen mod1_gen_top3quint_b	=r(estimate) 
					gen mod1_gen_top3quint_se 	= r(se) 
					tostring mod1_gen_top3quint_b, replace format(%10.4f) force
					tostring mod1_gen_top3quint_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`top3quint_generasi'/`sd1_1' + [var2_eg1_mean]`top3quint_generasi'/`sd1_2' + [var3_eg1_mean]`top3quint_generasi'/`sd1_3' + [var4_eg1_mean]`top3quint_generasi'/`sd1_4' + [var5_eg1_mean]`top3quint_generasi'/`sd1_5' + [var6_eg1_mean]`top3quint_generasi'/`sd1_6' + [var7_eg1_mean]`top3quint_generasi'/`sd1_7' - [var8_eg1_mean]`top3quint_generasi'/`sd1_8' ) / 8) = 0
					local p_val			=  r(p)
					replace mod1_gen_top3quint_SE`wave'		= mod1_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod1_gen_top3quint_SE`wave'		= "(" + mod1_gen_top3quint_se + ")" in `line_num_plus3'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'

			
					*Education
					
					lincom (([var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10' + [var11_eg1_mean]`top3quint_generasi'/`sd1_11' + [var12_eg1_mean]`top3quint_generasi'/`sd1_12') / 4)
					drop mod?_gen_top3quint_b mod?_gen_top3quint_se	
					gen mod1_gen_top3quint_b	=r(estimate) 
					gen mod1_gen_top3quint_se 	= r(se) 
					tostring mod1_gen_top3quint_b, replace format(%10.4f) force
					tostring mod1_gen_top3quint_se, replace format(%10.4f) force
	 
					test (([var9_eg1_mean]`top3quint_generasi'/`sd1_9' + [var10_eg1_mean]`top3quint_generasi'/`sd1_10' + [var11_eg1_mean]`top3quint_generasi'/`sd1_11' + [var12_eg1_mean]`top3quint_generasi'/`sd1_12') / 4) = 0
					local p_val			=  r(p)
					replace mod1_gen_top3quint_SE`wave'		= mod1_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod1_gen_top3quint_SE`wave'		= "(" + mod1_gen_top3quint_se + ")" in `line_num_plus5'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod1_gen_top3quint_SE`wave'	 	= mod1_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				*****			
					*Total
					
					lincom (([var1_eg1_mean]`top3quint'/`sd1_1' + [var2_eg1_mean]`top3quint'/`sd1_2' + [var3_eg1_mean]`top3quint'/`sd1_3' + [var4_eg1_mean]`top3quint'/`sd1_4' + [var5_eg1_mean]`top3quint'/`sd1_5' + [var6_eg1_mean]`top3quint'/`sd1_6'  + [var7_eg1_mean]`top3quint'/`sd1_7' - [var8_eg1_mean]`top3quint'/`sd1_8' + [var9_eg1_mean]`top3quint'/`sd1_9' + [var10_eg1_mean]`top3quint'/`sd1_10' + [var11_eg1_mean]`top3quint'/`sd1_11' + [var12_eg1_mean]`top3quint'/`sd1_12') / 12)

					gen mod1_top3quint_b	=r(estimate) 
					gen mod1_top3quint_se 	= r(se) 
					tostring mod1_top3quint_b, replace format(%10.4f) force
					tostring mod1_top3quint_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`top3quint'/`sd1_1' + [var2_eg1_mean]`top3quint'/`sd1_2' + [var3_eg1_mean]`top3quint'/`sd1_3' + [var4_eg1_mean]`top3quint'/`sd1_4' + [var5_eg1_mean]`top3quint'/`sd1_5' + [var6_eg1_mean]`top3quint'/`sd1_6' + [var7_eg1_mean]`top3quint'/`sd1_7' - [var8_eg1_mean]`top3quint'/`sd1_8' + [var9_eg1_mean]`top3quint'/`sd1_9' + [var10_eg1_mean]`top3quint'/`sd1_10' + [var11_eg1_mean]`top3quint'/`sd1_11' + [var12_eg1_mean]`top3quint'/`sd1_12' ) / 12) = 0
					local p_val			=  r(p)
					replace mod1_top3quint_SE`wave'		= mod1_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod1_top3quint_SE`wave'		= "(" + mod1_top3quint_se + ")" in `line_num_plus1'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
					
					lincom (([var1_eg1_mean]`top3quint'/`sd1_1' + [var2_eg1_mean]`top3quint'/`sd1_2' + [var3_eg1_mean]`top3quint'/`sd1_3' + [var4_eg1_mean]`top3quint'/`sd1_4' + [var5_eg1_mean]`top3quint'/`sd1_5' + [var6_eg1_mean]`top3quint'/`sd1_6' + [var7_eg1_mean]`top3quint'/`sd1_7' - [var8_eg1_mean]`top3quint'/`sd1_8' ) / 8)
					drop mod?_top3quint_b mod?_top3quint_se					
					gen mod1_top3quint_b	=r(estimate) 
					gen mod1_top3quint_se 	= r(se) 
					tostring mod1_top3quint_b, replace format(%10.4f) force
					tostring mod1_top3quint_se, replace format(%10.4f) force
	 
					test (([var1_eg1_mean]`top3quint'/`sd1_1' + [var2_eg1_mean]`top3quint'/`sd1_2' + [var3_eg1_mean]`top3quint'/`sd1_3' + [var4_eg1_mean]`top3quint'/`sd1_4' + [var5_eg1_mean]`top3quint'/`sd1_5' + [var6_eg1_mean]`top3quint'/`sd1_6' + [var7_eg1_mean]`top3quint'/`sd1_7' - [var8_eg1_mean]`top3quint'/`sd1_8' ) / 8) = 0
					local p_val			=  r(p)
					replace mod1_top3quint_SE`wave'		= mod1_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod1_top3quint_SE`wave'		= "(" + mod1_top3quint_se + ")" in `line_num_plus3'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'

			
					*Education
					
					lincom (([var9_eg1_mean]`top3quint'/`sd1_9' + [var10_eg1_mean]`top3quint'/`sd1_10' + [var11_eg1_mean]`top3quint'/`sd1_11' + [var12_eg1_mean]`top3quint'/`sd1_12') / 4)
					drop mod?_top3quint_b mod?_top3quint_se	
					gen mod1_top3quint_b	=r(estimate) 
					gen mod1_top3quint_se 	= r(se) 
					tostring mod1_top3quint_b, replace format(%10.4f) force
					tostring mod1_top3quint_se, replace format(%10.4f) force
	 
					test (([var9_eg1_mean]`top3quint'/`sd1_9' + [var10_eg1_mean]`top3quint'/`sd1_10' + [var11_eg1_mean]`top3quint'/`sd1_11' + [var12_eg1_mean]`top3quint'/`sd1_12') / 4) = 0
					local p_val			=  r(p)
					replace mod1_top3quint_SE`wave'		= mod1_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod1_top3quint_SE`wave'		= "(" + mod1_top3quint_se + ")" in `line_num_plus5'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod1_top3quint_SE`wave'	 	= mod1_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'

				*****
					*Total
		
					lincom ((([var1_eg1_mean]`top3quint_generasi' + [var1_eg1_mean]`generasi')/`sd1_1' + ([var2_eg1_mean]`top3quint_generasi' + [var2_eg1_mean]`generasi')/`sd1_2' + ([var3_eg1_mean]`top3quint_generasi' + [var3_eg1_mean]`generasi')/`sd1_3' + ([var4_eg1_mean]`top3quint_generasi' + [var4_eg1_mean]`generasi')/`sd1_4' + ([var5_eg1_mean]`top3quint_generasi' + [var5_eg1_mean]`generasi')/`sd1_5' + ([var6_eg1_mean]`top3quint_generasi' + [var6_eg1_mean]`generasi')/`sd1_6' + ([var7_eg1_mean]`top3quint_generasi' + [var7_eg1_mean]`generasi')/`sd1_7' - ([var8_eg1_mean]`top3quint_generasi' + [var8_eg1_mean]`generasi')/`sd1_8' + ([var9_eg1_mean]`top3quint_generasi' + [var9_eg1_mean]`generasi')/`sd1_9' + ([var10_eg1_mean]`top3quint_generasi' + [var10_eg1_mean]`generasi')/`sd1_10' + ([var11_eg1_mean]`top3quint_generasi' + [var11_eg1_mean]`generasi')/`sd1_11' + ([var12_eg1_mean]`top3quint_generasi' + [var12_eg1_mean]`generasi')/`sd1_12') / 12)
					gen mod1_gen_plustop3quint_b 		= r(estimate) 
					gen mod1_gen_plustop3quint_se 		= r(se) 
					tostring mod1_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod1_gen_plustop3quint_se, replace format(%10.4f) force

					test ((([var1_eg1_mean]`top3quint_generasi' + [var1_eg1_mean]`generasi')/`sd1_1' + ([var2_eg1_mean]`top3quint_generasi' + [var2_eg1_mean]`generasi')/`sd1_2' + ([var3_eg1_mean]`top3quint_generasi' + [var3_eg1_mean]`generasi')/`sd1_3' + ([var4_eg1_mean]`top3quint_generasi' + [var4_eg1_mean]`generasi')/`sd1_4' + ([var5_eg1_mean]`top3quint_generasi' + [var5_eg1_mean]`generasi')/`sd1_5' + ([var6_eg1_mean]`top3quint_generasi' + [var6_eg1_mean]`generasi')/`sd1_6' + ([var7_eg1_mean]`top3quint_generasi' + [var7_eg1_mean]`generasi')/`sd1_7' - ([var8_eg1_mean]`top3quint_generasi' + [var8_eg1_mean]`generasi')/`sd1_8' + ([var9_eg1_mean]`top3quint_generasi' + [var9_eg1_mean]`generasi')/`sd1_9' + ([var10_eg1_mean]`top3quint_generasi' + [var10_eg1_mean]`generasi')/`sd1_10' + ([var11_eg1_mean]`top3quint_generasi' + [var11_eg1_mean]`generasi')/`sd1_11' + ([var12_eg1_mean]`top3quint_generasi' + [var12_eg1_mean]`generasi')/`sd1_12') / 12) = 0
					local p_val			=  r(p)
					replace mod1_gen_plustop3quint_SE`wave'		= mod1_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod1_gen_plustop3quint_SE`wave'		= "(" + mod1_gen_plustop3quint_se + ")" in `line_num_plus1'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1_mean]`top3quint_generasi' + [var1_eg1_mean]`generasi')/`sd1_1' + ([var2_eg1_mean]`top3quint_generasi' + [var2_eg1_mean]`generasi')/`sd1_2' + ([var3_eg1_mean]`top3quint_generasi' + [var3_eg1_mean]`generasi')/`sd1_3' + ([var4_eg1_mean]`top3quint_generasi' + [var4_eg1_mean]`generasi')/`sd1_4' + ([var5_eg1_mean]`top3quint_generasi' + [var5_eg1_mean]`generasi')/`sd1_5' + ([var6_eg1_mean]`top3quint_generasi' + [var6_eg1_mean]`generasi')/`sd1_6' + ([var7_eg1_mean]`top3quint_generasi' + [var7_eg1_mean]`generasi')/`sd1_7' - ([var8_eg1_mean]`top3quint_generasi' + [var8_eg1_mean]`generasi')/`sd1_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod1_gen_plustop3quint_b		= r(estimate) 
					gen mod1_gen_plustop3quint_se 		= r(se) 
					tostring mod1_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod1_gen_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1_mean]`top3quint_generasi' + [var1_eg1_mean]`generasi')/`sd1_1' + ([var2_eg1_mean]`top3quint_generasi' + [var2_eg1_mean]`generasi')/`sd1_2' + ([var3_eg1_mean]`top3quint_generasi' + [var3_eg1_mean]`generasi')/`sd1_3' + ([var4_eg1_mean]`top3quint_generasi' + [var4_eg1_mean]`generasi')/`sd1_4' + ([var5_eg1_mean]`top3quint_generasi' + [var5_eg1_mean]`generasi')/`sd1_5' + ([var6_eg1_mean]`top3quint_generasi' + [var6_eg1_mean]`generasi')/`sd1_6' + ([var7_eg1_mean]`top3quint_generasi' + [var7_eg1_mean]`generasi')/`sd1_7' - ([var8_eg1_mean]`top3quint_generasi' + [var8_eg1_mean]`generasi')/`sd1_8') / 8) = 0
					local p_val			=  r(p)
					replace mod1_gen_plustop3quint_SE`wave'		= mod1_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod1_gen_plustop3quint_SE`wave'		= "(" + mod1_gen_plustop3quint_se + ")" in `line_num_plus3'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1_mean]`top3quint_generasi' + [var9_eg1_mean]`generasi')/`sd1_9' + ([var10_eg1_mean]`top3quint_generasi' + [var10_eg1_mean]`generasi')/`sd1_10' + ([var11_eg1_mean]`top3quint_generasi' + [var11_eg1_mean]`generasi')/`sd1_11' + ([var12_eg1_mean]`top3quint_generasi' + [var12_eg1_mean]`generasi')/`sd1_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod1_gen_plustop3quint_b		= r(estimate) 
					gen mod1_gen_plustop3quint_se 		= r(se) 
					tostring mod1_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod1_gen_plustop3quint_se, replace format(%10.4f) force
		
					test ((([var9_eg1_mean]`top3quint_generasi' + [var9_eg1_mean]`generasi')/`sd1_9' + ([var10_eg1_mean]`top3quint_generasi' + [var10_eg1_mean]`generasi')/`sd1_10' + ([var11_eg1_mean]`top3quint_generasi' + [var11_eg1_mean]`generasi')/`sd1_11' + ([var12_eg1_mean]`top3quint_generasi' + [var12_eg1_mean]`generasi')/`sd1_12') / 4) = 0
					local p_val			=  r(p)
					replace mod1_gen_plustop3quint_SE`wave'		= mod1_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod1_gen_plustop3quint_SE`wave'		= "(" + mod1_gen_plustop3quint_se + ")" in `line_num_plus5'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod1_gen_plustop3quint_SE`wave'	 	= mod1_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'


	 			suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA, cluster(Location_ID)
	 			*****
	 				*Total

					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 12)
									
					gen mod3_gen_b 		=r(estimate) 
					gen mod3_gen_se 		= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_gen_SE`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_SE`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8)
					drop mod?_gen_b mod?_gen_se		
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5' + [var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7' - [var8_eg1vA_mean]`generasi'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_SE`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_SE`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_SE`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 4)
					drop mod?_gen_b mod?_gen_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11' + [var12_eg1vA_mean]`generasi'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_SE`wave'			= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_SE`wave'			= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_SE`wave'	 		= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_SE`wave'	 		= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_SE`wave'	 		= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				*****		
					*Total
			
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12)
					gen mod3_genvA_b 		= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_genvA_SE`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_SE`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health
		
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_SE`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_SE`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
						
					*Education	
					
					lincom (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b			= r(estimate) 
					gen mod3_genvA_se 		= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`generasi_vA'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_SE`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_SE`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_SE`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				****
					*Total
		
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12)
					gen mod3_genplusA_b 		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_SE`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_SE`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_SE`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_SE`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b		= r(estimate) 
					gen mod3_genplusA_se 		= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_SE`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_SE`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_SE`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
					
	 			*****
	 				*Total

					lincom (([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi'/`sd1vA_12') / 12)
									
					gen mod3_gen_top3quint_b 		=r(estimate) 
					gen mod3_gen_top3quint_se 		= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_top3quint_SE`wave'		= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus1'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se		
					gen mod3_gen_top3quint_b	=r(estimate) 
					gen mod3_gen_top3quint_se 	= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`top3quint_generasi'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'		= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'		= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus3'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_top3quint_SE`wave'	 	= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_top3quint_b	=r(estimate) 
					gen mod3_gen_top3quint_se 	= r(se) 
					tostring mod3_gen_top3quint_b, replace format(%10.4f) force
					tostring mod3_gen_top3quint_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`top3quint_generasi'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_top3quint_SE`wave'			= mod3_gen_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'			= "(" + mod3_gen_top3quint_se + ")" in `line_num_plus5'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_top3quint_SE`wave'	 		= mod3_gen_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'

	 			*****
	 				*Total

					lincom (([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_12') / 12)
									
					gen mod3_genvA_top3quint_b 		=r(estimate) 
					gen mod3_genvA_top3quint_se 		= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'		= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_top3quint_SE`wave'		= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus1'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se		
					gen mod3_genvA_top3quint_b	=r(estimate) 
					gen mod3_genvA_top3quint_se 	= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'		= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'		= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus3'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_top3quint_SE`wave'	 	= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_top3quint_b	=r(estimate) 
					gen mod3_genvA_top3quint_se 	= r(se) 
					tostring mod3_genvA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_top3quint_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint_generasi_vA'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_top3quint_SE`wave'			= mod3_genvA_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'			= "(" + mod3_genvA_top3quint_se + ")" in `line_num_plus5'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_top3quint_SE`wave'	 		= mod3_genvA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
				*****
					*Total
		
					lincom ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 12)
					gen mod3_genplusA_top3quint_b 		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force

					test ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus1'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_top3quint_b		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus3'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_top3quint_b		= r(estimate) 
					gen mod3_genplusA_top3quint_se 		= r(se) 
					tostring mod3_genplusA_top3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_top3quint_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_top3quint_SE`wave'		= mod3_genplusA_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'		= "(" + mod3_genplusA_top3quint_se + ")" in `line_num_plus5'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_top3quint_SE`wave'	 	= mod3_genplusA_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
			*****
	 				*Total

					lincom (([var1_eg1vA_mean]`top3quint'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint'/`sd1vA_12') / 12)
									
					gen mod3_top3quint_b 		=r(estimate) 
					gen mod3_top3quint_se 		= r(se) 
					tostring mod3_top3quint_b, replace format(%10.4f) force
					tostring mod3_top3quint_se, replace format(%10.4f) force
	
					test (([var1_eg1vA_mean]`top3quint'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint'/`sd1vA_8' + [var9_eg1vA_mean]`top3quint'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint'/`sd1vA_12') / 12) = 0			
					local p_val			=  r(p)
					replace mod3_top3quint_SE`wave'		= mod3_top3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_top3quint_SE`wave'		= "(" + mod3_top3quint_se + ")" in `line_num_plus1'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
	
					*Health	
	
					lincom (([var1_eg1vA_mean]`top3quint'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint'/`sd1vA_8') / 8)
					drop mod?_*_b mod?_*_se		
					gen mod3_top3quint_b	=r(estimate) 
					gen mod3_top3quint_se 	= r(se) 
					tostring mod3_top3quint_b, replace format(%10.4f) force
					tostring mod3_top3quint_se, replace format(%10.4f) force
		
					test (([var1_eg1vA_mean]`top3quint'/`sd1vA_1' + [var2_eg1vA_mean]`top3quint'/`sd1vA_2' + [var3_eg1vA_mean]`top3quint'/`sd1vA_3' + [var4_eg1vA_mean]`top3quint'/`sd1vA_4' + [var5_eg1vA_mean]`top3quint'/`sd1vA_5' + [var6_eg1vA_mean]`top3quint'/`sd1vA_6' + [var7_eg1vA_mean]`top3quint'/`sd1vA_7' - [var8_eg1vA_mean]`top3quint'/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_top3quint_SE`wave'		= mod3_top3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_top3quint_SE`wave'		= "(" + mod3_top3quint_se + ")" in `line_num_plus3'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_top3quint_SE`wave'	 	= mod3_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'
	
					*Education
						
					lincom (([var9_eg1vA_mean]`top3quint'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint'/`sd1vA_12') / 4)
					drop mod?_*_b mod?_*_se
					gen mod3_top3quint_b	=r(estimate) 
					gen mod3_top3quint_se 	= r(se) 
					tostring mod3_top3quint_b, replace format(%10.4f) force
					tostring mod3_top3quint_se, replace format(%10.4f) force
		
					test (([var9_eg1vA_mean]`top3quint'/`sd1vA_9' + [var10_eg1vA_mean]`top3quint'/`sd1vA_10' + [var11_eg1vA_mean]`top3quint'/`sd1vA_11' + [var12_eg1vA_mean]`top3quint'/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_top3quint_SE`wave'			= mod3_top3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_top3quint_SE`wave'			= "(" + mod3_top3quint_se + ")" in `line_num_plus5'
					replace mod3_top3quint_SE`wave'	 		= mod3_top3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_top3quint_SE`wave'	 		= mod3_top3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_top3quint_SE`wave'	 		= mod3_top3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
			
			****
					*Total
		
					lincom ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12)
					gen mod3_gen_plustop3quint_b 		= r(estimate) 
					gen mod3_gen_plustop3quint_se 		= r(se) 
					tostring mod3_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_gen_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_gen_plustop3quint_SE`wave'		= mod3_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_plustop3quint_SE`wave'		= "(" + mod3_gen_plustop3quint_se + ")" in `line_num_plus1'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_gen_plustop3quint_b		= r(estimate) 
					gen mod3_gen_plustop3quint_se 		= r(se) 
					tostring mod3_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_gen_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`top3quint_generasi' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`top3quint_generasi' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`top3quint_generasi' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`top3quint_generasi' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`top3quint_generasi' + [var5_eg1vA_mean]`generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`top3quint_generasi' + [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`top3quint_generasi' + [var7_eg1vA_mean]`generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`top3quint_generasi' + [var8_eg1vA_mean]`generasi')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_gen_plustop3quint_SE`wave'		= mod3_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_plustop3quint_SE`wave'		= "(" + mod3_gen_plustop3quint_se + ")" in `line_num_plus3'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_plustop3quint_b		= r(estimate) 
					gen mod3_gen_plustop3quint_se 		= r(se) 
					tostring mod3_gen_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_gen_plustop3quint_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`top3quint_generasi' + [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`top3quint_generasi' + [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`top3quint_generasi' + [var11_eg1vA_mean]`generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`top3quint_generasi' + [var12_eg1vA_mean]`generasi')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_plustop3quint_SE`wave'		= mod3_gen_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_plustop3quint_SE`wave'		= "(" + mod3_gen_plustop3quint_se + ")" in `line_num_plus5'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_plustop3quint_SE`wave'	 	= mod3_gen_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
				
				****
					*Total
		
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 12)
					gen mod3_genvA_plustop3quint_b 		= r(estimate) 
					gen mod3_genvA_plustop3quint_se 		= r(se) 
					tostring mod3_genvA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plustop3quint_SE`wave'		= mod3_genvA_plustop3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_plustop3quint_SE`wave'		= "(" + mod3_genvA_plustop3quint_se + ")" in `line_num_plus1'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genvA_plustop3quint_b		= r(estimate) 
					gen mod3_genvA_plustop3quint_se 		= r(se) 
					tostring mod3_genvA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plustop3quint_SE`wave'		= mod3_genvA_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_plustop3quint_SE`wave'		= "(" + mod3_genvA_plustop3quint_se + ")" in `line_num_plus3'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_plustop3quint_b		= r(estimate) 
					gen mod3_genvA_plustop3quint_se 		= r(se) 
					tostring mod3_genvA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genvA_plustop3quint_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_plustop3quint_SE`wave'		= mod3_genvA_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_plustop3quint_SE`wave'		= "(" + mod3_genvA_plustop3quint_se + ")" in `line_num_plus5'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_plustop3quint_SE`wave'	 	= mod3_genvA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
					
	 			*****
	 				*Total
		
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA' + [var1_eg1vA_mean]`generasi' + [var1_eg1vA_mean]`top3quint_generasi' )/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA'+ [var2_eg1vA_mean]`generasi' + [var2_eg1vA_mean]`top3quint_generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA'+ [var3_eg1vA_mean]`generasi' + [var3_eg1vA_mean]`top3quint_generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA'+ [var4_eg1vA_mean]`generasi' + [var4_eg1vA_mean]`top3quint_generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA'+ [var5_eg1vA_mean]`generasi' + [var5_eg1vA_mean]`top3quint_generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA'+ [var6_eg1vA_mean]`generasi' + [var6_eg1vA_mean]`top3quint_generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA'+ [var7_eg1vA_mean]`generasi' + [var7_eg1vA_mean]`top3quint_generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA'+ [var8_eg1vA_mean]`generasi' + [var8_eg1vA_mean]`top3quint_generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA'+ [var9_eg1vA_mean]`generasi' + [var9_eg1vA_mean]`top3quint_generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA'+ [var10_eg1vA_mean]`generasi' + [var10_eg1vA_mean]`top3quint_generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA'+ [var11_eg1vA_mean]`generasi' + [var11_eg1vA_mean]`top3quint_generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA'+ [var12_eg1vA_mean]`generasi' + [var12_eg1vA_mean]`top3quint_generasi')/`sd1vA_12') / 12)
					gen mod3_genplusA_plustop3quint_b 		= r(estimate) 
					gen mod3_genplusA_plustop3quint_se 		= r(se) 
					tostring mod3_genplusA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA' + [var1_eg1vA_mean]`generasi' + [var1_eg1vA_mean]`top3quint_generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA'+ [var2_eg1vA_mean]`generasi' + [var2_eg1vA_mean]`top3quint_generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA'+ [var3_eg1vA_mean]`generasi' + [var3_eg1vA_mean]`top3quint_generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA'+ [var4_eg1vA_mean]`generasi' + [var4_eg1vA_mean]`top3quint_generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA'+ [var5_eg1vA_mean]`generasi' + [var5_eg1vA_mean]`top3quint_generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA'+ [var6_eg1vA_mean]`generasi' + [var6_eg1vA_mean]`top3quint_generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA'+ [var7_eg1vA_mean]`generasi' + [var7_eg1vA_mean]`top3quint_generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA'+ [var8_eg1vA_mean]`generasi' + [var8_eg1vA_mean]`top3quint_generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA'+ [var9_eg1vA_mean]`generasi' + [var9_eg1vA_mean]`top3quint_generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA'+ [var10_eg1vA_mean]`generasi' + [var10_eg1vA_mean]`top3quint_generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA'+ [var11_eg1vA_mean]`generasi' + [var11_eg1vA_mean]`top3quint_generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA'+ [var12_eg1vA_mean]`generasi' + [var12_eg1vA_mean]`top3quint_generasi')/`sd1vA_12') / 12) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_plustop3quint_SE`wave'		= mod3_genplusA_plustop3quint_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_plustop3quint_SE`wave'		= "(" + mod3_genplusA_plustop3quint_se + ")" in `line_num_plus1'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num'
	
					*Health
			
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA' + [var1_eg1vA_mean]`generasi' + [var1_eg1vA_mean]`top3quint_generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA' + [var2_eg1vA_mean]`generasi' + [var2_eg1vA_mean]`top3quint_generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA'+ [var3_eg1vA_mean]`generasi' + [var3_eg1vA_mean]`top3quint_generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA'+ [var4_eg1vA_mean]`generasi' + [var4_eg1vA_mean]`top3quint_generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA'+ [var5_eg1vA_mean]`generasi' + [var5_eg1vA_mean]`top3quint_generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA'+ [var6_eg1vA_mean]`generasi' + [var6_eg1vA_mean]`top3quint_generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA'+ [var7_eg1vA_mean]`generasi' + [var7_eg1vA_mean]`top3quint_generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA'+ [var8_eg1vA_mean]`generasi' + [var8_eg1vA_mean]`top3quint_generasi')/`sd1vA_8') / 8)
					drop mod?_gen*_b mod?_gen*_se				
					gen mod3_genplusA_plustop3quint_b		= r(estimate) 
					gen mod3_genplusA_plustop3quint_se 		= r(se) 
					tostring mod3_genplusA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_plustop3quint_se, replace format(%10.4f) force
	
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`top3quint_generasi_vA' + [var1_eg1vA_mean]`generasi' + [var1_eg1vA_mean]`top3quint_generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`top3quint_generasi_vA' + [var2_eg1vA_mean]`generasi' + [var2_eg1vA_mean]`top3quint_generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`top3quint_generasi_vA'+ [var3_eg1vA_mean]`generasi' + [var3_eg1vA_mean]`top3quint_generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`top3quint_generasi_vA'+ [var4_eg1vA_mean]`generasi' + [var4_eg1vA_mean]`top3quint_generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`top3quint_generasi_vA'+ [var5_eg1vA_mean]`generasi' + [var5_eg1vA_mean]`top3quint_generasi')/`sd1vA_5' + ([var6_eg1vA_mean]`generasi_vA' + [var6_eg1vA_mean]`top3quint_generasi_vA'+ [var6_eg1vA_mean]`generasi' + [var6_eg1vA_mean]`top3quint_generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA' + [var7_eg1vA_mean]`top3quint_generasi_vA'+ [var7_eg1vA_mean]`generasi' + [var7_eg1vA_mean]`top3quint_generasi')/`sd1vA_7' - ([var8_eg1vA_mean]`generasi_vA' + [var8_eg1vA_mean]`top3quint_generasi_vA'+ [var8_eg1vA_mean]`generasi' + [var8_eg1vA_mean]`top3quint_generasi')/`sd1vA_8') / 8) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_plustop3quint_SE`wave'		= mod3_genplusA_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_plustop3quint_SE`wave'		= "(" + mod3_genplusA_plustop3quint_se + ")" in `line_num_plus3'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus2'	

					*Education	

					lincom ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA'+ [var9_eg1vA_mean]`generasi' + [var9_eg1vA_mean]`top3quint_generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA'+ [var10_eg1vA_mean]`generasi' + [var10_eg1vA_mean]`top3quint_generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA'+ [var11_eg1vA_mean]`generasi' + [var11_eg1vA_mean]`top3quint_generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA'+ [var12_eg1vA_mean]`generasi' + [var12_eg1vA_mean]`top3quint_generasi')/`sd1vA_12') / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_plustop3quint_b		= r(estimate) 
					gen mod3_genplusA_plustop3quint_se 		= r(se) 
					tostring mod3_genplusA_plustop3quint_b, replace format(%10.4f) force
					tostring mod3_genplusA_plustop3quint_se, replace format(%10.4f) force
		
					test ((([var9_eg1vA_mean]`generasi_vA' + [var9_eg1vA_mean]`top3quint_generasi_vA' + [var9_eg1vA_mean]`generasi' + [var9_eg1vA_mean]`top3quint_generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA' + [var10_eg1vA_mean]`top3quint_generasi_vA'+ [var10_eg1vA_mean]`generasi' + [var10_eg1vA_mean]`top3quint_generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA' + [var11_eg1vA_mean]`top3quint_generasi_vA'+ [var11_eg1vA_mean]`generasi' + [var11_eg1vA_mean]`top3quint_generasi')/`sd1vA_11' + ([var12_eg1vA_mean]`generasi_vA' + [var12_eg1vA_mean]`top3quint_generasi_vA'+ [var12_eg1vA_mean]`generasi' + [var12_eg1vA_mean]`top3quint_generasi')/`sd1vA_12') / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_plustop3quint_SE`wave'		= mod3_genplusA_plustop3quint_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_plustop3quint_SE`wave'		= "(" + mod3_genplusA_plustop3quint_se + ")" in `line_num_plus5'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_plustop3quint_SE`wave'	 	= mod3_genplusA_plustop3quint_b + "***" if `p_val' < 0.01 in `line_num_plus4'
	
				
		
		
				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_SE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet indicator_name_SE mod3_genplusA_top3quint_SE`wave' mod3_gen_top3quint_SE`wave' mod3_genvA_top3quint_SE`wave' in 1/10 using `direc'table10B_suest_avgSE_`z'_`b'_`wave', replace
				
			}	
		}
	}				
}


if `do_table11' == 1 {

	cd\
	cd `rundir'
	cd "Wave I"
	
	use ..\kecs_info_clean, clear
	
	gen kab_id = llk02_cd
	gen prov_id = llk01_cd
	gen ea_code = Location_ID
	egen generasi = rowmax(gen_year1 gen_year2)
	gen type = 3
	sort ea_code
	tempfile temp
	save `temp'
	
	**
	
	use Data\R, clear
	
	gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile tempback
	save `tempback'

	drop panel_hh_id_back_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'
	
	use `tempback', clear
	drop panel_hh_id_back_w2
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'	
	****
	
	use table_1_4_vars_generasi_w1, clear
	cap drop _m*
	sort ea_code
	
	merge ea_code using `temp', uniqusing
	drop if _m == 2
	drop _merge
 

	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
		
	//Creating kecamatan level Wave 1 averages of 23 variables 
	foreach x in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway{ 
		bys ea_code: egen k_`x'_w1 = mean(`x'_w1)
		bys kab_id:		egen kb_`x'_w1 = mean(`x'_w1)	
		replace k_`x'_w1 = kb_`x'_w1 if k_`x'_w1 == .	
	}

	**Generating place holder variables for those 8 which not have Wave I info
	 foreach x in SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		capture drop `x'_w1
		gen `x'_w1 = .
		gen k_`x'_w1 = .
	}
	
	keep ea_code k_*_w1 kb_*_w1
	duplicates drop 
	
	
	sort ea_code
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	*******************
	***  Wave II    ***
	*******************
	
		
	cd ..\
	cd "Wave II"
	
	use table_1_4_vars_w2_with_w1controls, clear
	
	gen ea_code = substr(rid,1,3)
	replace ea_code = substr(sid,1,3) if ea_code == ""
	
	
	**Merging in Location_ID, kab_id info
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	

	
	//Dropping observations from the drop kec list
	drop if drop == 1

	
	sort ea_code
	merge ea_code using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _merge

	sort Location_ID
	
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m2)
	tab _m2 panel_hh if obs_type != 3, m
	drop if _m2 == 2
	drop _m2
	
	
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*


	sort rid
	merge rid using Data\R, uniqusing
	tab _merge
	drop if _merge == 2
	
	//Generate household type variable
	rename rlk12 HH_type
	

	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m

	****
	
	**Panel and split are panel HH's 

	replace HH_type = HH_type_fill if panel_hh == 1
	tab obs_type HH_type, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
		
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	replace age_years = 8888 if age_years == . 
	
	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10 & obs_type != 11)

	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
		
	********
	* create differenced versions
	********

	***

	foreach x in SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		gen `x'_w1 = .
	}



	foreach q in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway{
		display "**`q' kec***"
		g dkec_`q' = `q'_w2 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w2 - k_`q'_w1
		if "`q'" != "migrate_12_mons_hh"{
		count if `q'_w2 != . & panel_2007 == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		}
		if "`q'" == "migrate_12_mons_hh"{
			count if `q'_w2 != . & panel_hh == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		}	
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w2 - `q'_w1 if `q'_w1 != .

	}

	
	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 == .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 == .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 == .)
		replace k_`x'_w1 = 0 if k_`x'_w1 == .
	}

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)

	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep ea_code
	duplicates drop
	sort ea_code
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore

	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2

	save table_1_4_vars_w2_full_suest, replace


	*******************
	***  Wave III   ***
	*******************
	
	
	cd ..\
	cd "Wave III"
	
	use Data\R, clear
	duplicates drop rid, force
	sort rid
	tempfile temp_R
	save `temp_R'
	
	use table_1_4_vars_generasi_w3_with_w1controls, clear
	
	drop ea_code
	gen ea_code = substr(rid,1,3)
	replace ea_code = substr(lid,1,3) if ea_code == ""
		

	
	**Merging in Location_ID, kab_id info
	sort ea_code
	merge ea_code using `temp', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	
		
	//Dropping observations from the drop kec list
	drop if drop == 1
	
	sort ea_code
	merge ea_code using `kec_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _merge

	sort Location_ID
	
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m2)
	tab _m2 panel_hh if obs_type != 3, m
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*


	sort rid
	merge rid using `temp_R', uniqusing
	tab _merge
	drop if _merge == 2
	
	//Generate household type variable
	rename rlk12 HH_type
	
	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m

	****
	
	**Panel and split are panel HH's 

	replace HH_type = HH_type_fill if panel_hh == 1
	tab obs_type HH_type, m
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
		
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	replace age_years = 8888 if age_years == . 
	
	//Not want to include age dummies for non-child obs, constant so will drop out
	replace age_years = 9999 if (obs_type != 7 & obs_type != 10 & obs_type != 11)

	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
		
	********
	* create differenced versions
	********

	***

	foreach x in SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		gen `x'_w1 = .
	}



	foreach q in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway{
		display "**`q' kec***"
		g dkec_`q' = `q'_w3 - k_`q'_w1
	  
		display "**`q' ind***"
		g dind_`q' = `q'_w3 - k_`q'_w1
		if "`q'" != "migrate_12_mons_hh"{
		count if `q'_w3 != . & panel_2007 == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		}
		if "`q'" == "migrate_12_mons_hh"{
			count if `q'_w3 != . & panel_hh == 1 & `q'_w1 != . & k_`q'_w1 != . & k_`q'_w1 != `q'_w1
		}	
		count if `q'_w1 != k_`q'_w1 & `q'_w1 != .
		replace dind_`q' = `q'_w3 - `q'_w1 if `q'_w1 != .

	}

	
	**generating dummy for whether the wave 1 individual and/or kec level control variables are missing
	foreach x in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		disp "***`x'_ind***"
		gen i_`x'_m1 = (`x'_w1 == .)
		gen i_`x'_w1 = `x'_w1
		replace i_`x'_w1 = 0 if `x'_w1 == .

		disp "***`x'_kec***"
		gen k_`x'_m1 = (k_`x'_w1 == .)
		replace k_`x'_w1 = 0 if k_`x'_w1 == .
	}


	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
				

	save table_1_4_vars_generasi_w3_full_suest, replace	
	
	
	********************************************
	*****      Waves II & III Pooled       ***** 
	********************************************
	
	use "..\Wave II\table_1_4_vars_w2_full_suest", clear
	
	foreach q in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway SMA_enroll health_service_use mother_knowledge quality_pos{
		gen `q'_po = `q'_w2
		drop `q'_w2
	}
	
	keep wave *_po *_w1 *_m1 id panel_hh obs_type rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x panel_2007

	tempfile tempwave
	save `tempwave'	
	
	use table_1_4_vars_generasi_w3_full_suest, clear
	

	foreach q in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

	keep wave *_po *_w1 *_m1 id panel_hh obs_type rid kab_id Location_ID age_years HH_type HH_type_fill HH_type_and_panel prov_id prov_P intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x panel_2007 panel_2008
	append using `tempwave'
	
	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)
				
			gen wave_3 = wave==3
			
			rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
		
			local k12_val_w1_group "k12_pre_natal_visits_w1 k12_good_assisted_delivery_w1 k12_post_natal_visits_w1 k12_iron_pills_categ_w1 k12_imm_uptak_pct_23mons_w1 k12_times_weighed_last3m_w1 k12_vitA_total_6mons_2years_w1 k12_mal_weightforage_w1 k12_enroll_age7to12_w1 k12_enroll_age13to15_w1 k12_age7to12_pct_twoweeks_w1 k12_age13to15_pct_twoweeks_w1"
			local kec_val_w1_group "k_*_w1"
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_group "i_*_w1"
			local ind_val_m1_group "i_*_m1"
	
			foreach q of varlist `k12_val_w1_group' `kec_val_w1_group' `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_group' `ind_val_m1_group'{
				gen `q'w = wave_3 * `q'
				}
						
	save table_1_4_vars_pooled_full_suest, replace


************************************
************************************

foreach w in table_1_4_vars_w2_full_suest table_1_4_vars_generasi_w3_full_suest table_1_4_vars_pooled_full_suest{
	foreach z in indcontrols{
		foreach b in all{

			if "`w'" == "table_1_4_vars_w2_full_suest"{
				local wave "w2"
				use "..\Wave II\table_1_4_vars_w2_full_suest", clear
			}
			if "`w'" == "table_1_4_vars_generasi_w3_full_suest"{
				local wave "w3"
				use `w', clear
			}			
			if "`w'" == "table_1_4_vars_pooled_full_suest"{
				local wave "po"
				use `w', clear
			}			

			***Creating variables to create draft tables for export to excel

			gen indicator_name 				= ""
			gen baseline_mean 				= ""
			gen control_mean_`wave'		= ""
			gen mod1_gen_`wave'		 		= ""
			gen mod3_genplusA_`wave' 	= ""
			gen mod3_gen_`wave'		 		= ""
			gen mod3_genvA_`wave' 		= ""
			gen num_obs_`wave'		 		= .

			gen indicator_name_avgSE 				= ""
			gen mod1_gen_avgSE_`wave'		 		= ""
			gen mod3_genplusA_avgSE_`wave' 	= ""
			gen mod3_gen_avgSE_`wave'		 		= ""
			gen mod3_genvA_avgSE_`wave' 		= ""
		
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
				local direc "..\Output\java\"
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
				local direc "..\Output\sulawesi\"
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53
				local direc "..\Output\ntt\"
			}
			if "`b'" == "all"{
				local direc "..\Output\all\"
			}


			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_4_vars_generasi_w1", clear	
			destring prov_id, replace

			**Merging in Location_ID, kab_id info
			sort ea_code
			merge ea_code using `temp', uniqusing
			tab _merge
			drop if _merge == 2
			drop _merge
			
			
			if "`b'" == "java"{
				keep if prov_id == 32 | prov_id == 35
			}
			if "`b'" == "sulawesi"{
				keep if prov_id == 71 | prov_id == 75
			}
			if "`b'" == "ntt"{
				keep if prov_id == 53						
			}
		
			sort ea_code
			merge ea_code using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop


			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3
		

			**Schools, villages unweighted, so give all same 1 weight
			replace baseline_weight = 1 if obs_type == 3
			replace baseline_weight = 1 if obs_type == 12
				
			foreach x in SMP_transition SMP_transition_def2 breastfed_1hr dropout exclusive_breastfed facility_deliv family_planning hrs_school hrs_work_house hrs_work_wage hrs_work_house_dummy hrs_work_wage_dummy live_birth_12mon prenatal_serv_qual hrs_school_enroll_only mom_purch_decisions mom_child_decisions migrate_12_mons_hh excess_pre_natal excess_vit_A SMP_distance SMP_time_oneway SMP_transcost_oneway{ 
				**Creating overall wave 1 average of each variable for table
				cap drop avg_`x'_w1 se_`x'_w1
				summ `x'_w1 [weight = baseline_weight]
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}

			foreach x in SMA_enroll health_service_use mother_knowledge quality_pos paket_A paket_B paket_C migrate_out_12mon_village{
				**Creating placeholders for vars not having w1 info
				gen avg_`x'_w1 = .
				gen se_`x'_w1 = .
			}

			keep avg_*_w1 se_*_w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm
	


			local marker = 0
			local count = 1
			local number = 1
			local number_plus1 = 2
			local var_num = 1
				
			gen include_obs = 1


			
			if "`wave'" == "w2"{
				local vars_list "facility_deliv family_planning health_service_use excess_pre_natal excess_vit_A prenatal_serv_qual quality_pos breastfed_1hr exclusive_breastfed mother_knowledge mom_child_decisions live_birth_12mon migrate_12_mons_hh SMA_enroll dropout SMP_transition hrs_school SMP_distance SMP_time_oneway SMP_transcost_oneway hrs_work_wage hrs_work_house hrs_work_wage_dummy hrs_work_house_dummy "
			}
			
			if "`wave'" == "w3" | "`wave'" == "po"{
				local vars_list	"facility_deliv family_planning health_service_use excess_pre_natal excess_vit_A prenatal_serv_qual quality_pos breastfed_1hr exclusive_breastfed mother_knowledge mom_child_decisions live_birth_12mon migrate_out_12mon_village migrate_12_mons_hh SMA_enroll dropout SMP_transition hrs_school paket_A paket_B paket_C SMP_distance SMP_time_oneway SMP_transcost_oneway hrs_work_wage hrs_work_house hrs_work_wage_dummy hrs_work_house_dummy"
			}			

			
					
			foreach x in `vars_list'{
				
	
				disp "*******`x'_`wave'**********"
	
				cap drop kab_wave* 
				sort kab_id wave
				egen kab_wave = group(prov_id kab_id wave)
				tab kab_wave, gen(kab_wave_)
	
	
				****
				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "k_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "i_`x'_w1"
					local ind_val_m1_wave "i_`x'_m1"
					local kab_wave "kab_id"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "k_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "i_`x'_w1*"
					local ind_val_m1_wave "i_`x'_m1*"
					local kab_wave "kab_wave"
				}	
	
						
				
				if "`z'" == "indallkeccontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
	
				if "`z'" == "allkeccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`k12_val_w1_wave' `kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}	
								
				if "`z'" == "indcontrols" {
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	
	
				if "`z'" == "keccontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}					
	
				if "`z'" == "nocontrols"{
					local yvar "`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel ""
					local age_vals ""
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
											
				if "`z'" == "differenceskec"{
					local yvar "dk_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}
	
				if "`z'" == "differencesind"{
					local yvar "di_`x'_`wave'"
					local kec_val_w1 ""
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val ""
					local ind_val_m1 ""
					local baseline_mean ""
					local baseline_se ""
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
				}

				
				if "`x'" != "SMA_enroll" & "`x'" != "hrs_school" & "`x'" != "SMP_transition" & "`x'" != "SMP_transition_def2" & "`x'" != "hrs_work_wage" & "`x'" != "hrs_work_house" & "`x'" != "dropout" & "`x'" != "SMP_distance" & "`x'" != "SMP_time_oneway" & "`x'" != "SMP_transcost_oneway"{
					local age_vals ""		
				}
				if ("`x'" == "SMA_enroll" | "`x'" == "hrs_school" | "`x'" == "SMP_transition" | "`x'" == "SMP_transition_def2" | "`x'" == "hrs_work_wage" | "`x'" == "hrs_work_house" | "`x'" == "dropout" | "`x'" == "SMP_distance" | "`x'" == "SMP_time_oneway" | "`x'" == "SMP_transcost_oneway") & "`z'" != "nocontrols"{
					local age_vals "`age_vals_wave'"
				}

				if "`wave'" == "w2"{
					local generasi "gen_year1"
					local generasi_vA "gen_year1_versi_A"
				}
				if "`wave'" == "w3"{
					local generasi	"gen_year1or2"
					local generasi_vA "gen_year1or2_versi_A"
				}			
				if "`wave'" == "po"{
					local generasi	"gen_pooled"
					local generasi_vA "gen_pooled_versi_A"
				}			

				
				****
								
				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1, cluster(Location_ID)
								
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					summ `baseline_mean'
					gen baseline_mean_1 	= r(mean) 
					gen baseline_mean_2	= `baseline_se'
					tostring baseline_mean_1, replace format(%10.4f) force
					tostring baseline_mean_2, replace format(%10.4f) force
					replace baseline_mean 	= baseline_mean_1 in `number'
					replace baseline_mean	= "(" + baseline_mean_2 + ")" in `number_plus1'	
				}
				
				**Cross-sectional households (exclude Surade for baseline mean comparability); obs_type == 12 for village level migration variable	
				summ `control_mean' & (panel_hh == 0 | obs_type == 12)
				gen control_mean_1 	= r(mean) 
				gen control_mean_2	= `control_se'
				tostring control_mean_1, replace format(%10.4f) force
				tostring control_mean_2, replace format(%10.4f) force
				replace control_mean_`wave' = control_mean_1 in `number'
				replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'

				
				gen mod3_gen_b 		=_b[`generasi'] 
				gen mod3_gen_se 		= _se[`generasi'] 
				tostring mod3_gen_b, replace format(%10.4f) force
				tostring mod3_gen_se, replace format(%10.4f) force
	
				test `generasi'	
				local p_val			= r(p) 	
				replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
				replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
				gen mod3_genvA_b 	=_b[`generasi_vA'] 
				gen mod3_genvA_se 	= _se[`generasi_vA'] 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
		
				test `generasi_vA'	
				local p_val			= r(p) 
				replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
				replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
				lincom `generasi' + `generasi_vA' 
				gen mod3_genplusA_b 	= r(estimate)
				gen mod3_genplusA_se 	= r(se)
				tostring mod3_genplusA_b, replace format(%10.4f) force
				tostring mod3_genplusA_se, replace format(%10.4f) force
	
				test `generasi' + `generasi_vA' = 0
				local p_val			=  r(p)
				replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
				replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
				replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
				**************************
				replace indicator_name = "`x'" in `number'
	
				**************************

				quie reg `yvar' `generasi' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_* if include_obs == 1
				
				noi estimates store var`var_num'_eg1vA	

				replace num_obs = e(N) in `number'
				tempvar samplevar
				g `samplevar' = e(sample)

								
				tempvar samplevar
				g `samplevar' = e(sample)
				summ `yvar' if `samplevar' == 1 & intervention == "3"
				local sd1vA_`var_num' = r(sd)					
				
				****
				
				local marker = 1
				local count = `count' + 1
				local number = `number' + 2
				local number_plus1 = `number_plus1' + 2
				local var_num = `var_num' + 1		
	
				drop *mod?_gen*_b mod?_gen*_se control_mean_?
				if "`z'" != "differencesind" & "`z'" != "differenceskec"{
					drop baseline_mean_?
				}				
			}
	

			if "`wave'" == "w2"{
			
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			local line_num_plus6 = `line_num' + 6
			local line_num_plus7 = `line_num' + 7
			local line_num_plus8 = `line_num' + 8
			local line_num_plus9 = `line_num' + 9
			local line_num_plus10 = `line_num' + 10
			local line_num_plus11 = `line_num' + 11
			local line_num_plus12 = `line_num' + 12
			local line_num_plus13 = `line_num' + 13
			local line_num_plus14 = `line_num' + 14
			local line_num_plus15 = `line_num' + 15
			local line_num_plus16 = `line_num' + 16
			local line_num_plus17 = `line_num' + 17
			local line_num_plus18 = `line_num' + 18
			local line_num_plus19 = `line_num' + 19
			
*****
			
					suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA var13_eg1vA var14_eg1vA var15_eg1vA var16_eg1vA var17_eg1vA var18_eg1vA var19_eg1vA var20_eg1vA var21_eg1vA var22_eg1vA var23_eg1vA var24_eg1vA, cluster(Location_ID)

					*Health Utilization
					
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5)

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus7'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					
					lincom (([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus9'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test ((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus11'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus13'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2) + (([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4)) / 7)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2) + (([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus15'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2)) / 4)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13')/2)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus17'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom (((([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4)) / 3)
					drop mod?_gen_b mod?_gen_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var14_eg1vA_mean]`generasi'/`sd1vA_14' - [var15_eg1vA_mean]`generasi'/`sd1vA_15' + [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi'/`sd1vA_18' - [var19_eg1vA_mean]`generasi'/`sd1vA_19' - [var20_eg1vA_mean]`generasi'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi'/`sd1vA_21' - [var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus19'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus18'


*****	 			

					*Health Utilization
					
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5)

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus7'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					
					lincom (([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus9'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test ((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus11'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus13'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2) + (([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4)) / 7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2) + (([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus15'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2)) / 4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13')/2)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus17'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom (((([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4)) / 3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' - [var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' + [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17')/4)+((-[var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' - [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' - [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20' )/3)+ ((-[var21_eg1vA_mean]`generasi_vA'/`sd1vA_21' - [var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus19'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus18'

*****		

					*Health Utilization
					
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5)

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus7'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					
					lincom ((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus9'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus11'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus13'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2) + ((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4)+((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3)+ ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4)) / 7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2) + ((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4)+((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3)+ ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus15'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2)) / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13')/2)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus17'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom ((((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4)+((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3)+ ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4)) / 3)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' - ([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' + ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17')/4)+((-([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' - ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' - ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20' )/3)+ ((-([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21' - ([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus19'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus18'


			}
			
			if "`wave'" == "w3" | "`wave'" == "po"{
			
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			local line_num_plus6 = `line_num' + 6
			local line_num_plus7 = `line_num' + 7
			local line_num_plus8 = `line_num' + 8
			local line_num_plus9 = `line_num' + 9
			local line_num_plus10 = `line_num' + 10
			local line_num_plus11 = `line_num' + 11
			local line_num_plus12 = `line_num' + 12
			local line_num_plus13 = `line_num' + 13
			local line_num_plus14 = `line_num' + 14
			local line_num_plus15 = `line_num' + 15
			local line_num_plus16 = `line_num' + 16
			local line_num_plus17 = `line_num' + 17
			local line_num_plus18 = `line_num' + 18
			local line_num_plus19 = `line_num' + 19
			

					suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA var12_eg1vA var13_eg1vA var14_eg1vA var15_eg1vA var16_eg1vA var17_eg1vA var18_eg1vA var19_eg1vA var20_eg1vA var21_eg1vA var22_eg1vA var23_eg1vA var24_eg1vA var25_eg1vA var26_eg1vA var27_eg1vA var28_eg1vA, cluster(Location_ID)

					*Health Utilization
					
					lincom (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5)

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus1'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus3'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus5'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus7'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					
					lincom (([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus9'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test ((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus11'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus13'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3) + (([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4)) / 7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3) + (([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus15'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3)) / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi'/`sd1vA_1' + [var2_eg1vA_mean]`generasi'/`sd1vA_2' + [var3_eg1vA_mean]`generasi'/`sd1vA_3' + [var4_eg1vA_mean]`generasi'/`sd1vA_4' + [var5_eg1vA_mean]`generasi'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi'/`sd1vA_6' + [var7_eg1vA_mean]`generasi'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi'/`sd1vA_8' + [var9_eg1vA_mean]`generasi'/`sd1vA_9' + [var10_eg1vA_mean]`generasi'/`sd1vA_10' + [var11_eg1vA_mean]`generasi'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi'/`sd1vA_12' - [var13_eg1vA_mean]`generasi'/`sd1vA_13' - [var14_eg1vA_mean]`generasi'/`sd1vA_14' )/3)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus17'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom (((([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4)) / 3)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_gen_b	=r(estimate) 
					gen mod3_gen_se 	= r(se) 
					tostring mod3_gen_b, replace format(%10.4f) force
					tostring mod3_gen_se, replace format(%10.4f) force
	 
					test (((([var15_eg1vA_mean]`generasi'/`sd1vA_15' - [var16_eg1vA_mean]`generasi'/`sd1vA_16' + [var17_eg1vA_mean]`generasi'/`sd1vA_17' + [var18_eg1vA_mean]`generasi'/`sd1vA_18' + [var19_eg1vA_mean]`generasi'/`sd1vA_19' + [var20_eg1vA_mean]`generasi'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi'/`sd1vA_22' - [var23_eg1vA_mean]`generasi'/`sd1vA_23' - [var24_eg1vA_mean]`generasi'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi'/`sd1vA_25' - [var26_eg1vA_mean]`generasi'/`sd1vA_26' - [var27_eg1vA_mean]`generasi'/`sd1vA_27' - [var28_eg1vA_mean]`generasi'/`sd1vA_28')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_gen_avgSE_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'		= "(" + mod3_gen_se + ")" in `line_num_plus19'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_gen_avgSE_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `line_num_plus18'
*****	 			

					*Health Utilization
					
					lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5)

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus7'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					drop mod?_gen*_b mod?_gen*_se
					
					lincom (([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7)

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus9'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test ((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus11'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus13'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3) + (([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4)) / 7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3) + (([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus15'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3)) / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5')/5) + (([var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7')/2) + (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11')/4) + (([var12_eg1vA_mean]`generasi_vA'/`sd1vA_12' - [var13_eg1vA_mean]`generasi_vA'/`sd1vA_13' - [var14_eg1vA_mean]`generasi_vA'/`sd1vA_14' )/3)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus17'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom (((([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4)) / 3)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genvA_b	=r(estimate) 
					gen mod3_genvA_se 	= r(se) 
					tostring mod3_genvA_b, replace format(%10.4f) force
					tostring mod3_genvA_se, replace format(%10.4f) force
	 
					test (((([var15_eg1vA_mean]`generasi_vA'/`sd1vA_15' - [var16_eg1vA_mean]`generasi_vA'/`sd1vA_16' + [var17_eg1vA_mean]`generasi_vA'/`sd1vA_17' + [var18_eg1vA_mean]`generasi_vA'/`sd1vA_18' + [var19_eg1vA_mean]`generasi_vA'/`sd1vA_19' + [var20_eg1vA_mean]`generasi_vA'/`sd1vA_20'  + [var21_eg1vA_mean]`generasi_vA'/`sd1vA_21')/7)+((-[var22_eg1vA_mean]`generasi_vA'/`sd1vA_22' - [var23_eg1vA_mean]`generasi_vA'/`sd1vA_23' - [var24_eg1vA_mean]`generasi_vA'/`sd1vA_24' )/3)+ ((-[var25_eg1vA_mean]`generasi_vA'/`sd1vA_25' - [var26_eg1vA_mean]`generasi_vA'/`sd1vA_26' - [var27_eg1vA_mean]`generasi_vA'/`sd1vA_27' - [var28_eg1vA_mean]`generasi_vA'/`sd1vA_28')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus19'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus18'


*****		

					*Health Utilization
					
					lincom ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5)

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus1'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num'

					*Health quality
					
					lincom ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus3'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus2'

					*Maternal knowledge and practices
					
					lincom ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus5'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus4'

					*Family composition decisions
					
					lincom ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus7'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus6'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus6'

					*Other education metrics
					
					lincom ((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus9'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus8'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus8'

					*Distance to school
					
					lincom ((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus11'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus10'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus10'

					*Child Labor
					
					lincom ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus13'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus12'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus12'
			
					*Total
					
					lincom ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3) + ((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7)+((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3)+ ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4)) / 7)
					drop mod?_gen*_b mod?_gen*_se

					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3) + ((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7)+((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3)+ ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4)) / 7) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus15'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus14'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus14'

					*Health
					
					lincom ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3)) / 4)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var1_eg1vA_mean]`generasi_vA' + [var1_eg1vA_mean]`generasi')/`sd1vA_1' + ([var2_eg1vA_mean]`generasi_vA' + [var2_eg1vA_mean]`generasi')/`sd1vA_2' + ([var3_eg1vA_mean]`generasi_vA' + [var3_eg1vA_mean]`generasi')/`sd1vA_3' + ([var4_eg1vA_mean]`generasi_vA' + [var4_eg1vA_mean]`generasi')/`sd1vA_4' + ([var5_eg1vA_mean]`generasi_vA' + [var5_eg1vA_mean]`generasi')/`sd1vA_5')/5) + ((([var6_eg1vA_mean]`generasi_vA'+ [var6_eg1vA_mean]`generasi')/`sd1vA_6' + ([var7_eg1vA_mean]`generasi_vA'+ [var7_eg1vA_mean]`generasi')/`sd1vA_7')/2) + ((([var8_eg1vA_mean]`generasi_vA'+ [var8_eg1vA_mean]`generasi')/`sd1vA_8' + ([var9_eg1vA_mean]`generasi_vA'+ [var9_eg1vA_mean]`generasi')/`sd1vA_9' + ([var10_eg1vA_mean]`generasi_vA'+ [var10_eg1vA_mean]`generasi')/`sd1vA_10' + ([var11_eg1vA_mean]`generasi_vA'+ [var11_eg1vA_mean]`generasi')/`sd1vA_11')/4) + ((([var12_eg1vA_mean]`generasi_vA'+ [var12_eg1vA_mean]`generasi')/`sd1vA_12' - ([var13_eg1vA_mean]`generasi_vA'+ [var13_eg1vA_mean]`generasi')/`sd1vA_13' - ([var14_eg1vA_mean]`generasi_vA'+ [var14_eg1vA_mean]`generasi')/`sd1vA_14' )/3)) / 4) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus17'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus16'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus16'

			
					*Education
					
					lincom ((((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7)+((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3)+ ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4)) / 3)
					drop mod?_gen*_b mod?_gen*_se
					gen mod3_genplusA_b	=r(estimate) 
					gen mod3_genplusA_se 	= r(se) 
					tostring mod3_genplusA_b, replace format(%10.4f) force
					tostring mod3_genplusA_se, replace format(%10.4f) force
	 
					test ((((([var15_eg1vA_mean]`generasi_vA'+ [var15_eg1vA_mean]`generasi')/`sd1vA_15' - ([var16_eg1vA_mean]`generasi_vA'+ [var16_eg1vA_mean]`generasi')/`sd1vA_16' + ([var17_eg1vA_mean]`generasi_vA'+ [var17_eg1vA_mean]`generasi')/`sd1vA_17' + ([var18_eg1vA_mean]`generasi_vA'+ [var18_eg1vA_mean]`generasi')/`sd1vA_18' + ([var19_eg1vA_mean]`generasi_vA'+ [var19_eg1vA_mean]`generasi')/`sd1vA_19' + ([var20_eg1vA_mean]`generasi_vA'+ [var20_eg1vA_mean]`generasi')/`sd1vA_20'  + ([var21_eg1vA_mean]`generasi_vA'+ [var21_eg1vA_mean]`generasi')/`sd1vA_21')/7)+((-([var22_eg1vA_mean]`generasi_vA'+ [var22_eg1vA_mean]`generasi')/`sd1vA_22' - ([var23_eg1vA_mean]`generasi_vA'+ [var23_eg1vA_mean]`generasi')/`sd1vA_23' - ([var24_eg1vA_mean]`generasi_vA'+ [var24_eg1vA_mean]`generasi')/`sd1vA_24' )/3)+ ((-([var25_eg1vA_mean]`generasi_vA'+ [var25_eg1vA_mean]`generasi')/`sd1vA_25' - ([var26_eg1vA_mean]`generasi_vA'+ [var26_eg1vA_mean]`generasi')/`sd1vA_26' - ([var27_eg1vA_mean]`generasi_vA'+ [var27_eg1vA_mean]`generasi')/`sd1vA_27' - ([var28_eg1vA_mean]`generasi_vA'+ [var28_eg1vA_mean]`generasi')/`sd1vA_28')/4)) / 3) = 0
					local p_val			=  r(p)
					replace mod3_genplusA_avgSE_`wave'		= mod3_genplusA_b if `p_val' >= 0.1 in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'		= "(" + mod3_genplusA_se + ")" in `line_num_plus19'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus18'
					replace mod3_genplusA_avgSE_`wave'	 	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `line_num_plus18'


			}
					
		
				local count_line = 1
				foreach w in avg_std_effect_HU avg_std_effect_HQ avg_std_effect_MKP avg_std_effect_FCD avg_std_effect_OEM avg_std_effect_DS avg_std_effect_CH avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* in 1/30 using `direc'table11_suest_avgSE_`z'_`b'_`wave', replace

	
				
		}
	}	
}	
}


*******************************************************
//Carrying out regressions for Table 12A 
******************************************************


if `do_table12A' == 1{
***********************************************************************************
*BCG vaccine sabortage: create difference between recorded vaccine and mark on arm
***********************************************************************************
//get baseline values 
cd\
cd `rundir'
cd "Wave I"
use "Data\T_IM1TYPE.dta", clear

keep tid tim1type tim07 tim08
keep if tim1type==1 //keep BCG vaccines only

tempfile info_on_BCG
save `info_on_BCG'

use "Data\T.dta", clear

keep tid tus05 tim05

mmerge tid using `info_on_BCG'
keep if _merge==3
drop _m

gen ea = substr(tid,1,3)
gen Location_ID = substr(tid,1,3)
mmerge Location_ID using "..\kecs_info_clean"
keep if _m==3
drop _m
gen id_desa = Location_ID + substr(tid,5,3)

//clean tim08 data
replace tim08=. if tim08>6

gen have_scar_w1 = (tus05==1)
gen recorded_BCG_w1 = (tim08==1)
gen declared_BCG_w1 = (tim07==1)
gen decl_or_record_BCG_w1 = (recorded_BCG==1 | declared_BCG==1)

egen BCG_diff_declared_w1 = diff(tim07 tus05)  //dummy=1 if mother declared she had the vaccine and the sign was not visible
replace BCG_diff_declared_w1 = . if tus05==6 | tus05==. | tim07==. | tim07==8

egen BCG_diff_recorded_w1 = diff(tim08 tus05)  //dummy=1 if the vaccine was recorded 
replace BCG_diff_recorded_w1 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace BCG_diff_recorded_w1 = . if tus05==6 | tus05==. | tim08==6
replace BCG_diff_recorded_w1 = . if tim08==. & (tim07==1 | tim07==. | tim07==8)

egen total_BCG_declared_diff_w1 = total(BCG_diff_declared_w1), by(id_desa)
egen total_BCG_recorded_diff_w1 = total(BCG_diff_recorded_w1), by(id_desa)
bys id_desa: gen count_obs = _N
gen share_BCG_declared_diff_w1 = total_BCG_declared_diff_w1 / count_obs
gen share_BCG_recorded_diff_w1 = total_BCG_recorded_diff_w1 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present

gen false_yes_recorded_dummy_w1 = (tim08==1 & tus05==3)
replace false_yes_recorded_dummy_w1 =. if tus05==. | tus05==6 | tim08==6
replace false_yes_recorded_dummy_w1 = . if tim08==. & (tim07==1 | tim07==. | tim07==8)
gen false_yes_declared_dummy_w1 = (tim07==1 & tus05==3)
replace false_yes_declared_dummy_w1 =. if tim07==. | tus05==. | tus05==6 | tim07==8
egen total_false_yes_BCG_rec_w1 = total(false_yes_recorded_dummy), by(id_desa)
egen total_false_yes_BCG_decl_w1 = total(false_yes_declared_dummy), by(id_desa)
gen share_false_yes_BCG_rec_w1 = total_false_yes_BCG_rec_w1 / count_obs
gen share_false_yes_BCG_decl_w1 = total_false_yes_BCG_decl_w1 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present
gen false_no_recorded_dummy_w1 = (tim08==3 & tus05==1)
replace false_no_recorded_dummy_w1 = . if tus05==. | tus05==6 | tim08==6
replace false_no_recorded_dummy =. if tim08==. & (tim07==1 | tim07==. | tim07==8)
gen false_no_declared_dummy_w1 = (tim07==3 & tus05==1)
replace false_no_declared_dummy_w1 = . if tim07==. | tus05==. | tus05==6 | tim07==8
egen total_false_no_BCG_rec_w1 = total(false_no_recorded_dummy), by(id_desa)
egen total_false_no_BCG_decl_w1 = total(false_no_declared_dummy), by(id_desa)
gen share_false_no_BCG_rec_w1 = total_false_no_BCG_rec_w1 / count_obs
gen share_false_no_BCG_decl_w1 = total_false_no_BCG_decl_w1 / count_obs

//create dummy on whether the mom has record card (KIA or KMS) (dummy=1 means no record card)
replace tim05=. if tim05>6
gen no_record_card_w1 = (tim05==6)
replace no_record_card_w1 = . if tim05==.
egen total_no_record_card_w1 = total(no_record_card), by(id_desa)
gen share_no_record_card_w1 = total_no_record_card_w1 / count_obs

//get numbers and shares for the declared "yes's" and "no's" separated by those who have and those who don't have record cards
//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has record card
gen false_yes_declared_card_w1 = (tim07==1 & tus05==3) & tim05<6 & !missing(tim05)
replace false_yes_declared_card_w1 =. if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_yes_BCG_decl_card_w1 = total(false_yes_declared_card), by(id_desa)
gen share_false_yes_BCG_decl_card_w1 = total_false_yes_BCG_decl_card_w1 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has record card
gen false_no_declared_card_w1 = (tim07==3 & tus05==1) & tim05<6 & !missing(tim05)
replace false_no_declared_card_w1 = . if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_no_BCG_decl_card_w1 = total(false_no_declared_card), by(id_desa)
gen share_false_no_BCG_decl_card_w1 = total_false_no_BCG_decl_card_w1 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has no record card
gen false_yes_declared_nocard_w1 = (tim07==1 & tus05==3) & no_record_card==1
replace false_yes_declared_nocard_w1 =. if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_yes_BCG_decl_nocard_w1 = total(false_yes_declared_nocard), by(id_desa)
gen share_false_yes_BCG_d_nocard_w1 = tot_false_yes_BCG_decl_nocard_w1 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has no record card
gen false_no_declared_nocard_w1 = (tim07==3 & tus05==1) & no_record_card==1
replace false_no_declared_nocard_w1 = . if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_no_BCG_decl_nocard_w1 = total(false_no_declared_nocard), by(id_desa)
gen share_false_no_BCG_d_nocard_w1 = tot_false_no_BCG_decl_nocard_w1 / count_obs

drop tim* tus*


drop if drop==1


gen wave = 1

tempfile BCG_diff_w1
save `BCG_diff_w1'

********************************
*Wave II
********************************

//get info on recorded BCG vaccinations
cd ..\
cd "Wave II"
use "Data\T_IM1TYPE.dta", clear

keep tid tim1type tim07 tim08
keep if tim1type==1 //keep BCG vaccines only

tempfile info_on_BCG
save `info_on_BCG'

use "Data\T.dta", clear

keep tid tcov3 tus05 tim05

mmerge tid using `info_on_BCG'
keep if _merge==3
drop _m

gen ea = substr(tid,1,3)
gen Location_ID = substr(tid,1,3)
mmerge Location_ID using "..\kecs_info_clean"
keep if _m==3
drop _m
gen id_desa = Location_ID + substr(tid,5,3)

gen panel_hh = (tcov3==1)
replace panel_hh=. if tcov3==.
//clean tim08 data
replace tim08=. if tim08>6

gen have_scar_w2 = (tus05==1)
gen recorded_BCG_w2 = (tim08==1)
gen declared_BCG_w2 = (tim07==1)
gen decl_or_record_BCG_w2 = (recorded_BCG==1 | declared_BCG==1)

egen BCG_diff_declared_w2 = diff(tim07 tus05)  //dummy=1 if mother declared she had the vaccine and the sign was not visible
replace BCG_diff_declared_w2 = . if tus05==6 | tus05==. | tim07==. | tim07==8

egen BCG_diff_recorded_w2 = diff(tim08 tus05)  //dummy=1 if the vaccine was recorded 
replace BCG_diff_recorded_w2 = . if tim08==.
replace BCG_diff_recorded_w2 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace BCG_diff_recorded_w2 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

egen total_BCG_declared_diff_w2 = total(BCG_diff_declared_w2), by(id_desa)
egen total_BCG_recorded_diff_w2 = total(BCG_diff_recorded_w2), by(id_desa)
bys id_desa: gen count_obs = _N
gen share_BCG_declared_diff_w2 = total_BCG_declared_diff_w2 / count_obs
gen share_BCG_recorded_diff_w2 = total_BCG_recorded_diff_w2 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present
gen false_yes_recorded_dummy_w2 = (tim08==1 & tus05==3)

replace false_yes_recorded_dummy_w2 = . if tim08==.
replace false_yes_recorded_dummy_w2 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace false_yes_recorded_dummy_w2 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

gen false_yes_declared_dummy_w2 = (tim07==1 & tus05==3)
replace false_yes_declared_dummy_w2 =. if tim07==. | tus05==. | tus05==6 | tim07==8

egen total_false_yes_BCG_rec_w2 = total(false_yes_recorded_dummy), by(id_desa)
egen total_false_yes_BCG_decl_w2 = total(false_yes_declared_dummy), by(id_desa)

gen share_false_yes_BCG_rec_w2 = total_false_yes_BCG_rec_w2 / count_obs
gen share_false_yes_BCG_decl_w2 = total_false_yes_BCG_decl_w2 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present
gen false_no_recorded_dummy_w2 = (tim08==3 & tus05==1)
replace false_no_recorded_dummy_w2 = . if tim08==.
replace false_no_recorded_dummy_w2 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace false_no_recorded_dummy_w2 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

gen false_no_declared_dummy_w2 = (tim07==3 & tus05==1)
replace false_no_declared_dummy_w2 = . if tim07==. | tus05==. | tus05==6 | tim07==8

egen total_false_no_BCG_rec_w2 = total(false_no_recorded_dummy), by(id_desa)
egen total_false_no_BCG_decl_w2 = total(false_no_declared_dummy), by(id_desa)

gen share_false_no_BCG_rec_w2 = total_false_no_BCG_rec_w2 / count_obs
gen share_false_no_BCG_decl_w2 = total_false_no_BCG_decl_w2 / count_obs

//create dummy on whether the mom has record card (KIA or KMS) (dummy=1 means no record card)
replace tim05=. if tim05>6
gen no_record_card_w2 = (tim05==6)
replace no_record_card_w2 = . if tim05==.
egen total_no_record_card_w2 = total(no_record_card), by(id_desa)
gen share_no_record_card_w2 = total_no_record_card_w2 / count_obs

//get numbers and shares for the declared "yes's" and "no's" separated by those who have and those who don't have record cards
//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has record card
gen false_yes_declared_card_w2 = (tim07==1 & tus05==3) & tim05<6 & !missing(tim05)
replace false_yes_declared_card_w2 =. if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_yes_BCG_decl_card_w2 = total(false_yes_declared_card), by(id_desa)
gen share_false_yes_BCG_decl_card_w2 = total_false_yes_BCG_decl_card_w2 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has record card
gen false_no_declared_card_w2 = (tim07==3 & tus05==1) & tim05<6 & !missing(tim05)
replace false_no_declared_card_w2 = . if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_no_BCG_decl_card_w2 = total(false_no_declared_card), by(id_desa)
gen share_false_no_BCG_decl_card_w2 = total_false_no_BCG_decl_card_w2 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has no record card
gen false_yes_declared_nocard_w2 = (tim07==1 & tus05==3) & no_record_card==1
replace false_yes_declared_nocard_w2 =. if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_yes_BCG_decl_nocard_w2 = total(false_yes_declared_nocard), by(id_desa)
gen share_false_yes_BCG_d_nocard_w2 = tot_false_yes_BCG_decl_nocard_w2 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has no record card
gen false_no_declared_nocard_w2 = (tim07==3 & tus05==1) & no_record_card==1
replace false_no_declared_nocard_w2 = . if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_no_BCG_decl_nocard_w2 = total(false_no_declared_nocard), by(id_desa)
gen share_false_no_BCG_d_nocard_w2 = tot_false_no_BCG_decl_nocard_w2 / count_obs

drop tim* tus*


drop if drop==1

gen gen_pooled = (gen_year1 == 1)
gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
gen wave = 2



tempfile BCG_diff_w2
save `BCG_diff_w2'


********************************
*Wave III
********************************

//get info on recorded BCG vaccinations
cd ..\
cd "Wave III"
use "Data\T_IM1TYPE.dta", clear

keep tid tim1type tim07 tim08
keep if tim1type==1 //keep BCG vaccines only

tempfile info_on_BCG
save `info_on_BCG'

use "Data\T.dta", clear

*keep tid tcov3 tus05 tim05
keep tid tcov3 tim05
bys tid: keep if _n==1

tempfile a
save `a', replace

use  "Data\R_US.dta", clear
keep if  rus05!=.
gen id = rus01a
tostring id, replace
replace id = "0" + id if  rus01a<10
gen ea = substr(rid,1,3)
gen desart = substr(rid,5,9)
gen tid =  ea+"4"+desart+ id

keep tid rus05
rename rus05 tus05
bys tid: keep if _n==1
mmerge tid using `a'

drop if _m==1
drop _m

mmerge tid using `info_on_BCG'

keep if _merge==3
drop _m

gen ea = substr(tid,1,3)
gen Location_ID = substr(tid,1,3)
mmerge Location_ID using "..\kecs_info_clean"
keep if _m==3
drop _m
gen id_desa = Location_ID + substr(tid,5,3)

gen panel_hh = (tcov3==1)
replace panel_hh=. if tcov3==.
//clean tim08 data
replace tim08=. if tim08>6

gen have_scar_w3 = (tus05==1)
gen recorded_BCG_w3 = (tim08==1)
gen declared_BCG_w3 = (tim07==1)
gen decl_or_record_BCG_w3 = (recorded_BCG==1 | declared_BCG==1)

egen BCG_diff_declared_w3 = diff(tim07 tus05)  //dummy=1 if mother declared she had the vaccine and the sign was not visible
replace BCG_diff_declared_w3 = . if tus05==6 | tus05==. | tim07==. | tim07==8

egen BCG_diff_recorded_w3 = diff(tim08 tus05)  //dummy=1 if the vaccine was recorded 
replace BCG_diff_recorded_w3 = . if tim08==.
replace BCG_diff_recorded_w3 = . if tus05==.
replace BCG_diff_recorded_w3 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace BCG_diff_recorded_w3 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

egen total_BCG_declared_diff_w3 = total(BCG_diff_declared_w3), by(id_desa)
egen total_BCG_recorded_diff_w3 = total(BCG_diff_recorded_w3), by(id_desa)
bys id_desa: gen count_obs = _N
gen share_BCG_declared_diff_w3 = total_BCG_declared_diff_w3 / count_obs
gen share_BCG_recorded_diff_w3 = total_BCG_recorded_diff_w3 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present
gen false_yes_recorded_dummy_w3 = (tim08==1 & tus05==3)
replace false_yes_recorded_dummy_w3 = . if tim08==.
replace false_yes_recorded_dummy_w3 = . if tus05==.
replace false_yes_recorded_dummy_w3 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace false_yes_recorded_dummy_w3 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

gen false_yes_declared_dummy_w3 = (tim07==1 & tus05==3)
replace false_yes_declared_dummy_w3 =. if tim07==. | tus05==. | tus05==6 | tim07==8

egen total_false_yes_BCG_rec_w3 = total(false_yes_recorded_dummy), by(id_desa)
egen total_false_yes_BCG_decl_w3 = total(false_yes_declared_dummy), by(id_desa)

gen share_false_yes_BCG_rec_w3 = total_false_yes_BCG_rec_w3 / count_obs
gen share_false_yes_BCG_decl_w3 = total_false_yes_BCG_decl_w3 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present
gen false_no_recorded_dummy_w3 = (tim08==3 & tus05==1)
replace false_no_recorded_dummy_w3 = . if tim08==.
replace false_no_recorded_dummy_w3 = . if tus05==.
replace false_no_recorded_dummy_w3 = 0 if tus05==3 & tim08==. & (tim07==3 | tim07==8)  //in many cases, tim08 is missing if the mother declared that no vaccine was administered
replace false_no_recorded_dummy_w3 = . if (tus05==6 & (tim08==1|tim08==3|tim08==6)) | (tim08==6 & (tus05==1|tus05==3|tus05==6))

gen false_no_declared_dummy_w3 = (tim07==3 & tus05==1)
replace false_no_declared_dummy_w3 = . if tim07==. | tus05==. | tus05==6 | tim07==8

egen total_false_no_BCG_rec_w3 = total(false_no_recorded_dummy), by(id_desa)
egen total_false_no_BCG_decl_w3 = total(false_no_declared_dummy), by(id_desa)

gen share_false_no_BCG_rec_w3 = total_false_no_BCG_rec_w3 / count_obs
gen share_false_no_BCG_decl_w3 = total_false_no_BCG_decl_w3 / count_obs

//create dummy on whether the mom has record card (KIA or KMS) (dummy=1 means no record card)
replace tim05=. if tim05>6
gen no_record_card_w3 = (tim05==6)
replace no_record_card_w3 = . if tim05==.
egen total_no_record_card_w3 = total(no_record_card), by(id_desa)
gen share_no_record_card_w3 = total_no_record_card_w3 / count_obs

//get numbers and shares for the declared "yes's" and "no's" separated by those who have and those who don't have record cards
//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has record card
gen false_yes_declared_card_w3 = (tim07==1 & tus05==3) & tim05<6 & !missing(tim05)
replace false_yes_declared_card_w3 =. if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_yes_BCG_decl_card_w3 = total(false_yes_declared_card), by(id_desa)
gen share_false_yes_BCG_decl_card_w3 = total_false_yes_BCG_decl_card_w3 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has record card
gen false_no_declared_card_w3 = (tim07==3 & tus05==1) & tim05<6 & !missing(tim05)
replace false_no_declared_card_w3 = . if  tim07==. | tus05==. | tus05==6  | tim07==8 | missing(tim05) | tim05==6
egen total_false_no_BCG_decl_card_w3 = total(false_no_declared_card), by(id_desa)
gen share_false_no_BCG_decl_card_w3 = total_false_no_BCG_decl_card_w3 / count_obs

//create dummy=1 if BCG vaccine was recorded/declared but mark is not present and has no record card
gen false_yes_declared_nocard_w3 = (tim07==1 & tus05==3) & no_record_card==1
replace false_yes_declared_nocard_w3 =. if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_yes_BCG_decl_nocard_w3 = total(false_yes_declared_nocard), by(id_desa)
gen share_false_yes_BCG_d_nocard_w3 = tot_false_yes_BCG_decl_nocard_w3 / count_obs

//create dummy=1 if BCG vaccine was not recorded/declared but mark is present and has no record card
gen false_no_declared_nocard_w3 = (tim07==3 & tus05==1) & no_record_card==1
replace false_no_declared_nocard_w3 = . if tim07==. | tus05==. | tus05==6  | tim07==8 | no_record_card!=1
egen tot_false_no_BCG_decl_nocard_w3 = total(false_no_declared_nocard), by(id_desa)
gen share_false_no_BCG_d_nocard_w3 = tot_false_no_BCG_decl_nocard_w3 / count_obs

drop tim* tus*


drop if drop==1

gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
gen wave = 3


tempfile BCG_diff_w3
save `BCG_diff_w3'



********************************
*Wave III & Pooled 
********************************

use `BCG_diff_w2', clear

foreach q in have_scar recorded_BCG declared_BCG decl_or_record_BCG BCG_diff_declared BCG_diff_recorded total_BCG_declared_diff total_BCG_recorded_diff share_BCG_declared_diff share_BCG_recorded_diff false_yes_recorded_dummy false_yes_declared_dummy total_false_yes_BCG_rec total_false_yes_BCG_decl share_false_yes_BCG_rec share_false_yes_BCG_decl false_no_recorded_dummy false_no_declared_dummy total_false_no_BCG_rec total_false_no_BCG_decl share_false_no_BCG_rec share_false_no_BCG_decl no_record_card total_no_record_card share_no_record_card false_yes_declared_card total_false_yes_BCG_decl_card share_false_yes_BCG_decl_card false_no_declared_card total_false_no_BCG_decl_card share_false_no_BCG_decl_card false_yes_declared_nocard tot_false_yes_BCG_decl_nocard share_false_yes_BCG_d_nocard false_no_declared_nocard tot_false_no_BCG_decl_nocard share_false_no_BCG_d_nocard {
		gen `q'_po = `q'_w2
		drop `q'_w2
	}

tempfile tempwave
save `tempwave'	

use `BCG_diff_w3', clear

foreach q in have_scar recorded_BCG declared_BCG decl_or_record_BCG BCG_diff_declared BCG_diff_recorded total_BCG_declared_diff total_BCG_recorded_diff share_BCG_declared_diff share_BCG_recorded_diff false_yes_recorded_dummy false_yes_declared_dummy total_false_yes_BCG_rec total_false_yes_BCG_decl share_false_yes_BCG_rec share_false_yes_BCG_decl false_no_recorded_dummy false_no_declared_dummy total_false_no_BCG_rec total_false_no_BCG_decl share_false_no_BCG_rec share_false_no_BCG_decl no_record_card total_no_record_card share_no_record_card false_yes_declared_card total_false_yes_BCG_decl_card share_false_yes_BCG_decl_card false_no_declared_card total_false_no_BCG_decl_card share_false_no_BCG_decl_card false_yes_declared_nocard tot_false_yes_BCG_decl_nocard share_false_yes_BCG_d_nocard false_no_declared_nocard tot_false_no_BCG_decl_nocard share_false_no_BCG_d_nocard {
		gen `q'_po = `q'_w3
		drop `q'_w3
	}

append using `tempwave'

tempfile BCG_diff_po
save `BCG_diff_po'


********************************************
*Regressions
********************************************

cd ..\
cd "Wave III\"

foreach w in w2 w3 po {
	
  foreach z in BCG_diff {
	
	use ``z'_`w'', clear

	gen kab_id = llk02_cd
	gen prov_id = llk01_cd	
	
	local wave "`w'"
	local direc "..\Output\all\"
	
	***Creating variables to create draft tables for export to excel
	gen indicator_name 		= ""
	gen baseline_mean 		= ""
	gen mean_obs_`wave'	= .
	gen mod3_genplusA_`wave'= ""
	gen mod3_gen_`wave'		= ""
	gen mod3_genvA_`wave' 	= ""
	gen num_obs_`wave'		= .
	gen control_mean_`wave' = ""
	
    local marker=0
	local number=1
	local number_plus1=2
	
	
	egen prov_P = group(prov_id P)
	egen kab_wave = group(prov_id kab_id wave)

	if ("`wave'"=="w2" | "`wave'"=="w3"){
		local prov_P_wave "i.prov_P"
		local kab_wave "kab_wave"
	}

	if ("`wave'"=="po"){
		local prov_P_wave "i.prov_P"
		local kab_wave "kab_wave"
	}
	
	sort prov_id
	tempfile tempz
	save	`tempz'

	//Bringing in Wave 1 overall control values
	use `BCG_diff_w1', clear
	
	sort Location_ID
	disp "here00"
	mmerge Location_ID using "..\kecs_info_clean.dta"
	keep if _m==3
	drop _m

	gen kab_id = llk02_cd
	gen prov_id = llk01_cd	
	
	foreach x in false_yes_recorded_dummy false_yes_declared_dummy no_record_card{
	 cap drop  avg_`x'_w1 se_`x'_w1
	 summ `x'_w1
	 gen avg_`x'_w1 = r(mean)
	 gen se_`x'_w1 = r(sd)
	}
	keep avg_*w1 se_*w1 prov_id
	duplicates drop
	cap drop _m*
	sort prov_id
	merge prov_id using `tempz', uniqmaster _merge(_mm)
	tab _mm
	drop if _mm == 1
	drop _mm	  
	
	local var_list "false_yes_recorded_dummy false_yes_declared_dummy no_record_card"
	 
	foreach x in `var_list'{
	
	
	  local yvar "`x'_`wave'"
	  if "`wave'" == "w2"{
		local generasi "gen_year1"
		local generasi_vA "gen_year1_versi_A"
	}
	  if "`wave'" == "w3"{
		local generasi	"gen_year1or2"
		local generasi_vA "gen_year1or2_versi_A"
	}			
	  if "`wave'" == "po"{
		local generasi	"gen_pooled"
		local generasi_vA "gen_pooled_versi_A"
	}			
	
	local baseline_mean "avg_`x'_w1"
	local baseline_se "se_`x'_w1"
	local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
	local control_se "r(sd)"
	local control_add "& panel_hh == 0"
		
	****
				
	xi: areg `yvar' `generasi' `generasi_vA' `prov_P_wave', absorb(`kab_wave') cluster(Location_ID)
			
	summ `baseline_mean'
	gen baseline_mean_1 	= r(mean) 
	gen baseline_mean_2	= `baseline_se'
	tostring baseline_mean_1, replace format(%10.4f) force
	tostring baseline_mean_2, replace format(%10.4f) force
	replace baseline_mean 	= baseline_mean_1 in `number'
	replace baseline_mean	= "[" + baseline_mean_2 + "]" in `number_plus1'	
	
	**Cross sectional observations						
	summ `control_mean' `control_add' 
	gen control_mean_1 	= r(mean) 
	gen control_mean_2	= `control_se'
	tostring control_mean_1, replace format(%10.4f) force
	tostring control_mean_2, replace format(%10.4f) force
	replace control_mean_`wave' = control_mean_1 in `number'
	replace control_mean_`wave'	= "[" + control_mean_2 + "]" in `number_plus1'
		
	replace num_obs = e(N) in `number'
	
		gen mod3_gen_b 		= _b[`generasi'] 
		gen mod3_gen_se 	= _se[`generasi'] 
		tostring mod3_gen_b, replace format(%10.4f) force
		tostring mod3_gen_se, replace format(%10.4f) force
	
		test `generasi'	
		local p_val			= r(p) 	
		replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
		replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
		gen mod3_genvA_b 	=_b[`generasi_vA'] 
		gen mod3_genvA_se 	= _se[`generasi_vA'] 
		tostring mod3_genvA_b, replace format(%10.4f) force
		tostring mod3_genvA_se, replace format(%10.4f) force
		
		test `generasi_vA'	
		local p_val			= r(p) 
		replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
		replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
		lincom `generasi' + `generasi_vA' 
		gen mod3_genplusA_b 	= r(estimate)
		gen mod3_genplusA_se 	= r(se)
		tostring mod3_genplusA_b, replace format(%10.4f) force
		tostring mod3_genplusA_se, replace format(%10.4f) force
	
		test `generasi' + `generasi_vA' = 0
		local p_val			=  r(p)
		replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
		replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
		**************************
		replace indicator_name = "`x'" in `number'
	
		**************************

		local marker = 1
		local number = `number' + 2
		local number_plus1 = `number_plus1' + 2
	
		drop *mod?_gen*_b mod?_gen*_se baseline_mean_? control_mean_?
	}
 
	    outsheet indicator_name baseline_mean control_mean mod*_gen* num_obs in 1/100 using `direc'table12A_`z'_`wave', replace	
 }
}	
}

*******************************************************
//Carrying out regressions for Table 12B 
******************************************************


if `do_table12B' == 1{

***************************************************
*Calculate the attendance rates in 2008 (Wave II)
***************************************************

cd \
cd `rundir'
cd "Wave II"

//get Location_ID
use "Data\S.dta", clear

keep sid slk05 slk05a

gen type_school = slk05
gen panel_school = (slk05a==1)
replace panel_school=. if missing(slk05a)

gen Location_ID = substr(sid,1,3)

tempfile stemp1
save `stemp1'

**get attendance rates from school records (on Aug 4 or 2 weeks before)
use "Data\S_AS2TYPE.dta", clear

// keep only classes 1, 3 and 5
keep if sas2type ==1 | sas2type ==3 | sas2type ==5

summ sas1*

gen num_students_rec_w2 = sas10
gen absent_rec_w2 = sas11
gen attend_rate_rec_w2 = ((sas10-sas11) / sas10) *100
gen absent_sick_rec_w2 = sas12
gen absent_sick_rate_rec_w2 = sas12*100 / sas10
gen absent_permission_rec_w2 = sas13
gen absent_permission_rate_rec_w2 = sas13*100 / sas10
gen absent_no_perm_rec_w2 = sas14
gen absent_no_perm_rate_rec_w2 = sas14*100 / sas10

gen class_year_w2 = 1 if sas2type==1
replace class_year_w2 = 3 if sas2type==3
replace class_year_w2 = 5 if sas2type==5
tempfile stemp2
save `stemp2'

**get attendance rates from direct observation on survey day
use "Data\S_OLTYPE.dta", clear

summ sol29 sol3*

gen num_students_obs_w2 = sol29
gen absent_obs_w2 = sol29 - sol30
gen attend_rate_obs_w2 = (sol30 / sol29) *100
gen absent_sick_obs_w2 = sol31
gen absent_sick_rate_obs_w2 = sol31*100 / sol29
gen absent_permission_obs_w2 = sol32
gen absent_permission_rate_obs_w2 = sol32*100 / sol29
gen absent_no_perm_obs_w2 = sol33
gen absent_no_perm_rate_obs_w2 = sol33*100 / sol29

gen class_year_w2=1 if soltype==1
replace class_year_w2 = 3 if soltype==2
replace class_year_w2 = 5 if soltype==3

//merge in the records data and calculate difference in attendance rates

mmerge sid class_year_w2 using `stemp2'
keep if _m==3
drop _m

gen attend_rate_diff_w2 = attend_rate_rec_w2 - attend_rate_obs_w2


mmerge sid using `stemp1'
drop _m

mmerge Location_ID using "..\kecs_info_clean.dta"
drop _m

drop if drop==1
gen kab_id = llk02_cd
gen prov_id = llk01_cd

gen gen_pooled = (gen_year1 == 1)
gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
gen wave = 2

drop sol* sas*

save "..\Wave II\4_4_school_attendance_w2", replace



***************************************************
*Calculate the attendance rates in 2009 (Wave III)
***************************************************
cd ..\
cd "Wave III"

//get Location_ID
use "Data\s.dta", clear

keep sid slk05 slk05a
gen Location_ID = substr(sid,1,3)
mmerge Location_ID using "..\kecs_info_clean"
drop if _m==2
drop _m

gen type_school = slk05
gen panel_school = (slk05a==1)
replace panel_school=. if missing(slk05a)

*gen Location_ID = prov+kab+kec

tempfile stemp3
save `stemp3'


**get attendance rates from school records (on Aug 4 or 2 weeks before)
use "Data\S_AS2TYPE.dta", clear

// keep only classes 1, 3 and 5
keep if sas2type ==1 | sas2type ==3 | sas2type ==5

summ sas1*

gen num_students_rec_w3 = sas10
gen absent_rec_w3 = sas11
gen attend_rate_rec_w3 = ((sas10-sas11) / sas10) *100
gen absent_sick_rec_w3 = sas12
gen absent_sick_rate_rec_w3 = sas12*100 / sas10
gen absent_permission_rec_w3 = sas13
gen absent_permission_rate_rec_w3 = sas13*100 / sas10
gen absent_no_perm_rec_w3 = sas14
gen absent_no_perm_rate_rec_w3 = sas14*100 / sas10


gen class_year_w3 = 1 if sas2type==1
replace class_year_w3 = 3 if sas2type==3
replace class_year_w3 = 5 if sas2type==5
tempfile stemp4
save `stemp4'

**get attendance rates from direct observation on survey day
use "Data\S_OLTYPE.dta", clear

summ sol29 sol3*

gen num_students_obs_w3 = sol29
gen absent_obs_w3 = sol29 - sol30
gen attend_rate_obs_w3 = (sol30 / sol29) *100
gen absent_sick_obs_w3 = sol31
gen absent_sick_rate_obs_w3 = sol31*100 / sol29
gen absent_permission_obs_w3 = sol32
gen absent_permission_rate_obs_w3 = sol32*100 / sol29
gen absent_no_perm_obs_w3 = sol33
gen absent_no_perm_rate_obs_w3 = sol33*100 / sol29

gen class_year_w3=1 if soltype==1
replace class_year_w3 = 3 if soltype==2
replace class_year_w3 = 5 if soltype==3

//merge in the records data and calculate difference in attendance rates

mmerge sid class_year_w3 using `stemp4'
keep if _m==3
drop _m


gen attend_rate_diff_w3 = attend_rate_rec_w3 - attend_rate_obs_w3


mmerge sid using `stemp3'
drop _m

mmerge Location_ID using "..\kecs_info_clean.dta"
drop _m

drop if drop==1
gen kab_id = llk02_cd
gen prov_id = llk01_cd


gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)

gen wave = 3

drop sol* sas*


save "..\Wave III\4_4_school_attendance_w3", replace

********************************
*Pooled
********************************
use "..\Wave II\4_4_school_attendance_w2", replace


foreach x in attend_rate_obs attend_rate_rec attend_rate_diff{
   gen `x'_po = `x'_w2
   drop `x'_w2
}


tempfile pooled0
save `pooled0'


use "..\Wave III\4_4_school_attendance_w3", replace

foreach x in attend_rate_obs attend_rate_rec attend_rate_diff{
   gen `x'_po = `x'_w3
   drop `x'_w3
}

append using `pooled0'

save "..\Wave III\4_4_school_attendance_po", replace


********************************************
*Regressions
********************************************


foreach w in 4_4_school_attendance_w2 4_4_school_attendance_w3 4_4_school_attendance_po {
	
	if ("`w'"=="4_4_school_attendance_w2"){
	  use "..\Wave II\4_4_school_attendance_w2", clear
	  local wave "w2"
	}
	if ("`w'"=="4_4_school_attendance_w3"){
	  use "..\Wave III\4_4_school_attendance_w3", clear
	  local wave "w3"
	}
	if ("`w'"=="4_4_school_attendance_po"){
	  use "..\Wave III\4_4_school_attendance_po", clear
	  local wave "po"
	}
	 

	local direc "..\Output\all\"
	
	egen prov_P = group(prov_id P)			
	egen kab_wave = group(prov_id kab_id wave)
	
	***Creating variables to create draft tables for export to excel
	gen indicator_name 		= ""
	gen baseline_mean 		= ""
	gen mean_obs_`wave'	= .
	gen sd_obs_`wave' = .
	gen mod3_genplusA_`wave'= ""
	gen mod3_gen_`wave'		= ""
	gen mod3_genvA_`wave' 	= ""
	gen num_obs_`wave'		= .
		
	
	
	if ("`wave'"=="w2" | "`wave'"=="w3"){
		local prov_P_wave "i.prov_P"
		local panel_wave "panel_school"
		local type_school_wave "i.type_school"
		local kab_wave "kab_wave"
		local class_year_wave "i.class_year_`wave'"
	}

	if ("`wave'"=="po"){
		local prov_P_wave "i.prov_P"
		local panel_wave "panel_school"
		local type_school_wave "i.type_school"
		local kab_wave "kab_wave"
		local class_year_wave "i.class_year_po"
	}

	local var_list "attend_rate_obs attend_rate_rec attend_rate_diff"

	local marker=0
	local number=1
	local number_plus1=2
	
	foreach x in `var_list'{
	 
	  local yvar "`x'_`wave'"
	  if "`wave'" == "w2"{
		local generasi "gen_year1"
		local generasi_vA "gen_year1_versi_A"
	}
	  if "`wave'" == "w3"{
		local generasi	"gen_year1or2"
		local generasi_vA "gen_year1or2_versi_A"
	}			
	  if "`wave'" == "po"{
		local generasi	"gen_pooled"
		local generasi_vA "gen_pooled_versi_A"
	}			
	
		
				
	
	
	
	
	****
				
	xi: areg `yvar' `generasi' `generasi_vA' `prov_P_wave', absorb(`kab_wave') cluster(Location_ID)
			

	summ `yvar' if e(sample) & intervention == "3"
	replace mean_obs=r(mean) in `number'
	replace sd_obs = r(sd) in `number'
	replace num_obs = e(N) in `number'
	
	
		gen mod3_gen_b 		= _b[`generasi'] 
		gen mod3_gen_se 	= _se[`generasi'] 
		tostring mod3_gen_b, replace format(%10.4f) force
		tostring mod3_gen_se, replace format(%10.4f) force
	
		test `generasi'	
		local p_val			= r(p) 	
		replace mod3_gen_`wave'		= mod3_gen_b if `p_val' >= 0.1 in `number'
		replace mod3_gen_`wave'		= "(" + mod3_gen_se + ")" in `number_plus1'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_gen_`wave'	 	= mod3_gen_b + "***" if `p_val' < 0.01 in `number'
	 
		gen mod3_genvA_b 	=_b[`generasi_vA'] 
		gen mod3_genvA_se 	= _se[`generasi_vA'] 
		tostring mod3_genvA_b, replace format(%10.4f) force
		tostring mod3_genvA_se, replace format(%10.4f) force
		
		test `generasi_vA'	
		local p_val			= r(p) 
		replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
		replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
	
		lincom `generasi' + `generasi_vA' 
		gen mod3_genplusA_b 	= r(estimate)
		gen mod3_genplusA_se 	= r(se)
		tostring mod3_genplusA_b, replace format(%10.4f) force
		tostring mod3_genplusA_se, replace format(%10.4f) force
	
		test `generasi' + `generasi_vA' = 0
		local p_val			=  r(p)
		replace mod3_genplusA_`wave'	= mod3_genplusA_b if `p_val' >= 0.1 in `number'
		replace mod3_genplusA_`wave'	= "(" + mod3_genplusA_se + ")" in `number_plus1'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
		replace mod3_genplusA_`wave'	= mod3_genplusA_b + "***" if `p_val' < 0.01 in `number'
	
		**************************
		replace indicator_name = "`x'" in `number'
	
		**************************

		local marker = 1
		local number = `number' + 2
		local number_plus1 = `number_plus1' + 2
	
		drop *mod?_gen*_b mod?_gen*_se
	}
	
	    outsheet indicator_name mean_obs sd_obs mod*_gen* num_obs in 1/100 using `direc'table12B_`wave', replace	
}	
	
}


if `do_table12C' == 1 {

	set more off
	cd\
	cd `rundir'
	
	******************************************
	** Generate w2 MIS info
	******************************************
	cd "Wave II"

	//Load relevant variables for Form 17 from MIS data
	use "..\Wave III\MIS Data\f17-2007_clean.dta", clear

	rename  totalin1 c_pre_natal_visits_w2 
	rename  totalin2 c_iron_pills_w2 
	rename  totalin3a c_good_assisted_delivery_w2 
	rename  totalin4 c_post_natal_visits_w2 

	rename  totalin5 c_imm_total_w2 
	rename  totalin6 c_weight_increased_w2 
	rename  totalin7 c_times_weighed_last3months_w2 
	rename  totalin8 c_vitA_total_w2 

	rename  totalin9 c_enroll_age6to12_SD_w2 
	rename  totalin10 c_age6to12_SD_85_twoweeks_w2 
	rename  totalin11 c_enroll_age13to15_SMP_w2 
	rename  totalin12 c_age13to15_SMP_85_twoweeks_w2 


	gen Location_ID= ea

	keep Location_ID id_desa_clean c_*
	duplicates drop
	sort id_desa_clean

	tempfile capaian
	save `capaian', replace

	use "..\Wave III\MIS Data\form 6-2007_clean.dta", clear

	gen Location_ID= ea
	duplicates drop

	bys id_desa_clean: gen y=_N
	drop if y>1
	drop y

	sort id_desa_clean

	merge 1:1 id_desa_clean using `capaian'
	tab _merge

	keep if _merge==3
	drop _merge

	gen pre_natal_visits_w2 	= c_pre_natal_visits_w2/a0
	gen iron_pills_w2 		= c_iron_pills_w2/a0
	gen good_assisted_delivery_w2 	= c_good_assisted_delivery_w2/a0
	gen post_natal_visits_w2 	= c_post_natal_visits_w2/a0

	gen imm_total_w2 		= c_imm_total_w2/(a0+a1)
	gen weight_increased_w2 	= c_weight_increased_w2/(a0+a1)
	gen times_weighed_last3months_w2 = c_times_weighed_last3months_w2/(a0+a1)
	gen vitA_total_w2	 	= c_vitA_total_w2/(a0+a1)

	gen enroll_age6to12_SD_w2 	= c_enroll_age6to12_SD_w2/a2
	gen age6to12_SD_85_twoweeks_w2 	= c_age6to12_SD_85_twoweeks_w2/a2
	gen enroll_age13to15_SMP_w2 	= c_enroll_age13to15_SMP_w2/a3
	gen age13to15_SMP_85_twoweeks_w2 = c_age13to15_SMP_85_twoweeks_w2/a3

	foreach var of varlist jml_penduduk jml_kk jml_kk_miskin a0 a1 a2 a3 jarak_smp bidan jarak_puskesmas {
		rename `var' `var'_w2
	}

	sort Location_ID
	tempfile a
	save `a', replace

	use "..\kecs_info_clean.dta", clear
	drop gen_year2 gen_year2_versi_A

	//Merge kecamatan type info with program expenses info
	merge Location_ID using `a', uniqmaster
	tab _merge
	drop if _merge==1
	drop _m

	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)	
	gen wave = 2

	duplicates drop

	save main_indicator_MIS_w2, replace
	
	******************************************
	** Generate w3 MIS info
	******************************************	
	cd ..\
	cd "Wave III"
	use "MIS Data\form 6-17_2008_clean", clear

	rename  capaian1 c_pre_natal_visits_w3 
	rename  capaian2 c_iron_pills_w3 
	rename  capaian3 c_good_assisted_delivery_w3 
	rename  capaian4 c_post_natal_visits_w3 

	rename  capaian5 c_imm_total_w3 
	rename  capaian6 c_weight_increased_w3 
	rename  capaian7 c_times_weighed_last3months_w3 
	rename  capaian8 c_vitA_total_w3 

	rename  capaian9 c_enroll_age6to12_SD_w3 
	rename  capaian10 c_age6to12_SD_85_twoweeks_w3 
	rename  capaian11 c_enroll_age13to15_SMP_w3 
	rename  capaian12 c_age13to15_SMP_85_twoweeks_w3 

	gen pre_natal_visits_w3 	= c_pre_natal_visits_w3/a0
	gen iron_pills_w3 		= c_iron_pills_w3/a0
	gen good_assisted_delivery_w3 	= c_good_assisted_delivery_w3/a0
	gen post_natal_visits_w3 	= c_post_natal_visits_w3/a0

	gen imm_total_w3 		= c_imm_total_w3/(a0+a1)
	gen weight_increased_w3 	= c_weight_increased_w3/(a0+a1)
	gen times_weighed_last3months_w3 = c_times_weighed_last3months_w3/(a0+a1)
	gen vitA_total_w3	 	= c_vitA_total_w3/(a0+a1)

	gen enroll_age6to12_SD_w3 	= c_enroll_age6to12_SD_w3/a2
	gen age6to12_SD_85_twoweeks_w3 	= c_age6to12_SD_85_twoweeks_w3/a2
	gen enroll_age13to15_SMP_w3 	= c_enroll_age13to15_SMP_w3/a3
	gen age13to15_SMP_85_twoweeks_w3 = c_age13to15_SMP_85_twoweeks_w3/a3

	foreach var of varlist  jml_penduduk jmlkk jml_kkmskn a0 a0_non_user a1 a1_non_user a2 a2_non_user a3 a3_non_user jrk_smp__km_ bidan jrkpuskesmas__km_ {
		rename `var' `var'_w3
	}

	gen Location_ID = ea
	sort Location_ID
	
	//Merge kecamatan type info with program expenses info
	merge m:1 Location_ID using "..\kecs_info_clean"
	tab _merge
	drop if _merge==2
	drop _m

	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)	
	gen wave = 3

	save main_indicator_MIS_alternatif_w3, replace
 
	**********
	** Generate w2 and w3 HH main indicator info
	**********
	
	cd ..\
	cd "Wave I"
	
	use table_1_2_vars_generasi_w1, clear
	
	//Keeping only non-drop kecamatan
	cap drop _merge
	sort Location_ID
	merge Location_ID using `kecs_match_for_avg', uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Creating kecamatan level Wave 1 averages of the 12 indicator variables (+ 4 other alt specs) [not want to do the kab average fill in for the gross enrollment kec variables, since doing regression at kec level]
	foreach x of var  pre_natal_visits_w1 good_assisted_delivery_w1 post_natal_visits_w1 iron_pills_categ_w1 imm_uptak_pct_23mons_w1 times_weighed_last3months_w1 vitA_total_6mons_2years_w1 mal_weightforage_w1 enroll_age7to12_w1 enroll_age13to15_w1 age7to12_pct_twoweeks_w1 age13to15_pct_twoweeks_w1 cond_age13to15_pct_2wks_w1 enroll_age13to15_SMP_w1 enroll_age7to12_SD_w1 enroll_age13to15_other_w1 imm_total_w1 vitA_total_w1{ 
		bys Location_ID: egen kec_`x' = mean(`x')
		bys kab_id:		egen kab_`x' = mean(`x')	
		replace kec_`x' = kab_`x' if kec_`x' == .
	}
	
	drop _merge
	keep Location_ID kec_*_w1 kab_*_w1
	duplicates drop 
	
	sort Location_ID
	tempfile kec_avg_w1
	save `kec_avg_w1'
	
	****
	
	use Data\R, clear
	
	gen panel_hh_id_back_w2 = substr(rid,1,3) + substr(rid,5,5) + "00"
	gen panel_hh_id_back_w3 = substr(rid,1,3) + substr(rid,5,5) + "00" + "00"
	
	//Renaming variable for use to fill in information for panel households in wave 2
	rename rlk12  HH_type_fill
	
	keep panel_hh_id_back* HH_type_fill
	duplicates drop
	tempfile tempback
	save `tempback'

	drop panel_hh_id_back_w3
	sort panel_hh_id_back_w2
	tempfile hhtype_w2
	save `hhtype_w2'
	
	use `tempback'
	drop panel_hh_id_back_w2
	sort panel_hh_id_back_w3
	tempfile hhtype_w3
	save `hhtype_w3'

	
	********************************************
	*****           Wave II                ***** 
	********************************************
	
	
	cd ..\
	cd "Wave II"
	
	use table_1_2_vars_w2_with_w1controls, clear
	
	drop _merge
	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
	drop _merge
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 2 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	sort panel_hh_id_back_w2
	merge panel_hh_id_back_w2 using `hhtype_w2', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	
	****

	** New household - Wave II info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	
	

**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	
	***
	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other  imm_total vitA_total{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
		
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w2 -gross_SD_enroll_kec_w2 -gross_SMP_enroll_kec_w1 -gross_SD_enroll_kec_w1
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	
	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)
	
	gen wave = 2


	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
	
	save main_indicator_HH_w2, replace


	************************************
	*Wave III
	************************************

	cd ..\
	cd "Wave III"
	
	use table_1_2_vars_generasi_w3_with_w1controls, clear

	drop _merge

	
	//Merging in treatment/control information
	sort Location_ID
	merge Location_ID using "..\kecs_info_clean", uniqusing
	tab _merge
	keep if _merge == 3
		
	
	//Dropping observations from the drop kec list
	drop if drop == 1
	cap drop _m*
	
	//Merging in kec level wave 1 values to the wave 3 data
	sort Location_ID
	merge Location_ID using `kec_avg_w1', uniqusing
	tab _merge
	
	drop if _merge == 2
	drop _merge
	
	
	sort panel_hh_id_back_w3
	merge panel_hh_id_back_w3 using `hhtype_w3', uniqusing _merge(_m2)
	tab _m2 panel_hh, m
	
	drop if _m2 == 2
	drop _m2
	
	** Merge in 12 main indicator kec avg levels from baseline
	cap drop _merge
	sort Location_ID
	merge Location_ID using `k12_avg_w1', uniqusing
	tab _merge
	drop if _merge == 2
	drop _m*

	
	****

	** New household - Wave III info 	-> hh_type
	** Panel household - Wave I info	-> hh_type_fill
	** Split household - Wave I info	-> hh_type_fill

	tab HH_type HH_type_fill, m
	
	****
	
	**Panel and split are panel HH's 
	cap drop panel_hh
	gen panel_hh = (rar00x == 1 | rar00x == 2)

	replace HH_type = HH_type_fill if panel_hh == 1
	tab HH_type rar00x, m

	**Include missing option so that those with HH_type info still missing and those with panel_hh info n/a are put into own groups
	egen HH_type_and_panel = group(HH_type panel_hh), missing
	
	****
	
	destring prov_id, replace
	
	
	gen categ = ""
	gen sub_categ = ""
	
	foreach x of numlist 1/18{
		gen indic_`x'_gen_1plusA = .
		gen indic_`x'_gen_2plusA = .
	}
	
	replace categ = "Generasi Year 1, Versi A" in 1
	replace sub_categ = "Coeff" in 2
	replace sub_categ = "SE" in 3
	replace sub_categ = "P-val" in 4
	
	replace categ = "Generasi Year 1, Year 2, Versi A" in 5
	replace sub_categ = "Coeff" in 6
	replace sub_categ = "SE" in 7
	replace sub_categ = "P-val" in 8
	
	
	//Creating age value that will not overlap with any true age values to create a dummy group for those children with missing ages
	//(this okay since doing dummies for age use the i.age_years method below)
	**Are actually no children presently with missing age_years, but have this in case need in future
	replace age_years = 8888 if age_years == . & obs_type != 6
	
	//Generating variable for the interaction of province and P
	egen prov_P = group(prov_id P)
	

	

	**Only have gross enrollment wave I values for those in original wave, so need to apply values to all obs
	foreach q in gross_SD_enroll_kec gross_SMP_enroll_kec{
		bys Location_ID: egen `q'_w1_temp = max(`q'_w1) if obs_type == 10
		replace `q'_w1 = `q'_w1_temp if obs_type == 10
		drop `q'_w1_temp
	}
	

	
	**generating dummy for whether the wave 1 individual level control variable is missing
	foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3months vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other  imm_total vitA_total{
		gen ind_`x'_m1 = (`x'_w1 == .)
		gen ind_`x'_w1 = `x'_w1
		replace ind_`x'_w1 = 0 if `x'_w1 == .
	}
	
	
	
	gen include_x = 0
	
	gsort Location_ID obs_type -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3 -gross_SMP_enroll_kec_w3 -gross_SD_enroll_kec_w3
	by Location_ID obs_type: replace include_x = 1 if _n == 1 & obs_type == 10
	

	gen wave = 3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)



		
	save main_indicator_HH_w3, replace	

	************
	** Combine HH and MIS info
	************
	
	********************************************
	*****           Wave II                ***** 
	********************************************
	
	cd ..\
	cd "Wave II"
	
	use Data\R, clear
	gen ea = substr(rid,1,3)
	gen vill = substr(rid,5,3)

	keep rid ea vill
	
	gen id_desa_clean = ea + vill
	duplicates drop
	sort rid
	tempfile k1
	save `k1', replace

	use main_indicator_HH_w2, clear

	rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
	rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1 
	rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1
	rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
	rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
	rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
	rename times_weighed_last3months_w1 times_weighed_last3m_w1
	rename times_weighed_last3months_w2 times_weighed_last3m_w2

	foreach var of varlist pre_natal_visits_w2 good_assisted_delivery_w2 post_natal_visits_w2 iron_pills_categ_w2 imm_total_w2 times_weighed_last3m_w2 vitA_total_w2 mal_weightforage_w2  enroll_age7to12_w2 enroll_age13to15_w2 age7to12_pct_twoweeks_w2 age13to15_pct_twoweeks_w2 {
		rename `var' HH_`var'	
	}	
	sort rid
	merge m:1 rid using `k1'
	tab _merge
	keep if _merge==3
	drop _merge
	
	sort id_desa_clean
	tempfile k2
	save `k2', replace

	use main_indicator_MIS_w2, clear
	
	rename iron_pills_w2 			iron_pills_categ_w2
	rename weight_increased_w2  		mal_weightforage_w2  
	rename enroll_age6to12_SD_w2 		enroll_age7to12_w2 
	rename age6to12_SD_85_twoweeks_w2 	age7to12_pct_twoweeks_w2
	rename enroll_age13to15_SMP_w2 		enroll_age13to15_w2 
	rename age13to15_SMP_85_twoweeks_w2 	age13to15_pct_twoweeks_w2
	rename times_weighed_last3months_w2 	times_weighed_last3m_w2
	
	foreach var of varlist pre_natal_visits_w2 good_assisted_delivery_w2 post_natal_visits_w2 iron_pills_categ_w2 imm_total_w2 times_weighed_last3m_w2 vitA_total_w2 mal_weightforage_w2  enroll_age7to12_w2 enroll_age13to15_w2 age7to12_pct_twoweeks_w2 age13to15_pct_twoweeks_w2 {
		rename `var' MIS_`var'	
	}	
	sort id_desa_clean
	merge 1:m id_desa_clean using `k2'
	tab _merge

	
	keep if _merge==3
	drop _merge

	local var_list "pre_natal_visits_w2 good_assisted_delivery_w2 post_natal_visits_w2 iron_pills_categ_w2 imm_total_w2 times_weighed_last3m_w2 vitA_total_w2 mal_weightforage_w2  enroll_age7to12_w2 enroll_age13to15_w2 age7to12_pct_twoweeks_w2 age13to15_pct_twoweeks_w2"

	foreach x of local var_list {
		gen d_`x' = MIS_`x' - HH_`x'	
	}	

		destring prov_id, replace
		cap drop prov_P
		egen prov_P = group(prov_id P)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)
				                                      
	**Saving list of kecs not dropped for use in constructing comparable baseline mean
	preserve
	keep Location_ID
	duplicates drop
	sort Location_ID
	tempfile nodrop_kecs
	save `nodrop_kecs'
	restore
		
	save main_indicator_HHandMIS_w2_suest, replace


************************************
*Wave III
************************************

	cd ..\
	cd "Wave III"
	
	use Data\R, clear

	gen ea = substr(rid,1,3)
	gen vill = substr(rid,5,3)

	keep rid ea vill
	
	gen id_desa_clean = ea + vill
	
	duplicates drop
	sort rid
	tempfile k1
	save `k1', replace

	use main_indicator_HH_w3, clear

	rename k12_times_weighed_last3months_w1 k12_times_weighed_last3m_w1 /* the name is too long, max name character is 32 */
	rename ka12times_weighed_last3months_w1 ka12times_weighed_last3m_w1 
	rename kab_times_weighed_last3months_w1 kab_times_weighed_last3m_w1	
	rename kec_times_weighed_last3months_w1 kec_times_weighed_last3m_w1
	rename ind_times_weighed_last3months_w1 ind_times_weighed_last3m_w1
	rename ind_times_weighed_last3months_m1 ind_times_weighed_last3m_m1
	rename times_weighed_last3months_w1 times_weighed_last3m_w1				
	rename times_weighed_last3months_w3 times_weighed_last3m_w3

	foreach var of varlist pre_natal_visits_w3 good_assisted_delivery_w3 post_natal_visits_w3 iron_pills_categ_w3 imm_total_w3 times_weighed_last3m_w3 vitA_total_w3 mal_weightforage_w3  enroll_age7to12_w3 enroll_age13to15_w3 age7to12_pct_twoweeks_w3 age13to15_pct_twoweeks_w3 {
		rename `var' HH_`var'	
	}	
	sort rid
	merge m:1 rid using `k1'
	tab _merge
	keep if _merge==3
	drop _merge
	
	sort id_desa_clean
	tempfile k2
	save `k2', replace
	
	use main_indicator_MIS_alternatif_w3, clear


	rename iron_pills_w3 			iron_pills_categ_w3
	rename weight_increased_w3  		mal_weightforage_w3  
	rename enroll_age6to12_SD_w3 		enroll_age7to12_w3 
	rename age6to12_SD_85_twoweeks_w3 	age7to12_pct_twoweeks_w3
	rename enroll_age13to15_SMP_w3 		enroll_age13to15_w3 
	rename age13to15_SMP_85_twoweeks_w3 	age13to15_pct_twoweeks_w3
	rename times_weighed_last3months_w3 	times_weighed_last3m_w3

	foreach var of varlist pre_natal_visits_w3 good_assisted_delivery_w3 post_natal_visits_w3 iron_pills_categ_w3 imm_total_w3 times_weighed_last3m_w3 vitA_total_w3 mal_weightforage_w3  enroll_age7to12_w3 enroll_age13to15_w3 age7to12_pct_twoweeks_w3 age13to15_pct_twoweeks_w3 {
		rename `var' MIS_`var'	
	}	
	sort id_desa_clean
	merge 1:m id_desa_clean using `k2'
	tab _merge
	keep if _merge==3
	drop _merge

	local var_list "pre_natal_visits_w3 good_assisted_delivery_w3 post_natal_visits_w3 iron_pills_categ_w3 imm_total_w3 times_weighed_last3m_w3 vitA_total_w3 mal_weightforage_w3  enroll_age7to12_w3 enroll_age13to15_w3 age7to12_pct_twoweeks_w3 age13to15_pct_twoweeks_w3"

	foreach x of local var_list {
		gen d_`x' = MIS_`x' - HH_`x'	
	}	

	
		destring prov_id, replace
		cap drop prov_P
		egen prov_P = group(prov_id P)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
				tab prov_P, gen(prov_P_)
				tab HH_type_and_panel, gen(HH_type_and_panel_)
				tab age_years, gen(age_years_)

		
	save main_indicator_HHandMIS_w3_suest, replace
	
************************************
*Pooled
************************************

	cd ..\
	cd "Wave III"
	
	//pooled
	use "..\Wave II\main_indicator_HHandMIS_w2_suest", clear
 
	foreach x in  d_pre_natal_visits d_good_assisted_delivery d_post_natal_visits d_iron_pills_categ d_imm_total d_times_weighed_last3m d_vitA_total d_mal_weightforage  d_enroll_age7to12 d_enroll_age13to15 d_age7to12_pct_twoweeks d_age13to15_pct_twoweeks  {
    		rename `x'_w2 `x'_po
	}

	keep wave *_po *_w1 *_m1 id panel_hh obs_type HH_id rid kab_id Location_ID prov_id prov_P P age_years HH_type HH_type_fill HH_type_and_panel intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x control_pnpmyr2

	tempfile temp0
	save `temp0', replace

	use "main_indicator_HHandMIS_w3_suest", clear
	 
	foreach x in  d_pre_natal_visits d_good_assisted_delivery d_post_natal_visits d_iron_pills_categ d_imm_total d_times_weighed_last3m d_vitA_total d_mal_weightforage  d_enroll_age7to12 d_enroll_age13to15 d_age7to12_pct_twoweeks d_age13to15_pct_twoweeks  {
    		rename `x'_w3 `x'_po
	}

	keep wave *_po *_w1 *_m1 id panel_hh HH_id obs_type rid kab_id Location_ID prov_id prov_P P age_years HH_type HH_type_fill HH_type_and_panel intervention gen_year1 gen_year2 gen_year1_versi_A gen_year2_versi_A gen_year1or2 gen_year1or2_versi_A obs_type type gen_pooled gen_pooled_versi_A rar00x control_pnpmyr2
	append using `temp0'

	gen wave_3 = wave==3

		destring prov_id, replace
		cap drop prov_P
		egen prov_P = group(prov_id P)

	**Generating dummies equivalent to FE methods used previously (can't use areg, xi, etc. b/c of suest being particular)
			tab prov_P, gen(prov_P_)
			tab HH_type_and_panel, gen(HH_type_and_panel_)
			tab age_years, gen(age_years_)

			rename age13to15_fullattend_twoweeks_w1 age13to15_fullattend_2weeks_w1	
							
			local prov_P_group "prov_P_*"
			local type_panel_group "HH_type_and_panel_*"
			local age_vals_group "age_years_*"
			local ind_val_m1_group "ind_*_m1"
			local group_kec_w1 "*_w1"
				
			foreach q of varlist `prov_P_group' `type_panel_group' `age_vals_group' `ind_val_m1_group' `group_kec_w1'{
				gen `q'w = wave_3 * `q'
				}


	save "main_indicator_HHandMIS_po_suest", replace
	
***********************************
* Regressions
***********************************

cd ..\
cd "Wave III"

foreach wave in w2 w3 po {
	foreach z in indcontrols {

		if "`wave'" == "w2" {
			use "..\Wave II\main_indicator_HHandMIS_w2_suest", clear
		}
		if "`wave'" == "w3" {
			use "main_indicator_HHandMIS_w3_suest", clear
		}
		if "`wave'" == "po" {
			use "main_indicator_HHandMIS_po_suest", clear
		}

		local wave "`wave'"
		local direc "..\Output\all\"
		
		destring kab_id, replace
		egen kab_wave = group(prov_id kab_id wave)

	
		***Creating variables to create draft tables for export to excel
		gen indicator_name 		= ""
		gen mod3_genvA_`wave' 		= ""
		gen num_obs_`wave'		= .

			gen indicator_name_avgSE 				= ""
			gen control_avgSE_`wave' 				= ""
			gen mod3_genvA_avgSE_`wave' 		= ""

			sort prov_id
			tempfile tempz
			save	`tempz'

			//Bringing in Wave 1 overall control values
			use "..\Wave I\table_1_2_vars_generasi_w1", clear	
			destring prov_id, replace
		
			sort Location_ID
			merge Location_ID using `nodrop_kecs', uniqusing _merge(_mergenodrop)
			keep if _mergenodrop == 3
			drop _mergenodrop

	
			gen 		baseline_weight = 3/2 if HH_type == 1
			replace baseline_weight = 1/2 if HH_type == 2
			replace baseline_weight = 1   if HH_type == 3

			rename  times_weighed_last3months_w1  times_weighed_last3m_w1
			rename  times_weighed_last2months_w1  times_weighed_last2m_w1

			**Generating baseline means
			foreach x in pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_uptak_pct_23mons times_weighed_last3m vitA_total_6mons_2years mal_weightforage enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks cond_age13to15_pct_2wks enroll_age13to15_SMP enroll_age7to12_SD enroll_age13to15_other imm_total vitA_total{
				cap drop avg_`x'_w1 se_`x'_w1
				summ `x'_w1 [weight = baseline_weight]
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}

			foreach x in gross_SMP_enroll_kec gross_SD_enroll_kec{
				cap drop avg_`x'_w1 se_`x'_w1
				cap drop include_x_w1
				bys obs_type Location_ID: gen include_x_w1 = 1 if _n == 1 & obs_type == 10 
				summ `x'_w1 if include_x_w1 == 1
				gen avg_`x'_w1 = r(mean)
				gen se_`x'_w1 = r(sd)
			}		

			keep avg_*w1 se_*w1 prov_id
			duplicates drop
			cap drop _m*
			sort prov_id
			merge prov_id using `tempz', uniqmaster _merge(_mm)
			tab _mm
			drop if _mm == 1
			drop _mm	  
	
		local var_list "pre_natal_visits good_assisted_delivery post_natal_visits iron_pills_categ imm_total times_weighed_last3m vitA_total enroll_age7to12 enroll_age13to15 age7to12_pct_twoweeks age13to15_pct_twoweeks"
		
		local marker = 0
		local count = 1
		local number = 1
		local number_plus1 = 2
		local var_num = 1
	
		local pick = 1

			gen wave3 = (wave == 3)
		
		foreach x in `var_list'{	 

			if ("`x'" == "gross_SD_enroll_kec" | "`x'" == "gross_SMP_enroll_kec"){
				gen wv_`x'_int = `x'_w1 * wave3
			}
			else{
				gen wv_`x'_int = ind_`x'_w1 * wave3
			}

			disp "*******`x'_`wave'**********"

			cap drop kab_wave* 
			sort kab_id wave
			egen kab_wave = group(prov_id kab_id wave)
			tab kab_wave, gen(kab_wave_)

				if "`wave'" == "w2" | "`wave'" == "w3"{
					local k12_val_w1_wave "k12_*_w1"
					local kec_val_w1_wave "kec_`x'_w1"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1"
					local ind_val_m1_wave "ind_`x'_m1"
					local kab_wave "kab_id"
					local gross_kec_w1 "`x'_w1"
					local gross_k12_wl "k12_*_w1"
				}

				if "`wave'" == "po"{	
					local k12_val_w1_wave "k12_pre_natal_visits_w1* k12_good_assisted_delivery_w1* k12_post_natal_visits_w1* k12_iron_pills_categ_w1* k12_imm_uptak_pct_23mons_w1* k12_times_weighed_last3m_w1* k12_vitA_total_6mons_2years_w1* k12_mal_weightforage_w1* k12_enroll_age7to12_w1* k12_enroll_age13to15_w1* k12_age7to12_pct_twoweeks_w1* k12_age13to15_pct_twoweeks_w1*"
					local kec_val_w1_wave "kec_`x'_w1*"
					local prov_P_wave "prov_P_*"
					local type_panel_wave "HH_type_and_panel_*"
					local age_vals_wave "age_years_*"
					local ind_val_wave "ind_`x'_w1*"
					local ind_val_m1_wave "ind_`x'_m1*"
					local kab_wave "kab_wave"
					local gross_kec_w1 "`x'_w1*"
				}


				if "`z'" == "indcontrols" {
					local yvar "d_`x'_`wave'"
					local kec_val_w1 "`kec_val_w1_wave'"
					local prov_P "`prov_P_wave'"
					local type_panel "`type_panel_wave'"
					local age_vals "`age_vals_wave'"
					local ind_val "`ind_val_wave'"
					local ind_val_m1 "`ind_val_m1_wave'"
					local baseline_mean "avg_`x'_w1"
					local baseline_se "se_`x'_w1"
					local control_mean "`yvar' if e(sample) == 1 & intervention == "3""
					local control_se "r(sd)"
					}	

			if "`wave'" == "w2"{
				local generasi "gen_year1"
				local generasi_vA "gen_year1_versi_A"
			}
			if "`wave'" == "w3"{
				local generasi	"gen_year1or2"
				local generasi_vA "gen_year1or2_versi_A"
			}			
			if "`wave'" == "po"{
				local generasi	"gen_pooled"
				local generasi_vA "gen_pooled_versi_A"
			}			
		****

			****
				
			quie xi: reg `yvar' `generasi_vA' `ind_val' `ind_val_m1' `kec_val_w1' `age_vals' `type_panel' `prov_P' kab_wave_*
		
			noi estimates store var`var_num'_eg1vA	

			replace num_obs = e(N) in `number'
			tempvar samplevar
			g `samplevar' = e(sample)
				
			summ `yvar' if `samplevar' == 1 & intervention == "2"
			local sd1vA_`var_num' = r(sd)	
	 
			gen mod3_genvA_b 	=_b[`generasi_vA'] 
			gen mod3_genvA_se 	= _se[`generasi_vA'] 
			tostring mod3_genvA_b, replace format(%10.4f) force
			tostring mod3_genvA_se, replace format(%10.4f) force
		
			test `generasi_vA'	
			local p_val			= r(p) 
			replace mod3_genvA_`wave'	= mod3_genvA_b if `p_val' >= 0.1 in `number'
			replace mod3_genvA_`wave'	= "(" + mod3_genvA_se + ")" in `number_plus1'
			replace mod3_genvA_`wave'	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `number'
			replace mod3_genvA_`wave'	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `number'
			replace mod3_genvA_`wave'	= mod3_genvA_b + "***" if `p_val' < 0.01 in `number'
		
			**************************
			replace indicator_name = "`x'" in `number'
	

			**************************

			local marker = 1
			local count = `count' + 1
			local number = `number' + 2
			local number_plus1 = `number_plus1' + 2
			local var_num = `var_num' + 1
		
	
			drop *mod?_gen*_b mod?_gen*_se	
	
			}
	
	
			local line_num = 1
			local line_num_plus1 = `line_num' + 1
			local line_num_plus2 = `line_num' + 2
			local line_num_plus3 = `line_num' + 3
			local line_num_plus4 = `line_num' + 4
			local line_num_plus5 = `line_num' + 5
			
  				suest var1_eg1vA var2_eg1vA var3_eg1vA var4_eg1vA var5_eg1vA var6_eg1vA var7_eg1vA var8_eg1vA var9_eg1vA var10_eg1vA var11_eg1vA, cluster(Location_ID)
				 			
				*Total
				*SE, VA
				lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11') / 11)
				gen mod3_genvA_b 		= r(estimate) 
				gen mod3_genvA_se 		= r(se) 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
	
				test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7' + [var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11') / 11) = 0			
				local p_val			=  r(p)
				replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num'
				replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus1'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num'

				*Health
	
				lincom (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7') / 7)
				drop mod?_gen*_b mod?_gen*_se
				gen mod3_genvA_b			= r(estimate) 
				gen mod3_genvA_se 		= r(se) 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force

				test (([var1_eg1vA_mean]`generasi_vA'/`sd1vA_1' + [var2_eg1vA_mean]`generasi_vA'/`sd1vA_2' + [var3_eg1vA_mean]`generasi_vA'/`sd1vA_3' + [var4_eg1vA_mean]`generasi_vA'/`sd1vA_4' + [var5_eg1vA_mean]`generasi_vA'/`sd1vA_5' + [var6_eg1vA_mean]`generasi_vA'/`sd1vA_6' + [var7_eg1vA_mean]`generasi_vA'/`sd1vA_7') / 7) = 0
				local p_val			=  r(p)
				replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus2'
				replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus3'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus2'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus2'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus2'	
					
				*Education	
				
				lincom (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11') / 4)
				drop mod?_gen*_b mod?_gen*_se
				gen mod3_genvA_b			= r(estimate) 
				gen mod3_genvA_se 		= r(se) 
				tostring mod3_genvA_b, replace format(%10.4f) force
				tostring mod3_genvA_se, replace format(%10.4f) force
	
				test (([var8_eg1vA_mean]`generasi_vA'/`sd1vA_8' + [var9_eg1vA_mean]`generasi_vA'/`sd1vA_9' + [var10_eg1vA_mean]`generasi_vA'/`sd1vA_10' + [var11_eg1vA_mean]`generasi_vA'/`sd1vA_11') / 4) = 0
				local p_val			=  r(p)
				replace mod3_genvA_avgSE_`wave'		= mod3_genvA_b if `p_val' >= 0.1 in `line_num_plus4'
				replace mod3_genvA_avgSE_`wave'		= "(" + mod3_genvA_se + ")" in `line_num_plus5'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "*" if  (`p_val' < 0.1 & `p_val' >= 0.05) in `line_num_plus4'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "**" if (`p_val' < 0.05 & `p_val' >= 0.01) in `line_num_plus4'
				replace mod3_genvA_avgSE_`wave'	 	= mod3_genvA_b + "***" if `p_val' < 0.01 in `line_num_plus4'
		
		
				local count_line = 1
				foreach w in avg_std_effect avg_std_effect_health avg_std_effect_educ{
					replace indicator_name_avgSE = "`w'" in `count_line'
					local count_line = `count_line' + 2
				}			
	
				drop mod?_gen*_b mod?_gen*_se

				outsheet *avgSE* in 1/10 using `direc'table12C_suest_avgSE_`z'_`b'_`wave', replace

	
}

}
}


*******************************************************
//Carrying out regressions for Table 13 
******************************************************


if `do_table13' == 1 {
	set more off
	cd\
	cd `rundir'

***********************************
*year 1 of GENERASI
***********************************
	cd "Wave II"
	
	use "..\Wave III\MIS Data\f15-16-17-2007_clean.dta", clear
		
	// calcualting actual rupiah bonus
	
	gen Location_ID = ea
	rename nilai_akhir point_vill_w2
	
	// dropping missing & double
	drop if point_vill==.
	drop if point_vill==0
	bys id_desa_clean: keep if _n==1
	
	egen point_kec_w2= sum( point_vill_w2), by(Location_ID)
	egen point_all_w2= sum( point_vill_w2)
	
	tempfile a
	save `a', replace
	
 	use "..\Wave I\program_expenses_w1", clear
 	drop if drop==1
 	 
 	rename sum_blm sum_blm_w2
 	egen blm_kec_w2 = sum(sum_blm_w2), by(Location_ID)
 	 	
 	keep id_desa_clean ea sum_blm blm_* intervention  prov_id kab_id 
 	 	
 	mmerge id_desa_clean using `a' 	
 	keep if _m==3
 	drop _m
 	
	mmerge Location_ID using "..\kecs_info_clean.dta"		
	keep if _m==3
	drop _m
	drop if drop==1

 	egen blm_total_incentives_w2 = sum(sum_blm_w2) if intervention=="1"
 	egen blm_total_nonincentives_w2 = sum(sum_blm_w2) if intervention=="2"
 	egen blm_total_1A_w2 = sum(sum_blm_w2) if intervention=="1"|intervention=="2"

 	gen bonus_kec_w2 = 0.2 * blm_kec_w2 if intervention=="1"
 	replace bonus_kec_w2 = 0 if intervention=="2"
 	
 	gen bonus_generasi_w2 = 0.2* blm_total_incentives_w2
 	replace bonus_generasi_w2 = 0.2 *(blm_total_1A_w2-blm_total_nonincentives_w2) if bonus_generasi_w2==.

	gen actual_w2 = point_vill_w2/point_kec_w2 * bonus_kec_w2
	gen counterfactual_w2 = point_vill_w2/point_all * bonus_generasi_w2

	gen gen_pooled = (gen_year1 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1)	
	gen wave = 2
	
	save bonus_w2.dta, replace 
	
************************************
*Wave II - 2008 (year 2 of Generasi)
************************************
	
	cd ..\

	cd "Wave III"
	
	use "MIS Data\f16-17-2008-alternatif_clean.dta", clear
	
	
	// calcualting actual rupiah bonus
	
	gen Location_ID = ea
	rename total_skor point_vill_w3
	
	// dropping missing & double
	drop if point_vill==.
	drop if point_vill==0
	bys id_desa_clean: keep if _n==1
	
	egen point_kec_w3= sum( point_vill_w3), by(Location_ID)
	egen point_all_w3= sum( point_vill_w3)
	
	tempfile a
	save `a', replace
	
 	use "..\Wave II\program_expenses_w2", clear
 	drop if drop==1
 	 
 	rename sum_blm sum_blm_w3
 	egen blm_kec_w3 = sum(sum_blm_w3), by(Location_ID)
 	
 	keep id_desa_clean sum_blm blm_* intervention  prov_id kab_id ea
 	 	
 	mmerge id_desa_clean using `a' 	
  	keep if _m==3
 	drop _m
 	
	mmerge Location_ID using "..\kecs_info_clean.dta"	
	keep if _m==3
	
	drop _m
	drop if drop==1

 	egen blm_total_incentives_w3 = sum(sum_blm_w3) if intervention=="1"
 	egen blm_total_nonincentives_w3 = sum(sum_blm_w3) if intervention=="2"
 	egen blm_total_1A_w3 = sum(sum_blm_w3) if intervention=="1"|intervention=="2"

 	gen bonus_kec_w3 = 0.2 * blm_kec_w3 if intervention=="1"
 	replace bonus_kec_w3 = 0 if intervention=="2"
 	
 	gen bonus_generasi_w3 = 0.2* blm_total_incentives_w3
 	replace bonus_generasi_w3 = 0.2 *(blm_total_1A_w3-blm_total_nonincentives_w3) if bonus_generasi_w3==.

	gen actual_w3 = point_vill_w3/point_kec_w3 * bonus_kec_w3
	gen counterfactual_w3 = point_vill_w3/point_all * bonus_generasi_w3
	
	gen gen_year1or2 = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_year1or2_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)
	gen gen_pooled = (gen_year1 == 1 | gen_year2 == 1)
	gen gen_pooled_versi_A = (gen_year1_versi_A == 1 | gen_year2_versi_A == 1)	
	gen wave = 3
	
	save bonus_w3.dta, replace 

************************************
*Pooled
************************************

	//pooled
	use "..\Wave II\bonus_w2", clear
 
	foreach x in  sum_blm blm_kec point_vill point_kec point_all blm_total_incentives blm_total_nonincentives blm_total_1A bonus_kec bonus_generasi actual counterfactual {
    		rename `x'_w2 `x'_po
	}

	tempfile temp0
	save `temp0', replace

	use "bonus_w3", clear
 
	foreach x in sum_blm blm_kec point_vill point_kec point_all blm_total_incentives blm_total_nonincentives blm_total_1A bonus_kec bonus_generasi actual counterfactual  {
    		rename `x'_w3 `x'_po
	}

	append using `temp0'

	save "bonus_po", replace
	
***********************************
* Village characteristics at baseline level
***********************************

** Per capita consumption

cd ..\
cd "Wave III"

use "..\Wave I\Data\R_KS1TYPE.dta", clear
collapse (sum) wfood=rks01, by(rid)
gen mfood = wfood*30/7
tempfile food
save `food', replace

use "..\Wave I\Data\R_KS2TYPE.dta", clear
collapse (sum) ynonfood= rks04, by( rid)
gen mnonfood = ynonfood/12
mmerge rid using `food'
keep if _m==3
drop _m

gen hhexp = mfood + mnonfood
tempfile hhexp
save `hhexp', replace

use "..\Wave I\Data\R_AR_01.dta", clear
keep rid rar00
bys rid: gen hhsize = _N
bys rid: keep if _n==1
drop rar00

mmerge rid using `hhexp'
keep if _m==3
drop _m

gen pcexp = hhexp/hhsize
gen Location_ID = substr(rid,1,3)
gen ea = Location_ID

gen vill = substr(rid,5,3)
gen id_desa_clean = ea + vill

collapse (mean) vill_pcexp_w1= pcexp, by(Location_ID ea id_desa_clean)

tempfile l1
save `l1', replace

** Village access = distance to the nearest capital of district/ city

use "..\Wave I\Data\L_TR.dta", clear
keep lid ltrtype ltr01
keep if ltrtype==4
gen dist_district_w1 = ltr01
drop ltrtype ltr01

gen ea = substr(lid,1,3)
gen vill = substr(lid,5,3)
gen id_desa_clean = ea + vill


mmerge id_desa_clean using `l1'
keep if _m==3
drop _m

tempfile l2
save `l2', replace

** Share of poor households in the village

use "..\Wave I\Data\L.dta", clear
keep  lid lid02 lid04
gen spoorHH_w1 = lid04 / lid02

mmerge lid using `l2'
keep if _m==3
drop _m 

mmerge Location_ID using "..\kecs_info_clean.dta"	
keep if _m==3
drop _m

drop if intervention=="3"


**Need to have id_desa_clean come in here somewhere
save village.dta, replace

***********************************
* Regressions
***********************************

cd ..\
cd "Wave III"

foreach wave in w2 w3 po {
	foreach z in noFE{

		if "`wave'" == "w2" {
			use "..\Wave II\bonus_w2", clear
		}
		if "`wave'" == "w3" {
			use "bonus_w3", clear
		}
		if "`wave'" == "po" {
			use "bonus_po", clear
		}

		local wave "`wave'"
		
		mmerge id_desa_clean using village.dta

		keep if _m==3
		drop _m

		// keep only versi A
		
		keep if  intervention=="1"
		
		destring prov_id, replace
		egen prov_P = group(prov_id P)

		destring kab_id, replace
		egen kab_wave = group(prov_id kab_id wave)

	
		***Creating variables to create draft tables for export to excel
		gen indicator_name 		= ""
		gen mean_obs_`wave'		= .
		gen mod3_genvA_`wave' 	= ""
		gen num_obs_`wave'		= .
	
	
		if ("`wave'"=="w2" | "`wave'"=="w3" ){
			local prov_P_wave "i.prov_P"
			local kab_wave "kab_wave"
		}

		if ("`wave'"=="po"){
			local prov_P_wave "i.prov_P"
			local kab_wave "kab_wave"
		}

		local var_list "actual counterfactual"

		local marker=0
		local number=1
		local number_plus1=2
	
		foreach x in `var_list'{	 

			local yvar "`x'_`wave'"

			if "`wave'" == "w2"{
				local generasi "gen_year1"
				local generasi_vA "gen_year1_versi_A"
			}
			if "`wave'" == "w3"{
				local generasi	"gen_year1or2"
				local generasi_vA "gen_year1or2_versi_A"
			}			
			if "`wave'" == "po"{
				local generasi	"gen_pooled"
				local generasi_vA "gen_pooled_versi_A"
			}			
		
		****

			*** Village percapita expenditures
			if "`z'"== "noFE" {		
				quie xi: reg `yvar' `prov_P_wave' vill_pcexp_w1, cluster(Location_ID)
			}		
			if `marker' == 0{
				quie outreg2  vill_pcexp_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel replace
			}
			else{
				quie outreg2   vill_pcexp_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}						

			*** Distance district
			if "`z'"== "noFE" {		
				quie xi: reg `yvar' `prov_P_wave' dist_district_w1, cluster(Location_ID)
			}			
			if `marker' == 0{
				quie outreg2  dist_district_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}
			else{
				quie outreg2  dist_district_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}						

			*** Number of poor HH
			if "`z'"== "noFE" {		
				quie xi: reg `yvar' `prov_P_wave' spoorHH_w1, cluster(Location_ID)
			}			
			if `marker' == 0{
				quie outreg2  spoorHH_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}
			else{
				quie outreg2  spoorHH_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}						

			*** all
			if "`z'"== "noFE" {		
				quie xi: reg `yvar' `prov_P_wave' vill_pcexp_w1 dist_district_w1 spoorHH_w1, cluster(Location_ID)
			}			
			if `marker' == 0{
				quie outreg2  vill_pcexp_w1 dist_district_w1 spoorHH_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}
			else{
				quie outreg2   vill_pcexp_w1 dist_district_w1 spoorHH_w1 using "`rundir'\Output\all\table13_`z'_`wave'", excel
			}						

		local marker = 1

	}
}

}
}
